<?php // $Revision: 1.24 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: admin.php,v 1.24 2009/09/13 16:25:35 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), in));
$blockPage->itemBreadcrumbs(lang_strings('admin_intro'));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->heading(lang_strings('administration'));
$block1->openContent();
$block1->contentTitle(lang_strings('admin_intro'));

if ($SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../approvals/approvalprocedures.php', lang_strings('approval_procedures'), in));
}

if ($SW_Permissions['Client']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink("../clients/listclients.php?", lang_strings("clients"), in));
}

if ($SW_Permissions['Company Detail']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/mycompany.php', lang_strings('company_details'), in));
}

if ($SW_Permissions['System Settings']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/updatesettings.php', lang_strings('edit_settings'), in));
}

if ($SW_Permissions['Currency Rate']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/viewcurrencyrates.php', lang_strings('exchange_rates'), in));
}

if ($SW_Permissions['File']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../linkedcontent/listfiles.php?id=0', lang_strings('files'), in));
}

if ($enableTimesheet == 'true') {
    if ($SW_Permissions['Leave']['Read'][$profilSession]) {
        $block1->contentRow('', $blockPage->buildLink('../leaves/listleaves.php', lang_strings('leave_management'), in));
    }
}

if ($SW_Permissions['System Log']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/listlogs.php', lang_strings('logs'), in));
}

if ($SW_Permissions['Period']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/listperiods.php', lang_strings('periods'), in));
}

if ($enablePE == 'true') {
    $block1->contentRow('', $blockPage->buildLink("../person_evaluations/listpersonevaluations.php", lang_strings("person_evaluations"), in));
}

if ($SW_Permissions['Service']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../services/listservices.php', lang_strings('service_management'), in));
}

if ($supportType == 'admin') {
    $block1->contentRow('', $blockPage->buildLink('../administration/support.php', lang_strings('support_management'), in));
}

if ($SW_Permissions['System Settings']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/systeminfo.php', lang_strings('system_information'), in));
}

if ($enableTimesheet == 'true') {
    if ($SW_Permissions['Time Ticket']['Read'][$profilSession]) {
        $block1->contentRow('', $blockPage->buildLink('../timetickets/listtimetickets.php', lang_strings('timeticket_management'), in));
    }
}

if ($SW_Permissions['Translation']['Admin'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/updatestrings.php', lang_strings('translation'), in));
}

if ($SW_Permissions['User']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../users/listusers.php', lang_strings('user_management'), in));
}

if ($SW_Permissions['Work Calendar']['Read'][$profilSession]) {
    $block1->contentRow('', $blockPage->buildLink('../administration/viewworkcalendar.php', lang_strings('workcalendar_management'), in));
}

if ($updateChecker == 'true' && $installationType == 'online' && $profilSession == PF_ADMINISTRATOR) {
    $block1->contentRow('', updatechecker($version));
}

if ($profilSession == PF_ADMINISTRATOR) {
    if (is_dir('../installation')) {
        $block1->contentRow('', '<b>' . $strings['attention'] . '</b> : ' . $strings['install_erase']);
    }
}

$block1->closeContent();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
