<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listperiods.php,v 1.5 2009/10/07 14:39:28 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Permission check
 */
if (!$SW_Permissions['Period']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['Period']['Edit'][$profilSession]) {
    $disabled = "disabled";
}

/**
 * Variables init
 */
$fyear = isset($_GET['fyear'])?$_GET['fyear']:date('Y');
$locked = isset($_POST['locked'])?$_POST['locked']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$prevYear = $fyear - 1;
$thisYear = date('Y');
$nextYear = $fyear + 1;

/**
 * Actions
 */
if ($action == 'update') {
    $tmpquery = "UPDATE " . $tableName['periods'] . " SET locked='N',modified='$dateheure' WHERE fyear=$fyear";
    connectSql($tmpquery);

    if (is_array($locked)) {
        foreach ($locked as $key => $val) {
            if ($val == 'Y') {
                $tmpquery = "UPDATE " . $tableName['periods'] . " SET locked='Y',modified='$dateheure' WHERE fyear=$fyear AND serial_no=$key";
                connectSql($tmpquery);
            }
        }
    }

    $msg = 'update';
}

/**
 * Prepare Data
 */
$tmpquery = " WHERE per.fyear=$fyear ORDER BY per.serial_no";
$listPeriods = new request();
$listPeriods->openPeriods($tmpquery);
$comptListPeriods = count($listPeriods->per_id);

if ($periodUnit == 'month') {
    if ($comptListPeriods != '12') {
        for ($i=1; $i<13; $i++) {
            if ($comptListPeriods != '0') {
                if (in_array($i, $listPeriods->per_serial_no)) {
                    continue;
                }
            }

            $date_start = date('Y-m-d', mktime(12, 0, 0, $i, 1, $fyear));
            periodLocked($date_start);
        }

        $tmpquery = " WHERE per.fyear=$fyear ORDER BY per.serial_no";
        $listPeriods = new request();
        $listPeriods->openPeriods($tmpquery);
        $comptListPeriods = count($listPeriods->per_id);
    }
} else {
    $day = '';

    do {
        if ($day == '') {
            $day = '31';
        } else {
            $day = $day - 1;
        }

        $WW = date('W', mktime(12, 0, 0, 12, $day, $fyear));
    } while ($WW == '01');

    if ($comptListPeriods != intval($WW)) {
        $date = $fyear . '-01-01';
        $w = date('w', mktime(12, 0, 0, 1, 1, $fyear));

        while ($w != '1') {
            $year = intval(substr($date, 0, 4));
            $month = intval(substr($date, 5, 2));
            $day = intval(substr($date, 8, 2));
            $W = date('W', mktime(12, 0, 0, $month, $day, $year));

            if ($W == '01') {
                $date = date('Y-m-d', mktime(12, 0, 0, $month, $day - 1, $year));
                $w = date('w', mktime(12, 0, 0, $month, $day - 1, $year));
            } else {
                $date = date('Y-m-d', mktime(12, 0, 0, $month, $day + 1, $year));
                $w = date('w', mktime(12, 0, 0, $month, $day + 1, $year));
            }
        }

        for ($i=0; $i<intval($WW); $i++) {
            if ($comptListPeriods != '0') {
                if (in_array($i, $listPeriods->per_serial_no)) {
                    continue;
                }
            }

            $year = intval(substr($date, 0, 4));
            $month = intval(substr($date, 5, 2));
            $day = intval(substr($date, 8, 2));
            $date_start = date('Y-m-d', mktime(12, 0, 0, $month, $day+$i*7, $year));
            periodLocked($date_start);
        }

        $tmpquery = " WHERE per.fyear=$fyear ORDER BY per.serial_no";
        $listPeriods = new request();
        $listPeriods->openPeriods($tmpquery);
        $comptListPeriods = count($listPeriods->per_id);
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), in));
$blockPage->itemBreadcrumbs(lang_strings('periods'));
$blockPage->closeBreadcrumbs();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/listperiods.php?fyear=$prevYear", lang_strings("previous_year"), in) . " | " . $blockPage->buildLink("../administration/listperiods.php?fyear=$thisYear", lang_strings("this_year"), in) . " | " . $blockPage->buildLink("../administration/listperiods.php?fyear=$nextYear", lang_strings("next_year"), in));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = 'lsP';
$block1->openForm('../administration/listperiods.php?fyear=' . $fyear . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('periods') . " $fyear");
$block1->openContent();

if ($periodUnit == 'month') {
    for ($i=0; $i<$comptListPeriods; $i++) {
        $checked = ($listPeriods->per_locked[$i]=='Y')?'checked':'';
        $block1->contentRow($monthNameArray[$listPeriods->per_serial_no[$i]] . '&nbsp;' . $fyear . '&nbsp;&nbsp;' . $listPeriods->per_date_start[$i] . '&nbsp;~&nbsp;' . $listPeriods->per_date_end[$i], '<input type="checkbox" name="locked[' . $listPeriods->per_serial_no[$i] . ']" value="Y" ' . $checked . ' ' . $disabled . '/> ' . lang_strings('locked'), false, '');
    }
} else {
    for ($i=0; $i<$comptListPeriods; $i++) {
        $checked = ($listPeriods->per_locked[$i]=='Y')?'checked':'';
        $block1->contentRow(lang_strings('week') . '&nbsp;' . $listPeriods->per_serial_no[$i] . '&nbsp;' . $fyear . '&nbsp;&nbsp;' . $listPeriods->per_date_start[$i] . '&nbsp;~&nbsp;' . $listPeriods->per_date_end[$i], '<input type="checkbox" name="locked[' . $listPeriods->per_serial_no[$i] . ']" value="Y" ' . $checked . ' ' . $disabled . '/> ' . lang_strings('locked'), false, '');
    }
}

if ($disabled == '') {
    echo '<input type="hidden" name="action" value="update"/>';
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings["update"] . '"/>');
}

$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');
?>