<?php // $Revision: 1.5.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcurrencyrates.php,v 1.5.2.1 2010/04/22 09:26:56 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$thisMonth = date("Y-m");
$action = isset($_POST['action'])?$_POST['action']:'';
$currency_from = isset($_REQUEST['currency_from'])?$_REQUEST['currency_from']:$defaultCurrency;
$month = isset($_GET['month'])?$_GET['month']:$thisMonth;
$prevMonth = date('Y-m', mktime(12, 0, 0, intval(substr($month, 5, 2)) - 1, 1, intval(substr($month, 0, 4))));
$nextMonth = date('Y-m', mktime(12, 0, 0, intval(substr($month, 5, 2)) + 1, 1, intval(substr($month, 0, 4))));
$rates = isset($_POST['rates'])?$_POST['rates']:'';

/**
 * Permission check
 */
if ($action == 'update') {
    if (!$SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['Currency Rate']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'update') {
    foreach ($rates as $refdate => $ratesCurr) {
        foreach ($ratesCurr as $curr => $rate) {
            if (is_numeric($rate) && floatval($rate)>0) {
                $tmpquery = " WHERE cur.currency_from='$currency_from' AND cur.currency_to='$curr' AND cur.reference_date='$refdate'";
                $currencyRateDetail = new request();
                $currencyRateDetail->openCurrencyRates($tmpquery);
                $comptCurrencyRateDetail = count($currencyRateDetail->cur_currency_from);
                $exchange_rate = round(floatval($rate), 5);

                if ($comptCurrencyRateDetail == '0') {
                    $tmpquery = "INSERT INTO " . $tableName["currency_rates"] . " (currency_from,currency_to,reference_date,exchange_rate) VALUES ('$currency_from','$curr','$refdate','$exchange_rate')";
                } else {
                    $tmpquery = "UPDATE " . $tableName["currency_rates"] . " SET exchange_rate='$exchange_rate' WHERE currency_from='$currency_from' AND currency_to='$curr' AND reference_date='$refdate'";
                }

                connectSql($tmpquery);
            }
        }
    }
}

/**
 * Load data
 */
unset($rates);
$tmpquery = " WHERE cur.currency_from='$currency_from' AND cur.reference_date LIKE '$month%' ORDER BY cur.currency_to,cur.reference_date";
$listCurrencyRates = new request();
$listCurrencyRates->openCurrencyRates($tmpquery);
$comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

foreach ($CurrencyMatrix['name'] as $key => $val) {
    if ($key == $currency_from) continue;

    for ($d=$month . '-01'; $d<$nextMonth . '-01'; $d=date('Y-m-d', mktime(12, 0, 0, intval(substr($d, 5, 2)), intval(substr($d, 8, 2)) + 1, intval(substr($d, 0, 4))))) {
        $rates[$d][$key] = '';
    }
}

for ($i=0; $i<$comptListCurrencyRates; $i++) {
    $rates[$listCurrencyRates->cur_reference_date[$i]][$listCurrencyRates->cur_currency_to[$i]] = $listCurrencyRates->cur_exchange_rate[$i];
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('exchange_rates'));
$blockPage->closeBreadcrumbs();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/viewcurrencyrates.php?currency_from=' . $currency_from . '&amp;month=' . $prevMonth, lang_strings('previous'), 'in') . " | " . $blockPage->buildLink('../administration/viewcurrencyrates.php?currency_from=' . $currency_from . '&amp;month=' . date('Y-m'), lang_strings('today'), 'in') . " | " . $blockPage->buildLink('../administration/viewcurrencyrates.php?currency_from=' . $currency_from . '&amp;month=' . $nextMonth, lang_strings('next'), 'in'));
$blockPage->closeBreadcrumbs();

if (isset($_GET['msg'])) {
    $msg = $_GET['msg'];
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->heading(lang_strings('exchange_rates'));
$block1->form = "cuR";
$block1->openForm("../administration/viewcurrencyrates.php?month=$month#" . $block1->form . "Anchor");
$helpStr = '<table>';
echo "<select name=\"currency_from\" onchange=\"currency_changed()\">";

foreach ($CurrencyMatrix['name'] as $key => $val) {
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';

    if ($key == $currency_from) {
        echo '<option value="' . $key . '" selected>' . $key . '</option>';
    } else {
        echo '<option value="' . $key . '">' . $key . '</option>';
    }
}

$helpStr .= '</table>';
echo "</select> " . $blockPage->printHelp($helpStr, 'true');
echo "<table class=\"listing\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr><th>" . lang_strings('date') . "</th>";

foreach ($CurrencyMatrix['name'] as $key => $val) {
    if ($key != $currency_from) {
        echo '<th width="58px">' . $key . '</th>';
    }
}

echo '<th>' . lang_strings('date') . '</th></tr>';

foreach ($rates as $refdate => $ratesCurr) {
    $block1->openRow();
    $block1->cellRow($refdate . '&nbsp;');

    if ($SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
        foreach ($ratesCurr as $curr => $rate) {
            $block1->cellRow('<input size="8" type="text" name="rates[' . $refdate . '][' . $curr . ']" value="' . $rate . '" maxlength="19">');
        }
    } else {
        foreach ($ratesCurr as $curr => $rate) {
            $block1->cellRow($rate);
        }
    }

    $block1->cellRow('&nbsp;' . $refdate);
    $block1->closeRow();
}

echo "<tr><th>" . lang_strings('date') . "</th>";

foreach ($CurrencyMatrix['name'] as $key => $val) {
    if ($key != $currency_from) {
        echo '<th>' . $key . '</th>';
    }
}

echo '<th>' . lang_strings('date') . '</th></tr>';
$block1->closeResults();

if ($SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
    $block1->contentRow("", "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
}

$block1->closeFormResults();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
<script type="text/javascript">
function currency_changed(){
    var x = document.cuRForm.action;
    x.value = '';
    document.cuRForm.submit();
}
</script>