<?php // $Revision: 1.20.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewworkcalendar.php,v 1.20.2.1 2010/04/22 09:26:56 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Permission check
 */
if (!$SW_Permissions['Work Calendar']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
$thisYear = date("Y");
$action = isset($_POST['action'])?$_POST['action']:'';
$id = isset($_GET['id'])?$_GET['id']:'0';
$type = isset($_GET['type'])?$_GET['type']:'view';
$yearCalend = isset($_GET['yearCalend'])?$_GET['yearCalend']:$thisYear;
$prevYear = $yearCalend - 1;
$nextYear = $yearCalend + 1;
$commentsCalend = isset($_POST['commentsCalend'])?$_POST['commentsCalend']:'';
$hoursCalend = isset($_POST['hoursCalend'])?$_POST['hoursCalend']:'';
$typeCalend = isset($_POST['typeCalend'])?$_POST['typeCalend']:'';

if ($type == 'edit') {
    $bodyCommand = 'onLoad="document.wkCForm.hoursCalend.focus();"';
}

/**
 * Permission check
 */
if ($type == 'edit') {
    $tmpquery = " WHERE wca.id=$id";
    $workCalendarDetail = new request();
    $workCalendarDetail->openWorkCalendar($tmpquery);
    $comptWorkCalendarDetail = count($workCalendarDetail->wca_id);

    if ($comptWorkCalendarDetail == '0') {
        header("Location: ../administration/viewworkcalendar.php?yearCalend=$yearCalend&amp;type=view");
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'update') {
    if ($hoursCalend == '') {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.wkCForm.hoursCalend.focus();"';
    } else if (!is_numeric($hoursCalend)) {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
        $bodyCommand = 'onLoad="document.wkCForm.hoursCalend.focus();document.wkCForm.hoursCalend.select();"';
    } else if ($hoursCalend > 24) {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_hours');
        $bodyCommand = 'onLoad="document.wkCForm.hoursCalend.focus();document.wkCForm.hoursCalend.select();"';
    }

    if ($error == '') {
        $hoursCalend = round($hoursCalend, $hourAccuracy);
        $commentsCalend = HtmlEntitiesNOD($commentsCalend);
        $tmpquery = "UPDATE " . $tableName["workcalendar"] . " SET type='$typeCalend',hours='$hoursCalend',comments='$commentsCalend' WHERE id='$id'";
        connectSql($tmpquery);
        header("Location: ../administration/viewworkcalendar.php?yearCalend=$yearCalend&type=view&msg=update");
        exit;
    } else {
        $hoursCalend_highlight = true;
    }
}

/**
 * Variables init
 */
if ($type == 'view') {
    $tmpquery = " WHERE wca.year='$yearCalend'";
    $listWorkCalendar = new request();
    $listWorkCalendar->openWorkCalendar($tmpquery);
    $comptListWorkCalendar = count($listWorkCalendar->wca_id);

    if ($comptListWorkCalendar == 0) {
        $currDate = $yearCalend . '-01-01';
        $lastDate = $yearCalend . '-12-31';

        while ($currDate <= $lastDate) {
            $weekDay = date('w', mktime(12, 0, 0, intval(substr($currDate, 5, 2)), intval(substr($currDate, 8, 2)), intval($yearCalend)));

            if ($weekDay == 0 || $weekDay == 6) {
                $hours = 0;
                $dt = DT_WEEKEND;
            } else {
                $hours = 8;
                $dt = DT_WORKDAY;
            }

            $tmpquery = "INSERT INTO " . $tableName['workcalendar'] . "(year,date,type,hours,comments) VALUES ('$yearCalend','$currDate','$dt','$hours','')";
            connectSql("$tmpquery");
            $currDate = date('Y-m-d', mktime(12, 0, 0, intval(substr($currDate, 5, 2)), intval(substr($currDate, 8, 2))+1, intval($yearCalend)));
        }

        $tmpquery = " WHERE wca.year='$yearCalend'";
        $listWorkCalendar = new request();
        $listWorkCalendar->openWorkCalendar($tmpquery);
        $comptListWorkCalendar = count($listWorkCalendar->wca_id);
    }
} else {
    if ($error == '') {
        $typeCalend = $workCalendarDetail->wca_type[0];
        $hoursCalend = $workCalendarDetail->wca_hours[0];
        $commentsCalend = $workCalendarDetail->wca_comments[0];
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');

if ($type == "edit") {
    $blockPage = new block();
    $blockPage->openBreadcrumbs();
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/viewworkcalendar.php?yearCalend=$yearCalend&amp;type=view", lang_strings('workcalendar_management') . " $yearCalend", 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit'));
    $blockPage->closeBreadcrumbs();

    if ($error != '') {
        $blockPage->errorBox($error);
    }

    $blockPage->openLongList();
    $block1 = new block();
    $block1->heading($monthNameArray[$monthCalend] . " $dayCalend");
    $block1->form = "wkC";
    $block1->openForm("../administration/viewworkcalendar.php?yearCalend=$yearCalend&amp;monthCalend=$monthCalend&amp;dayCalend=$dayCalend&amp;id=$id&amp;type=edit#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    $typeSel = "<select name=\"typeCalend\" onchange=\"changeType(this)\">";

    foreach ($dayType as $key => $value) {
        if ($key == $typeCalend) {
            $typeSel .= "<option value=\"$key\" selected>$value</option>";
        } else {
            $typeSel .= "<option value=\"$key\">$value</option>";
        }
    }

    $typeSel .= "</select>";
    $block1->contentRow(lang_strings("type"), $typeSel);

    if ($hoursCalend_highlight) {
        $block1->contentRow("* " . lang_strings("working_hours"), "<input size=\"8\" value=\"$hoursCalend\" class=\"input_hours_highlight\" name=\"hoursCalend\" maxlength=\"8\" type=\"TEXT\">&nbsp;" . lang_strings("hours"));
    } else {
        $block1->contentRow("* " . lang_strings("working_hours"), "<input size=\"8\" value=\"$hoursCalend\" class=\"input_hours\" name=\"hoursCalend\" maxlength=\"8\" type=\"TEXT\">&nbsp;" . lang_strings("hours"));
    }

    $block1->contentRow(lang_strings("comments"), "<textarea rows=\"3\" class=\"textarea_3rows\" name=\"commentsCalend\" cols=\"47\">$commentsCalend</textarea>");
    $block1->contentRow("", "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
    $blockPage->closeLongList();
} else if ($type == "view") {
    $blockPage = new block();
    $blockPage->openBreadcrumbs();
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('workcalendar_management'));
    $blockPage->closeBreadcrumbs();
    $blockPage->openBreadcrumbs();
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/viewworkcalendar.php?yearCalend=$prevYear&amp;type=view", lang_strings("previous_year"), 'in') . " | " . $blockPage->buildLink("../administration/viewworkcalendar.php?yearCalend=$thisYear&amp;type=view", lang_strings("this_year"), 'in') . " | " . $blockPage->buildLink("../administration/viewworkcalendar.php?yearCalend=$nextYear&amp;type=view", lang_strings("next_year"), 'in'));
    $blockPage->closeBreadcrumbs();

    if (isset($_GET['msg'])) {
        $msg = $_GET['msg'];
        require_once('../includes/messages.php');
        $blockPage->messageBox($msgLabel);
    }

    $blockPage->openLongList();
    $block1 = new block();
    $block1->heading(lang_strings('workcalendar') . " $yearCalend");
    $currDate = $yearCalend . '-01-01';
    $month = 1;

    for ($monthRow=0; $monthRow<3; $monthRow++) {
        echo "<table border=0 width=95% cellPadding=5 cellSpacing=0>";

        for ($monthCol=0; $monthCol<4; $monthCol++) {
            echo "<td align=center width=25%>";
            echo "<table border=0 cellPadding=1 cellSpacing=1>";
            echo "<caption><strong>" . $monthNameArray[$month] . "</strong></caption><tr>";

            for ($daynumber=1; $daynumber<=7; $daynumber++) {
                echo "<th width=14% class=calendDays>" . $dayShortNameArray[$daynumber] . "</th>";
            }

            echo "</tr>";
            $firstDay = date("w", mktime(12, 0, 0, $month, 1, $yearCalend));
            $firstDay = ($firstDay=='0')?'7':$firstDay;
            $lastDay = date("Y-m-d", mktime(12, 0, 0, $month+1, 0, $yearCalend));
            $day = 1;

            for ($dayRow=0; $dayRow<6; $dayRow++) {
                echo "<tr>";

                for ($dayCol=1; $dayCol<=7; $dayCol++) {
                    if (($dayRow == 0 && $dayCol < $firstDay) || ($currDate > $lastDay)) {
                         echo "<td width=14% class=\"empty\">&nbsp;</td>";
                    } else {
                        $h = array_search($currDate, $listWorkCalendar->wca_date);

                        if ($listWorkCalendar->wca_type[$h] == DT_WEEKEND) {
                            $classCell = "weekend";
                        } else if ($listWorkCalendar->wca_type[$h] == DT_WORKDAY) {
                            $classCell = "workday";
                        } else if ($listWorkCalendar->wca_type[$h] == DT_STATUTORY_HOLIDAY) {
                            $classCell = "statutoryHoliday";
                        } else if ($listWorkCalendar->wca_type[$h] == DT_MAKEUP_HOLIDAY) {
                            $classCell = "makeupHoliday";
                        } else {
                            $classCell = "workday";
                        }

                        $comments = $currDate . " " . convert_html2txt($listWorkCalendar->wca_comments[$h]) . " (" . $listWorkCalendar->wca_hours[$h] . $strings['hours'] . ")";

                        if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
                            echo "<td width=14% class=\"$classCell\"><acronym title=\"" . str_replace('"', '&quot;', $comments) . "\">" . $blockPage->buildLink("../administration/viewworkcalendar.php?yearCalend=$yearCalend&amp;monthCalend=$month&amp;dayCalend=$day&amp;id=" . $listWorkCalendar->wca_id[$h] . "&amp;typeCalend=" . $listWorkCalendar->wca_type[$h] . "&amp;type=edit", $day, 'in') . "</acronym></td>";
                        } else {
                            echo "<td width=14% class=\"$classCell\"><acronym title=\"" . str_replace('"', '&quot;', $comments) . "\">$day</acronym></td>";
                        }

                        $day++;
                        $currDate = date('Y-m-d', mktime(12, 0, 0, intval(substr($currDate, 5, 2)), intval(substr($currDate, 8, 2))+1, intval($yearCalend)));
                    }
                }

                echo "</tr>";
            }

            $month++;
            echo "</table></td>";
        }

        echo "</table>";
    }

    $blockPage->closeLongList();
}

require_once('../themes/' . THEME . '/footer.php');

?>
<script type="text/javascript">
function changeType(theObj) {
    if (theObj.selectedIndex == 0) {
        document.wkCForm.hoursCalend.value = 0;
    } else if (theObj.selectedIndex == 1) {
        document.wkCForm.hoursCalend.value = 0;
    } else if (theObj.selectedIndex == 2) {
        document.wkCForm.hoursCalend.value = 0;
    } else if (theObj.selectedIndex == 3) {
        document.wkCForm.hoursCalend.value = 8;
    }
}
</script>
