<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: createanalysis.php,v 1.5 2009/09/04 08:58:47 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$action = isset($_GET['action'])?$_GET['action']:'';
$nam = isset($_REQUEST['nam'])?$_REQUEST['nam']:'';
$ob = isset($_REQUEST['ob'])?$_REQUEST['ob']:NOO_PROJECT_COUNT;
$dimensions = isset($_REQUEST['dimensions'])?$_REQUEST['dimensions']:array();
$bodyCommand = 'onLoad="document.anCForm.nam.focus();"';

/**
 * Permission check
 */
if (!$SW_Permissions['Project']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "create") {
    if ($nam == "") {
       $error = lang_strings("blank_fields");
       $nam_highlight = true;
    } else {
        $analysisExist = false;
        $tmpquery = " WHERE ana.object='$ob' AND ana.dimension_count='" . count($dimensions) . "'";
        $listAnalysis = new request();
        $listAnalysis->openAnalysis($tmpquery);
        $comptListAnalysis = count($listAnalysis->ana_id);

        for ($i=0; $i<$comptListAnalysis; $i++) {
            $notFound = false;
            $analysisNew = $listAnalysis->ana_id[$i];
            unset($analysis_dimension);

            foreach ($dimensions as $dimension) {
                $tmpquery = " WHERE dim.analysis='$analysisNew' AND dim.dimension='$dimension'";
                $dimensionDetail = new request();
                $dimensionDetail->openAnalysisDimensions($tmpquery);

                if (count($dimensionDetail->dim_id) == 0) {
                    $notFound = true;
                    break;
                } else {
                    $analysis_dimension[] = $dimensionDetail->dim_id[0];
                }
            }

            if ($notFound == false) {
                $analysisExist = true;
                break;
            }
        }

        if ($analysisExist == false) {
            $tmpsql = "INSERT INTO " . $tableName['analysis'] . " (object,expired,dimension_count) VALUES ('$ob','$dateheures','" . count($dimensions) . "')";
            connectSql($tmpsql);
            $analysisNew = last_id($tableName['analysis']);
            $i = 1;

            foreach ($dimensions as $dimension) {
                $tmpsql = "INSERT INTO " . $tableName['analysis_dimensions'] . " (analysis,dimension,fieldname) VALUES ('$analysisNew','$dimension','dimension$i')";
                connectSql($tmpsql);
                $analysis_dimension[] = last_id($tableName['analysis_dimensions']);
                $i++;
            }
        }

        $tmpquery = "INSERT INTO " . $tableName['analysis_view'] . " (member,name,analysis,chart,chart_mode) VALUES ('$idSession','$nam','$analysisNew','" . AC_NONE . "','compact')";
        connectSql($tmpquery);
        $num = last_id($tableName['analysis_view']);
        $i = 0;
        $j = 0;

        while ($j < count($dimensions)/2) {
            $expanded = ($i==0)?"Y":"N";

            foreach ($analysisLanguages as $lang1) {
                $tmpquery = "INSERT INTO " . $tableName['dimensions_view'] . " (analysis_view,analysis_dimension,axis,order_num,filters,sorting_order,expanded,language) VALUES ('$num','" . $analysis_dimension[$j] . "','" . DA_X . "','$i','','" . SO_ASC . "','$expanded','$lang1')";
                connectSql($tmpquery);
            }

            $j++;
            $i++;
        }

        $i = 0;

        while ($j < count($dimensions)) {
            $expanded = ($i==0)?"Y":"N";

            foreach ($analysisLanguages as $lang1) {
                $tmpquery = "INSERT INTO " . $tableName['dimensions_view'] . " (analysis_view,analysis_dimension,axis,order_num,filters,sorting_order,expanded,language) VALUES ('$num','" . $analysis_dimension[$j] . "','" . DA_Y . "','$i','','" . SO_ASC . "','$expanded','$lang1')";
                connectSql($tmpquery);
            }

            $j++;
            $i++;
        }

        header("Location: ../analysis/listanalysis.php?msg=add");
        exit;
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../general/home.php', lang_strings('home'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../analysis/listanalysis.php?', lang_strings('my_analysis'), in));
$blockPage->itemBreadcrumbs(lang_strings('create_analysis'));
$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = 'anC';
$block1->openForm('../analysis/createanalysis.php?action=create#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('create_analysis'));
$block1->openContent();
$block1->contentTitle(lang_strings("analysis_intro"));

if ($nam_highlight) {
    $block1->contentRow("* " . lang_strings('name'), "<input type=\"text\" name=\"nam\" value=\"$nam\" class=\"input_text_highlight\" maxlength=\"64\">");
} else {
    $block1->contentRow("* " . lang_strings('name'), "<input type=\"text\" name=\"nam\" value=\"$nam\" class=\"input_text\" maxlength=\"64\">");
}

$obSel = "<select name=\"ob\" onchange=\"changeObject()\">";

foreach ($netOfficeObjects as $key => $val) {
    if ($ob == $key) {
        $obSel .= "<option value=\"$key\" selected>" . $val . "</option>"; 
    } else {
        $obSel .= "<option value=\"$key\">" . $val . "</option>"; 
    }
}

$obSel .= "</select>";
$block1->contentRow(lang_strings('object'), $obSel);
$availableDim = array();
$selectedDim = array();

foreach ($dimensionArray[$ob] as $key => $val) {
    $selected = "";

    if (count($dimensions) > 0) {
        foreach ($dimensions as $x) {
            if ($x == $key) {
                $selected = "selected";
                break;
            }
        }
    }

    if ($selected == "selected") {
        $selectedDim[$key] = $val;
    } else {
        $availableDim[$key] = $val;
    }
}

$xSel = "<table><tr><td align=\"center\">" . lang_strings('available_dimensions') . "</td><td>&nbsp;</td><td align=\"center\">" . lang_strings('selected_dimensions') . "</td></tr>\n";
$xSel .= "<tr><td><select id=\"adim\" style=\"width:220px;\" size=\"" . count($dimensionArray[$ob]) . "\" multiple onchange=\"changeAvailable()\">\n";

foreach ($availableDim as $key => $val) {
    $xSel .= "<option value=\"$key\">$val</option>\n";
}

$xSel .= "</select></td><td><table>";
$selectAllDisabled = (count($availableDim)==0)?'disabled':'';
$selectNoneDisabled = (count($selectedDim)==0)?'disabled':'';
$xSel .= '<tr><td align="center"><input type="button" id="selall" style="width:40px;" value="&gt;&gt;" onclick="clickSelectAll()" ' . $selectAllDisabled . '></td></tr>
<tr><td align="center"><input type="button" id="selmore" style="width:40px;" value="&gt;" onclick="clickSelectMore()" disabled></td></tr>
<tr><td align="center"><input type="button" id="selless" style="width:40px;" value="&lt;" onclick="clickSelectLess()" disabled></td></tr>
<tr><td align="center"><input type="button" id="selnone" style="width:40px;" value="&lt;&lt;" onclick="clickSelectNone()" ' . $selectNoneDisabled . '></td></tr>
</table></td>';
$xSel .= "<td><select id=\"sdim\" name=\"dimensions[]\" style=\"width:220px;\" size=\"" . count($dimensionArray[$ob]) . "\" multiple onchange=\"changeSelected()\">\n";

foreach ($selectedDim as $key => $val) {
    $xSel .= "<option value=\"$key\">$val</option>\n";
}

$xSel .= "</select></td>\n";
$xSel .= "</tr></table>\n";
$block1->contentRow("", $xSel);
$createDisabled = (count($selectedDim)<2)?'disabled':'';
$block1->contentRow("", "<input id=\"cre\" type=\"SUBMIT\" value=\"" . $strings["create"] . "\" $createDisabled onclick=\"clickCreate()\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
<script>
function changeObject()
{
    var x=document.anCForm;
    x.action="";
    document.anCForm.submit();
}

function changeAvailable()
{
    var x=document.getElementById("adim");
    var selmore=document.getElementById("selmore");

    for (i=0;i<x.length;i++) {
        if (x.options[i].selected==true) {
            selmore.disabled=false;
            return;
        }
    }

    selmore.disabled=true;
}

function changeSelected()
{
    var x=document.getElementById("sdim");
    var selless=document.getElementById("selless");

    for (i=0;i<x.length;i++) {
        if (x.options[i].selected==true) {
            selless.disabled=false;
            return;
        }
    }

    selless.disabled=true;
}

function clickSelectAll()
{
    var x=document.getElementById("adim");
    var y=document.getElementById("sdim");

    for (i=0;i<x.length;i++) {
        var n=document.createElement('option');
        n.value=x.options[i].value;
        n.text=x.options[i].text;
        y.add(n,null);
    }

    x.length=0;
    var selall=document.getElementById("selall");
    var selmore=document.getElementById("selmore");
    var selless=document.getElementById("selless");
    var selnone=document.getElementById("selnone");
    var cre=document.getElementById("cre");
    selall.disabled=true;
    selmore.disabled=true;
    selless.disabled=true;
    selnone.disabled=false;

    if (y.length>1) {
        cre.disabled=false;
    } else {
        cre.disabled=true;
    }
}

function clickSelectMore()
{
    var x=document.getElementById("adim");
    var y=document.getElementById("sdim");

    for (i=0;i<x.length;i++) {
        if (x.options[i].selected==true) {
            var n=document.createElement('option');
            n.value=x.options[i].value;
            n.text=x.options[i].text;
            y.add(n,null);
        }
    }

    for (i=x.length-1;i>=0;i--) {
        if (x.options[i].selected==true) {
            x.remove(i);
        }
    }

    var selall=document.getElementById("selall");
    var selmore=document.getElementById("selmore");
    var selless=document.getElementById("selless");
    var selnone=document.getElementById("selnone");
    var cre=document.getElementById("cre");

    if (x.length==0) {
        selall.disabled=true;
    } else {
        selall.disabled=false;
    }

    selmore.disabled=true;
    selless.disabled=true;
    selnone.disabled=false;

    if (y.length>1) {
        cre.disabled=false;
    } else {
        cre.disabled=true;
    }
}

function clickSelectLess()
{
    var x=document.getElementById("adim");
    var y=document.getElementById("sdim");

    for (i=0;i<y.length;i++) {
        if (y.options[i].selected==true) {
            var n=document.createElement('option');
            n.value=y.options[i].value;
            n.text=y.options[i].text;
            x.add(n,null);
        }
    }

    for (i=y.length-1;i>=0;i--) {
        if (y.options[i].selected==true) {
            y.remove(i);
        }
    }

    var selall=document.getElementById("selall");
    var selmore=document.getElementById("selmore");
    var selless=document.getElementById("selless");
    var selnone=document.getElementById("selnone");
    var cre=document.getElementById("cre");

    selall.disabled=false;
    selmore.disabled=true;
    selless.disabled=true;

    if (y.length==0) {
        selnone.disabled=true;
    } else {
        selnone.disabled=false;
    }

    if (y.length>1) {
        cre.disabled=false;
    } else {
        cre.disabled=true;
    }
}

function clickSelectNone()
{
    var x=document.getElementById("adim");
    var y=document.getElementById("sdim");

    for (i=0;i<y.length;i++) {
        var n=document.createElement('option');
        n.value=y.options[i].value;
        n.text=y.options[i].text;
        x.add(n,null);
    }

    y.length=0;
    var selall=document.getElementById("selall");
    var selmore=document.getElementById("selmore");
    var selless=document.getElementById("selless");
    var selnone=document.getElementById("selnone");
    var cre=document.getElementById("cre");
    selall.disabled=false;
    selmore.disabled=true;
    selless.disabled=true;
    selnone.disabled=true;
    cre.disabled=true;
}

function clickCreate()
{
    var x=document.getElementById("sdim");

    for (i=0;i<x.length;i++) {
        x.options[i].selected=true;
    }
}
</script>
