<?php // $Revision: 1.7.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: adddocument.php,v 1.7.2.1 2010/04/22 09:26:55 luiswang Exp $
 * 
 * Copyright (c) 2010 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if ($producer == '' || $doctype == '') {
    exit;
}

$listApprovals1 = new request();
$listApprovals1->openApprovals1($producer, $doctype);
$comptListApprovals1 = count($listApprovals1->app_id);

for ($i=0; $i<$comptListApprovals1; $i++) {
    $approval = $listApprovals1->app_id[$i];

    if ($listApprovals1->app_conditions[$i] == 'Y') {
        $tmpquery = " WHERE apt.approval=$approval";
        $listApprovalTerms = new request();
        $listApprovalTerms->openApprovalsTerms($tmpquery);
        $comptListApprovalTerms = count($listApprovalTerms->apt_approval);
        $tmpquery = "SELECT * FROM ";

        switch ($doctype) {
            case ADT_FILE:
                $tmpquery .= $tableName['files'];
                break;
            case ADT_TIMESHEET:
                $tmpquery .= $tableName['timesheet'];
                break;
            case ADT_LEAVEREQUEST:
                $tmpquery .= $tableName['leave_requests'];
                break;
            case ADT_EXPENSE:
                $tmpquery .= $tableName['expenses'];
                break;
            case ADT_PROJECT:
                $tmpquery .= $tableName['projects'];
        }

        $tmpquery .= " WHERE id=$num";

        for ($j=0; $j<$comptListApprovalTerms; $j++) {
            $tmpquery .= " AND " . $listApprovalTerms->apt_fieldname[$j];

            switch ($listApprovalTerms->apt_ratio[$j]) {
                case R_GREATER_THAN:
                    $tmpquery .= ">";
                    break;
                case R_GREATER_OR_EQUAL:
                    $tmpquery .= ">=";
                    break;
                case R_LESS_THAN:
                    $tmpquery .= "<";
                    break;
                case R_LESS_OR_EQUAL:
                    $tmpquery .= "<=";
                    break;
                case R_EQUAL:
                    $tmpquery .= "=";
                    break;
                case R_NOT_EQUAL:
                    $tmpquery .= "<>";
                    break;
                case R_IN_RANGE:
                    $tmpquery .= " IN (";
                    break;
                case R_NOT_IN_RANGE:
                    $tmpquery .= " NOT IN (";
                    break;
            }

            if ($listApprovalTerms->apt_compare_fields[$j] == 'N') {
                if ((stristr($listApprovalTerms->apt_fieldtype[$j], 'int') === false) && (stristr($listApprovalTerms->apt_fieldtype[$j], 'float') == false)) {
                    if (($listApprovalTerms->apt_ratio[$j] == R_IN_RANGE) || ($listApprovalTerms->apt_ratio[$j] == R_NOT_IN_RANGE)) {
                        $values = preg_split('/,/', HtmlEntitiesNOD($listApprovalTerms->apt_value[$j]));
                        $newValue = '';

                        foreach ($values as $value) {
                            if ($newValue != '') {
                                $newValue .= ',';
                            }

                            $newValue .= "N'" . $value . "'";
                        }

                        $tmpquery .= $newValue;
                    } else {
                        $tmpquery .= "N'" . HtmlEntitiesNOD($listApprovalTerms->apt_value[$j]) . "'";
                    }
                } else {
                    $tmpquery .= HtmlEntitiesNOD($listApprovalTerms->apt_value[$j]);
                }
            } else {
                $tmpquery .= HtmlEntitiesNOD($listApprovalTerms->apt_value[$j]);
            }

            if ($listApprovalTerms->apt_ratio[$j] == R_IN_RANGE || $listApprovalTerms->apt_ratio[$j] == R_NOT_IN_RANGE) {
                $tmpquery .= ")";
            }
        }

        if (compt($tmpquery) != "0") {
            $status = FS_NEEDS_APPROVAL;
        }
    } else {
        $status = FS_NEEDS_APPROVAL;
    }

    if ($status == FS_NEEDS_APPROVAL) {
        switch ($doctype) {
            case ADT_FILE:
                $tmpquery1 = "SELECT (
CASE doc_type
    WHEN " . DOC_PROJECT . " THEN doc_id
    WHEN " . DOC_PHASE . " THEN (SELECT pha.project_id FROM " . $tableName['phases'] . " pha WHERE pha.id=doc_id)
    WHEN " . DOC_TASK . " THEN (SELECT tas.project FROM " . $tableName['tasks'] . " tas WHERE tas.id=doc_id)
    WHEN " . DOC_MEETING . " THEN (SELECT mee.project FROM " . $tableName['meetings'] . " mee WHERE mee.id=doc_id)
    WHEN " . DOC_DISCUSSION . " THEN (SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=doc_id)
    WHEN " . DOC_NOTE . " THEN (SELECT note.project FROM " . $tableName['notes'] . " note WHERE note.id=doc_id)
    WHEN " . DOC_EXPENSE . " THEN (SELECT exp.project FROM " . $tableName['expenses'] . " exp WHERE exp.id=doc_id)
    WHEN " . DOC_SUPPORT_REQUEST . " THEN (SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=doc_id)
    WHEN " . DOC_SUPPORT_POST . " THEN (SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=doc_id)
    ELSE '-1' END) AS project,comments FROM " . $tableName['files'] . " WHERE id=$num";
                break;
            case ADT_TIMESHEET:
                $tmpquery1 = "SELECT '-1' AS project,comments FROM " . $tableName['timesheet'] . " WHERE id=$num";
                break;
            case ADT_LEAVEREQUEST:
                $tmpquery1 = "SELECT '-1' AS project,comments FROM " . $tableName['leave_requests'] . " WHERE id=$num";
                break;
            case ADT_EXPENSE:
                $tmpquery1 = "SELECT project,description FROM " . $tableName['expenses'] . " WHERE id=$num";
                break;
            case ADT_PROJECT:
                $tmpquery1 = "SELECT id,description FROM " . $tableName['projects'] . " WHERE id=$num";
                break;
        }

        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery1);

        if ($request1->fetch()) {
            $project = ($row[0]);
            $comments = ($row[1]);
        } else {
            $status = FS_NO_APPROVALS_NEEDED;
            $comments = '';
        }

        $request1->close();

        if ($project == '-1') {
            $tmpquery1 = " WHERE tea.member=$producer AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
            $listTeams = new request();
            $listTeams->openTeams($tmpquery1);
            $comptListTeams = count($listTeams->tea_id);

            if ($comptListTeams == '0') {
                $projects = "''";
            } else {
                $projects = implode(',', $listTeams->tea_project);
            }
        }

        if ($status == FS_NEEDS_APPROVAL) {
            $need_more_approvals = true;
            $current_stage = '0';
            $tmpquery = " WHERE mem.id=$producer";
            $producerDetail = new request();
            $producerDetail->openMembers($tmpquery);

            while ($need_more_approvals) {
                $need_more_approvals = false;
                $tmpquery = " WHERE aps.approval=$approval AND aps.sortid>=$current_stage ORDER BY aps.sortid";
                $listApprovalStages = new request();
                $listApprovalStages->openApprovalsStages($tmpquery);
                $comptListApprovalStages = count($listApprovalStages->aps_approval);
                $confirmation_level = $listApprovalStages->aps_confirmation_level[0];
                $tmpquery = " WHERE cld.confirmation_level=$confirmation_level";
                $listConfirmationLevelsDetail = new request();
                $listConfirmationLevelsDetail->openConfirmationLevelsDetail($tmpquery);
                $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);
                $authorizers = array();
                $authorizersApproved = array();

                for ($j=0; $j<$comptListConfirmationLevelsDetail; $j++) {
                    switch ($listConfirmationLevelsDetail->cld_authorizer_type[$j]) {
                        case AT_USER:
                            $tmpquery = " WHERE mem.id='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $memberDetail = new request();
                            $memberDetail->openMembers($tmpquery);
                            $comptMemberDetail = count($memberDetail->mem_id);

                            if ($comptMemberDetail != '0') {
                                if (!in_array($listConfirmationLevelsDetail->cld_authorizer[$j], $authorizers)) {
                                    $authorizers[] = $listConfirmationLevelsDetail->cld_authorizer[$j];
                                }

                                if ($listConfirmationLevelsDetail->cld_authorizer[$j]==$producer && !in_array($listConfirmationLevelsDetail->cld_authorizer[$j], $authorizersApproved)) {
                                    $authorizersApproved[] = $listConfirmationLevelsDetail->cld_authorizer[$j];
                                }
                            }

                            break;
                        case AT_PROFILE:
                            $tmpquery = " WHERE mem.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $listMembers = new request();
                            $listMembers->openMembers($tmpquery);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($k=0; $k<$comptListMembers; $k++) {
                                if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$k];
                                }

                                if ($listMembers->mem_id[$k]==$producer && !in_array($listMembers->mem_id[$k], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$k];
                                }
                            }

                            break;
                        case AT_DEP_TITLE:
                            $tmpquery = " WHERE mem.organization=" . $producerDetail->mem_organization[0] . " AND mem.department=" . $producerDetail->mem_department[0] . " AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $listMembers = new request();
                            $listMembers->openMembers($tmpquery);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($k=0; $k<$comptListMembers; $k++) {
                                if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$k];
                                }

                                if ($listMembers->mem_id[$k]==$producer && !in_array($listMembers->mem_id[$k], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$k];
                                }
                            }

                            break;
                        case AT_ORG_TITLE:
                            $tmpquery = " WHERE mem.organization=" . $producerDetail->mem_organization[0] . " AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $listMembers = new request();
                            $listMembers->openMembers($tmpquery);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($k=0; $k<$comptListMembers; $k++) {
                                if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$k];
                                }

                                if ($listMembers->mem_id[$k]==$producer && !in_array($listMembers->mem_id[$k], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$k];
                                }
                            }

                            break;
                        case AT_ROLE:
                            if ($project == '-1') {
                                $tmpquery = " WHERE tea.project IN ($projects) AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "'";
                            } else {
                                $tmpquery = " WHERE tea.project=$project AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "'";
                            }

                            $tmpquery .= " AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $listTeams = new request();
                            $listTeams->openTeams($tmpquery);
                            $comptListTeams = count($listTeams->tea_id);

                            for ($k=0; $k<$comptListTeams; $k++) {
                                if (!in_array($listTeams->tea_member[$k], $authorizers)) {
                                    $authorizers[] = $listTeams->tea_member[$k];
                                }

                                if ($listTeams->tea_member[$k]==$producer && !in_array($listTeams->tea_member[$k], $authorizersApproved)) {
                                    $authorizersApproved[] = $listTeams->tea_member[$k];
                                }
                            }

                            break;
                    }
                }

                if (count($authorizers) == 0) {
                    $status = FS_NOT_APPROVED;

                    switch ($doctype) {
                        case ADT_FILE:
                            $updSql = "UPDATE " . $tableName['files'] . " SET status='" . FS_NOT_APPROVED . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_TIMESHEET:
                            $updSql = "UPDATE " . $tableName['timesheet'] . " SET status='" . FS_NOT_APPROVED . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_LEAVEREQUEST:
                            $updSql = "UPDATE " . $tableName['leave_requests'] . " SET status='" . FS_NOT_APPROVED . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_EXPENSE:
                            $updSql = "UPDATE " . $tableName['expenses'] . " SET status='" . FS_NOT_APPROVED . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_PROJECT:
                            $updSql = "UPDATE " . $tableName['projects'] . " SET status=" . PJS_CANCELED . " WHERE id=$num";
                            connectSql($updSql);
                            break;
                    }
                } else if (($listApprovalStages->aps_con_max_requirements[0] != '0' && count($authorizersApproved) >= $listApprovalStages->aps_con_max_requirements[0]) || ($listApprovalStages->aps_con_max_requirements[0] == '0' && count($authorizersApproved) == count($authorizers))) {
                    if ($comptListApprovalStages == '1') {
                        $status = FS_NO_APPROVALS_NEEDED;
                    } else {
                        $need_more_approvals = true;
                        $current_stage = $listApprovalStages->aps_sortid[1];
                    }
                } else {
                    switch ($doctype) {
                        case ADT_FILE:
                            $updSql = "UPDATE " . $tableName['files'] . " SET status='" . FS_NEEDS_APPROVAL . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_TIMESHEET:
                            $updSql = "UPDATE " . $tableName['timesheet'] . " SET status='" . FS_NEEDS_APPROVAL . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_LEAVEREQUEST:
                            $updSql = "UPDATE " . $tableName['leave_requests'] . " SET status='" . FS_NEEDS_APPROVAL . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_EXPENSE:
                            $updSql = "UPDATE " . $tableName['expenses'] . " SET status='" . FS_NEEDS_APPROVAL . "' WHERE id=$num";
                            connectSql($updSql);
                            break;
                        case ADT_PROJECT:
                            $updSql = "UPDATE " . $tableName['projects'] . " SET status=" . PJS_PROPOSED . " WHERE id=$num";
                            connectSql($updSql);
                            break;
                    }
                }
            }
        }

        if ($status == FS_NEEDS_APPROVAL) {
            $tmpquery = "INSERT INTO " . $tableName['documents_approval'] . " (approval,owner,docid,doctype,docdate,current_stage,status,canceled,closed,comments,created) VALUES ($approval,$producer,$num,$doctype,'$date',$current_stage," . AS_PENDING . ",'N','N','$comments','$dateheures')";
            connectSql($tmpquery);
            $document_approval = last_id($tableName['documents_approval']);

            if ($listApprovals1->app_conditions[$i] == 'Y') {
                for ($j=0; $j<$comptListApprovalTerms; $j++) {
                    $tmpquery = "INSERT INTO " . $tableName['documents_approval_terms'] . " (document_approval,fieldname,ratio,value,compare_fields) VALUES ($document_approval,'" . $listApprovalTerms->apt_fieldname[$j] . "'," . $listApprovalTerms->apt_ratio[$j] . ",'" . HtmlEntitiesNOD($listApprovalTerms->apt_value[$j]) . "','" . $listApprovalTerms->apt_compare_fields[$j] . "')";
                    connectSql($tmpquery);
                }
            }

            $authorizers = array();

            for ($j=0; $j<$comptListConfirmationLevelsDetail; $j++) {
                switch ($listConfirmationLevelsDetail->cld_authorizer_type[$j]) {
                    case AT_USER:
                        if ($listConfirmationLevelsDetail->cld_authorizer[$j] != $producer) {
                            $tmpquery = " WHERE mem.id='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                            $memberDetail = new request();
                            $memberDetail->openMembers($tmpquery);
                            $comptMemberDetail = count($memberDetail->mem_id);

                            if ($comptMemberDetail != '0') {
                                if (!in_array($listConfirmationLevelsDetail->cld_authorizer[$j], $authorizers)) {
                                    $approve_string = get_rand_id(32);
                                    $not_approve_string = get_rand_id(32);
                                    $string_validto = time() + $approvalStringLifeTime;
                                    $tmpquery = "INSERT INTO " . $tableName['documents_approval_authorizers'] . " (document_approval,confirmation_level,authorizer,stage,status,approve_string,not_approve_string,string_validto,created,modified) VALUES ($document_approval,$confirmation_level," . $listConfirmationLevelsDetail->cld_authorizer[$j] . ",$current_stage," . AS_PENDING . ",'$approve_string','$not_approve_string',$string_validto,'$dateheures','$dateheures')";
                                    connectSql($tmpquery);
                                    $authorizers[] = $listConfirmationLevelsDetail->cld_authorizer[$j];
                                }
                            }
                        }

                        break;
                    case AT_PROFILE:
                        $tmpquery = " WHERE mem.id<>'$producer' AND mem.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                        $listMembers = new request();
                        $listMembers->openMembers($tmpquery);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($k=0; $k<$comptListMembers; $k++) {
                            if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpquery = "INSERT INTO " . $tableName['documents_approval_authorizers'] . " (document_approval,confirmation_level,authorizer,stage,status,approve_string,not_approve_string,string_validto,created,modified) VALUES ($document_approval,$confirmation_level," . $listMembers->mem_id[$k] . ",$current_stage," . AS_PENDING . ",'$approve_string','$not_approve_string',$string_validto,'$dateheures','$dateheures')";
                                connectSql($tmpquery);
                                $authorizers[] = $listMembers->mem_id[$k];
                            }
                        }

                        break;
                    case AT_DEP_TITLE:
                        $tmpquery = " WHERE mem.id<>'$producer' AND mem.organization=" . $producerDetail->mem_organization[0] . " AND mem.department=" . $producerDetail->mem_department[0] . " AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                        $listMembers = new request();
                        $listMembers->openMembers($tmpquery);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($k=0; $k<$comptListMembers; $k++) {
                            if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpquery = "INSERT INTO " . $tableName['documents_approval_authorizers'] . " (document_approval,confirmation_level,authorizer,stage,status,approve_string,not_approve_string,string_validto,created,modified) VALUES ($document_approval,$confirmation_level," . $listMembers->mem_id[$k] . ",$current_stage," . AS_PENDING . ",'$approve_string','$not_approve_string',$string_validto,'$dateheures','$dateheures')";
                                connectSql($tmpquery);
                                $authorizers[] = $listMembers->mem_id[$k];
                            }
                        }

                        break;
                    case AT_ORG_TITLE:
                        $tmpquery = " WHERE mem.id<>'$producer' AND mem.organization=" . $producerDetail->mem_organization[0] . " AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "' AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                        $listMembers = new request();
                        $listMembers->openMembers($tmpquery);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($k=0; $k<$comptListMembers; $k++) {
                            if (!in_array($listMembers->mem_id[$k], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpquery = "INSERT INTO " . $tableName['documents_approval_authorizers'] . " (document_approval,confirmation_level,authorizer,stage,status,approve_string,not_approve_string,string_validto,created,modified) VALUES ($document_approval,$confirmation_level," . $listMembers->mem_id[$k] . ",$current_stage," . AS_PENDING . ",'$approve_string','$not_approve_string',$string_validto,'$dateheures','$dateheures')";
                                connectSql($tmpquery);
                                $authorizers[] = $listMembers->mem_id[$k];
                            }
                        }

                        break;
                    case AT_ROLE:
                        if ($project == '-1') {
                            $tmpquery = " WHERE tea.project IN ($projects) AND tea.member<>$producer AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "'";
                        } else {
                            $tmpquery = " WHERE tea.project=$project AND tea.member<>$producer AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "'";
                        }

                        $tmpquery .= " AND mem.active='" . B_TRUE . "' AND mem.deleted<>'" . B_TRUE . "'";
                        $listTeams = new request();
                        $listTeams->openTeams($tmpquery);
                        $comptListTeams = count($listTeams->tea_id);

                        for ($k=0; $k<$comptListTeams; $k++) {
                            if (!in_array($listTeams->tea_member[$k], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpquery = "INSERT INTO " . $tableName['documents_approval_authorizers'] . " (document_approval,confirmation_level,authorizer,stage,status,approve_string,not_approve_string,string_validto,created,modified) VALUES ($document_approval,$confirmation_level," . $listTeams->tea_member[$k] . ",$current_stage," . AS_PENDING . ",'$approve_string','$not_approve_string',$string_validto,'$dateheures','$dateheures')";
                                connectSql($tmpquery);
                                $authorizers[] = $listTeams->tea_member[$k];
                            }
                        }

                        break;
                }
            }

            if ($notifications == "true") {
                require("../approvals/noti_documentadded.php");
            }
        }
    }
}

?>
