<?php // $Revision: 1.8.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editapprovalstage.php,v 1.8.2.1 2010/04/22 09:26:55 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = 'onLoad="document.eClForm.nm.focus();"';

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$nm = isset($_POST['nm'])?$_POST['nm']:'';
$cm = isset($_POST['cm'])?$_POST['cm']:'';
$max = isset($_POST['max'])?$_POST['max']:'0';
$au = isset($_POST['au'])?$_POST['au']:'';
$aut = isset($_POST['aut'])?$_POST['aut']:'';
$idx = isset($_POST['idx'])?$_POST['idx']:'';
$error = '';

/**
 * Permission check
 */
if ($id == '') {
    if (!$SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tmpquery = " WHERE cld.confirmation_level=$id";
    $listConfirmationLevelsDetail = new request();
    $listConfirmationLevelsDetail->openConfirmationLevelsDetail($tmpquery);
    $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);

    if ($comptListConfirmationLevelsDetail == "0") {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'add' || $action == 'update') {
    if (is_array($au)) {
        $auX = array();
        $autX = array();

        for ($i=0; $i<count($au); $i++) {
            if ($au[$i] == '' || $aut[$i] == '') {
                continue;
            }

            $auI = array_search($au[$i], $auX);
            $autI = array_search($aut[$i], $autX);

            if ($auI !== false && $autI !== false && $auI === $autI) {
                $error = lang_strings('auth_already_exist') . '(' . $au[$i] . ')';
                $bodyCommand = 'onLoad="document.eClForm.au[' . $i . '].focus();"';
            }

            $auX[] = $au[$i];
            $autX[] = $aut[$i];
        }

        $cnt = count($auX);
    } else {
        $cnt = '0';
    }

    if ($error == '') {
        $nm = HtmlEntitiesNOD($nm);
        $cm = HtmlEntitiesNOD($cm);

        if ($nm == '') {
            $error = lang_strings('name') . ' ' . lang_strings('error_required');
            $bodyCommand = 'onLoad="document.eClForm.nm.focus();"';
            $nm_highlight = true;
        } else if ($cm == '') {
            $error = lang_strings('description') . ' ' . lang_strings('error_required');
            $bodyCommand = 'onLoad="document.eClForm.cm.focus();"';
            $cm_highlight = true;
        } else if ($max == '') {
            $error = lang_strings('no_of_approvals_required') . ' ' . lang_strings('error_required');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (!is_numeric($max)) {
            $error = lang_strings('no_of_approvals_required') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (intval($max) < 0) {
            $error = lang_strings('zero_auth_no');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (intval($max) > intval($cnt)) {
            $error = lang_strings('auth_no_lower_min');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        }
    }

    if ($error == '') {
        if ($action == 'add') {
            $tmpquery = "INSERT INTO " . $tableName['confirmation_levels'] . " (name,comments,max_requirements) VALUES ('$nm','$cm',$max)";
            connectSql($tmpquery);
            $num = last_id($tableName['confirmation_levels']);

            for ($i=0; $i<$cnt; $i++) {
                $tmpquery = "INSERT INTO " . $tableName['confirmation_levels_detail'] . "(confirmation_level,authorizer_type,authorizer) VALUES ($num," . $autX[$i] . ",'" . $auX[$i] . "')";
                connectSql($tmpquery);
            }

            header("Location: ../approvals/viewapprovalstage.php?id=$num&msg=add");
            exit;
        } else if ($action == 'update') {
            $tmpquery = "DELETE FROM " . $tableName['confirmation_levels_detail'] . " WHERE confirmation_level=$id";
            connectSql($tmpquery);
            $tmpquery = "UPDATE " . $tableName['confirmation_levels'] . " SET name='$nm',comments='$cm',max_requirements=$max WHERE id=$id";
            connectSql($tmpquery);

            for ($i=0; $i<$cnt; $i++) {
                $tmpquery = "INSERT INTO " . $tableName['confirmation_levels_detail'] . "(confirmation_level,authorizer_type,authorizer) VALUES ($id," . $autX[$i] . ",'" . $auX[$i] . "')";
                connectSql($tmpquery);
            }

            header("Location: ../approvals/viewapprovalstage.php?id=$id&msg=update");
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($action == '') {
        unset($au,$aut);

        if ($id != '') {
            $nm = $listConfirmationLevelsDetail->cld_con_name[0];
            $cm = $listConfirmationLevelsDetail->cld_con_comments[0];
            $max = $listConfirmationLevelsDetail->cld_con_max_requirements[0];

            for ($i=0; $i<$comptListConfirmationLevelsDetail; $i++) {
                $au[] = $listConfirmationLevelsDetail->cld_authorizer[$i];
                $aut[] = $listConfirmationLevelsDetail->cld_authorizer_type[$i];
            }
        } else {
            $nm = '';
            $cm = '';
            $max = '1';
            $au[] = $idSession;
            $aut[] = AT_USER;
        }
    } else if ($action == 'addrow') {
        $cnt = is_array($au)?count($au):'0';
        $au[] = '';
        $aut[] = ($cnt=='0')?AT_USER:$aut[$cnt-1];
    } else if ($action == 'delrow') {
        $auX = $au;
        $autX = $aut;
        unset($au,$aut);

        for ($i=0; $i<count($auX); $i++) {
            if ($i != $idx) {
                $au[] = $auX[$i];
                $aut[] = $autX[$i];
            }
        }
    }

    $cnt = count($au);
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovalstages.php?", lang_strings("approval_stages"), 'in'));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_approval_stage'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../approvals/viewapprovalstage.php?id=' . $id, $listConfirmationLevelsDetail->cld_con_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit_approval_stage'));
}

$blockPage->closeBreadcrumbs();

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "eCl";

if ($id == '') {
    $block1->openForm("../approvals/editapprovalstage.php?#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
} else {
    $block1->openForm("../approvals/editapprovalstage.php?id=$id#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
}

if ($id == '') {
    $block1->heading(lang_strings('add_approval_stage'));
} else {
    $block1->heading(lang_strings('edit_approval_stage') . ' : ' . $listConfirmationLevelsDetail->cld_con_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings('info'));
echo '<input type="hidden" name="idx" value="">';

if ($nm_highlight) {
    $block1->contentRow('* ' . lang_strings('name') . $block1->printHelp("approval_stage_name_help"), '<input size="24" class="input_text_highlight" type="text" name="nm" value="' . str_replace('"', '&quot;', $nm) . '" maxlength="30">');
} else {
    $block1->contentRow('* ' . lang_strings('name') . $block1->printHelp("approval_stage_name_help"), '<input size="24" class="input_text" type="text" name="nm" value="' . str_replace('"', '&quot;', $nm) . '" maxlength="30">');
}

if ($cm_highlight) {
    $block1->contentRow('* ' . lang_strings('description') . $block1->printHelp("approval_stage_description_help"), '<textarea rows="3" class="textarea_3rows_highlight" name="cm" cols="47">' . $cm . '</textarea>');
} else {
    $block1->contentRow('* ' . lang_strings('description') . $block1->printHelp("approval_stage_description_help"), '<textarea rows="3" class="textarea_3rows" name="cm" cols="47">' . $cm . '</textarea>');
}

if ($max_highlight) {
    $block1->contentRow('* ' . lang_strings('no_of_approvals_required') . $block1->printHelp("approval_stage_num_help"), '<input size="24" class="input_text_highlight" type="text" name="max" value="' . $max . '" maxlength="30">');
} else {
    $block1->contentRow('* ' . lang_strings('no_of_approvals_required') . $block1->printHelp("approval_stage_num_help"), '<input size="24" class="input_text" type="text" name="max" value="' . $max . '" maxlength="30">');
}

$block1->contentTitle(lang_strings("authorizers"));
$block1->contentRow($block1->printHelp("approval_stage_authorizers_help"), "", "false", "");
$tmpquery = " WHERE mem.profil<>'" . PF_CLIENT_USER . "' AND mem.deleted<>'" . B_TRUE . "' AND mem.active='" . B_TRUE . "' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);
$tmpquery = "SELECT DISTINCT mem.title FROM " . $tableName['members'] . " mem WHERE mem.profil<>'" . PF_CLIENT_USER . "' AND mem.deleted<>'" . B_TRUE . "' AND mem.active='" . B_TRUE . "' ORDER BY mem.title";
$listTitles = new request();
$listTitles->connectClass();
$listTitles->query($tmpquery);

while ($listTitles->fetch()) {
    $listTitles->title[] = ($row[0]);
}

$listTitles->close();
$comptListTitles = count($listTitles->title);

for ($i=0; $i<$cnt; $i++) {
    $authorizersSel = '<select name="aut[' . $i . ']" onchange="reloadForm(\'reload\',0);">';

    foreach ($authorizerType as $key => $val) {
        if ($aut[$i] == $key) {
            $authorizersSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
        } else {
            $authorizersSel .= '<option value="' . $key . '">' . $val . '</option>';
        }
    }

    $authorizersSel .= '</select><select name="au[' . $i . ']">';

    switch ($aut[$i]) {
        case AT_USER:
            for ($j=0; $j<$comptListMembers; $j++) {
                if ($listMembers->mem_id[$j] == $au[$i]) {
                    $authorizersSel .= '<option value="' . $listMembers->mem_id[$j] . '" selected>' . $listMembers->mem_name[$j] . '</option>';
                } else {
                    $authorizersSel .= '<option value="' . $listMembers->mem_id[$j] . '">' . $listMembers->mem_name[$j] . '</option>';
                }
            }

            break;
        case AT_PROFILE:
            foreach ($profil as $key => $val) {
                if ($key != PF_CLIENT_USER) {
                    if ($key == $au[$i]) {
                        $authorizersSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
                    } else {
                        $authorizersSel .= '<option value="' . $key . '">' . $val . '</option>';
                    }
                }
            }

            break;
        case AT_DEP_TITLE:
        case AT_ORG_TITLE:
            for ($j=0; $j<$comptListTitles; $j++) {
                if ($listTitles->title[$j] == $au[$i]) {
                    $authorizersSel .= '<option value="' . $listTitles->title[$j] . '" selected>' . $listTitles->title[$j] . '</option>';
                } else {
                    $authorizersSel .= '<option value="' . $listTitles->title[$j] . '">' . $listTitles->title[$j] . '</option>';
                }
            }

            break;
        case AT_ROLE:
            foreach ($projectRoles as $key => $val) {
                if ($key != PJ_GUEST) {
                    if ($key == $au[$i]) {
                        $authorizersSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
                    } else {
                        $authorizersSel .= '<option value="' . $key . '">' . $val . '</option>';
                    }
                }
            }

            break;
        default:
            $authorizersSel .= '<option value=""></option>';
    }

    $authorizersSel .= '</select>';
    $block1->contentRow('<img src="../themes/' . THEME . '/btn_remove_norm.gif" alt="' . $strings['delete'] . '"/ onclick="reloadForm(\'delrow\',' . $i . ');">', $authorizersSel, 'false', '');
}

$block1->contentRow('<img src="../themes/' . THEME . '/btn_add_norm.gif" alt="' . $strings['add'] . '"/ onclick="reloadForm(\'addrow\',0);">', '', 'false', '');
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
<script type="text/javascript">
function reloadForm(a,b){
    var x = document.eClForm.action;
    var y = document.eClForm.idx;
    x.value = a;
    y.value = b;
    document.eClForm.submit();
}
</script>
