<?php // $Revision: 1.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportapprovaltemplates.php,v 1.1 2009/09/11 09:58:57 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$ids = explode('**', $id);
$id = implode(',', $ids);
$tmpquery = " WHERE app.id IN ($id)";
$listApprovals = new request();
$listApprovals->openApprovals($tmpquery);
$comptListApprovals = count($listApprovals->app_id);

if ($comptListApprovals != count($ids)) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
$tmpquery = "SELECT aps.confirmation_level FROM " . $tableName['approvals_stages'] . " aps WHERE aps.approval IN ($id) GROUP BY aps.confirmation_level";
$listConfirmationLevels = new request();
$listConfirmationLevels->connectClass();
$listConfirmationLevels->query($tmpquery);

while ($listConfirmationLevels->fetch()) {
    $listConfirmationLevels->confirmation_level[] = ($row[0]);
}

$listConfirmationLevels->close();
$consId = implode(',', $listConfirmationLevels->confirmation_level);
$tmpquery = " WHERE con.id IN ($consId)";
$listConfirmationLevels = new request();
$listConfirmationLevels->openConfirmationLevels($tmpquery);
$comptListConfirmationLevels = count($listConfirmationLevels->con_id);
$doc = new DOMDocument('1.0', 'UTF-8');
$doc->formatOutput = true;
$approvals = $doc->createElement("approval_procedures");
$doc->appendChild($approvals);

for ($i=0; $i<$comptListConfirmationLevels; $i++) {
    $stage = $doc->createElement("approval_stage");
    $name = $doc->createElement("name");
    $name->appendChild($doc->createTextNode($listConfirmationLevels->con_name[$i]));
    $stage->appendChild($name);
    $comments = $doc->createElement("comments");
    $comments->appendChild($doc->createTextNode($listConfirmationLevels->con_comments[$i]));
    $stage->appendChild($comments);
    $max_requirements = $doc->createElement("max_requirements");
    $max_requirements->appendChild($doc->createTextNode($listConfirmationLevels->con_max_requirements[$i]));
    $stage->appendChild($max_requirements);
    $authorizers = $doc->createElement("authorizers");
    $tmpquery = " WHERE cld.confirmation_level=" . $listConfirmationLevels->con_id[$i];
    $listConfirmationLevelsDetail = new request();
    $listConfirmationLevelsDetail->openConfirmationLevelsDetail($tmpquery);
    $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);

    for ($j=0; $j<$comptListConfirmationLevelsDetail; $j++) {
        $authorizer = $doc->createElement("authorizer");
        $authorizer_type = $doc->createElement("type");
        $authorizer_type->appendChild($doc->createTextNode($listConfirmationLevelsDetail->cld_authorizer_type[$j]));
        $authorizer->appendChild($authorizer_type);
        $authorizer_id = $doc->createElement("id");
        $authorizer_id->appendChild($doc->createTextNode($listConfirmationLevelsDetail->cld_authorizer[$j]));
        $authorizer->appendChild($authorizer_id);
        $authorizers->appendChild($authorizer);
    }

    $stage->appendChild($authorizers);
    $approvals->appendChild($stage);
}

for ($i=0; $i<$comptListApprovals; $i++) {
    $approval = $doc->createElement("approval_procedure");
    $name = $doc->createElement("name");
    $name->appendChild($doc->createTextNode($listApprovals->app_name[$i]));
    $approval->appendChild($name);
    $doctype = $doc->createElement("doctype");
    $doctype->appendChild($doc->createTextNode($listApprovals->app_doctype[$i]));
    $approval->appendChild($doctype);
    $comments = $doc->createElement("comments");
    $comments->appendChild($doc->createTextNode($listApprovals->app_comments[$i]));
    $approval->appendChild($comments);
    $conditions = $doc->createElement("conditions");
    $conditions->appendChild($doc->createTextNode($listApprovals->app_conditions[$i]));
    $approval->appendChild($conditions);

    if ($listApprovals->app_conditions[$i] == 'Y') {
        $terms = $doc->createElement("terms");
        $tmpquery = " WHERE apt.approval=" . $listApprovals->app_id[$i];
        $listApprovalTerms = new request();
        $listApprovalTerms->openApprovalsTerms($tmpquery);
        $comptListApprovalTerms = count($listApprovalTerms->apt_id);

        for ($j=0; $j<$comptListApprovalTerms; $j++) {
            $term = $doc->createElement("term");
            $fieldname = $doc->createElement("fieldname");
            $fieldname->appendChild($doc->createTextNode($listApprovalTerms->apt_fieldname[$j]));
            $term->appendChild($fieldname);
            $fieldtype = $doc->createElement("fieldtype");
            $fieldtype->appendChild($doc->createTextNode($listApprovalTerms->apt_fieldtype[$j]));
            $term->appendChild($fieldtype);
            $ratio = $doc->createElement("ratio");
            $ratio->appendChild($doc->createTextNode($listApprovalTerms->apt_ratio[$j]));
            $term->appendChild($ratio);
            $value = $doc->createElement("value");
            $value->appendChild($doc->createTextNode($listApprovalTerms->apt_value[$j]));
            $term->appendChild($value);
            $compare_fields = $doc->createElement("compare_fields");
            $compare_fields->appendChild($doc->createTextNode($listApprovalTerms->apt_compare_fields[$j]));
            $term->appendChild($compare_fields);
            $terms->appendChild($term);
        }

        $approval->appendChild($terms);
    }

    $originators = $doc->createElement("originators");
    $tmpquery = " WHERE apd.approval=" . $listApprovals->app_id[$i] . " ORDER BY apd.exclude";
    $listApprovalProducers = new request();
    $listApprovalProducers->openApprovalsProducers($tmpquery);
    $comptListApprovalProducers = count($listApprovalProducers->apd_approval);

    for ($j=0; $j<$comptListApprovalProducers; $j++) {
        $originator = $doc->createElement("originator");
        $producer_type = $doc->createElement("type");
        $producer_type->appendChild($doc->createTextNode($listApprovalProducers->apd_producer_type[$j]));
        $originator->appendChild($producer_type);
        $producer = $doc->createElement("id");
        $producer->appendChild($doc->createTextNode($listApprovalProducers->apd_producer[$j]));
        $originator->appendChild($producer);
        $exclude = $doc->createElement("exclude");
        $exclude->appendChild($doc->createTextNode($listApprovalProducers->apd_exclude[$j]));
        $originator->appendChild($exclude);
        $originators->appendChild($originator);
    }

    $approval->appendChild($originators);
    $stages = $doc->createElement("stages");
    $tmpquery = " WHERE aps.approval=" . $listApprovals->app_id[$i];
    $listApprovalStages = new request();
    $listApprovalStages->openApprovalsStages($tmpquery);
    $comptListApprovalStages = count($listApprovalStages->aps_approval);

    for ($j=0; $j<$comptListApprovalStages; $j++) {
        $stage = $doc->createElement("stage");
        $confirmation_level = $doc->createElement("name");
        $confirmation_level->appendChild($doc->createTextNode($listApprovalStages->aps_con_name[$j]));
        $stage->appendChild($confirmation_level);
        $sortid = $doc->createElement("sortid");
        $sortid->appendChild($doc->createTextNode($listApprovalStages->aps_sortid[$j]));
        $stage->appendChild($sortid);
        $stages->appendChild($stage);
    }

    $approval->appendChild($stages);
    $approvals->appendChild($approval);
}

$dump = $doc->saveXML();
$size = strlen($dump);
$name = (($comptListApprovals=='1')?$listApprovals->app_name[0]:'approval_procedures') . '.xml';

/**
 * Output
 */
header('Content-Length: ' . $size);
header('Content-Type: text/plain');
header("Content-Disposition: attachment; filename=$name");
echo $dump;

?>
