<?php // $Revision: 1.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importapprovaltemplates.php,v 1.1 2009/09/11 09:58:57 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "import") {
    if ($_FILES['upload']['name'] == '') {
        $error = lang_strings("no_file");
    } else if ($_FILES['upload']['size'] == '0') {
        $error = lang_strings('exceed_size');
    } else {
        $extension = strtolower(substr(strrchr($_FILES['upload']['name'], ".") , 1));
        $extension_len = strlen($extension) + 1;
        $filename_len = strlen($_FILES['upload']['name']);
        $filename_prefix = substr($_FILES['upload']['name'], 0, $filename_len - $extension_len);

        if ($allowPhp == "false") {
            if ($extension == "php" || $extension == "php3" || $extension == "phtml") {
                $error = lang_strings("no_php");
            }
        }
    }

    if ($error == "") {
        $doc = new DOMDocument();

        if ($doc->load($_FILES['upload']['tmp_name']) === false) {
            $error = str_replace('%FILE%', $_FILES['upload']['name'], $strings['load_file_fail']);
        }
    }

    if ($error == "") {
        $stages = $doc->getElementsByTagName("approval_stage");

        foreach ($stages as $stage) {
            $elements = $stage->getElementsByTagName("name");
            $nm = $elements->item(0)->nodeValue;
            $elements = $stage->getElementsByTagName("comments");
            $cm = $elements->item(0)->nodeValue;
            $elements = $stage->getElementsByTagName("max_requirements");
            $max = $elements->item(0)->nodeValue;
            $tmpquery = "INSERT INTO " . $tableName['confirmation_levels'] . " (name,comments,max_requirements) VALUES ('" . HtmlEntitiesNOD($nm) . "','" . HtmlEntitiesNOD($cm) . "',$max)";
            connectSql($tmpquery);
            $num = last_id($tableName['confirmation_levels']);
            $approval_stages[$nm] = $num;
            $authorizers = $stage->getElementsByTagName("authorizers");

            foreach ($authorizers as $authorizer) {
                $elements = $authorizer->getElementsByTagName("type");
                $aut = $elements->item(0)->nodeValue;
                $elements = $authorizer->getElementsByTagName("id");
                $au = $elements->item(0)->nodeValue;
                $tmpquery = "INSERT INTO " . $tableName['confirmation_levels_detail'] . "(confirmation_level,authorizer_type,authorizer) VALUES ($num," . $aut . ",'" . $au . "')";
                connectSql($tmpquery);
            }
        }

        $approvals = $doc->getElementsByTagName("approval_procedure");

        foreach ($approvals as $approval) {
            $elements = $approval->getElementsByTagName("name");
            $nm = $elements->item(0)->nodeValue;
            $elements = $approval->getElementsByTagName("doctype");
            $dt = $elements->item(0)->nodeValue;
            $elements = $approval->getElementsByTagName("comments");
            $cm = $elements->item(0)->nodeValue;
            $elements = $approval->getElementsByTagName("conditions");
            $cd = $elements->item(0)->nodeValue;
            $tmpquery = "INSERT INTO " . $tableName['approvals'] . " (name,doctype,conditions,active,comments) VALUES ('" . HtmlEntitiesNOD($nm) . "',$dt,'$cd','N','" . HtmlEntitiesNOD($cm) . "')";
            connectSql($tmpquery);
            $num = last_id($tableName['approvals']);

            if ($cd == 'Y') {
                $terms = $approval->getElementsByTagName("term");

                foreach ($terms as $term) {
                    $elements = $term->getElementsByTagName("fieldname");
                    $fn = $elements->item(0)->nodeValue;
                    $elements = $term->getElementsByTagName("fieldtype");
                    $ft = $elements->item(0)->nodeValue;
                    $elements = $term->getElementsByTagName("ratio");
                    $r = $elements->item(0)->nodeValue;
                    $elements = $term->getElementsByTagName("value");
                    $v = $elements->item(0)->nodeValue;
                    $elements = $term->getElementsByTagName("compare_fields");
                    $cf = $elements->item(0)->nodeValue;
                    $tmpquery = "INSERT INTO " . $tableName['approvals_terms'] . "(approval,fieldname,fieldtype,ratio,value,compare_fields) VALUES ($num,'$fn','$ft',$r,'" . HtmlEntitiesNOD($v) . "','$cf')";
                    connectSql($tmpquery);
                }
            }

            $originators = $approval->getElementsByTagName("originator");

            foreach ($originators as $originator) {
                $elements = $originator->getElementsByTagName("type");
                $pdt = $elements->item(0)->nodeValue;
                $elements = $originator->getElementsByTagName("id");
                $pd = $elements->item(0)->nodeValue;
                $elements = $originator->getElementsByTagName("exclude");
                $ex = $elements->item(0)->nodeValue;
                $tmpquery = "INSERT INTO " . $tableName['approvals_producers'] . "(approval,producer_type,producer,exclude) VALUES ($num,'$pdt',$pd,'$ex')";
                connectSql($tmpquery);
            }

            $stages = $approval->getElementsByTagName("stage");

            foreach ($stages as $stage) {
                $elements = $stage->getElementsByTagName("name");
                $nm = $elements->item(0)->nodeValue;
                $elements = $stage->getElementsByTagName("sortid");
                $sortid = $elements->item(0)->nodeValue;
                $st = isset($approval_stages[$nm])?$approval_stages[$nm]:'0';
                $tmpquery = "INSERT INTO " . $tableName['approvals_stages'] . "(approval,confirmation_level,sortid) VALUES ($num,$st,$sortid)";
                connectSql($tmpquery);
            }
        }

        header("Location: ../approvals/listapprovaltemplates.php?msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovaltemplates.php?", lang_strings("approval_templates"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_approval_templates"));
$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "imA";
$block1->openForm("../approvals/importapprovaltemplates.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import"/>';
echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $maxFileSize . '"/>';
$block1->heading(lang_strings("import_approval_templates"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), "<input size=\"44\" class=\"input_text\" name=\"upload\" type=\"FILE\">");
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
