<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listapprovalstages.php,v 1.3 2009/09/01 15:01:15 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("approval_stages"));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'apS';
$block1->openForm('../approvals/listapprovalstages.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_stages'));
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', lang_strings('add'));
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
}

$block1->paletteIcon(2, 'info', lang_strings('view'));

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', lang_strings('edit'));
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('confirmation_levels', $sortingUser->sor_confirmation_levels[0], 'con.name ASC', $sortingFields = array(0 => 'con.name', 1 => 'con.comments', 2 => 'con.max_requirements'));
$block1->recordsTotal = compt($initrequest['confirmation_levels']);
$tmpquery = " ORDER BY " . $block1->sortingValue;
$listConfirmationLevels = new request();
$listConfirmationLevels->openConfirmationLevels($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListConfirmationLevels = count($listConfirmationLevels->con_id);

if ($comptListConfirmationLevels != '0') {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('description'), 2 => lang_strings('no_of_approvals_required')), 'false');

    for ($i=0; $i<$comptListConfirmationLevels; $i++) {
        $block1->openRow();
        $block1->checkboxRow($listConfirmationLevels->con_id[$i]);
        $block1->cellRow($blockPage->buildLink("../approvals/viewapprovalstage.php?id=" . $listConfirmationLevels->con_id[$i], $listConfirmationLevels->con_name[$i], 'in'));
        $comm = $listConfirmationLevels->con_comments[$i];
        $block1->cellRow(nl2br($comm));
        $block1->cellRow($listConfirmationLevels->con_max_requirements[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "");
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../approvals/editapprovalstage.php?', 'true,false,false', lang_strings('add'));
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../approvals/deleteapprovalstages.php?', 'false,true,true', lang_strings('delete'));
}

$block1->paletteScript(2, 'info', '../approvals/viewapprovalstage.php?', 'false,true,false', lang_strings('view'));

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../approvals/editapprovalstage.php?', 'false,true,false', lang_strings('edit'));
}

$block1->closePaletteScript($comptListConfirmationLevels, $listConfirmationLevels->con_id);
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
