<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listapprovaltemplates.php,v 1.4 2009/09/11 09:58:57 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("approval_templates"));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'apT';
$block1->openForm('../approvals/listapprovaltemplates.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_templates'));
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', lang_strings('add'));
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
}

$block1->paletteIcon(2, 'info', lang_strings('view'));

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', lang_strings('edit'));
}

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(4, 'import', lang_strings('import'));
}

$block1->paletteIcon(5, 'export', lang_strings('export'));
$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('approvals', $sortingUser->sor_approvals[0], 'app.name ASC', $sortingFields = array(0 => 'app.name', 1 => 'app.comments', 2 => 'app.active'));
$block1->recordsTotal = compt($initrequest['approvals']);
$tmpquery = " ORDER BY " . $block1->sortingValue;
$listApprovals = new request();
$listApprovals->openApprovals($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListApprovals = count($listApprovals->app_id);

if ($comptListApprovals != '0') {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('description'), 2 => lang_strings('active_str')), 'false');

    for ($i=0; $i<$comptListApprovals; $i++) {
        $block1->openRow();
        $block1->checkboxRow($listApprovals->app_id[$i]);
        $block1->cellRow($blockPage->buildLink("../approvals/viewapprovaltemplate.php?id=" . $listApprovals->app_id[$i], $listApprovals->app_name[$i], 'in'));
        $comm = $listApprovals->app_comments[$i];
        $block1->cellRow(nl2br($comm));
        $active = ($listApprovals->app_active[$i]=='Y')?lang_strings('yes'):lang_strings('no');
        $block1->cellRow($active);
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "");
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../approvals/editapprovaltemplate.php?', 'true,false,false', lang_strings('add'));
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../approvals/deleteapprovaltemplates.php?', 'false,true,true', lang_strings('delete'));
}

$block1->paletteScript(2, 'info', '../approvals/viewapprovaltemplate.php?', 'false,true,false', lang_strings('view'));

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../approvals/editapprovaltemplate.php?', 'false,true,false', lang_strings('edit'));
}

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(4, 'import', '../approvals/importapprovaltemplates.php?', 'true,false,false', lang_strings('import'));
}

$block1->paletteScript(5, 'export', '../approvals/exportapprovaltemplates.php?', 'false,true,true', lang_strings('export'));
$block1->closePaletteScript($comptListApprovals, $listApprovals->app_id);
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
