<?php // $Revision: 1.6.2.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_documentapproved.php,v 1.6.2.2 2012/03/15 04:41:43 luiswang Exp $
 *
 * Copyright (c) 2011 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if ($document_approval == '') {
    exit;
}

// check if email address of receipt is empty
$tmpquery = " WHERE mem.id='$producer'";
$producerDetail = new request();
$producerDetail->openMembers($tmpquery);
$comptProducerDetail = count($producerDetail->mem_id);

if ($comptProducerDetail > 0 && $producerDetail->mem_email_work[0] != '') {
    $tmpquery = " WHERE dap.id=$document_approval";
    $documentsApprovalDetail = new request();
    $documentsApprovalDetail->openDocumentsApproval($tmpquery);
    unset($att_name, $att_path);

    switch ($doctype) {
        case ADT_FILE:
            $tmpquery = " WHERE fil.id=$num";
            $fileDetail = new request();
            $fileDetail->openFiles($tmpquery);
            $att_name[] = $fileDetail->fil_name[0];
            $path = $fileDetail->fil_fullname[0];
            $mail_priority = 3;

            if ($mkdirMethod == 'FTP') {
                $tmpfname = tempnam ("../files", "FOO");
                $ftp = ftp_connect(FTPSERVER);
                ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $path, FTP_BINARY);
                ftp_quit($ftp);
                $att_path[] = $tmpfname;
            } else {
                $att_path[] = "../files/" . $path;
            }

            break;
        case ADT_TIMESHEET:
            $tmpquery = " WHERE tim.id=$num";
            $timesheetDetail = new request();
            $timesheetDetail->openTimesheet($tmpquery);
            $mail_priority = 3;
            $generate_mail_attach = 'Y';
            $S_org = 'ALL';
            $S_prj = 'ALL';
            $S_mem = $documentsApprovalDetail->dap_owner[0];
            $dateRange = true;
            $s_sdate2 = $timesheetDetail->tim_per_date_start[0];
            $s_edate2 = $timesheetDetail->tim_per_date_end[0];
            $billing = 'ALL';
            include('../reports/exporthours.php');
            $att_name[] = 'hours.csv';
            $att_path[] = $tmpfname;
            break;
        case ADT_LEAVEREQUEST:
            $tmpquery = " WHERE lea.id=$num";
            $leaveRequestDetail = new request();
            $leaveRequestDetail->openLeaveRequests($tmpquery);
            $mail_priority = 3;
            $tmpquery = " WHERE fil.doc_type='" . DOC_LEAVE . "' AND fil.doc_id=$num AND fil.vc_parent=0";
            $listFiles = new request();
            $listFiles->openFiles($tmpquery);
            $comptListFiles = count($listFiles->fil_id);

            for ($i=0; $i<$comptListFiles; $i++) {
                $att_name[] = $listFiles->fil_name[$i];

                if ($mkdirMethod == 'FTP') {
                    $tmpfname = tempnam ("../files", "FOO");
                    $ftp = ftp_connect(FTPSERVER);
                    ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                    ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$i], FTP_BINARY);
                    ftp_quit($ftp);
                    $att_path[] = $tmpfname;
                } else {
                    $att_path[] = "../files/" . $listFiles->fil_fullname[$i];
                }
            }

            break;
        case ADT_EXPENSE:
            $tmpquery = " WHERE exp.id=$num";
            $expenseDetail = new request();
            $expenseDetail->openExpenses($tmpquery);
            $bill_client = ($expenseDetail->exp_billable[0]=='Y')?$strings['yes']:$strings['no'];

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $mail_priority = 3;
            $tmpquery = " WHERE fil.doc_type='" . DOC_EXPENSE . "' AND fil.doc_id=$num AND fil.vc_parent=0";
            $listFiles = new request();
            $listFiles->openFiles($tmpquery);
            $comptListFiles = count($listFiles->fil_id);

            for ($i=0; $i<$comptListFiles; $i++) {
                $att_name[] = $listFiles->fil_name[$i];

                if ($mkdirMethod == 'FTP') {
                    $tmpfname = tempnam ("../files", "FOO");
                    $ftp = ftp_connect(FTPSERVER);
                    ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                    ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$i], FTP_BINARY);
                    ftp_quit($ftp);
                    $att_path[] = $tmpfname;
                } else {
                    $att_path[] = "../files/" . $listFiles->fil_fullname[$i];
                }
            }

            break;
        case ADT_PROJECT:
            $tmpquery = " WHERE pro.id=$num";
            $projectDetail = new request();
            $projectDetail->openProjects($tmpquery);
            $mail_priority = ($projectDetail->pro_priority[0] == PR_NONE)?3:(6 - intval($projectDetail->pro_priority[0]));
            $tmpquery = " WHERE fil.doc_type='" . DOC_PROJECT . "' AND fil.doc_id=$num AND fil.vc_parent=0";
            $listFiles = new request();
            $listFiles->openFiles($tmpquery);
            $comptListFiles = count($listFiles->fil_id);

            for ($i=0; $i<$comptListFiles; $i++) {
                $att_name[] = $listFiles->fil_name[$i];

                if ($mkdirMethod == 'FTP') {
                    $tmpfname = tempnam ("../files", "FOO");
                    $ftp = ftp_connect(FTPSERVER);
                    ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                    ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$i], FTP_BINARY);
                    ftp_quit($ftp);
                    $att_path[] = $tmpfname;
                } else {
                    $att_path[] = "../files/" . $listFiles->fil_fullname[$i];
                }
            }

            // get Project Budget
            $tmpquery = " WHERE pjb.project=$num";
            $listProjectBudget = new request();
            $listProjectBudget->openProjectsBudget($tmpquery);
            $comptListProjectBudget = count($listProjectBudget->pjb_project);

            if ($projectDetail->pro_currency[0] == '') {
                $currency_display = $defaultCurrency;
            } else {
                $currency_display = $projectDetail->pro_currency[0];
            }

            if ($comptListProjectBudget == '0') {
                $project_budget = '';
            } else {
                if ($projectDetail->pro_currency[0] == '') {
                    $currSets = array();

                    foreach ($listProjectBudget->pjb_currency as $curr) {
                        if ($curr != $defaultCurrency && !in_array($curr, $currSets)) {
                            $currSets[] = $curr;
                        }
                    }

                    $currStr = "'" . implode("','", $currSets) . "'";
                    $tmpquery = " WHERE cur.currency_to='$defaultCurrency' AND cur.currency_from IN ($currStr) AND cur.reference_date<='" . substr($dateheure, 0, 10) . "'";
                    $listCurrencyRates = new request();
                    $listCurrencyRates->openCurrencyRates($tmpquery);
                    $comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

                    if ($comptListCurrencyRates != count($currSets)) {
                        $project_budget = '';
                    } else {
                        $project_budget = 0;

                        for ($i=0; $i<$comptListProjectBudget; $i++) {
                            if ($listProjectBudget->pjb_currency[$i] == $defaultCurrency) {
                                $amount = $listProjectBudget->pjb_amount[$i];
                            } else {
                                $idx = array_search($listProjectBudget->pjb_currency[$i], $listCurrencyRates->cur_currency_from);
                                $rate = $listCurrencyRates->cur_exchange_rate[$idx];
                                $amount = round($listProjectBudget->pjb_amount[$i] * $rate, $costAccuracy);
                            }

                            $project_budget += $amount;
                        }
                    }
                } else {
                    $project_budget = 0;

                    for ($i=0; $i<$comptListProjectBudget; $i++) {
                        $project_budget += $listProjectBudget->pjb_amount[$i];
                    }
                }
            }

            break;
    }

    $tmpquery = " WHERE dap.docid=$num AND dap.doctype='" . $doctype . "' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($tmpquery);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($k=0,$ah=''; $k<$comptListDocumentsApproval; $k++,$ah.='<br>') {
        if ($k == 0) {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$k], $timezoneSession), $strings['submit_at']) . '</i>';
        } else {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$k], $timezoneSession), $strings['resubmit_at']) . '</i>';
        }

        $tmpquery = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$k] . " AND daa.status<>'" . AS_PENDING . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($tmpquery);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_APPROVED) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_NOT_APPROVED) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], $timezoneSession), $ahd);
                $ah .= '<br><i>' . $ahd  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $ah .= '<br>' . nl2br($listDocumentsApprovalAuthorizer->daa_comments[$j]);
                }
            }
        }
    }

    $mail = new notification();
    $mail->getUserinfo('1', "from");
    $mail->getUserinfo($producer, "to");
    $mail->partSubject = $strings["noti_documentapproved1"];
    $mail->partMessage = $strings["noti_documentapproved2"];
    $mail->openBody();
    $mail->openContent();
    $mail->contentTitle($strings["details"]);
    $mail->contentRow($strings["owner"], $documentsApprovalDetail->dap_mem_name[0]);
    $mail->contentRow($strings["comments"], nl2br($documentsApprovalDetail->dap_comments[0]));
    $mail->contentRow($strings["type"], $approvalDocType[$doctype]);

    switch ($doctype) {
        case ADT_FILE:
            $mail->contentRow($strings["name"], $fileDetail->fil_name[0]);
            $mail->contentRow($strings["vc_version"], $fileDetail->fil_vc_version[0]);
            $mail->contentRow($strings["ifc_last_date"], $fileDetail->fil_date[0]);
            $mail->contentRow($strings["size"], $fileDetail->fil_size[0]);
            break;
        case ADT_TIMESHEET:
            $mail->contentRow($strings["period"], $timesheetDetail->tim_per_date_start[0] . '&nbsp;~&nbsp;' . $timesheetDetail->tim_per_date_end[0]);
            $mail->contentRow($strings["standard"], $timesheetDetail->tim_standard_hours[0]);
            $mail->contentRow($strings["actual"], $timesheetDetail->tim_actual_hours[0]);
            $mail->contentRow($strings["overtime"], $timesheetDetail->tim_overtime_hours[0]);
            $mail->contentRow($strings["billable"], $timesheetDetail->tim_billable_hours[0]);
            break;
        case ADT_LEAVEREQUEST:
            $mail->contentRow($strings["type"], $hourCodeArray[$leaveRequestDetail->lea_type[0]]);
            $mail->contentRow($strings["time_start"], $leaveRequestDetail->lea_date_start[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_start[0]));
            $mail->contentRow($strings["time_end"], $leaveRequestDetail->lea_date_end[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_end[0]));
            $mail->contentRow($strings["hours"], $leaveRequestDetail->lea_hours[0]);
            break;
        case ADT_EXPENSE:
            $mail->contentRow($strings["project"], $expenseDetail->exp_pro_name[0]);
            $mail->contentRow($strings["claim_type"], $claimType[$expenseDetail->exp_claimtype[0]]);
            $mail->contentRow($strings["trip_type"], $tripType[$expenseDetail->exp_triptype[0]]);
            $mail->contentRow($strings["expense_type"], $expenseType['sets'][$expenseDetail->exp_expensetype[0]]);
            $mail->contentRow($strings["bill_client"], $bill_client);
            $mail->contentRow($strings["amount"], $amount);
            break;
        case ADT_PROJECT:
            $mail->contentRow($strings["name"], $projectDetail->pro_name[0]);
            $mail->contentRow($strings["priority"], $priority[$projectDetail->pro_priority[0]]);
            $mail->contentRow($strings["description"], $projectDetail->pro_description[0]);
            $mail->contentRow($strings["organization"], $projectDetail->pro_org_name[0]);
            $mail->contentRow($strings["type"], $projectType[$projectDetail->pro_type[0]]);

            if ($project_budget != '') {
                if ($currencyOnRight == 'true') {
                    $mail->contentRow($strings["budget"], $project_budget . ' ' . $currency_display);
                } else {
                    $mail->contentRow($strings["budget"], $currency_display . ' ' . $project_budget);
                }
            }

            break;
    }

    for ($j=0; $j<count($att_name); $j++) {
        $mail->AddAttachment($att_path[$j], $att_name[$j]);
    }

    $mail->contentTitle($strings["approval_history"]);
    $mail->contentRow('', $ah);
    $mail->closeContent();

    switch ($doctype) {
        case ADT_FILE:
            $mail->note("$root/general/login.php?url=linkedcontent/viewfile.php%3Fid=$num");
            break;
        case ADT_TIMESHEET:
            $mail->note("$root/general/login.php?url=timesheet/viewtimesheet.php%3Fid=$num");
            break;
        case ADT_LEAVEREQUEST:
            $mail->note("$root/general/login.php?url=leaves/viewleaverequest.php%3Fid=$num");
            break;
        case ADT_EXPENSE:
            $mail->note("$root/general/login.php?url=expenses/viewexpense.php%3Fid=$num");
            break;
        case ADT_PROJECT:
            $mail->note("$root/general/login.php?url=projects/viewproject.php%3Fid=$num");
            break;
    }

    $mail->closeBody();
    $subject = $mail->partSubject;
    $mail->Subject = $subject;
    $mail->Priority = $mail_priority;
    $mail->Send();
}

?>
