<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewapprovaltemplate.php,v 1.6 2009/09/16 02:11:04 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$msg = isset($_POST['msg'])?$_POST['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE app.id=$id";
$approvalDetail = new request();
$approvalDetail->openApprovals($tmpquery);
$comptApprovalDetail = count($approvalDetail->app_id);

if ($comptApprovalDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
$tmpquery = " WHERE apd.approval=$id ORDER BY apd.exclude";
$listApprovalProducers = new request();
$listApprovalProducers->openApprovalsProducers($tmpquery);
$comptListApprovalProducers = count($listApprovalProducers->apd_approval);
$tmpquery = " WHERE apt.approval=$id";
$listApprovalTerms = new request();
$listApprovalTerms->openApprovalsTerms($tmpquery);
$comptListApprovalTerms = count($listApprovalTerms->apt_id);
$tmpquery = " WHERE aps.approval=$id ORDER BY aps.sortid";
$listApprovalStages = new request();
$listApprovalStages->openApprovalsStages($tmpquery);
$comptListApprovalStages = count($listApprovalStages->aps_approval);

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovaltemplates.php?", lang_strings("approval_templates"), in));
$blockPage->itemBreadcrumbs($approvalDetail->app_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "vAp";
$block1->openForm('../approvals/viewapprovaltemplate.php?id=' . $id . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_template') . ' : ' . $approvalDetail->app_name[0]);
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, 'remove', lang_strings('delete'));
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'edit', lang_strings('edit'));
}

$block1->paletteIcon(2, 'export', lang_strings('export'));
$block1->closePaletteIcon();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesMore");
}

$block1->openContent();
$block1->contentTitle(lang_strings('info'));
$block1->contentRow(lang_strings('name'), $approvalDetail->app_name[0]);
$block1->contentRow(lang_strings('description'), nl2br(html_entity_decode($approvalDetail->app_comments[0], ENT_QUOTES, $htmlEntityCharset)));
$block1->contentRow(lang_strings('document'), $approvalDocType[$approvalDetail->app_doctype[0]]);
$block1->contentRow(lang_strings("active_str"), (($approvalDetail->app_active[0] == 'Y')?lang_strings("yes"):lang_strings("no")));
$block1->closeContent();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

$block1->openContent();
$block1->contentTitle(lang_strings('launch_approval'));

if ($approvalDetail->app_conditions[0] == 'Y') {
    $block1->contentRow(lang_strings("when_following"), '', 'false', '');

    for ($i=0, $c=''; $i<$comptListApprovalTerms; $i++, $c=lang_strings('op_and')) {
        if ($listApprovalTerms->apt_compare_fields[$i] == 'Y') {
            $block1->contentRow($c, $listApprovalTerms->apt_fieldname[$i] . ' ' . $ratioArray[$listApprovalTerms->apt_ratio[$i]] . ' ' . $listApprovalTerms->apt_value[$i] . '(' . lang_strings('compare_fields') . ')', "false", "");
        } else {
            if (array_key_exists($listApprovalTerms->apt_fieldname[$i], $fieldValidValue[$approvalDetail->app_doctype[0]])) {
                $vla = explode(',', $listApprovalTerms->apt_value[$i]);
                unset($vl);

                foreach ($vla as $v) {
                    $vl[] = $fieldValidValue[$approvalDetail->app_doctype[0]][$listApprovalTerms->apt_fieldname[$i]][$v];
                }

                $value = implode(',', $vl);
            } else {
                $value = $listApprovalTerms->apt_value[$i];
            }

            $block1->contentRow($c, $listApprovalTerms->apt_fieldname[$i] . ' ' . $ratioArray[$listApprovalTerms->apt_ratio[$i]] . ' ' . $value, "false", "");
        }
    }
} else {
    $block1->contentRow(lang_strings("always"), '', 'false', '');
}

$block1->closeContent();
$block1->openContent();
$block1->contentTitle(lang_strings("originators"));

for ($i=0, $c=''; $i<$comptListApprovalProducers; $i++, $c=lang_strings('op_or')) {
    $rval = $producerType[$listApprovalProducers->apd_producer_type[$i]] . '&nbsp;';

    switch ($listApprovalProducers->apd_producer_type[$i]) {
        case PT_USER:
            $rval .= $block1->buildLink('../users/viewuser.php?id=' . $listApprovalProducers->apd_producer[$i], $listApprovalProducers->apd_producer_name[$i], 'in');
            break;
        case PT_PROFILE:
            $rval .= $profil[$listApprovalProducers->apd_producer[$i]];
            break;
        case PT_DEPARTMENT:
            $rval .= $listApprovalProducers->apd_producer_name[$i];
            break;
        case PT_TEAM:
            $rval .= $block1->buildLink('../projects/viewproject.php?id=' . $listApprovalProducers->apd_producer[$i], $listApprovalProducers->apd_producer_name[$i], 'in');
            break;
    }

    if ($listApprovalProducers->apd_exclude[$i] == 'Y') {
        $block1->contentRow(lang_strings('exclude'), $rval, "false", "");
    } else {
        $block1->contentRow($c, $rval, "false", "");
    }
}

$block1->closeContent();
$block1->openContent();
$block1->contentTitle(lang_strings("stages"));

for ($i=0; $i<$comptListApprovalStages; $i++) {
    $block1->contentRow($i+1, $block1->buildLink('../approvals/viewapprovalstage.php?id=' . $listApprovalStages->aps_confirmation_level[$i], $listApprovalStages->aps_con_name[$i], 'in'));
}

$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../approvals/deleteapprovaltemplates.php?id=' . $id, 'true,true,false', lang_strings('delete'));
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'edit', '../approvals/editapprovaltemplate.php?id=' . $id, 'true,true,false', lang_strings('edit'));
}

$block1->paletteScript(2, 'export', '../approvals/exportapprovaltemplates.php?id=' . $id, 'true,true,true', lang_strings('export'));
$block1->closePaletteScript('', '');

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>