<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewdocument.php,v 1.7 2009/09/01 15:01:16 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE daa.document_approval=$id AND daa.authorizer=$idSession AND daa.stage=dap.current_stage AND dap.closed='N' ORDER BY dap.created";
$documentsApprovalAuthorizerDetail = new request();
$documentsApprovalAuthorizerDetail->openDocumentsApprovalAuthorizers($tmpquery);
$comptDocumentsApprovalAuthorizerDetail = count($documentsApprovalAuthorizerDetail->daa_document_approval);

if ($comptDocumentsApprovalAuthorizerDetail == "1") {
    if ($documentsApprovalAuthorizerDetail->daa_dap_canceled[0] == 'Y') {
        header("Location: ../general/home.php?msg=docCanceled");
        exit;
    } else {
        $tmpquery = " WHERE dap.id=$id";
        $documentsApprovalDetail = new request();
        $documentsApprovalDetail->openDocumentsApproval($tmpquery);
        $doctype = $documentsApprovalDetail->dap_doctype[0];
        $num = $documentsApprovalDetail->dap_docid[0];
    }
} else {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == 'approve') {
    switch ($doctype) {
        case ADT_FILE:
            header("Location: ../linkedcontent/approvefile.php?id=$num&doc=$id");
            exit;
        case ADT_TIMESHEET:
            header("Location: ../timesheet/approvetimesheet.php?id=$num&doc=$id");
            exit;
        case ADT_LEAVEREQUEST:
            header("Location: ../leaves/approveleaverequest.php?id=$num&doc=$id");
            exit;
        case ADT_EXPENSE:
            header("Location: ../expenses/approveexpense.php?id=$num&doc=$id");
            exit;
        case ADT_PROJECT:
            header("Location: ../projects/approveproject.php?id=$num&doc=$id");
            exit;
    }
} else if ($action == 'reject') {
    switch ($doctype) {
        case ADT_FILE:
            header("Location: ../linkedcontent/rejectfile.php?id=$num&doc=$id");
            exit;
        case ADT_TIMESHEET:
            header("Location: ../timesheet/rejecttimesheet.php?id=$num&doc=$id");
            exit;
        case ADT_LEAVEREQUEST:
            header("Location: ../leaves/rejectleaverequest.php?id=$num&doc=$id");
            exit;
        case ADT_EXPENSE:
            header("Location: ../expenses/rejectexpense.php?id=$num&doc=$id");
            exit;
        case ADT_PROJECT:
            header("Location: ../projects/rejectproject.php?id=$num&doc=$id");
            exit;
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../general/home.php', lang_strings('home'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('view_document'));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = 'vDo';
$block1->openForm('../approvals/viewdocument.php?id=' . $id . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('view_document'));
$block1->openContent();
echo '<input type="hidden" id="action" name="action" value=""/>';
$block1->contentTitle(lang_strings('info'));
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($documentsApprovalDetail->dap_mem_email_work[0], $documentsApprovalDetail->dap_mem_name[0], 'mail'));
$block1->contentRow(lang_strings("comments"), nl2br($documentsApprovalDetail->dap_comments[0]));
$block1->contentRow(lang_strings("status"), $statusDocumentApproval[$documentsApprovalAuthorizerDetail->daa_status[0]]);
$block1->contentRow(lang_strings('modify_last_time'), $documentsApprovalAuthorizerDetail->daa_modified[0]);
$block1->contentRow(lang_strings("type"), $approvalDocType[$doctype]);
$block1->contentTitle(lang_strings('details'));

switch ($doctype) {
    case ADT_FILE:
        $tmpquery = " WHERE fil.id=$num";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../linkedcontent/viewfile.php?id=' . $num . '&amp;doc_id=' . $fileDetail->fil_parent[0], lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("name"), $fileDetail->fil_name[0] . $viewLink);
        $block1->contentRow(lang_strings("vc_version"), $fileDetail->fil_vc_version[0]);
        $block1->contentRow(lang_strings("ifc_last_date"), $fileDetail->fil_date[0]);
        $block1->contentRow(lang_strings("size"), $fileDetail->fil_size[0]);
        break;
    case ADT_TIMESHEET:
        $tmpquery = " WHERE tim.id=$num";
        $timesheetDetail = new request();
        $timesheetDetail->openTimesheet($tmpquery);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../reports/hours.php?S_ATSEL=' . $documentsApprovalDetail->dap_owner[0] . '&amp;S_BILLING=ALL&amp;S_COMPLETEDATE=DATERANGE&amp;S_SDATE2=' . $timesheetDetail->tim_per_date_start[0] . '&amp;S_EDATE2=' . $timesheetDetail->tim_per_date_end[0], lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("period"), $timesheetDetail->tim_per_date_start[0] . '&nbsp;~&nbsp;' . $timesheetDetail->tim_per_date_end[0] . $viewLink);
        $block1->contentRow(lang_strings("standard"), $timesheetDetail->tim_standard_hours[0]);
        $block1->contentRow(lang_strings("actual"), $timesheetDetail->tim_actual_hours[0]);
        $block1->contentRow(lang_strings("overtime"), $timesheetDetail->tim_overtime_hours[0]);
        $block1->contentRow(lang_strings("billable"), $timesheetDetail->tim_billable_hours[0]);
        break;
    case ADT_LEAVEREQUEST:
        $tmpquery = " WHERE lea.id=$num";
        $leaveRequestDetail = new request();
        $leaveRequestDetail->openLeaveRequests($tmpquery);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../leaves/viewleaverequest.php?id=' . $num, lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("type"), $hourCodeArray[$leaveRequestDetail->lea_type[0]]);
        $block1->contentRow(lang_strings("time_start"), $leaveRequestDetail->lea_date_start[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_start[0]));
        $block1->contentRow(lang_strings("time_end"), $leaveRequestDetail->lea_date_end[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_end[0]));
        $block1->contentRow(lang_strings("hours"), $leaveRequestDetail->lea_hours[0] . $viewLink);
        break;
    case ADT_EXPENSE:
        $tmpquery = " WHERE exp.id=$num";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($tmpquery);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../expenses/viewexpense.php?id=' . $num, lang_strings("view"), 'in');
        $bill_client = ($expenseDetail->exp_billable[0]=='Y')?lang_strings('yes'):lang_strings('no');

        if ($currencyOnRight == 'true') {
            $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
        } else {
            $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
        }

        $block1->contentRow(lang_strings("project"), $expenseDetail->exp_pro_name[0]);
        $block1->contentRow(lang_strings("claim_type"), $claimType[$expenseDetail->exp_claimtype[0]]);
        $block1->contentRow(lang_strings("trip_type"), $tripType[$expenseDetail->exp_triptype[0]]);
        $block1->contentRow(lang_strings("expense_type"), $expenseType['sets'][$expenseDetail->exp_expensetype[0]]);
        $block1->contentRow(lang_strings("bill_client"), $bill_client);
        $block1->contentRow(lang_strings("amount"), $amount . $viewLink);
        break;
    case ADT_PROJECT:
        $tmpquery = " WHERE pro.id=$num";
        $projectDetail = new request();
        $projectDetail->openProjects($tmpquery);
        // get Project Budget
        $tmpquery = " WHERE pjb.project=$num";
        $listProjectBudget = new request();
        $listProjectBudget->openProjectsBudget($tmpquery);
        $comptListProjectBudget = count($listProjectBudget->pjb_project);

        if ($projectDetail->pro_currency[0] == '') {
            $currency_display = $defaultCurrency;
        } else {
            $currency_display = $projectDetail->pro_currency[0];
        }

        if ($comptListProjectBudget == '0') {
            $project_budget = '';
        } else {
            if ($projectDetail->pro_currency[0] == '') {
                $currSets = array();

                foreach ($listProjectBudget->pjb_currency as $curr) {
                    if ($curr != $defaultCurrency && !in_array($curr, $currSets)) {
                        $currSets[] = $curr;
                    }
                }

                $currStr = "'" . implode("','", $currSets) . "'";
                $tmpquery = " WHERE cur.currency_to='$defaultCurrency' AND cur.currency_from IN ($currStr) AND cur.reference_date<='" . substr($dateheure, 0, 10) . "'";
                $listCurrencyRates = new request();
                $listCurrencyRates->openCurrencyRates($tmpquery);
                $comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

                if ($comptListCurrencyRates != count($currSets)) {
                    $project_budget = '';
                } else {
                    $project_budget = 0;

                    for ($i=0; $i<$comptListProjectBudget; $i++) {
                        if ($listProjectBudget->pjb_currency[$i] == $defaultCurrency) {
                            $amount = $listProjectBudget->pjb_amount[$i];
                        } else {
                            $idx = array_search($listProjectBudget->pjb_currency[$i], $listCurrencyRates->cur_currency_from);
                            $rate = $listCurrencyRates->cur_exchange_rate[$idx];
                            $amount = round($listProjectBudget->pjb_amount[$i] * $rate, $costAccuracy);
                        }

                        $project_budget += $amount;
                    }
                }
            } else {
                $project_budget = 0;

                for ($i=0; $i<$comptListProjectBudget; $i++) {
                    $project_budget += $listProjectBudget->pjb_amount[$i];
                }
            }
        }

        $block1->contentRow(lang_strings("name"), $projectDetail->pro_name[0]);
        $block1->contentRow(lang_strings("priority"), $priority[$projectDetail->pro_priority[0]]);
        $block1->contentRow(lang_strings("description"), $projectDetail->pro_description[0]);
        $block1->contentRow(lang_strings("organization"), $projectDetail->pro_org_name[0]);
        $block1->contentRow(lang_strings("type"), $projectType[$projectDetail->pro_type[0]]);

        if ($project_budget != '') {
            if ($currencyOnRight == 'true') {
                $block1->contentRow(lang_strings("budget"), $project_budget . ' ' . $currency_display);
            } else {
                $block1->contentRow(lang_strings("budget"), $currency_display . ' ' . $project_budget);
            }
        }

        break;
}

$block1->contentTitle(lang_strings("approval_history"));
$tmpquery = " WHERE dap.docid=$num AND dap.doctype='" . $doctype . "' ORDER BY dap.id";
$listDocumentsApproval = new request();
$listDocumentsApproval->openDocumentsApproval($tmpquery);
$comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

for ($i=0,$ah=''; $i<$comptListDocumentsApproval; $i++,$ah.='<br>') {
    if ($i == 0) {
        $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['submit_at']) . '</i>';
    } else {
        $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['resubmit_at']) . '</i>';
    }

    $tmpquery = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . AS_PENDING . "' ORDER BY daa.created,daa.modified";
    $listDocumentsApprovalAuthorizer = new request();
    $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($tmpquery);
    $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

    for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
        $ahd = '';

        if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_APPROVED) {
            $ahd = $strings['approval_history_approved'];
        } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_NOT_APPROVED) {
            $ahd = $strings['approval_history_rejected'];
        }

        if ($ahd != '') {
            $ahd = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
            $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], $timezoneSession), $ahd);
            $ah .= '<br><i>' . $ahd  . '</i>';

            if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                $ah .= '<br>' . nl2br($listDocumentsApprovalAuthorizer->daa_comments[$j]);
            }
        }
    }
}

$block1->contentRow('', $ah);
$block1->contentRow('', '
<input type="SUBMIT" value="' . $strings['approve'] . '" onclick="document.getElementById(\'action\').value=\'approve\';">&nbsp;&nbsp;
<input type="SUBMIT" value="' . $strings['reject'] . '" onclick="document.getElementById(\'action\').value=\'reject\';">
');
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>