<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editclient.php,v 1.23 2009/11/02 05:57:26 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$icp = isset($_GET['icp'])?$_GET['icp']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$logoDel = isset($_POST['logoDel'])?$_POST['logoDel']:'';
$extensionOld = isset($_POST['extensionOld'])?$_POST['extensionOld']:'';
$cn = isset($_POST['cn'])?$_POST['cn']:'';
$add = isset($_POST['add'])?$_POST['add']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$wp = isset($_POST['wp'])?$_POST['wp']:'';
$fa = isset($_POST['fa'])?$_POST['fa']:'';
$url = isset($_POST['url'])?$_POST['url']:'';
$email = isset($_POST['email'])?$_POST['email']:'';
$cown = isset($_POST['cown'])?$_POST['cown']:'';
$curr = isset($_POST['curr'])?$_POST['curr']:'';
$bodyCommand = 'onLoad="document.edCForm.cn.focus();"';

/**
 * Permission check
 */
if ($id != '') {
    // test exists selected client organization, redirect to list if not
    $tmpquery = " WHERE org.id=$id";
    $clientDetail = new request();
    $clientDetail->openOrganizations($tmpquery);
    $comptClientDetail = count($clientDetail->org_id);

    if ($comptClientDetail == '0') {
        header('Location: ../clients/listclients.php?msg=blankClient');
        exit;
    }

    if (!$SW_Permissions['Client']['Edit'][$profilSession] && $clientDetail->org_owner[0] != $idSession) {
        header("Location: ../general/home.php?msg=permissiondenied");
        exit;
    }
} else if (!$SW_Permissions['Client']['Write'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Fields Check
 */
if ($action != '') {
    // test if name blank
    if ($cn == '') {
        $error = lang_strings('blank_organization_field');
        $bodyCommand = 'onLoad="document.edCForm.cn.focus();"';
        $cn_highlight = true;
    } else if ($email != '' && !ValidateMail($email)) {
        $error = lang_strings("invalid_email");
        $bodyCommand = 'onLoad="document.myCForm.email.focus();document.edCForm.email.select();"';
        $email_highlight = true;
    }
}

/**
 * Actions
 */
if ($action != '' && $error == '') {
    $cn = HtmlEntitiesNOD($cn);
    $add = HtmlEntitiesNOD($add);
    $wp = HtmlEntitiesNOD($wp);
    $fa = HtmlEntitiesNOD($fa);
    $url = HtmlEntitiesNOD($url);
    $c = HtmlEntitiesNOD($c);

    if (strlen($add) > 254) {
        $add1 = substr($add, 0, 254);
        $add2 = substr($add, 254, 254);
    } else {
        $add1 = $add;
        $add2 = '';
    }

    if ($action == 'update') { // case update client organization
        if ($logoDel == 'on') {
            $tmpquery = 'UPDATE ' . $tableName['organizations'] . " SET extension_logo='' WHERE id=$id";
            connectSql($tmpquery);
            @unlink("../logos_clients/" . $id . ".$extensionOld");
        }

        $extension = strtolower(substr(strrchr($_FILES['upload']['name'], '.'), 1));

        if (@move_uploaded_file($_FILES['upload']['tmp_name'], '../logos_clients/' . $id . ".$extension")) {
            $tmpquery = 'UPDATE ' . $tableName['organizations'] . " SET extension_logo='$extension' WHERE id=$id";
            connectSql($tmpquery);
        }

        $tmpquery = 'UPDATE ' . $tableName['organizations'] . " SET name='$cn',address1='$add1',address2='$add2',phone='$wp',fax='$fa',url='$url',email='$email',comments='$c',owner=$cown, currency='$curr' WHERE id=$id";
        connectSql($tmpquery);
        header("Location: ../clients/viewclient.php?id=$id&msg=update");
        exit;
    } else if ($action == 'add') { // case add client organization
        // test if name already exists
        $tmpquery = " WHERE org.name='$cn'";
        $existsClient = new request();
        $existsClient->openOrganizations($tmpquery);
        $comptExistsClient = count($existsClient->org_id);

        if ($comptExistsClient != '0') {
            $error = lang_strings('organization_already_exists');
        } else {
            // insert into organizations and redirect to new client organization detail (last id)
            $tmpquery1 = "INSERT INTO " . $tableName["organizations"] . "(name,address1,address2,phone,fax,url,email,comments,created,owner,currency) VALUES('$cn','$add1','$add2','$wp','$fa','$url','$email','$c','$dateheures',$idSession,'$curr')";
            connectSql($tmpquery1);
            $num = last_id($tableName['organizations']);
            $extension = strtolower(substr(strrchr($upload_name, '.'), 1));

            if (@move_uploaded_file($upload, '../logos_clients/' . $num . ".$extension")) {
                $tmpquery = 'UPDATE ' . $tableName['organizations'] . " SET extension_logo='$extension' WHERE id=$num";
                connectSql($tmpquery);
            }

            if ($icp == 'true') {
                header("Location: ../projects/editproject.php?icp=true&organization=$num");
            } else {
                header("Location: ../clients/viewclient.php?id=$num&msg=add");
            }

            exit;
        }
    }
}

/**
 * Form variables init
 */
if ($error == '') {
    // set value in form
    if ($id != '') {
        $cn = $clientDetail->org_name[0];
        $add = $clientDetail->org_address[0];
        $wp = $clientDetail->org_phone[0];
        $fa = $clientDetail->org_fax[0];
        $url = $clientDetail->org_url[0];
        $email = $clientDetail->org_email[0];
        $c = $clientDetail->org_comments[0];
        $curr = $clientDetail->org_currency[0];
    } else {
        $cn = '';
        $add = '';
        $wp = '';
        $fa = '';
        $url = 'http://';
        $email = '';
        $c = '';
        $curr = '';
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/listclients.php?', lang_strings('clients'), in));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_organization'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/viewclient.php?id=' . $clientDetail->org_id[0], $clientDetail->org_name[0], in));
    $blockPage->itemBreadcrumbs(lang_strings('edit_organization'));
}

$blockPage->closeBreadcrumbs();

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "edC";

if ($id == '') {
    $block1->openForm('../clients/editclient.php?icp=' . $icp . '#' . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
} else {
    $block1->openForm("../clients/editclient.php?id=$id&icp=$icp#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
}

if ($id == '') {
    $block1->heading(lang_strings('add_organization'));
} else {
    $block1->heading(lang_strings('edit_organization') . ' : ' . $clientDetail->org_name[0]);
}

echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"100000000\">\n";
$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if (($clientsFilter == 'true') && ($SW_Permissions['Client']['Admin'][$profilSession])) {
    $selectOwner = '<select name="cown">';
    $tmpquery = " WHERE mem.profil IN ('" . PF_ADMINISTRATOR . "'";

    if ($SW_Permissions['Client']['Write'][PF_PROJECT_MANAGER]) {
        $tmpquery .= ",'" . PF_PROJECT_MANAGER . "'";
    }

    if ($SW_Permissions['Client']['Write'][PF_USER]) {
        $tmpquery .= ",'" . PF_USER . "'";
    }

    if ($SW_Permissions['Client']['Write'][PF_CLIENT_USER]) {
        $tmpquery .= ",'" . PF_CLIENT_USER . "'";
    }

    if ($SW_Permissions['Client']['Write'][PF_PROJECT_MANAGER_ADMINISTRATOR]) {
        $tmpquery .= ",'" . PF_PROJECT_MANAGER_ADMINISTRATOR . "'";
    }

    if ($SW_Permissions['Client']['Write'][PF_RESOURCE_MANAGER]) {
        $tmpquery .= ",'" . PF_RESOURCE_MANAGER . "'";
    }

    $tmpquery .= ") ORDER BY mem.name";
    $clientOwner = new request();
    $clientOwner->openMembers($tmpquery);
    $comptClientOwner = count($clientOwner->mem_id);

    for ($i = 0; $i < $comptClientOwner; $i++) {
        if ($clientDetail->org_owner[0] == $clientOwner->mem_id[$i] || $idSession == $clientOwner->mem_id[$i]) {
            $selectOwner .= '<option value="' . $clientOwner->mem_id[$i] . '" selected>' . $clientOwner->mem_name[$i] . '</option>';
        } else {
            $selectOwner .= '<option value="' . $clientOwner->mem_id[$i] . '">' . $clientOwner->mem_name[$i] . '</option>';
        }
    }

    $selectOwner .= '</select>';
    $block1->contentRow(lang_strings('owner'), $selectOwner);
} else {
    echo "<input type=\"hidden\" name=\"cown\" value=\"0\">\n";
}

if ($cn_highlight) {
    $block1->contentRow('* ' . lang_strings('name'), '<input size="44" value="' . str_replace('"', '&quot;', $cn) . '" class="input_text_highlight" name="cn" maxlength="254" type="TEXT">');
} else {
    $block1->contentRow('* ' . lang_strings('name'), '<input size="44" value="' . str_replace('"', '&quot;', $cn) . '" class="input_text" name="cn" maxlength="254" type="TEXT">');
}

$block1->contentRow(lang_strings('address'), '<textarea rows="3" class="textarea_3rows" name="add" cols="43">' . $add . '</textarea>');
$block1->contentRow(lang_strings('phone'), '<input size="32" value="' . str_replace('"', '&quot;', $wp) . '" class="input_text" name="wp" maxlength="154" type="TEXT">');
$block1->contentRow(lang_strings('fax'), '<input size="32" value="' . str_replace('"', '&quot;', $fa) . '" class="input_text" name="fa" maxlength="154" type="TEXT">');
$block1->contentRow(lang_strings('url'), '<input size="44" value="' . str_replace('"', '&quot;', $url) . '" class="input_text" name="url" maxlength="254" type="TEXT">');

if ($email_highlight) {
    $block1->contentRow(lang_strings('email'), '<input size="44" value="' . $email . '" class="input_text_highlight" name="email" maxlength="154" type="TEXT">');
} else {
    $block1->contentRow(lang_strings('email'), '<input size="44" value="' . $email . '" class="input_text" name="email" maxlength="154" type="TEXT">');
}

$helpStr = '<table>';
$currSel = '<select name="curr"><option value="">' . $strings['CRC'] . '</option>';

foreach ($CurrencyMatrix['name'] as $key => $val) {
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';

    if ($curr == $key) {
        $currSel .= '<option value="' . $key . '" selected>' . $key . '</option>';
    } else {
        $currSel .= '<option value="' . $key . '">' . $key . '</option>';
    }
}

$currSel .= '</select>';
$helpStr .= '</table>';
$block1->contentRow(lang_strings('currency') . '&nbsp;' . $blockPage->printHelp($helpStr, 'true'), $currSel);
$block1->contentRow(lang_strings('comments'), '<textarea rows="3" class="textarea_3rows" name="c" cols="43">' . $c . '</textarea>');
$block1->contentRow(lang_strings('logo'), '<input size="44" class="input_text" name="upload" type="file" accept="image/png, image/gif, image/jpeg, image/jpg">');

if ($id != '') {
    if (file_exists('../logos_clients/' . $id . '.' . $clientDetail->org_extension_logo[0])) {
        $block1->contentRow('', '<img src="../logos_clients/' . $id . '.' . $clientDetail->org_extension_logo[0] . '"> <input name="extensionOld" type="hidden" value="' . $clientDetail->org_extension_logo[0] . '"><input name="logoDel" type="checkbox" value="on"> ' . lang_strings('delete'));
    }
}

$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
