<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listclients.php,v 1.16 2009/11/10 09:10:19 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$view = isset($_GET['view'])?$_GET['view']:'this_year';

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('clients'));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'clientList';
$block1->openForm('../clients/listclients.php#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('organizations'));
$block1->openPaletteIcon();

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', lang_strings('add'));
}

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
}

$block1->paletteIcon(2, 'info', lang_strings('view'));

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', lang_strings('edit'));
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('organizations', $sortingUser->sor_organizations[0], 'org.name ASC', $sortingFields = array(0 => 'org.name', 1 => 'num_open', 2 => 'num_complete', 3 => 'org.phone', 4 => 'org.fax', 5 => 'org.url'));

if ($clientsFilter == 'true') {
    if ($SW_Permissions['Client']['Admin'][$profilSession]) {
        $tmpquery = " WHERE org.id!=1 ORDER BY $block1->sortingValue";
    } else {
        $tmpquery = " WHERE org.id!=1 AND ((org.owner=$idSession) OR (EXISTS (SELECT * FROM " . $tableName['teams'] . " tea LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=tea.project WHERE tea.member=$idSession AND pro.organization=org.id))) ORDER BY $block1->sortingValue";
    }
} else {
    $tmpquery = " WHERE org.id!=1 ORDER BY $block1->sortingValue";
}

$block1->recordsTotal = compt($initrequest['organizations'] . ' ' . $tmpquery);
$listOrganizations = new request();

switch ($view) {
    case 'this_year':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, 1, 1, intval(date('Y'))));
        $dateto = date('Y-m-d', mktime(12, 0, 0, 12, 31, intval(date('Y'))));
        break;
    case 'recent_month':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n'))-1, intval(date('j'))+1, intval(date('Y'))));
        $dateto = date('Y-m-d');
        break;
    case 'recent_quarter':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n'))-3, intval(date('j'))+1, intval(date('Y'))));
        $dateto = date('Y-m-d');
        break;
    case 'recent_year':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y'))-1));
        $dateto = date('Y-m-d');
        break;
}

$listOrganizations->openOrganizations2($tmpquery, $datefrom, $dateto, $block1->borne, $block1->rowsLimit);
$comptListOrganizations = count($listOrganizations->org_id);

if ($comptListOrganizations != '0') {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('open') . ' *', 2 => lang_strings('completed') . ' **', 3 => lang_strings('phone'), 4 => lang_strings('fax'), 5 => lang_strings('url')), 'false');

    for ($i = 0; $i < $comptListOrganizations; $i++) {
        $block1->openRow();
        $block1->checkboxRow($listOrganizations->org_id[$i]);
        $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $listOrganizations->org_id[$i], $listOrganizations->org_name[$i], in));

        if ($listOrganizations->org_num_open[$i] == '0') {
            $block1->cellRow('0');
        } else {
            $block1->cellRow($blockPage->buildLink('../projects/listprojects.php?client=' . $listOrganizations->org_id[$i] . '&cstatus=open&cnum=' . $listOrganizations->org_num_open[$i], $listOrganizations->org_num_open[$i], 'in'));
        }

        if ($listOrganizations->org_num_complete[$i] == '0') {
            $block1->cellRow('0');
        } else {
            $block1->cellRow($blockPage->buildLink('../projects/listprojects.php?client=' . $listOrganizations->org_id[$i] . '&cview=' . $view . '&datefrom=' . $datefrom . '&dateto=' . $dateto . '&cstatus=completed&cnum=' . $listOrganizations->org_num_complete[$i], $listOrganizations->org_num_complete[$i], 'in'));
        }

        $block1->cellRow($listOrganizations->org_phone[$i]);
        $block1->cellRow($listOrganizations->org_fax[$i]);
        $block1->cellRow($blockPage->buildLink($listOrganizations->org_url[$i], $listOrganizations->org_url[$i], 'out'));
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "");
    $linkStr = '';

    foreach (array('this_year','recent_month','recent_quarter','recent_year') as $val) {
        if ($linkStr != '') {
            $linkStr .= "&nbsp;|&nbsp;";
        }

        if ($val == $view) {
            $linkStr .= lang_strings($val);
        } else {
            $linkStr .= $blockPage->buildLink('../clients/listclients.php?view=' . $val, lang_strings($val), 'in');
        }
    }

    $block1->note("*&nbsp;" . lang_strings('num_open_project') . "<br>**&nbsp;" . lang_strings('num_completed_project') . "&nbsp;&nbsp;&nbsp;&nbsp;" . $linkStr);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../clients/editclient.php?', 'true,false,false', lang_strings('add'));
}

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../clients/deleteclients.php?', 'false,true,true', lang_strings('delete'));
}

$block1->paletteScript(2, 'info', '../clients/viewclient.php?', 'false,true,false', lang_strings('view'));

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../clients/editclient.php?', 'false,true,false', lang_strings('edit'));
}

$block1->closePaletteScript($comptListOrganizations, $listOrganizations->org_id);
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
