<?php // $Revision: 1.26 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewclient.php,v 1.26 2009/11/10 08:45:17 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($clientsFilter == 'true') {
    if ($SW_Permissions['Client']['Admin'][$profilSession]) {
        $tmpquery = " WHERE org.id=$id";
    } else {
        $tmpquery = " WHERE org.owner=$idSession AND org.id=$id";
        $clientDetail = new request();
        $clientDetail->openOrganizations($tmpquery);
        $comptClientDetail = count($clientDetail->org_id);

        if ($comptClientDetail == "0") {
            $tmpquery = " WHERE tea.member=$idSession AND org2.id=$id";
            $memberTest = new request();
            $memberTest->openTeams($tmpquery);
            $comptMemberTest = count($memberTest->tea_id);

            if ($comptMemberTest == "0") {
                header('Location: ../clients/listclients.php?msg=permissiondenied');
                exit;
            }

            $tmpquery = " WHERE org.id=$id";
        }
    }
} else {
    $tmpquery = " WHERE org.id=$id";
}

$clientDetail = new request();
$clientDetail->openOrganizations($tmpquery);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header('Location: ../clients/listclients.php?msg=blankClient');
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/listclients.php?', lang_strings('clients'), in));
$blockPage->itemBreadcrumbs($clientDetail->org_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = 'ecD';
$block1->openForm('../projects/listprojects.php#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('organization') . ' : ' . $clientDetail->org_name[0]);

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, 'remove', lang_strings('delete'));
    $block1->paletteIcon(1, 'edit', lang_strings('edit'));
    $block1->closePaletteIcon();
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($clientsFilter == 'true') {
    $block1->contentRow(lang_strings('owner'), $blockPage->buildLink('../users/viewuser.php?id=' . $clientDetail->org_mem_id[0], $clientDetail->org_mem_login[0], 'in'));
}

$block1->contentRow(lang_strings('name'), $clientDetail->org_name[0]);
$block1->contentRow(lang_strings('address'), nl2br($clientDetail->org_address[0]));
$block1->contentRow(lang_strings('phone'), $clientDetail->org_phone[0]);
$block1->contentRow(lang_strings('fax'), $clientDetail->org_fax[0]);
$block1->contentRow(lang_strings('url'), $blockPage->buildLink($clientDetail->org_url[0], $clientDetail->org_url[0], 'out'));
$block1->contentRow(lang_strings('email'), $blockPage->buildLink($clientDetail->org_email[0], $clientDetail->org_email[0], mail));

if ($clientDetail->org_currency[0] == '') {
    $block1->contentRow(lang_strings('currency'), lang_strings('CRC'));
} else {
    $helpStr = $CurrencyMatrix['name'][$clientDetail->org_currency[0]];
    $block1->contentRow(lang_strings('currency') . '&nbsp;' . $blockPage->printHelp($helpStr, 'true'), $clientDetail->org_currency[0]);
}

$block1->contentRow(lang_strings('comments'), nl2br($clientDetail->org_comments[0]));
$block1->contentRow(lang_strings('created'), createDate($clientDetail->org_created[0], $timezoneSession));

if (file_exists('../logos_clients/' . $id . '.' . $clientDetail->org_extension_logo[0])) {
    $block1->contentRow(lang_strings('logo'), '<img src="../logos_clients/' . $id . '.' . $clientDetail->org_extension_logo[0] . '">');
}

$block1->closeContent();
$block1->closeForm();

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->openPaletteScript();
    $block1->paletteScript(0, 'remove', '../clients/deleteclients.php?id=' . $clientDetail->org_id[0], 'true,true,false', lang_strings('delete'));
    $block1->paletteScript(1, 'edit', '../clients/editclient.php?id=' . $clientDetail->org_id[0], 'true,true,false', lang_strings('edit'));
    $block1->closePaletteScript('', '');
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

$block2 = new block();
$block2->form = 'clPr';
$block2->openForm("../clients/viewclient.php?id=$id#" . $block2->form . 'Anchor');
$block2->headingToggle(lang_strings('client_projects'));
$block2->openPaletteIcon();

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    $block2->paletteIcon(0, 'add', lang_strings('add'));
}

if ($SW_Permissions['Project']['Admin'][$profilSession]) {
    $block2->paletteIcon(1, 'remove', lang_strings('delete'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block2->paletteIcon(2, 'info', lang_strings('view'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block2->paletteIcon(3, 'edit', lang_strings('edit'));
}

$block2->closePaletteIcon();
$block2->sorting('organization_projects', $sortingUser->sor_organization_projects[0], 'pro.name ASC', $sortingFields = array(0 => 'pro.id', 1 => 'pro.name', 2 => 'pro.priority', 3 => 'pro.status', 4 => 'mem.name', 5 => 'pro.published'));

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tmpquery = " LEFT OUTER JOIN " . $tableName["teams"] . " teams ON teams.project=pro.id ";
    $tmpquery .= " WHERE pro.organization=" . $clientDetail->org_id[0] . " AND teams.member=" . $idSession . " ORDER BY " . $block2->sortingValue;
} else {
    $tmpquery = " WHERE pro.organization=" . $clientDetail->org_id[0] . " ORDER BY " . $block2->sortingValue;
}

$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);

if ($comptListProjects != '0') {
    $block2->openResults();
    $block2->labels($labels = array(0 => lang_strings('id'), 1 => lang_strings('project'), 2 => lang_strings('priority'), 3 => lang_strings('status'), 4 => lang_strings('owner'), 5 => lang_strings('project_site')), 'true');

    for ($i = 0; $i < $comptListProjects; $i++) {
        $idStatus = $listProjects->pro_status[$i];
        $idPriority = $listProjects->pro_priority[$i];
        $block2->openRow();
        $block2->checkboxRow($listProjects->pro_id[$i]);
        $block2->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $listProjects->pro_id[$i], $listProjects->pro_id[$i], in));
        $block2->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $listProjects->pro_id[$i], $listProjects->pro_name[$i], in));
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
        $block2->cellRow('<img src="../themes/' . THEME . '/gfx_status/project_' . $idStatus . '.gif" alt="' . $statusProject[$idStatus] . '">&nbsp;' . $statusProject[$idStatus], '', true);
        $block2->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listProjects->pro_owner[$i], $listProjects->pro_mem_name[$i], 'in'));

        if ($sitePublish == 'true') {
            if ($listProjects->pro_published[$i] == '1') {
                $block2->cellRow('&lt;' . $blockPage->buildLink('../projects/addprojectsite.php?id=' . $listProjects->pro_id[$i], lang_strings('create') . '...', in) . '&gt;');
            } else {
                $block2->cellRow('&lt;' . $blockPage->buildLink('../projects/viewprojectsite.php?id=' . $listProjects->pro_id[$i], lang_strings('details'), in) . '&gt;');
            }
        }
    }

    $block2->closeResults();
} else {
    $block2->noresults();
}

$block2->closeToggle();
$block2->closeFormResults();
$block2->openPaletteScript();

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    $block2->paletteScript(0, 'add', '../projects/editproject.php?organization=' . $clientDetail->org_id[0], 'true,false,false', lang_strings('add'));
}

if ($SW_Permissions['Project']['Admin'][$profilSession]) {
    $block2->paletteScript(1, 'remove', '../projects/deleteproject.php?', 'false,true,false', lang_strings('delete'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block2->paletteScript(2, 'info', '../projects/viewproject.php?', 'false,true,false', lang_strings('view'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block2->paletteScript(3, 'edit', '../projects/editproject.php?', 'false,true,false', lang_strings('edit'));
}

$block2->closePaletteScript($comptListProjects, $listProjects->pro_id);

if ($sitePublish == 'true') {
    $block3 = new block();
    $block3->form = 'clU';
    $block3->openForm("../clients/viewclient.php?id=$id#" . $block3->form . 'Anchor');
    $block3->headingToggle(lang_strings('client_users'));
    $block3->openPaletteIcon();

    if ($SW_Permissions['Client']['Write'][$profilSession]) {
        $block3->paletteIcon(0, 'add', lang_strings('add'));
    }

    if ($SW_Permissions['Client']['Edit'][$profilSession]) {
        $block3->paletteIcon(1, 'remove', lang_strings('delete'));
    }

    if ($SW_Permissions['Client']['Read'][$profilSession]) {
        $block3->paletteIcon(2, 'info', lang_strings('view'));
    }

    if ($SW_Permissions['Client']['Edit'][$profilSession]) {
        $block3->paletteIcon(3, 'edit', lang_strings('edit'));
    }

    $block3->closePaletteIcon();
    $block3->sorting('users', $sortingUser->sor_users[0], 'mem.name ASC', $sortingFields = array(0 => 'mem.name', 1 => 'mem.login', 2 => 'mem.email_work', 3 => 'mem.profil', 4 => 'log.connected', 5 => 'mem.active'));
    $tmpquery = " WHERE mem.organization=$id ORDER BY " . $block3->sortingValue;
    $listMembers = new request();
    $listMembers->openMembers($tmpquery);
    $comptListMembers = count($listMembers->mem_id);

    if ($comptListMembers != '0') {
        $block3->openResults();
        $block3->labels($labels = array(0 => lang_strings('full_name'), 1 => lang_strings('user_name'), 2 => lang_strings('email'), 3 => lang_strings('work_phone'), 4 => lang_strings('connected'), 5 => lang_strings("active_user")), 'false');

        for ($i = 0; $i < $comptListMembers; $i++) {
            $block3->openRow();
            $block3->checkboxRow($listMembers->mem_id[$i]);
            $block3->cellRow($blockPage->buildLink('../users/viewclientuser.php?id=' . $listMembers->mem_id[$i] . "&amp;organization=$id", $listMembers->mem_name[$i], 'in'));
            $block3->cellRow($listMembers->mem_login[$i]);
            $block3->cellRow($blockPage->buildLink($listMembers->mem_email_work[$i], $listMembers->mem_email_work[$i], mail));
            $block3->cellRow($listMembers->mem_phone_work[$i]);

            if ($listMembers->mem_log_connected[$i] > $dateunix-5 * 60) {
                $block3->cellRow(lang_strings('yes') . ' (Client on project site)');
            } else {
                $block3->cellRow(lang_strings('no'));
            }

            if ($listMembers->mem_active[$i] == B_TRUE) {
                $block3->cellRow(lang_strings("yes"));
            } else {
                $block3->cellRow(lang_strings("no"));
            }
        }

        $block3->closeResults();
    } else {
        $block3->noresults();
    }

    $block3->closeToggle();
    $block3->closeFormResults();
    $block3->openPaletteScript();

    if ($SW_Permissions['Client']['Write'][$profilSession]) {
        $block3->paletteScript(0, 'add', '../users/addclientuser.php?organization=' . $id, 'true,false,false', lang_strings('add'));
    }

    if ($SW_Permissions['Client']['Edit'][$profilSession]) {
        $block3->paletteScript(1, 'remove', '../users/deleteclientusers.php?organization=' . $id, 'false,true,true', lang_strings('delete'));
    }

    if ($SW_Permissions['Client']['Read'][$profilSession]) {
        $block3->paletteScript(2, 'info', '../users/viewclientuser.php?organization=' . $id, 'false,true,false', lang_strings('view'));
    }

    if ($SW_Permissions['Client']['Edit'][$profilSession]) {
        $block3->paletteScript(3, 'edit', '../users/updateclientuser.php?organization=' . $id, 'false,true,false', lang_strings('edit'));
    }

    $block3->closePaletteScript($comptListMembers, $listMembers->mem_id);
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
