<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listexpenses.php,v 1.7 2009/09/01 15:01:17 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$project = isset($_GET['project'])?$_GET['project']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_expense[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("expenses"));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'exL';
$block1->openForm('../expenses/listexpenses.php?project=' . $project . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('expenses'));
$block1->openPaletteIcon();

if ($permissionDetail->prp_create_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, 'add', lang_strings('add'));
}

if ($permissionDetail->prp_delete_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
}

$block1->paletteIcon(2, 'info', lang_strings('view'));

if ($permissionDetail->prp_modify_expense_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', lang_strings('edit'));
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('expense', $sortingUser->sor_expenses[0], 'exp.docdate ASC', $sortingFields = array(0 => 'exp.docdate', 1 => 'mem.name', 2 => 'exp.status', 3 => 'exp.expensetype', 4 => 'exp.billable', 5 => 'exp.amount'));
$tmpquery = " WHERE exp.project=$project ORDER BY $block1->sortingValue";
$block1->recordsTotal = compt($initrequest['expenses'] . ' ' . $tmpquery);
$listExpenses = new request();
$listExpenses->openExpenses($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListExpenses = count($listExpenses->exp_id);

if ($comptListExpenses != '0') {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('date'), 1 => lang_strings('owner'), 2 => lang_strings('status'), 3 => lang_strings('expense_type'), 4 => lang_strings('bill_client'), 5 => lang_strings('amount')), 'false');

    for ($i=0; $i<$comptListExpenses; $i++) {
        $block1->openRow();
        $block1->checkboxRow($listExpenses->exp_id[$i]);
        $block1->cellRow($listExpenses->exp_docdate[$i]);
        $block1->cellRow($listExpenses->exp_mem_name[$i]);
        $block1->cellRow($statusFile[$listExpenses->exp_status[$i]]);
        $block1->cellRow($expenseType['sets'][$listExpenses->exp_expensetype[$i]]);
        $bill_client = ($listExpenses->exp_billable[$i]=='Y')?$strings['yes']:$strings['no'];
        $block1->cellRow($bill_client);

        if ($currencyOnRight == 'true') {
            $block1->cellRow($listExpenses->exp_amount[$i] . " " . $listExpenses->exp_currency[$i]);
        } else {
            $block1->cellRow($listExpenses->exp_currency[$i] . " " . $listExpenses->exp_amount[$i]);
        }

        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "");
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($permissionDetail->prp_create_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../expenses/editexpense.php?project=' . $project, 'true,false,false', lang_strings('add'));
}

if ($permissionDetail->prp_delete_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../expenses/deleteexpenses.php?project=' . $project, 'false,true,true', lang_strings('delete'));
}

$block1->paletteScript(2, 'info', '../expenses/viewexpense.php?', 'false,true,false', lang_strings('view'));

if ($permissionDetail->prp_modify_expense_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../expenses/editexpense.php?project=' . $project, 'false,true,false', lang_strings('edit'));
}

$block1->closePaletteScript($comptListExpenses, $listExpenses->exp_id);
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
