<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewexpense.php,v 1.10 2009/10/13 03:47:42 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$expense = isset($_GET['expense'])?$_GET['expense']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';

/**
 * Permission check
 */
if ($addToSiteFile == 'true' || $removeToSiteFile == 'true') {
    $tmpquery = " WHERE exp.id=$expense";
} else {
    $tmpquery = " WHERE exp.id=$id";
}

$expenseDetail = new request();
$expenseDetail->openExpenses($tmpquery);
$comptExpenseDetail = count($expenseDetail->exp_id);

if ($comptExpenseDetail != "1") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $expenseDetail->exp_project[0];
$status = $expenseDetail->exp_status[0];
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_expense[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

if ($action == 'publish') {
    if ($permissionDetail->prp_publish_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($addToSiteFile == 'true') {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "addToSite";
        $id = $expense;
    } else if ($removeToSiteFile == 'true') {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "removeToSite";
        $id = $expense;
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project, lang_strings("expenses"), 'in'));

if ($currencyOnRight == 'true') {
    $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
} else {
    $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
}

$blockPage->itemBreadcrumbs($expenseType['sets'][$expenseDetail->exp_expensetype[0]] . " " . $amount);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = 'vEx';
$block1->openForm('../expenses/viewexpense.php?id=' . $id . '#' . $block1->form . 'Anchor');
$block1->headingToggle(lang_strings('expense'));

if ($status != FS_NEEDS_APPROVAL && !periodLocked($expenseDetail->exp_docdate[0])) {
    $block1->openPaletteIcon();

    if ($permissionDetail->prp_delete_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(0, 'remove', lang_strings('delete'));
    }

    if ($permissionDetail->prp_modify_expense_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, 'edit', lang_strings('edit'));
    }

    $block1->closePaletteIcon();
}

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) && $layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('date'), $expenseDetail->exp_docdate[0]);
$block1->contentRow(lang_strings('owner'), $blockPage->buildLink('../users/viewuser.php?id=' . $expenseDetail->exp_owner[0], $expenseDetail->exp_mem_name[0], 'in'));
$block1->contentRow(lang_strings('description'), nl2br($expenseDetail->exp_description[0]));
$block1->contentRow(lang_strings('claim_type'), $claimType[$expenseDetail->exp_claimtype[0]]);
$block1->contentRow(lang_strings('trip_type'), $tripType[$expenseDetail->exp_triptype[0]]);
$block1->contentRow(lang_strings('expense_type') . '&nbsp;' . $blockPage->printHelp($expenseType['desc'][$expenseDetail->exp_expensetype[0]], 'true'), $expenseType['sets'][$expenseDetail->exp_expensetype[0]]);
$bill_client = ($expenseDetail->exp_billable[0]=='Y')?$strings['yes']:$strings['no'];
$block1->contentRow(lang_strings('bill_client'), $bill_client);
$block1->contentRow(lang_strings('amount') . '&nbsp;' . $blockPage->printHelp($CurrencyMatrix['name'][$expenseDetail->exp_currency[0]], 'true'), $amount);
$block1->contentRow(lang_strings('status'), $statusFile[$status]);

if ($status != FS_NO_APPROVALS_NEEDED) {
    $block1->contentTitle(lang_strings("approval_history"));
    $tmpquery = " WHERE dap.docid=$id AND dap.doctype='" . ADT_EXPENSE . "' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($tmpquery);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0,$ah=''; $i<$comptListDocumentsApproval; $i++,$ah.='<br>') {
        if ($i == 0) {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['submit_at']) . '</i>';
        } else {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['resubmit_at']) . '</i>';
        }

        $tmpquery = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . AS_PENDING . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($tmpquery);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_APPROVED) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_NOT_APPROVED) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], $timezoneSession), $ahd);
                $ah .= '<br><i>' . $ahd  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $ah .= '<br>' . nl2br($listDocumentsApprovalAuthorizer->daa_comments[$j]);
                }
            }
        }
    }

    $block1->contentRow('', $ah);
}

$block1->closeContent();
$block1->closeForm();

if ($status != FS_NEEDS_APPROVAL && !periodLocked($expenseDetail->exp_docdate[0])) {
    $block1->openPaletteScript();

    if ($permissionDetail->prp_delete_expense[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(0, 'remove', '../expenses/deleteexpenses.php?project=' . $project . '&id=' . $id, 'true,true,false', lang_strings('delete'));
    }

    if ($permissionDetail->prp_modify_expense_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(1, 'edit', '../expenses/editexpense.php?project=' . $project . '&id=' . $id, 'true,true,false', lang_strings('edit'));
    }

    $block1->closePaletteScript('', '');
}

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession])) {
    if ($layoutSession == LT_TWOPAGES) {
        $blockPage->turnPage();
    }

    $block2 = new block();
    $block2->form = "exF";
    $block2->openForm("../expenses/viewexpense.php?id=$id#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"));
    $block2->openPaletteIcon();

    if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(0, "add", lang_strings("add"));
     }

    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(1, "remove", lang_strings("delete"));
    }

    if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block2->paletteIcon(2, "add_projectsite", lang_strings("add_project_site"));
            $block2->paletteIcon(3, "remove_projectsite", lang_strings("remove_project_site"));
        }
    }

    $block2->paletteIcon(4, "info", lang_strings("view"));

    if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(5, "edit", lang_strings("edit"));
    }

    $block2->paletteIcon(6, "export", lang_strings("export"));
    $block2->closePaletteIcon();
    $block2->borne = $blockPage->returnBorne('1');
    $block2->sorting("files", $sortingUser->sor_files[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.extension', 1 => 'fil.name', 2 => 'fil.owner', 3 => 'fil.date', 4 => 'fil.status', 5 => 'fil.published'));
    $tmpquery = " WHERE fil.doc_type='" . DOC_EXPENSE . "' AND fil.doc_id=$id AND fil.vc_parent=0 ORDER BY $block2->sortingValue";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles != "0") {
        $block2->openResults();
        $block2->labels($labels = array(0 => lang_strings('type'), 1 => lang_strings('name'), 2 => lang_strings('owner'), 3 => lang_strings('date'), 4 => lang_strings('approval_tracking'), 5 => lang_strings('published')), 'true');
        require_once("../includes/files_types.php");

        for ($i=0; $i<$comptListFiles; $i++) {
            $idStatus = $listFiles->fil_status[$i];
            $idPublish = $listFiles->fil_published[$i];
            $type = file_info_type($listFiles->fil_extension[$i]);

            if (fileExists($listFiles->fil_fullname[$i])) {
                $existFile = 'true';
            } else {
                $existFile = 'false';
            }

            $block2->openRow();
            $block2->checkboxRow($listFiles->fil_id[$i]);

            if ($existFile == 'true') {
                $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_EXPENSE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $type, 'icone'));
            } else {
                $block2->cellRow('&nbsp;');
            }

            if ($existFile == 'true') {
                $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_EXPENSE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $listFiles->fil_name[$i], 'in'));
            } else {
                $block2->cellRow(lang_strings('missing_file') . ' (' . $listFiles->fil_name[$i] . ')');
            }

            $block2->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $listFiles->fil_owner[$i], $listFiles->fil_mem_name[$i], 'in'));
            $block2->cellRow($listFiles->fil_date[$i]);
            $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_EXPENSE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in'));

            if ($sitePublish == 'true') {
                $block2->cellRow($statusPublish[$idPublish]);
            }

            $block2->closeRow();
        }

        $block2->closeResults();
        $block2->bornesFooter('1', $blockPage->bornesNumber, '../linkedcontent/listfiles.php?doc_type=' . DOC_EXPENSE . '&doc_id=' . $id, 'id=' . $id);
    } else {
        $block2->noresults();
    }

    $block2->closeToggle();
    $block2->closeFormResults();
    $block2->openPaletteScript();

    if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(0, "add", "../linkedcontent/addfile.php?doc_type=" . DOC_EXPENSE . "&doc_id=$id", "true,false,false", lang_strings("add"));
     }

    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(1, "remove", "../linkedcontent/deletefiles.php?doc_type=" . DOC_EXPENSE . "&doc_id=$id", "false,true,true", lang_strings("delete"));
     }

    if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block2->paletteScript(2, "add_projectsite", "../expenses/viewexpense.php?addToSiteFile=true&expense=$id&action=publish", "false,true,true", lang_strings("add_project_site"));
            $block2->paletteScript(3, "remove_projectsite", "../expenses/viewexpense.php?removeToSiteFile=true&expense=$id&action=publish", "false,true,true", lang_strings("remove_project_site"));
        }
    }

    $block2->paletteScript(4, "info", "../linkedcontent/viewfile.php?doc_type=" . DOC_EXPENSE . "&doc_id=$id&", "false,true,false", lang_strings("view"));

    if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(5, "edit", "../linkedcontent/viewfile.php?edit=true&doc_type=" . DOC_EXPENSE . "&doc_id=$id&", "false,true,false", lang_strings("edit"));
    }

    $block2->paletteScript(6, "export", "../projects/accessfiles.php?zipfile=expense&project=$project", "false,true,true", lang_strings("export"));
    $block2->closePaletteScript($comptListFiles, $listFiles->fil_id);

    if ($layoutSession == LT_TWOPAGES) {
        $blockPage->closeTwoPages();
    }
}

$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
