<?php // $Revision: 1.15.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: defines.lib.php,v 1.15.2.1 2012/03/15 04:41:37 luiswang Exp $
 *
 * Copyright (c) 2012 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * DEFINES VARIABLES & CONSTANTS
 * Overview:
 *    NETOFFICE_USR_OS               (string) - the plateform (os) of the user
 *    NETOFFICE_USR_BROWSER_AGENT    (string) - the browser of the user
 *    NETOFFICE_USR_BROWSER_VER      (double) - the version of this browser
 */
// Determines platform (OS), browser and version of the user
// Based on a phpBuilder article:
//   see http://www.phpbuilder.net/columns/tim20000821.php
if (!defined('NETOFFICE_USR_OS')) {
    // loic1 - 2001/25/11: use the new globals arrays defined with
    // php 4.1+
    if (!empty($_SERVER['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
    } else if (!empty($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
    }
    // 1. Platform
    if (strstr($HTTP_USER_AGENT, 'Win')) {
        define('NETOFFICE_USR_OS', 'Win');
    } else if (strstr($HTTP_USER_AGENT, 'Mac')) {
        define('NETOFFICE_USR_OS', 'Mac');
    } else if (strstr($HTTP_USER_AGENT, 'Linux')) {
        define('NETOFFICE_USR_OS', 'Linux');
    } else if (strstr($HTTP_USER_AGENT, 'Unix')) {
        define('NETOFFICE_USR_OS', 'Unix');
    } else if (strstr($HTTP_USER_AGENT, 'OS/2')) {
        define('NETOFFICE_USR_OS', 'OS/2');
    } else {
        define('NETOFFICE_USR_OS', 'Other');
    }
    // 2. browser and version
    if (preg_match('/MSIE ([0-9].[0-9]{1,2})/', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'IE');
    } else if (preg_match('#Opera(/| )([0-9].[0-9]{1,2})#', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[2]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OPERA');
    } else if (preg_match('|OmniWeb/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OMNIWEB');
    } else if (preg_match('|Mozilla/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'MOZILLA');
    } else if (preg_match('|Konqueror/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'KONQUEROR');
    } else {
        define('NETOFFICE_USR_BROWSER_VER', 0);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OTHER');
    }
}

// Defines for status
DEFINE("ST_CLIENT_COMPLETED", "0");
DEFINE("ST_COMPLETED", "1");
DEFINE("ST_NOT_STARTED", "2");
DEFINE("ST_OPEN", "3");
DEFINE("ST_SUSPENDED", "4");

// Defines for project status
DEFINE("PJS_PROPOSED", "1");
DEFINE("PJS_CANCELED", "2");
DEFINE("PJS_CLIENT_COMPLETED", "3");
DEFINE("PJS_OPEN", "4");
DEFINE("PJS_COMPLETED", "5");
DEFINE("PJS_SUSPENDED", "6");

// Defines for profile
DEFINE("PF_ADMINISTRATOR", "0");
DEFINE("PF_PROJECT_MANAGER", "1");
DEFINE("PF_USER", "2");
DEFINE("PF_CLIENT_USER", "3");
DEFINE("PF_PROJECT_MANAGER_ADMINISTRATOR", "5");
DEFINE("PF_RESOURCE_MANAGER", "6");

// Defines for priority
DEFINE("PR_NONE", "0");
DEFINE("PR_VERY_LOW", "1");
DEFINE("PR_LOW", "2");
DEFINE("PR_MEDIUM", "3");
DEFINE("PR_HIGH", "4");
DEFINE("PR_VERY_HIGH", "5");

// Defines for publish status
DEFINE("PB_YES", "0");
DEFINE("PB_NO", "1");

// Defines for team authorization
DEFINE("TA_YES", "0");
DEFINE("TA_NO", "1");

// Defines for file status
DEFINE("FS_APPROVED", "0");
DEFINE("FS_APPROVED_WITH_CHANGES", "1");
DEFINE("FS_NEEDS_APPROVAL", "2");
DEFINE("FS_NO_APPROVALS_NEEDED", "3");
DEFINE("FS_NOT_APPROVED", "4");

// Defines for phase status
DEFINE("PS_NOT_STARTED", "0");
DEFINE("PS_OPEN", "1");
DEFINE("PS_COMPLETE", "2");
DEFINE("PS_SUSPENDED", "3");

// Defines for request status
DEFINE("RQ_NEW", "0");
DEFINE("RQ_OPEN", "1");
DEFINE("RQ_COMPLETE", "2");

// Defines for project type
DEFINE("PT_INTERNAL_PROJECT", "0");
DEFINE("PT_EXTERNAL_PROJECT", "1");

// Defines for fixed duration status
DEFINE("FD_YES", "0");
DEFINE("FD_NO", "1");

// Defines for milestone status
DEFINE("MS_YES", "0");
DEFINE("MS_NO", "1");

// Defines for task group status
DEFINE("TG_YES", "0");
DEFINE("TG_NO", "1");

// Defines for person evaluation status
DEFINE("PE_SUBMITTED", "0");
DEFINE("PE_OPEN", "1");

// Defines for work hours type
DEFINE("WT_PROJECT", "0");
DEFINE("WT_OTHERS", "1");
DEFINE("WT_SALES", "100");
DEFINE("WT_LEAVE", "101");

// Defines for day type
DEFINE("DT_WEEKEND", "0");
DEFINE("DT_STATUTORY_HOLIDAY", "1");
DEFINE("DT_MAKEUP_HOLIDAY", "2");
DEFINE("DT_WORKDAY", "3");

// Defines for billing flag
DEFINE("BF_YES", "0");
DEFINE("BF_NO", "1");

// Defines for layout type
DEFINE("LT_LONGLIST", "1");
DEFINE("LT_TWOPAGES", "0");

// Defines for leave type
DEFINE("LV_ANNUAL", 10100);
DEFINE("LV_SICK", 10101);
DEFINE("LV_ABSENCE", 10102);
DEFINE("LV_BANKHOLIDAY", 10103);
DEFINE("LV_MOURNING", 10104);
DEFINE("LV_HONEYMOON", 10105);
DEFINE("LV_MATERNITY", 10106);

// Defines for work type
DEFINE("WT_NONSPECIFIC_TASK", "0");
DEFINE("WT_SPECIFIC_TASK", "1");
DEFINE("WT_SPECIFIC_MEETING", "2");

// Defines for piecharts
DEFINE("PC_SIZE", 60);
DEFINE("PC_STARTANGLE", 20);
DEFINE("PC_ANGLE", 60);

// Defines for barcharts
DEFINE("BC_WIDTH", 160);
DEFINE("BC_HEIGHT", 20);
DEFINE("BC_VALUE_ANGLE", 30);

// Defines for analysis charts
DEFINE("AC_NONE", 0);
DEFINE("AC_PIE", 1);
DEFINE("AC_BAR", 2);

// Defines for netOffice Objects
DEFINE("NOO_PROJECT_COUNT", 11);
DEFINE("NOO_TASK_COUNT", 12);
DEFINE("NOO_LOG_HOURS", 13);
DEFINE("NOO_PROJECT_COST", 14);

// Defines for dimensions
DEFINE("D_CLIENT", 11);
DEFINE("D_PROJECT", 12);
DEFINE("D_STATUS", 21);
DEFINE("D_PRIORITY", 22);
DEFINE("D_PROJECT_TYPE", 23);
DEFINE("D_SERVICE", 24);
DEFINE("D_OWNER", 25);
DEFINE("D_ASSIGNEDTO", 26);
DEFINE("D_TASK_TYPE", 27);
DEFINE("D_BILLABLE", 28);
DEFINE("D_ANNUAL", 31);
DEFINE("D_BIANNUAL", 32);
DEFINE("D_QUATER", 33);
DEFINE("D_MONTH", 34);
DEFINE("D_CURRENCY", 41);

// Defines for dimension axis
DEFINE("DA_X", 0);
DEFINE("DA_Y", 1);

// Defines for sorting order
DEFINE("SO_ASC", 0);
DEFINE("SO_DESC", 1);

// Defines for permission levels
DEFINE("PL_RESTRICTED_EL", "1");
DEFINE("PL_RESTRICTED", "2");
DEFINE("PL_NOLIMITS_EO", "3");
DEFINE("PL_CUSTOM", "9");

// Defines for project profiles
DEFINE("PJ_LEADER", "1");
DEFINE("PJ_COLEADER", "2");
DEFINE("PJ_MEMBER", "3");
DEFINE("PJ_OBSERVER", "4");
DEFINE("PJ_GUEST", "5");

// Defines for boolean value
DEFINE("B_TRUE", "1");
DEFINE("B_FALSE", "0");

// Defines for approval document types
DEFINE("ADT_FILE", "1");
DEFINE("ADT_TIMESHEET", "2");
DEFINE("ADT_LEAVEREQUEST", "3");
DEFINE("ADT_EXPENSE", "4");
DEFINE("ADT_PROJECT", "5");

// Defines for ratio
DEFINE("R_GREATER_THAN", "1");
DEFINE("R_GREATER_OR_EQUAL", "2");
DEFINE("R_LESS_THAN", "3");
DEFINE("R_LESS_OR_EQUAL", "4");
DEFINE("R_EQUAL", "5");
DEFINE("R_NOT_EQUAL", "6");
DEFINE("R_IN_RANGE", "7");
DEFINE("R_NOT_IN_RANGE", "8");

// Defines for authorizer types
DEFINE("AT_USER", "1");
DEFINE("AT_PROFILE", "2");
DEFINE("AT_DEP_TITLE", "3");
DEFINE("AT_ORG_TITLE", "4");
DEFINE("AT_ROLE", "5");

// Defines for producer types
DEFINE("PT_USER", "1");
DEFINE("PT_PROFILE", "2");
DEFINE("PT_DEPARTMENT", "3");
DEFINE("PT_TEAM", "4");

// Defines for documents for approval status
DEFINE("AS_PENDING", "1");
DEFINE("AS_APPROVED", "2");
DEFINE("AS_NOT_APPROVED", "3");

// Defines for linked content document types
DEFINE("DOC_PROJECT", "1");
DEFINE("DOC_PHASE", "2");
DEFINE("DOC_TASK", "3");
DEFINE("DOC_MEETING", "4");
DEFINE("DOC_DISCUSSION", "5");
DEFINE("DOC_NOTE", "6");
DEFINE("DOC_EXPENSE", "7");
DEFINE("DOC_SUPPORT_REQUEST", "8");
DEFINE("DOC_SUPPORT_POST", "9");
DEFINE("DOC_LEAVE", "10");

// Defines for support request reproducibility
DEFINE("SRR_ALWAYS", "1");
DEFINE("SRR_SOMETIMES", "2");
DEFINE("SRR_RANDOM", "3");
DEFINE("SRR_HAVE_NOT_TRIED", "4");
DEFINE("SRR_UNABLE_TO_REPRODUCE", "5");

// Defines for support request severity
DEFINE("SRS_CRITICAL", "1");
DEFINE("SRS_MAJOR", "2");
DEFINE("SRS_MINOR", "3");
DEFINE("SRS_TRIVIAL", "4");
DEFINE("SRS_ENHANCEMENT", "5");

// Defines for support request resolution
DEFINE("SRE_ACCEPTED", "1");
DEFINE("SRE_DUPLICATE", "2");
DEFINE("SRE_FIXED", "3");
DEFINE("SRE_INVALID", "4");
DEFINE("SRE_LATER", "5");
DEFINE("SRE_OUTOFDATE", "6");
DEFINE("SRE_POSTPONED", "7");
DEFINE("SRE_REJECTED", "8");
DEFINE("SRE_REMIND", "9");
DEFINE("SRE_WONTFIX", "10");
DEFINE("SRE_WORKS4ME", "11");

// Defines for cost type
DEFINE("CTT_LABOR", "1");
DEFINE("CTT_MATERIAL", "2");
DEFINE("CTT_TRAVEL", "3");

// Defines for expense claim type
DEFINE("CMT_SHORT_DISTANCE_TRAVEL", "1");
DEFINE("CMT_LONG_DISTANCE_TRAVEL", "2");
DEFINE("CMT_OUT_OF_COUNTRY_TRAVEL", "3");
DEFINE("CMT_NONE_TRAVEL_EXPENSE_ONLY", "4");

?>
