<?php // $Revision: 1.39.2.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: initrequests.php,v 1.39.2.2 2010/04/22 09:26:55 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$initrequest["sorting"] = "SELECT *
FROM " . $tableName["sorting"] . " sor
";

$initrequest["services"] = "SELECT *
FROM " . $tableName["services"] . " serv
";

$initrequest["services1"] = "SELECT serv.*,(SELECT SUM(tim.hours) FROM " . $tableName['tasks_time'] . " tim WHERE tim.date>='%DATEFROM%' AND tim.date<='%DATETO%' AND tim.service=serv.id) as thours,(SELECT SUM(wkh.hours) FROM " . $tableName['work_hours'] . " wkh WHERE wkh.date>='%DATEFROM%' AND wkh.date<='%DATETO%' AND wkh.service=serv.id) as whours
FROM " . $tableName["services"] . " serv
";

$initrequest["calendar"] = "SELECT cal.*,mem.name,mem.email_work
FROM " . $tableName["calendar"] . " cal
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = cal.owner
";

$initrequest["calendar_view"] = "SELECT *
FROM " . $tableName["calendar_view"] . " cav
";

$initrequest["calendar_view_detail"] = "SELECT cav.calendar_view,cav.serial_no,cav.target,cav.target_id,(CASE cav.target WHEN 'user' THEN mem.name WHEN 'project' THEN pro.name ELSE '' END) AS target_name
FROM " . $tableName["calendar_view_detail"] . " cav
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = cav.target_id
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = cav.target_id
";

$initrequest["notes"] = "SELECT note.id, note.project, note.owner, note.topic, note.subject, note.description, note.date, note.published, mem.id, mem.login, mem.name, mem.email_work, tea.published
FROM " . $tableName["notes"] . " note
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = note.owner
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = note.project
LEFT OUTER JOIN " . $tableName["teams"] . " tea ON tea.project = note.project AND tea.member = note.owner
";

$initrequest["logs"] = "SELECT log.id, log.login, log.password, log.ip, log.session, log.compt, log.last_visite, log.connected, mem.profil
FROM " . $tableName["logs"] . " log
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.login = log.login
";

$initrequest["notifications"] = "SELECT noti.*,mem.id,mem.login,mem.name,mem.email_work,mem.organization,mem.profil
FROM " . $tableName["notifications"] . " noti
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = noti.member
";

$initrequest["members"] = "SELECT mem.*, org.name, log.connected, mem2.id, mem2.login, mem2.name, mem2.email_work, mem2.deputy, mem3.login, mem3.name, mem3.email_work, tim.name, dep.name
FROM " . $tableName["members"] . " mem
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = mem.organization
LEFT OUTER JOIN " . $tableName["logs"] . " log ON log.login = mem.login
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = mem.manager
LEFT OUTER JOIN " . $tableName["members"] . " mem3 ON mem3.id = mem.deputy
LEFT OUTER JOIN " . $tableName["timetickets"] . " tim ON tim.id = mem.timeticket
LEFT OUTER JOIN " . $tableName["departments"] . " dep ON dep.id = mem.department
";

$initrequest["departments"] = "SELECT dep.*,org.name
FROM " . $tableName["departments"] . " dep
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id=dep.organization
";

$initrequest["projects"] = "SELECT pro.*, org.id, org.name, mem.id, mem.login, mem.name, mem.email_work
FROM " . $tableName["projects"] . " pro
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = pro.owner
";

$initrequest["projects_budget"] = "SELECT pjb.*
FROM " . $tableName["projects_budget"] . " pjb
";

$initrequest["files"] = "SELECT fil.*, mem.login, mem.name, mem.email_work
FROM " . $tableName["files"] . " fil
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = fil.owner
";

$initrequest["files_view"] = "SELECT fil.*, mem.login, mem.name, mem.email_work
FROM (
SELECT f00.*
FROM " . $tableName["files"] . " f00
WHERE f00.doc_type NOT IN ('" . DOC_PROJECT . "','" . DOC_PHASE . "','" . DOC_TASK . "','" . DOC_MEETING . "','" . DOC_DISCUSSION . "','" . DOC_NOTE . "','" . DOC_EXPENSE . "','" . DOC_SUPPORT_REQUEST . "','" . DOC_SUPPORT_POST . "') AND f00.dir='" . B_FALSE . "'
UNION
SELECT f01.*
FROM " . $tableName["files"] . " f01
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=f01.doc_id AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f01.doc_type='" . DOC_PROJECT . "' AND f01.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f02.*
FROM " . $tableName["files"] . " f02
INNER JOIN " . $tableName["phases"] . " pha ON pha.id=f02.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=pha.project_id AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f02.doc_type='" . DOC_PHASE . "' AND f02.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f03.*
FROM " . $tableName["files"] . " f03
INNER JOIN " . $tableName["tasks"] . " tas ON tas.id=f03.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=tas.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f03.doc_type='" . DOC_TASK . "' AND f03.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f04.*
FROM " . $tableName["files"] . " f04
INNER JOIN " . $tableName["meetings"] . " mee ON mee.id=f04.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=mee.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f04.doc_type='" . DOC_MEETING . "' AND f04.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f05.*
FROM " . $tableName["files"] . " f05
INNER JOIN " . $tableName["posts"] . " pos ON pos.id=f05.doc_id
INNER JOIN " . $tableName["topics"] . " topic ON topic.id=pos.topic
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=topic.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f05.doc_type='" . DOC_DISCUSSION . "' AND f05.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f06.*
FROM " . $tableName["files"] . " f06
INNER JOIN " . $tableName["notes"] . " note ON note.id=f06.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=note.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f06.doc_type='" . DOC_NOTE . "' AND f06.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f07.*
FROM " . $tableName["files"] . " f07
INNER JOIN " . $tableName["expenses"] . " exp ON exp.id=f07.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=exp.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f07.doc_type='" . DOC_EXPENSE . "' AND f07.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f08.*
FROM " . $tableName["files"] . " f08
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=f08.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f08.doc_type='" . DOC_SUPPORT_REQUEST . "' AND f08.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f09.*
FROM " . $tableName["files"] . " f09
INNER JOIN " . $tableName["support_posts"] . " pos ON pos.id=f09.doc_id
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=pos.request_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f09.doc_type='" . DOC_SUPPORT_POST . "' AND f09.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
) fil
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = fil.owner
";

$initrequest["files_view_novc"] = "SELECT fvv.*, mem.login, mem.name, mem.email_work
FROM " . $tableName["files"] . " fvv
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = fvv.owner
WHERE fvv.id IN (
SELECT DISTINCT (CASE WHEN fil.vc_parent=0 THEN fil.id ELSE fil.vc_parent END) AS id
FROM (
SELECT f00.*
FROM " . $tableName["files"] . " f00
WHERE f00.doc_type NOT IN ('" . DOC_PROJECT . "','" . DOC_PHASE . "','" . DOC_TASK . "','" . DOC_MEETING . "','" . DOC_DISCUSSION . "','" . DOC_NOTE . "','" . DOC_EXPENSE . "','" . DOC_SUPPORT_REQUEST . "','" . DOC_SUPPORT_POST . "') AND f00.dir='" . B_FALSE . "'
UNION
SELECT f01.*
FROM " . $tableName["files"] . " f01
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=f01.doc_id AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f01.doc_type='" . DOC_PROJECT . "' AND f01.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f02.*
FROM " . $tableName["files"] . " f02
INNER JOIN " . $tableName["phases"] . " pha ON pha.id=f02.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=pha.project_id AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f02.doc_type='" . DOC_PHASE . "' AND f02.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f03.*
FROM " . $tableName["files"] . " f03
INNER JOIN " . $tableName["tasks"] . " tas ON tas.id=f03.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=tas.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f03.doc_type='" . DOC_TASK . "' AND f03.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f04.*
FROM " . $tableName["files"] . " f04
INNER JOIN " . $tableName["meetings"] . " mee ON mee.id=f04.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=mee.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f04.doc_type='" . DOC_MEETING . "' AND f04.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f05.*
FROM " . $tableName["files"] . " f05
INNER JOIN " . $tableName["posts"] . " pos ON pos.id=f05.doc_id
INNER JOIN " . $tableName["topics"] . " topic ON topic.id=pos.topic
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=topic.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f05.doc_type='" . DOC_DISCUSSION . "' AND f05.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f06.*
FROM " . $tableName["files"] . " f06
INNER JOIN " . $tableName["notes"] . " note ON note.id=f06.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=note.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f06.doc_type='" . DOC_NOTE . "' AND f06.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f07.*
FROM " . $tableName["files"] . " f07
INNER JOIN " . $tableName["expenses"] . " exp ON exp.id=f07.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=exp.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f07.doc_type='" . DOC_EXPENSE . "' AND f07.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f08.*
FROM " . $tableName["files"] . " f08
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=f08.doc_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f08.doc_type='" . DOC_SUPPORT_REQUEST . "' AND f08.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
UNION
SELECT f09.*
FROM " . $tableName["files"] . " f09
INNER JOIN " . $tableName["support_posts"] . " pos ON pos.id=f09.doc_id
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=pos.request_id
INNER JOIN " . $tableName["teams"] . " tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tableName["project_permissions"] . " prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f09.doc_type='" . DOC_SUPPORT_POST . "' AND f09.dir='" . B_FALSE . "' AND prp.view_file='" . B_TRUE . "'
) fil
%querymore%
)
%ordermore%
";

$initrequest["project_files"] = "SELECT fil.*, mem.login, mem.name, mem.email_work
FROM (
SELECT f01.*
FROM " . $tableName["files"] . " f01
WHERE f01.doc_type='" . DOC_PROJECT . "' AND f01.doc_id=%project% AND f01.dir='" . B_FALSE . "'
UNION
SELECT f02.*
FROM " . $tableName["files"] . " f02
INNER JOIN " . $tableName["phases"] . " pha ON pha.id=f02.doc_id
WHERE f02.doc_type='" . DOC_PHASE . "' AND f02.dir='" . B_FALSE . "' AND pha.project_id=%project%
UNION
SELECT f03.*
FROM " . $tableName["files"] . " f03
INNER JOIN " . $tableName["tasks"] . " tas ON tas.id=f03.doc_id
WHERE f03.doc_type='" . DOC_TASK . "' AND f03.dir='" . B_FALSE . "' AND tas.project=%project%
UNION
SELECT f04.*
FROM " . $tableName["files"] . " f04
INNER JOIN " . $tableName["meetings"] . " mee ON mee.id=f04.doc_id
WHERE f04.doc_type='" . DOC_MEETING . "' AND f04.dir='" . B_FALSE . "' AND mee.project=%project%
UNION
SELECT f05.*
FROM " . $tableName["files"] . " f05
INNER JOIN " . $tableName["posts"] . " pos ON pos.id=f05.doc_id
INNER JOIN " . $tableName["topics"] . " topic ON topic.id=pos.topic
WHERE f05.doc_type='" . DOC_DISCUSSION . "' AND f05.dir='" . B_FALSE . "' AND topic.project=%project%
UNION
SELECT f06.*
FROM " . $tableName["files"] . " f06
INNER JOIN " . $tableName["notes"] . " note ON note.id=f06.doc_id
WHERE f06.doc_type='" . DOC_NOTE . "' AND f06.dir='" . B_FALSE . "' AND note.project=%project%
UNION
SELECT f07.*
FROM " . $tableName["files"] . " f07
INNER JOIN " . $tableName["expenses"] . " exp ON exp.id=f07.doc_id
WHERE f07.doc_type='" . DOC_EXPENSE . "' AND f07.dir='" . B_FALSE . "' AND exp.project=%project%
UNION
SELECT f08.*
FROM " . $tableName["files"] . " f08
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=f08.doc_id
WHERE f08.doc_type='" . DOC_SUPPORT_REQUEST . "' AND f08.dir='" . B_FALSE . "' AND req.project=%project%
UNION
SELECT f09.*
FROM " . $tableName["files"] . " f09
INNER JOIN " . $tableName["support_posts"] . " pos ON pos.id=f09.doc_id
INNER JOIN " . $tableName["support_requests"] . " req ON req.id=pos.request_id
WHERE f09.doc_type='" . DOC_SUPPORT_POST . "' AND f09.dir='" . B_FALSE . "' AND req.project=%project%
) fil
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = fil.owner
";

$initrequest["phase_files"] = "SELECT fil.*, mem.login, mem.name, mem.email_work
FROM (
SELECT f01.*
FROM " . $tableName["files"] . " f01
WHERE f01.doc_type='" . DOC_PHASE . "' AND f01.doc_id=%phase% AND f01.dir='" . B_FALSE . "'
UNION
SELECT f02.*
FROM " . $tableName["files"] . " f02
INNER JOIN " . $tableName['tasks'] . " tas ON tas.id=f02.doc_id
INNER JOIN " . $tableName['phases'] . " pha ON pha.project_id=tas.project AND pha.order_num=tas.parent_phase
WHERE f02.doc_type='" . DOC_TASK . "' AND f02.dir='" . B_FALSE . "' AND pha.id=%phase%
) fil
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = fil.owner
";

$initrequest["organizations"] = "SELECT org.*,mem.id,mem.login,mem.name,mem.email_work
FROM " . $tableName["organizations"] . " org
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = org.owner
";

$initrequest["organizations2"] = "SELECT org.*,mem.id,mem.login,mem.name,mem.email_work,
(SELECT COUNT(pro1.id) FROM " . $tableName['projects'] . " pro1 WHERE pro1.organization=org.id AND pro1.status='" . PJS_OPEN . "') AS num_open,
(SELECT COUNT(pro2.id) FROM " . $tableName['projects'] . " pro2 WHERE pro2.organization=org.id AND pro2.status='" . PJS_COMPLETED . "' AND pro2.complete_date>='%DATEFROM%' AND pro2.complete_date<='%DATETO%') AS num_complete
FROM " . $tableName["organizations"] . " org
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = org.owner
";

$initrequest["topics"] = "SELECT topic.id, topic.project, topic.owner, topic.subject, topic.status, topic.last_post, topic.posts, topic.published, mem.id, mem.login, mem.name, mem.email_work, pro.id, pro.name, mem2.login, mem2.email_work, mem2.name
FROM " . $tableName["topics"] . " topic
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = topic.owner
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = topic.project
LEFT OUTER JOIN " . $tableName["posts"] . " pos ON pos.topic = topic.id and pos.created = topic.last_post
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = pos.member
";

$initrequest["posts"] = "SELECT pos.id, pos.topic, pos.member, pos.created, pos.message, mem.id, mem.login, mem.name, mem.email_work, topic.subject
FROM " . $tableName["posts"] . " pos
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = pos.member
LEFT OUTER JOIN " . $tableName["topics"] . " topic ON topic.id = pos.topic
";

$initrequest["assignments"] = "SELECT ass.id, ass.task, ass.owner, ass.assigned_to, ass.comments, ass.assigned, mem1.id, mem1.login, mem1.name, mem1.email_work, mem2.id, mem2.login, mem2.name, mem2.email_work
FROM " . $tableName["assignments"] . " ass
LEFT OUTER JOIN " . $tableName["members"] . " mem1 ON mem1.id = ass.owner
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = ass.assigned_to
";

$initrequest["reports"] = "SELECT *
FROM " . $tableName["reports"] . " rep
";

$initrequest["teams"] = "SELECT tea.*, mem.id, mem.login, mem.name, mem.email_work, mem.title, mem.phone_work, mem.profil, mem.password, mem.deleted, mem.active, org.name, pro.id, pro.name, pro.owner, pro.priority, pro.status, pro.published, org2.name, mem2.login, mem2.name, mem2.email_work, mem2.deputy, org2.id, log.connected
FROM " . $tableName["teams"] . " tea
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = tea.member
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = tea.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = mem.organization
LEFT OUTER JOIN " . $tableName["organizations"] . " org2 ON org2.id = pro.organization
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = pro.owner
LEFT OUTER JOIN " . $tableName["logs"] . " log ON log.login = mem.login
";

$initrequest["tasks"] = "SELECT tas.*, mem2.id, mem2.name, mem2.login, mem2.email_work, pro.name, org.id, sr.subject
FROM " . $tableName["tasks"] . " tas
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = tas.owner
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["support_requests"] . " sr ON sr.id = tas.support_request
";

$initrequest["tasks_predecessor"] = "SELECT pre.*, tas.project, tas.name, tas.start_date, tas.due_date, tas.estimated_time, tas.fixed_duration, tas.milestone, tas.level, tas.parent_task, tas2.name, tas2.start_date, tas2.due_date, tas2.estimated_time, tas2.fixed_duration, tas2.milestone, tas2.completion, tas2.assigned_to, mem2.login, mem2.email_work
FROM " . $tableName["tasks_predecessor"] . " pre
LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id = pre.task
LEFT OUTER JOIN " . $tableName["tasks"] . " tas2 ON tas2.id = pre.predecessor
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = tas2.assigned_to
";

$initrequest["tasks_resource"] = "SELECT res.*, tas.project, tas.name, pro.name, org.id
FROM " . $tableName["tasks_resource"] . " res
LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id = res.task
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
";

$initrequest["tasks_human_resource"] = "SELECT res.*, tas.project, tas.name, mem.name, mem.login, mem.email_work, mem.organization, pro.name, org.id, tas.description, tas.status, tas.start_date, tas.due_date, tas.estimated_time, tas.completion
FROM " . $tableName["tasks_resource"] . " res
LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id = res.task
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = res.resource
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
WHERE res.type = 'members'
";

$initrequest["tasks_time"] = "SELECT tim.*, mem.name, pro.name, pro.type, org.name, svc.name_print, svc.hourly_rate, svc.currency, tas.name, tas.type, wca.type, wca.hours, wca.comments, pro.organization
FROM " . $tableName["tasks_time"] . " tim
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = tim.owner
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = tim.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id = tim.task
LEFT OUTER JOIN " . $tableName["workcalendar"] . " wca ON wca.date = tim.date
LEFT OUTER JOIN " . $tableName["services"] . " svc ON svc.id = tim.service
";

$initrequest["work_hours"] = "SELECT wkh.*, mem.name, pro.name, pro.type, org.name, svc.name_print, svc.hourly_rate, svc.currency, wca.type, wca.hours, wca.comments, pro.organization
FROM " . $tableName["work_hours"] . " wkh
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = wkh.owner
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = wkh.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["services"] . " svc ON svc.id = wkh.service
LEFT OUTER JOIN " . $tableName["workcalendar"] . " wca ON wca.date = wkh.date
";

$initrequest["timesheet"] = "SELECT tim.*, mem.name, mem.login, per.fyear, per.serial_no, per.date_start, per.date_end, per.locked
FROM " . $tableName["timesheet"] . " tim
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = tim.owner
LEFT OUTER JOIN " . $tableName["periods"] . " per ON per.id = tim.period
";

$initrequest["phases"] = "SELECT pha.id, pha.project_id, pha.order_num, pha.status, pha.name, pha.date_start, pha.date_end, pha.comments
FROM " . $tableName["phases"] . " pha
";

$initrequest["phases2"] = "SELECT pha.id, pha.project_id, pha.order_num, pha.status, pha.name, pha.date_start, pha.date_end, pha.comments,
(SELECT COUNT(tas1.id) FROM " . $tableName["tasks"] . " tas1 WHERE tas1.project=pha.project_id AND tas1.parent_phase=pha.order_num AND tas1.milestone!='" . MS_YES . "' AND tas1.level='0'),
(SELECT COUNT(tas2.id) FROM " . $tableName["tasks"] . " tas2 WHERE tas2.project=pha.project_id AND tas2.parent_phase=pha.order_num AND tas2.status<>'" . ST_COMPLETED . "' AND tas2.milestone!='" . MS_YES . "' AND tas2.level='0'),
(SELECT COUNT(tas3.id) FROM " . $tableName["tasks"] . " tas3 WHERE tas3.project=pha.project_id AND tas3.parent_phase=pha.order_num AND tas3.milestone='" . MS_YES . "' AND tas3.level='0')
FROM " . $tableName["phases"] . " pha
";

$initrequest["updates"] = "SELECT upd.*, mem.id, mem.name, mem.login, mem.email_work
FROM " . $tableName["updates"] . " upd
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = upd.member
";

$initrequest["support_requests"] = "SELECT sr.id, sr.status, sr.owner, sr.reproducibility, sr.severity, sr.priority, sr.subject, sr.message, sr.date_open, sr.date_close, sr.project, sr.assigned_to, sr.resolution, pro.name, mem.name, mem.email_work, mem.profil, mem2.name, mem2.email_work, mem2.profil
FROM " . $tableName["support_requests"] . " sr
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = sr.project
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = sr.owner
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = sr.assigned_to
";

$initrequest["support_posts"] = "SELECT sp.id, sp.request_id, sp.message, sp.date, sp.owner, sp.project, mem.name, mem.email_work, sr.subject
FROM " . $tableName["support_posts"] . " sp
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = sp.owner
LEFT OUTER JOIN " . $tableName["support_requests"] . " sr ON sr.id = sp.request_id
";

$initrequest["bookmarks"] = "SELECT boo.*, mem.login, mem.name, mem.email_work, boocat.name
FROM " . $tableName["bookmarks"] . " boo
LEFT OUTER JOIN " . $tableName["bookmarks_categories"] . " boocat ON boocat.id = boo.category
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = boo.owner
";

$initrequest["bookmarks_categories"] = "SELECT boocat.*
FROM " . $tableName["bookmarks_categories"] . " boocat
";

$initrequest["meetings"] = "SELECT mee.*, pro.name, org.id, mem.name, mem2.name, mem.login, mem2.login, mem.email_work, mem2.email_work
FROM " . $tableName["meetings"] . " mee
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = mee.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = mee.chairman
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = mee.recorder
";

$initrequest["attendants"] = "SELECT att.*, mem.id, mem.login, mem.name, mem.email_work, mem.title, mem.phone_work, mee.id, mee.name, mee.agenda, mee.location, mee.date, mee.priority, mee.status, mee.start_time, mee.end_time, mee.published, org.name, pro.id, pro.name, pro.priority, pro.status, pro.published, org2.name, mem2.login, mem2.email_work, org2.id, log.connected, mem.profil, mem.password
FROM " . $tableName["attendants"] . " att
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = att.member
LEFT OUTER JOIN " . $tableName["meetings"] . " mee ON mee.id = att.meeting
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = mee.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = mem.organization
LEFT OUTER JOIN " . $tableName["organizations"] . " org2 ON org2.id = pro.organization
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = pro.owner
LEFT OUTER JOIN " . $tableName["logs"] . " log ON log.login = mem.login
";

$initrequest["meetings_time"] = "SELECT mti.*, mem.name, mee.name, pro.name, pro.type, org.name, pro.organization
FROM " . $tableName["meetings_time"] . " mti
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = mti.owner
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id = mti.project
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id = pro.organization
LEFT OUTER JOIN " . $tableName["meetings"] . " mee ON mee.id = mti.meeting
";

$initrequest["person_evaluations"] = "SELECT eva.*, mem.id, mem.name, mem.login, mem.email_work, mem2.id, mem2.name, mem2.login, mem2.email_work
FROM " . $tableName["person_evaluations"] . " eva
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = eva.appraiser
LEFT OUTER JOIN " . $tableName["members"] . " mem2 ON mem2.id = eva.member
";

$initrequest["workcalendar"] = "SELECT wca.*
FROM " . $tableName["workcalendar"] . " wca
";

$initrequest["leaves"] = "SELECT lea.*, mem.login, mem.name, mem.title, mem.email_work
FROM " . $tableName["leaves"] . " lea
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = lea.owner
";

$initrequest["leave_requests"] = "SELECT lea.*, mem.name, mem.manager, mem.login
FROM " . $tableName["leave_requests"] . " lea
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = lea.owner
";

$initrequest["timetickets"] = "SELECT tim.*
FROM " . $tableName["timetickets"] . " tim
";

$initrequest["timetickets_detail"] = "SELECT det.*, tim.name, tim.hours
FROM " . $tableName["timetickets_detail"] . " det
INNER JOIN " . $tableName["timetickets"] . " tim ON tim.id = det.timeticket
";

$initrequest["analysis_view"] = "SELECT anv.*, ana.object, ana.refresh, ana.expired, mem.login, mem.name
FROM " . $tableName["analysis_view"] . " anv
LEFT OUTER JOIN " . $tableName["analysis"] . " ana ON ana.id = anv.analysis
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id = anv.member
";

$initrequest["dimensions_view"] = "SELECT dimv.*, dim.dimension, dim.fieldname
FROM " . $tableName["dimensions_view"] . " dimv
LEFT OUTER JOIN " . $tableName["analysis_dimensions"] . " dim ON dim.id = dimv.analysis_dimension
";

$initrequest["analysis_dimensions"] = "SELECT dim.*
FROM " . $tableName["analysis_dimensions"] . " dim
";

$initrequest["analysis"] = "SELECT ana.*
FROM " . $tableName["analysis"] . " ana
";

$initrequest["project_permissions"] = "SELECT prp.*
FROM " . $tableName["project_permissions"] . " prp
";

$initrequest["strings"] = "SELECT str.*
FROM " . $tableName["strings"] . " str
";

$initrequest["expenses"] = "SELECT exp.*, mem.name, mem.login, mem.email_work, pro.name, org.id, org.name
FROM " . $tableName["expenses"] . " exp
LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=exp.project
LEFT OUTER JOIN " . $tableName["members"] . " mem ON mem.id=exp.owner
LEFT OUTER JOIN " . $tableName["organizations"] . " org ON org.id=pro.organization
";

$initrequest['confirmation_levels'] = "SELECT con.*
FROM " . $tableName['confirmation_levels'] . " con
";

$initrequest['confirmation_levels_detail'] = "SELECT cld.*,con.name,con.comments,con.max_requirements
FROM " . $tableName['confirmation_levels_detail'] . " cld
INNER JOIN " . $tableName['confirmation_levels'] . " con ON con.id=cld.confirmation_level
";

$initrequest['approvals'] = "SELECT app.*
FROM " . $tableName['approvals'] . " app
";

$initrequest['approvals_producers'] = "SELECT apd.*,app.name,app.doctype,app.conditions,app.active
FROM (
SELECT ap0.*, mem.name
FROM " . $tableName['approvals_producers'] . " ap0
INNER JOIN " . $tableName['members'] . " mem ON mem.id=ap0.producer
WHERE ap0.producer_type='" . PT_USER . "'
UNION ALL
SELECT ap1.*, '' as name
FROM " . $tableName['approvals_producers'] . " ap1
WHERE ap1.producer_type='" . PT_PROFILE . "'
UNION ALL
SELECT ap2.*, dep.name
FROM " . $tableName['approvals_producers'] . " ap2
INNER JOIN " . $tableName['departments'] . " dep ON dep.id=ap2.producer
WHERE ap2.producer_type='" . PT_DEPARTMENT . "'
UNION ALL
SELECT ap3.*, pro.name
FROM " . $tableName['approvals_producers'] . " ap3
INNER JOIN " . $tableName['projects'] . " pro ON pro.id=ap3.producer
WHERE ap3.producer_type='" . PT_TEAM . "'
) apd
INNER JOIN " . $tableName['approvals'] . " app ON app.id=apd.approval
";

$initrequest['approvals1'] = "SELECT v1.approval, app.conditions
FROM (
SELECT v0.approval, count(v0.approval) AS appcnt, (SELECT count(*) FROM " . $tableName['approvals_producers'] . " apx WHERE apx.approval=v0.approval AND apx.exclude='N') AS incnt, (SELECT count(*) FROM " . $tableName['approvals_producers'] . " apx WHERE apx.approval=v0.approval AND apx.exclude<>'N') AS excnt
FROM (
SELECT ap0.approval
FROM " . $tableName['approvals_producers'] . " ap0
INNER JOIN " . $tableName['approvals'] . " app0 ON app0.id=ap0.approval
INNER JOIN " . $tableName['members'] . " mem ON mem.id=ap0.producer
WHERE ap0.producer_type='" . PT_USER . "' AND ap0.producer=%producer% AND ap0.exclude='N' AND app0.doctype='%doctype%' AND app0.active='Y'
UNION ALL
SELECT ap1.approval
FROM " . $tableName['approvals_producers'] . " ap1
INNER JOIN " . $tableName['approvals'] . " app1 ON app1.id=ap1.approval
LEFT OUTER JOIN " . $tableName['members'] . " mem ON mem.profil=ap1.producer
WHERE ap1.producer_type='" . PT_PROFILE . "' AND mem.id=%producer% AND ap1.exclude='N' AND app1.doctype='%doctype%' AND app1.active='Y'
UNION ALL
SELECT ap2.approval
FROM " . $tableName['approvals_producers'] . " ap2
INNER JOIN " . $tableName['approvals'] . " app2 ON app2.id=ap2.approval
INNER JOIN " . $tableName['departments'] . " dep ON dep.id=ap2.producer
LEFT OUTER JOIN " . $tableName['members'] . " mem ON mem.department=dep.id
WHERE ap2.producer_type='" . PT_DEPARTMENT . "' AND mem.id=%producer% AND ap2.exclude='N' AND app2.doctype='%doctype%' AND app2.active='Y'
UNION ALL
SELECT ap3.approval
FROM " . $tableName['approvals_producers'] . " ap3
INNER JOIN " . $tableName['approvals'] . " app3 ON app3.id=ap3.approval
INNER JOIN " . $tableName['teams'] . " tea ON tea.project=ap3.producer
WHERE ap3.producer_type='" . PT_TEAM . "' AND tea.member=%producer% AND ap3.exclude='N' AND app3.doctype='%doctype%' AND app3.active='Y'
UNION ALL
SELECT ap10.approval
FROM " . $tableName['approvals_producers'] . " ap10
INNER JOIN " . $tableName['approvals'] . " app10 ON app10.id=ap10.approval
INNER JOIN " . $tableName['members'] . " mem ON mem.id=ap10.producer
WHERE ap10.producer_type='" . PT_USER . "' AND ap10.producer<>%producer% AND ap10.exclude='Y' AND app10.doctype='%doctype%' AND app10.active='Y'
UNION ALL
SELECT ap11.approval
FROM " . $tableName['approvals_producers'] . " ap11
INNER JOIN " . $tableName['approvals'] . " app11 ON app11.id=ap11.approval
LEFT OUTER JOIN " . $tableName['members'] . " mem ON mem.profil=ap11.producer
WHERE ap11.producer_type='" . PT_PROFILE . "' AND mem.id<>%producer% AND ap11.exclude='Y' AND app11.doctype='%doctype%' AND app11.active='Y'
UNION ALL
SELECT ap12.approval
FROM " . $tableName['approvals_producers'] . " ap12
INNER JOIN " . $tableName['approvals'] . " app12 ON app12.id=ap12.approval
INNER JOIN " . $tableName['departments'] . " dep ON dep.id=ap12.producer
LEFT OUTER JOIN " . $tableName['members'] . " mem ON mem.department=dep.id
WHERE ap12.producer_type='" . PT_DEPARTMENT . "' AND mem.id<>%producer% AND ap12.exclude='Y' AND app12.doctype='%doctype%' AND app12.active='Y'
UNION ALL
SELECT ap13.approval
FROM " . $tableName['approvals_producers'] . " ap13
INNER JOIN " . $tableName['approvals'] . " app13 ON app13.id=ap13.approval
INNER JOIN " . $tableName['teams'] . " tea ON tea.project=ap13.producer
WHERE ap13.producer_type='" . PT_TEAM . "' AND tea.member<>%producer% AND ap13.exclude='Y' AND app13.doctype='%doctype%' AND app13.active='Y'
) v0
GROUP BY v0.approval
) v1
INNER JOIN " . $tableName['approvals'] . " app ON app.id=v1.approval
WHERE (v1.incnt=0 AND v1.appcnt=v1.excnt)
OR (v1.incnt>0 AND v1.appcnt>v1.excnt)
";

$initrequest['approvals_stages'] = "SELECT aps.*,con.name,con.max_requirements
FROM " . $tableName['approvals_stages'] . " aps
INNER JOIN " . $tableName['confirmation_levels'] . " con ON con.id=aps.confirmation_level
";

$initrequest['approvals_terms'] = "SELECT apt.*
FROM " . $tableName['approvals_terms'] . " apt
";

$initrequest['documents_approval_authorizers'] = "SELECT daa.*,dap.approval,dap.owner,dap.doctype,dap.current_stage,dap.status,dap.canceled,dap.closed,dap.created,mem.name,mem2.name
FROM " . $tableName['documents_approval_authorizers'] . " daa
INNER JOIN " . $tableName['documents_approval'] . " dap ON dap.id=daa.document_approval
INNER JOIN " . $tableName['members'] . " mem ON mem.id=daa.authorizer
INNER JOIN " . $tableName['members'] . " mem2 ON mem2.id=dap.owner
";

$initrequest['documents_approval'] = "SELECT dap.*,mem.name,mem.email_work
FROM " . $tableName['documents_approval'] . " dap
INNER JOIN " . $tableName['members'] . " mem ON mem.id=dap.owner
";

$initrequest['projects_cost'] = "SELECT prc.project,prc.costtype,prc.currency,SUM(prc.amount)
FROM (
    SELECT exp.project,'" . CTT_MATERIAL . "' AS costtype,exp.currency,SUM(exp.amount) AS amount
    FROM " . $tableName['expenses'] . " exp
    WHERE exp.project IN (%PROJECTS%) AND exp.status IN ('" . FS_APPROVED . "','" . FS_NO_APPROVALS_NEEDED . "') AND exp.expensetype IN (%MATERIAL%)
    GROUP BY exp.project,exp.currency
    UNION ALL
    SELECT exp.project,'" . CTT_TRAVEL . "' AS costtype,exp.currency,SUM(exp.amount) AS amount
    FROM " . $tableName['expenses'] . " exp
    WHERE exp.project IN (%PROJECTS%) AND exp.status IN ('" . FS_APPROVED . "','" . FS_NO_APPROVALS_NEEDED . "') AND exp.expensetype IN (%TRAVEL%)
    GROUP BY exp.project,exp.currency
    UNION ALL
    SELECT wkh.project,'" . CTT_LABOR . "' AS costtype,svc.currency,SUM(wkh.hours*svc.hourly_rate) AS amount
    FROM " . $tableName['work_hours'] . " wkh
    INNER JOIN " . $tableName['services'] . " svc ON svc.id=wkh.service
    WHERE wkh.project IN (%PROJECTS%) AND EXISTS (
        SELECT * FROM " . $tableName['timesheet'] . " ts1
        INNER JOIN " . $tableName['periods'] . " pe1 ON pe1.id=ts1.period
        WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . FS_APPROVED . "','" . FS_NO_APPROVALS_NEEDED . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
    )
    GROUP BY wkh.project,svc.currency
    UNION ALL
    SELECT tim.project,'" . CTT_LABOR . "' AS costtype,svc.currency,SUM(tim.hours*svc.hourly_rate) AS amount
    FROM " . $tableName['tasks_time'] . " tim
    INNER JOIN " . $tableName['services'] . " svc ON svc.id=tim.service
    WHERE tim.project IN (%PROJECTS%) AND EXISTS (
        SELECT * FROM " . $tableName['timesheet'] . " ts2
        INNER JOIN " . $tableName['periods'] . " pe2 ON pe2.id=ts2.period
        WHERE ts2.owner=tim.owner AND ts2.status IN ('" . FS_APPROVED . "','" . FS_NO_APPROVALS_NEEDED . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
    )
    GROUP BY tim.project,svc.currency
) prc
%QUERYMORE%
GROUP BY prc.project,prc.costtype,prc.currency
";

$initrequest['periods'] = "SELECT per.*
FROM " . $tableName['periods'] . " per
";

$initrequest['currency_rates'] = "SELECT cur.*
FROM " . $tableName['currency_rates'] . " cur
";
?>
