<?php // $Revision: 1.13.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: notification.class.php,v 1.13.2.1 2010/02/02 09:13:54 luiswang Exp $
 *
 * Copyright (c) 2010 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

require_once('../includes/phpmailer/class.phpmailer.php');

class notification extends phpmailer {
    function notification()
    {
        global $strings, $root, $notificationMethod, $setCharset;
        $this->Mailer = $notificationMethod;
        $this->PluginDir = '../includes/phpmailer/';
        // Sets the CharSet of the message
        $this->CharSet = $setCharset;

        if ($this->Mailer == 'smtp') {
            $this->Host = SMTPSERVER;

            if (SMTPLOGIN != '') {
                $this->SMTPAuth = true;
                $this->Username = SMTPLOGIN;
                $this->Password = SMTPPASSWORD;
            }
        }

        $this->footer = "--\n" . $strings['noti_foot1'] . "\n\n" . $strings['noti_foot2'];
        $this->Addressee = array();
    }

    function getUserinfo($idUser, $type)
    {
        global $strings;
        $tmpquery = "WHERE mem.id = '$idUser'";
        $detailUser = new request();
        $detailUser->openMembers($tmpquery);

        if ($type == "from") {
            $this->From = $detailUser->mem_email_work[0];
            $this->FromName = $detailUser->mem_name[0];
            $this->signature = $detailUser->mem_name[0] . "\n";

            if ($detailUser->mem_title[0] == '') {
                $this->signature .= $detailUser->mem_org_name[0] . "\n";
            } else {
                $this->signature .= $detailUser->mem_title[0] . ", " . $detailUser->mem_org_name[0] . "\n";
            }

            if ($detailUser->mem_phone_work[0] != "") {
                $this->signature .= $strings["work_phone"] . " : " . $detailUser->mem_phone_work[0] . "\n";
            }

            if ($detailUser->mem_mobile[0] != "") {
                $this->signature .= $strings["mobile_phone"] . " : " . $detailUser->mem_mobile[0] . "\n";
            }

            if ($detailUser->mem_fax[0] != "") {
                $this->signature .= $strings["fax"] . " : " . $detailUser->mem_fax[0] . "\n";
            }
        }

        if ($type == 'to') {
            $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            $this->Addressee[] = $detailUser->mem_name[0];
        }

        if ($type == 'cc') {
            if ($this->Mailer == 'smtp') {
                $this->AddCC($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            } else {
                $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            }
        }

        if ($type == 'bcc') {
            if ($this->Mailer == 'smtp') {
                $this->AddBCC($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            } else {
                $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            }
        }
    }

    function openBody()
    {
        global $strings;
        $this->Body = "<body>\n";
        $this->AltBody = "";

        if (count($this->Addressee) > 0) {
            $this->Body .= $strings["dear"];
            $this->AltBody .= $strings["dear"];

            foreach ($this->Addressee as $usr) {
                $this->Body .= " $usr,";
                $this->AltBody .= " $usr,";
            }

            $this->Body .= "<br><br>\n";
            $this->AltBody .= "\n\n";
        }

        $this->Body .= $this->partMessage . "<br><br>\n";
        $this->AltBody .= $this->partMessage . "\n\n";
    }

    function note($url, $name = '')
    {
        global $strings;

        if ($name == '') {
            $name = $strings['noti_moreinfo'];
        }

        $this->Body .= "<p>$name<br><a href=\"$url\">" . $strings["here"] . "</a></p>\n";
        $this->AltBody .= "\n$name\n$url\n\n";
    }

    function heading($title)
    {
        $this->Body .= "<b>" . $title . "</b><br>\n";
        $this->AltBody .= $title . "\n";
    }

    /**
     * Start a table to display sheet/form
     *
     * @see block::contentRow()
     * @access public
     */
    function openContent()
    {
        $this->Body .= "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
    }

    /**
     * Display a table line in sheet/form
     *
     * @param string $left Text in left cell
     * @param string $right Text in right cell
     * @param string $mid Text in left cell ending
     * @access public
     */
    function contentRow($left, $right, $mid = " :")
    {
        if ($left != "") {
            $this->Body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">" . $left . $mid . "</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->AltBody .= sprintf("%40s : %s\n", $left, $right);
        } else {
            $this->Body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">&nbsp;</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->AltBody .= sprintf("%40s   %s\n", "", $right);
        }
    }

    function contentTitle($title)
    {
        $this->Body .= "<tr><th colspan=\"2\" align=\"left\">" . $title . "</th></tr>\n";
        $this->AltBody .= $title . "\n";
    }

    function closeContent()
    {
        $this->Body .= "</table>\n<hr/>\n";
        $this->AltBody .= "\n";
    }

    function closeBody()
    {
        global $strings, $root;
        $this->Body .= "<br>\n" . nl2br($this->signature) . "<br>\n" . nl2br($this->footer) . "<br><a href=\"$root/\">" . $strings["here"] . "</a>\n</body>";
        $this->AltBody .= "\n" . $this->signature . "\n" . $this->footer . "\n$root/";
    }

    function openResults()
    {
        $this->Body .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
        $this->AltBody .= "\n";
    }

    function closeResults()
    {
        $this->Body .= "</table>\n</hr>\n";
        $this->AltBody .= "\n";
    }

    function noresults()
    {
        global $strings;
        $this->Body .= "<table cellspacing=\"0\" border=\"1\" cellpadding=\"2\">\n<tr><td colspan=\"4\">" . $strings["no_items"] . "</td></tr>\n</table>\n<hr/>\n";
        $this->AltBody .= $strings["no_items"] . "\n";
    }

    function openRow()
    {
        $this->Body .= "<tr>";
    }

    function cellRow($content = null)
    {
        $this->Body .= "<td>$content</td>";
        $this->AltBody .= $content . "\t";
    }

    function closeRow()
    {
        $this->Body .= "</tr>\n";
        $this->AltBody .= "\n";
    }
}

?>
