<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editleave.php,v 1.21 2009/10/07 15:22:30 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$owner = isset($_POST['owner'])?$_POST['owner']:'';
$yr = isset($_POST['yr'])?$_POST['yr']:'';
$ty = isset($_POST['ty'])?$_POST['ty']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$dd = isset($_POST['dd'])?$_POST['dd']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

if ($id != '' && !$SW_Permissions['Leave']['Edit'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
} else if ($id == '' && !$SW_Permissions['Leave']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE mem.profil<>'" . PF_CLIENT_USER . "' AND mem.deleted='" . B_FALSE . "' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    header("Location: ../leaves/listleaves.php?msg=noAvailableUsers");
    exit;
}

if ($id != '') {
    $tmpquery = " WHERE lea.id=$id";
    $leaveDetail = new request();
    $leaveDetail->openLeaves($tmpquery);
    $comptLeaveDetail = count($leaveDetail->lea_id);

    if ($comptLeaveDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Fields Check
 */
if ($action != '') {
    if ($hr == '') {
        // required field
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";
        $hr_highlight = true;
    } else if (!is_numeric($hr)) {
        // we need this to be numeric
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_numerical');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();document.leEForm.hr.select();\"";
        $hr_highlight = true;
    } else if ($hr <= 0) {
        // we need this to be greater than zero
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('value_deviate');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();document.leEForm.hr.select();\"";
        $hr_highlight = true;
    } else if ($dd < $yr . '-01-01') {
        $error = lang_strings('year') . '&nbsp;' . lang_strings('value_deviate');
        $bodyCommand = "onLoad=\"document.leEForm.yr.focus();\"";
    } else if (periodLocked($yr . '-01-01', $dd)) {
        $error = lang_strings('period') . ' ' . $period_date_start . ' ~ ' . $period_date_end . ' ' . lang_strings('locked');
    }
}

/**
 * Actions
 */
if ($error == '') {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);

    if ($action == "update") {    // case update user
        $tmpquery = "UPDATE " . $tableName["leaves"] . " SET owner='$owner',year='$yr',type='$ty',hours='$hr',due_date='$dd',comments='$comm',modified='$dateheure' WHERE id=$id";
        connectSql($tmpquery);
        header("Location: ../leaves/listleaves.php?msg=update");
        exit;
    } else if ($action == "add") {    // case add user
        $tmpquery1 = "INSERT INTO " . $tableName["leaves"] . " (owner,year,type,hours,due_date,comments,created) VALUES ('$owner','$yr','$ty','$hr','$dd','$comm','$dateheure')";
        connectSql($tmpquery1);
        header("Location: ../leaves/listleaves.php?msg=add");
        exit;
    }
}

/**
 * Set form data
 */
if ($error == '') {
    if ($id != "") {
        // set values in form
        $owner = $leaveDetail->lea_owner[0];
        $yr = $leaveDetail->lea_year[0];
        $ty = $leaveDetail->lea_type[0];
        $hr = $leaveDetail->lea_hours[0];
        $dd = $leaveDetail->lea_due_date[0];
        $comm = $leaveDetail->lea_comments[0];
    } else {
        $yr = date('Y');
        $hr = "8";
        $dd = $yr . "-12-31";
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/listleaves.php?", lang_strings("leave_management"), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_leave"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleave.php?id=$id", "#$id", 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_leave"));
}

$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "leE";

if ($id == "") {
    $block1->openForm("../leaves/editleave.php?#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
    $block1->heading(lang_strings("add_leave"));
} else {
    $block1->openForm("../leaves/editleave.php?id=$id#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
    $block1->heading(lang_strings("edit_leave") . " : #" . $leaveDetail->lea_id[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$ownerSel = "<select name=\"owner\">";

for ($i=0; $i<$comptListMembers; $i++) {
    if ($owner == $listMembers->mem_id[$i]) {
        $ownerSel .= '<option value="' . $listMembers->mem_id[$i] . '" selected>' . $listMembers->mem_name[$i] . '</option>';
    } else {
        $ownerSel .= '<option value="' . $listMembers->mem_id[$i] . '">' . $listMembers->mem_name[$i] . '</option>';
    }
}

$ownerSel .= "</select>";
$block1->contentRow(lang_strings('owner'), $ownerSel);
$yearSel = '<select name="yr">';

for ($i = date('Y')-3; $i < date('Y')+4; $i++) {
    if ($i == $yr) {
        $yearSel .= '<option value="' . $i . '" selected>' . $i . '</option>';
    } else {
        $yearSel .= '<option value="' . $i . '">' . $i . '</option>';
    }
}

$yearSel .= '</select>';
$block1->contentRow(lang_strings("year"), $yearSel);
$typeSel = "<select name=\"ty\">";

if ($ty == LV_ANNUAL) {
    $typeSel .= "<option value=\"" . LV_ANNUAL . "\" selected>" . $hourCodeArray[LV_ANNUAL] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_ANNUAL . "\">" . $hourCodeArray[LV_ANNUAL] . "</option>";
}

if ($ty == LV_SICK) {
    $typeSel .= "<option value=\"" . LV_SICK . "\" selected>" . $hourCodeArray[LV_SICK] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_SICK . "\">" . $hourCodeArray[LV_SICK] . "</option>";
}

if ($ty == LV_ABSENCE) {
    $typeSel .= "<option value=\"" . LV_ABSENCE . "\" selected>" . $hourCodeArray[LV_ABSENCE] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_ABSENCE . "\">" . $hourCodeArray[LV_ABSENCE] . "</option>";
}

$typeSel .= "</select>";
$block1->contentRow(lang_strings('type'), $typeSel);

if ($hr_highlight) {
    $block1->contentRow("* " . lang_strings("hours"), "<input size='20' value='$hr' class='input_hours_highlight' name='hr' maxlength='6' type='text'>");
} else {
    $block1->contentRow("* " . lang_strings("hours"), "<input size='20' value='$hr' class='input_hours' name='hr' maxlength='6' type='text'>");
}

$block1->contentRow(lang_strings("due_date"), "<input type=\"text\" class=\"input_datetime\" name=\"dd\" id=\"sel3\" size=\"20\" value=\"$dd\" readonly><button type=\"reset\" id=\"trigger_b\">...</button><script type=\"text/javascript\">Calendar.setup({ inputField:\"sel3\", button:\"trigger_b\" });</script>");
$block1->contentRow(lang_strings("comments"), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
