<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewleaverequest.php,v 1.21 2009/10/13 03:48:32 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE lea.id=$id";
$leaveRequestDetail = new request();
$leaveRequestDetail->openLeaveRequests($tmpquery);
$comptLeaveRequestDetail = count($leaveRequestDetail->lea_id);

if ($comptLeaveRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$owner = $leaveRequestDetail->lea_owner[0];
$status = $leaveRequestDetail->lea_status[0];

if ($serialno == "") {
    $fyear = intval(substr($leaveRequestDetail->lea_date_start[0], 0, 4));
    $month = intval(substr($leaveRequestDetail->lea_date_start[0], 5, 2));
    $day = intval(substr($leaveRequestDetail->lea_date_start[0], 8, 2));

    if ($periodUnit == 'month') {
        $serialno = intval($month);
    } else {
        $weekday = date("w", mktime(12, 0, 0, $month, $day, $fyear));

        if ($weekday == '0') {
            $sdate = mktime(12, 0, 0, $month, $day-6, $year);
        } else {
            $sdate = mktime(12, 0, 0, $month, $day-$weekday+1, $year);
        }

        $month = date('n', $sdate);
        $serialno = intval(date("W", $sdate));

        if ($sdate == '12' && $serialno == '1') {
            $fyear += 1;
        } else if ($sdate == '1' && $serialno > '50') {
            $fyear -= 1;
        }
    }
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings('timesheet'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear", in));
$blockPage->itemBreadcrumbs(lang_strings("leave_request") . " #$id");
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();

if ($fileManagement == "true" && $SW_Permissions['File']['Read'][$profilSession] && $layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

$block1 = new block();
$block1->form = "leaD";
$block1->openForm("../leaves/viewleaverequest.php#" . $block1->form . "Anchor");
$block1->headingToggle(lang_strings("leave_request") . " : #$id");

if ($status != FS_NEEDS_APPROVAL && !periodLocked($leaveRequestDetail->lea_date_start[0], $leaveRequestDetail->lea_date_end[0])) {
    $block1->openPaletteIcon();

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Admin'][$profilSession]) {
        $block1->paletteIcon(0, "remove", lang_strings("delete"));
    }

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", lang_strings("edit"));
    }

    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("proposer"), $blockPage->buildLink("../users/viewuser.php?id=$owner", $leaveRequestDetail->lea_mem_name[0], 'in'));
$block1->contentRow(lang_strings('type'), $hourCodeArray[$leaveRequestDetail->lea_type[0]]);
$block1->contentRow(lang_strings('time_start'), $leaveRequestDetail->lea_date_start[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_start[0]));
$block1->contentRow(lang_strings('time_end'), $leaveRequestDetail->lea_date_end[0] . " " . formatted_timestamp($leaveRequestDetail->lea_time_end[0]));
$block1->contentRow(lang_strings("hours"), $leaveRequestDetail->lea_hours[0]);
$block1->contentRow(lang_strings("status"), $statusFile[$status]);
$block1->contentRow(lang_strings("reason"), nl2br($leaveRequestDetail->lea_comments[0]));

if ($status != FS_NO_APPROVALS_NEEDED) {
    $block1->contentTitle(lang_strings("approval_history"));
    $tmpquery = " WHERE dap.docid=$id AND dap.doctype='" . ADT_LEAVEREQUEST . "' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($tmpquery);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0,$ah=''; $i<$comptListDocumentsApproval; $i++,$ah.='<br>') {
        if ($i == 0) {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['submit_at']) . '</i>';
        } else {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['resubmit_at']) . '</i>';
        }

        $tmpquery = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . AS_PENDING . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($tmpquery);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_APPROVED) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_NOT_APPROVED) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], $timezoneSession), $ahd);
                $ah .= '<br><i>' . $ahd  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $ah .= '<br>' . nl2br($listDocumentsApprovalAuthorizer->daa_comments[$j]);
                }
            }
        }
    }

    $block1->contentRow('', $ah);
}

$block1->closeContent();
$block1->closeForm();

if ($status != FS_NEEDS_APPROVAL && !periodLocked($leaveRequestDetail->lea_date_start[0], $leaveRequestDetail->lea_date_end[0])) {
    $block1->openPaletteScript();

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Admin'][$profilSession]) {
        $block1->paletteScript(0, "remove", "../leaves/deleteleaverequests.php?id=$id&fyear=$fyear&serialno=$serialno&sdate=$sdate&id=$id", "true,true,true", lang_strings("delete"));
    }

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../leaves/editleaverequest.php?id=$id&fyear=$fyear&serialno=$serialno&sdate=$sdate&id=$id", "true,true,true", lang_strings("edit"));
    }

    $block1->closePaletteScript("", "");
}

if ($fileManagement == "true" && $SW_Permissions['File']['Read'][$profilSession]) {
    if ($layoutSession == LT_TWOPAGES) {
        $blockPage->turnPage();
    }

    $block2 = new block();
    $block2->form = "tdC";
    $block2->openForm("../expenses/viewexpense.php?id=$id#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"));
    $block2->openPaletteIcon();

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $block2->paletteIcon(0, "add", lang_strings("add"));
     }

    if ($SW_Permissions['File']['Admin'][$profilSession]) {
        $block2->paletteIcon(1, "remove", lang_strings("delete"));
    }

    $block2->paletteIcon(4, "info", lang_strings("view"));

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block2->paletteIcon(5, "edit", lang_strings("edit"));
    }

    if (strstr($sortingUser->sor_files[0], 'fil.published') !== false) {
        $sortingUser->sor_files[0] = 'fil.name ASC';
    }

    $block2->paletteIcon(6, "export", lang_strings("export"));
    $block2->closePaletteIcon();
    $block2->borne = $blockPage->returnBorne('1');
    $block2->sorting("files", $sortingUser->sor_files[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.extension', 1 => 'fil.name', 2 => 'fil.owner', 3 => 'fil.date', 4 => 'fil.status'));
    $tmpquery = " WHERE fil.doc_type='" . DOC_LEAVE . "' AND fil.doc_id=$id AND fil.vc_parent=0 ORDER BY $block2->sortingValue";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles != "0") {
        $block2->openResults();
        $block2->labels($labels = array(0 => lang_strings('type'), 1 => lang_strings('name'), 2 => lang_strings('owner'), 3 => lang_strings('date'), 4 => lang_strings('approval_tracking')), 'false');
        require_once("../includes/files_types.php");

        for ($i=0; $i<$comptListFiles; $i++) {
            $idStatus = $listFiles->fil_status[$i];
            $idPublish = $listFiles->fil_published[$i];
            $type = file_info_type($listFiles->fil_extension[$i]);

            if (fileExists($listFiles->fil_fullname[$i])) {
                $existFile = 'true';
            } else {
                $existFile = 'false';
            }

            $block2->openRow();
            $block2->checkboxRow($listFiles->fil_id[$i]);

            if ($existFile == 'true') {
                $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_LEAVE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $type, 'icone'));
            } else {
                $block2->cellRow('&nbsp;');
            }

            if ($existFile == 'true') {
                $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_LEAVE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $listFiles->fil_name[$i], 'in'));
            } else {
                $block2->cellRow(lang_strings('missing_file') . ' (' . $listFiles->fil_name[$i] . ')');
            }

            $block2->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $listFiles->fil_owner[$i], $listFiles->fil_mem_name[$i], 'in'));
            $block2->cellRow($listFiles->fil_date[$i]);
            $block2->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_LEAVE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in'));
            $block2->closeRow();
        }

        $block2->closeResults();
        $block2->bornesFooter('1', $blockPage->bornesNumber, '../linkedcontent/listfiles.php?doc_type=' . DOC_LEAVE . '&doc_id=' . $id, 'id=' . $id);
    } else {
        $block2->noresults();
    }

    $block2->closeToggle();
    $block2->closeFormResults();
    $block2->openPaletteScript();

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $block2->paletteScript(0, "add", "../linkedcontent/addfile.php?doc_type=" . DOC_LEAVE . "&doc_id=$id", "true,false,false", lang_strings("add"));
     }

    if ($SW_Permissions['File']['Admin'][$profilSession]) {
        $block2->paletteScript(1, "remove", "../linkedcontent/deletefiles.php?doc_type=" . DOC_LEAVE . "&doc_id=$id", "false,true,true", lang_strings("delete"));
     }

    $block2->paletteScript(4, "info", "../linkedcontent/viewfile.php?doc_type=" . DOC_LEAVE . "&doc_id=$id&", "false,true,false", lang_strings("view"));

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block2->paletteScript(5, "edit", "../linkedcontent/viewfile.php?edit=true&doc_type=" . DOC_LEAVE . "&doc_id=$id&", "false,true,false", lang_strings("edit"));
    }

    $block2->paletteScript(6, "export", "../linkedcontent/accessfiles.php?", "false,true,true", lang_strings("export"));
    $block2->closePaletteScript($comptListFiles, $listFiles->fil_id);

    if ($layoutSession == LT_TWOPAGES) {
        $blockPage->closeTwoPages();
    }
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
