<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addfile.php,v 1.19 2009/09/04 08:58:46 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = isset($_GET['doc_id'])?$_GET['doc_id']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$versionFile = isset($_POST['versionFile'])?$_POST['versionFile']:'';

/**
 * Permission check
 */
if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($doc_id != '0') {
        $parent = $doc_id;
        $tmpquery = " WHERE fil.id=$doc_id AND fil.dir='" . B_TRUE . "'";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        $comptFileDetail = count($fileDetail->fil_id);

        if ($comptFileDetail == '0') {
            header('Location: ../general/permissiondenied.php');
            exit;
        } else {
            $fullname = $fileDetail->fil_fullname[0];
        }
    } else {    // file in root folder is not allowed
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else if ($doc_type == DOC_LEAVE) {
    $tmpquery = " WHERE lea.id=$doc_id";
    $leaveRequestDetail = new request();
    $leaveRequestDetail->openLeaveRequests($tmpquery);
    $comptLeaveRequestDetail = count($leaveRequestDetail->lea_id);

    if ($comptLeaveRequestDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $owner = $leaveRequestDetail->lea_owner[0];
    $status = $leaveRequestDetail->lea_status[0];

    if ($serialno == "") {
        $fyear = intval(substr($leaveRequestDetail->lea_date_start[0], 0, 4));
        $month = intval(substr($leaveRequestDetail->lea_date_start[0], 5, 2));
        $day = intval(substr($leaveRequestDetail->lea_date_start[0], 8, 2));

        if ($periodUnit == 'month') {
            $serialno = intval($month);
        } else {
            $weekday = date("w", mktime(12, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(12, 0, 0, $month, $day-6, $year);
            } else {
                $sdate = mktime(12, 0, 0, $month, $day-$weekday+1, $year);
            }

            $month = date('n', $sdate);
            $serialno = intval(date("W", $sdate));

            if ($sdate == '12' && $serialno == '1') {
                $fyear += 1;
            } else if ($sdate == '1' && $serialno > '50') {
                $fyear -= 1;
            }
        }
    }

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    }

    $tmpquery = " WHERE fil.id=1";
    $fileDetail = new request();
    $fileDetail->openFiles($tmpquery);
    $fullname = $fileDetail->fil_fullname[0];
    $parent = '1';
} else {
    switch ($doc_type) {
        case DOC_PROJECT:
            $tmpquery = "SELECT id FROM " . $tableName['projects'] . " WHERE id=$doc_id";
            break;
        case DOC_PHASE:
            $tmpquery = "SELECT project_id FROM " . $tableName['phases'] . " WHERE id=$doc_id";
            break;
        case DOC_TASK:
            $tmpquery = "SELECT project FROM " . $tableName['tasks'] . " WHERE id=$doc_id";
            break;
        case DOC_MEETING:
            $tmpquery = "SELECT project FROM " . $tableName['meetings'] . " WHERE id=$doc_id";
            break;
        case DOC_DISCUSSION:
            $tmpquery = "SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=$doc_id";
            break;
        case DOC_NOTE:
            $tmpquery = "SELECT project FROM " . $tableName['notes'] . " WHERE id=$doc_id";
            break;
        case DOC_EXPENSE:
            $tmpquery = "SELECT project FROM " . $tableName['expenses'] . " WHERE id=$doc_id";
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=$fil_doc_id";
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=$fil_doc_id";
            break;
        default:
            header('Location: ../general/permissiondenied.php');
            exit;
    }

    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $project = ($row[0]);
    } else {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $request1->close();
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_add_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project);
        exit;
    }

    $parent = $projectDetail->pro_upload_dir[0];
    $tmpquery = " WHERE fil.id=$parent";
    $fileDetail = new request();
    $fileDetail->openFiles($tmpquery);
    $fullname = $fileDetail->fil_fullname[0];
}

/**
 * Actions
 */
if ($action == "add") {
    if ($_FILES['upload']['name'] == '') {
        $error = lang_strings("no_file");
    } else if ($_FILES['upload']['size'] == '0') {
        $error = lang_strings('exceed_size');
    } else if ($versionFile != '' && !is_numeric($versionFile)) {
        $error = lang_strings('vc_version') . '&nbsp;' . lang_strings('error_numerical');
        $bodyCommand = "onLoad=\"document.adFForm.versionFile.focus();\"";
        $vc_version_highlight = true;
    } else {
        $extension = strtolower(substr(strrchr($_FILES['upload']['name'], ".") , 1));
        $extension_len = strlen($extension) + 1;
        $filename_len = strlen($_FILES['upload']['name']);
        $filename_prefix = substr($_FILES['upload']['name'], 0, $filename_len - $extension_len);

        if ($allowPhp == "false") {
            if ($extension == "php" || $extension == "php3" || $extension == "phtml") {
                $error = lang_strings("no_php");
            }
        }
    }

    if ($error == "") {
        if ($versionFile == "") {
            $versionFile = "0.0";
        } else if (strstr($versionFile, ".") == '') {
            $versionFile = $versionFile . ".0";
        }

        $c = HtmlEntitiesNOD($c);
        $status = FS_NO_APPROVALS_NEEDED;
        $tmpquery = "INSERT INTO " . $tableName["files"] . "(owner,doc_type,doc_id,name,date,comments,upload,published,status,vc_version,vc_parent,dir,parent,fullname) VALUES ($idSession,$doc_type,$doc_id,'" . HtmlEntitiesNOD($_FILES['upload']['name']) . "','$dateheure','$c','$dateheure','1','$status','$versionFile','0','" . B_FALSE . "',$parent,'')";
        connectSql($tmpquery);
        $num = last_id($tableName["files"]);
        $realname = urlencode($filename_prefix) . '--' . $num . '.v' . $versionFile . '.' . $extension;
        $size = uploadFile($fullname, $_FILES['upload']['tmp_name'], $realname);
        $extension = strtolower($extension);
        $fullname = HtmlEntitiesNOD($fullname . '/' . $realname);
        $tmpquery = 'UPDATE ' . $tableName['files'] . " SET size='$size',extension='$extension',fullname='$fullname' WHERE id=$num";
        connectSql($tmpquery);
        $producer = $idSession;
        $doctype = ADT_FILE;
        require_once('../approvals/adddocument.php');
        header("Location: ../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$num&msg=addFile");
        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0", lang_strings('files'), 'in'));
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id", $fileDetail->fil_name[0], 'in'));
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case DOC_PHASE:
        $tmpquery = " WHERE pha.id=$doc_id";
        $phaseDetail = new request();
        $phaseDetail->openPhases($tmpquery);
        break;
    case DOC_TASK:
        $tmpquery = " WHERE tas.id=$doc_id";
        $taskDetail = new request();
        $taskDetail->openTasks($tmpquery);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $tmpquery = " WHERE pha.project_id=$project AND pha.order_num=" . $taskDetail->tas_parent_phase[0];
            $targetPhase = new request();
            $targetPhase->openPhases($tmpquery);
        }

        break;
    case DOC_MEETING:
        $tmpquery = " WHERE mee.id=$doc_id";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($tmpquery);
        break;
    case DOC_DISCUSSION:
        $tmpquery = " WHERE pos.id=$doc_id";
        $postDetail = new request();
        $postDetail->openPosts($tmpquery);
        break;
    case DOC_NOTE:
        $tmpquery = " WHERE note.id=$doc_id";
        $noteDetail = new request();
        $noteDetail->openNotes($tmpquery);
        break;
    case DOC_EXPENSE:
        $tmpquery = " WHERE exp.id=$doc_id";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($tmpquery);
        break;
    case DOC_SUPPORT_REQUEST:
        $tmpquery = " WHERE sr.id=$doc_id";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($tmpquery);
    case DOC_SUPPORT_POST:
        $tmpquery = " WHERE sp.id=$doc_id";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($tmpquery);
        break;
}

if ($error == '') {
    $versionFile = '0.0';
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($parent);
} else if ($doc_type == DOC_LEAVE) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings('timesheet'), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear", in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("leave_request") . " #$doc_id", in));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case DOC_PHASE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0], $phaseDetail->pha_name[0], 'in'));
            break;
        case DOC_TASK:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0], $targetPhase->pha_name[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project", lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id", $taskDetail->tas_name[0], 'in'));
            break;
        case DOC_MEETING:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project", lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id", $meetingDetail->mee_name[0], 'in'));
            break;
        case DOC_DISCUSSION:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project", lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0], $postDetail->pos_topic_subject[0], 'in'));
            break;
        case DOC_NOTE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project", lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0], $noteDetail->note_subject[0], 'in'));
            break;
        case DOC_EXPENSE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0], $expenseType['sets'][$expenseDetail->exp_expensetype[0]] . " " . $amount, 'in'));
            break;
        case DOC_SUPPORT_REQUEST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0], $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case DOC_SUPPORT_POST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0], $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id", lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("add_file"));
$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "adF";
$block1->openForm("../linkedcontent/addfile.php?doc_type=$doc_type&doc_id=$doc_id#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add"/>';

if ($project == '') {
    echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $maxFileSize . '"/>';
} else {
    echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $projectDetail->pro_upload_max[0] . '"/>';
}

$block1->heading(lang_strings("add_file"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow("*&nbsp;" . lang_strings("upload"), "<input size=\"44\" class=\"input_text\" name=\"upload\" type=\"FILE\">");
$block1->contentRow(lang_strings("comments"), "<textarea rows=\"3\" class=\"textarea_3rows\" name=\"c\" cols=\"43\">$c</textarea>");

if ($vc_version_highlight) {
    $block1->contentRow(lang_strings("vc_version"), "<input size=\"44\" class=\"input_text_highlight\" name=\"versionFile\" type=\"text\" value=\"$versionFile\">");
} else {
    $block1->contentRow(lang_strings("vc_version"), "<input size=\"44\" class=\"input_text\" name=\"versionFile\" type=\"text\" value=\"$versionFile\">");
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
