<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletefiles.php,v 1.11 2009/09/01 15:01:17 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = isset($_GET['doc_id'])?$_GET['doc_id']:'0';
$id = isset($_GET['id'])?$_GET['id']:'0';
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = str_replace('**', ',', $id);

/**
 * Permission check
 */
$tmpquery = " WHERE fil.id IN ($ids) ORDER BY fil.name";
$listFiles = new request();
$listFiles->openFiles($tmpquery);
$comptListFiles = count($listFiles->fil_id);

if ($comptListFiles == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Admin'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $tmpquery = " WHERE fil.id=$doc_id AND fil.dir='" . B_TRUE . "'";
    $folderDetail = new request();
    $folderDetail->openFiles($tmpquery);
    $comptFolderDetail = count($folderDetail->fil_id);

    if ($comptFolderDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else if ($doc_type == DOC_LEAVE) {
    $tmpquery = " INNER JOIN " . $tableName['leave_requests'] . " lea ON lea.id=fil.doc_id WHERE fil.id IN ($ids) AND fil.doc_type='" . DOC_LEAVE . "' AND lea.owner=$idSession";
    $listLeaveRequestFiles = new request();
    $listLeaveRequestFiles->openFiles($tmpquery);
    $comptListLeaveRequestFiles = count($listLeaveRequestFiles->fil_id);

    if ($comptListLeaveRequestFiles != $comptListFiles) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $owner = $leaveRequestDetail->lea_owner[0];
    $status = $leaveRequestDetail->lea_status[0];

    if ($serialno == "") {
        $fyear = intval(substr($leaveRequestDetail->lea_date_start[0], 0, 4));
        $month = intval(substr($leaveRequestDetail->lea_date_start[0], 5, 2));
        $day = intval(substr($leaveRequestDetail->lea_date_start[0], 8, 2));

        if ($periodUnit == 'month') {
            $serialno = intval($month);
        } else {
            $weekday = date("w", mktime(12, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(12, 0, 0, $month, $day-6, $year);
            } else {
                $sdate = mktime(12, 0, 0, $month, $day-$weekday+1, $year);
            }

            $month = date('n', $sdate);
            $serialno = intval(date("W", $sdate));

            if ($sdate == '12' && $serialno == '1') {
                $fyear += 1;
            } else if ($sdate == '1' && $serialno > '50') {
                $fyear -= 1;
            }
        }
    }

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    }
}

for ($i=0; $i<$comptListFiles; $i++) {
    $fil_doc_type = $listFiles->fil_doc_type[$i];
    $fil_doc_id = $listFiles->fil_doc_id[$i];
    $linkedProject = '';

    switch ($fil_doc_type) {
        case DOC_PROJECT:
            $tmpquery = "SELECT id FROM " . $tableName['projects'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_PHASE:
            $tmpquery = "SELECT project_id FROM " . $tableName['phases'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_TASK:
            $tmpquery = "SELECT project FROM " . $tableName['tasks'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_MEETING:
            $tmpquery = "SELECT project FROM " . $tableName['meetings'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_DISCUSSION:
            $tmpquery = "SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=$fil_doc_id";
            break;
        case DOC_NOTE:
            $tmpquery = "SELECT project FROM " . $tableName['notes'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_EXPENSE:
            $tmpquery = "SELECT project FROM " . $tableName['expenses'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=$fil_doc_id";
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=$fil_doc_id";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery != '') {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $linkedProject = ($row[0]);
        }

        $request1->close();
    }

    if ($linkedProject != '') {
        $tmpquery = " WHERE pro.id=$linkedProject";
        $projectDetail = new request();
        $projectDetail->openProjects($tmpquery);
        $comptProjectDetail = count($projectDetail->pro_id);

        if ($comptProjectDetail == 0) {
            header('Location: ../projects/listprojects.php?msg=blankProject');
            exit;
        }

        $tmpquery = " WHERE tea.project=$linkedProject AND tea.member=$idSession";
        $memberDetail = new request();
        $memberDetail->openTeams($tmpquery);
        $comptMemberDetail = count($memberDetail->tea_id);

        if ($comptMemberDetail == 0) {
            $tmpquery = " WHERE prp.project=$linkedProject AND prp.profil='" . PJ_GUEST . "'";
        } else {
            $tmpquery = " WHERE prp.project=$linkedProject AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail = new request();
        $permissionDetail->openProjectPermissions($tmpquery);
        $comptPermissionDetail = count($permissionDetail->prp_id);

        if ($action == "publish") {
            if ($permissionDetail->prp_publish_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
                header('Location: ../projects/viewproject.php?id=' . $linkedProject);
                exit;
            }
        } else if ($action == 'delete') {
            if ($permissionDetail->prp_delete_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
                header('Location: ../projects/viewproject.php?id=' . $linkedProject);
                exit;
            }
        } else {
            if ($permissionDetail->prp_view_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
                header('Location: ../projects/viewproject.php?id=' . $linkedProject);
                exit;
            }
        }
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    deleteFiles($listFiles->fil_fullname);
    $tmpquery = " WHERE fil.vc_parent IN ($ids)";
    $listVCFiles = new request();
    $listVCFiles->openFiles($tmpquery);
    $comptListVCFiles = count($listVCFiles->fil_id);

    if ($comptListVCFiles != '0') {
        deleteFiles($listVCFiles->fil_fullname);
    }

    $tmpquery = "DELETE FROM " . $tableName["files"] . " WHERE id IN ($ids) OR vc_parent IN ($ids)";
    connectSql($tmpquery);

    if ($sendto == "filedetails") {
        header('Location: ../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_vc_parent[0] . '&msg=deleteFile');
    } else {
        switch ($doc_type) {
            case DOC_PROJECT:
                header('Location: ../projects/viewproject.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_PHASE:
                header('Location: ../phases/viewphase.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_TASK:
                header('Location: ../tasks/viewtask.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_MEETING:
                header('Location: ../meetings/viewmeeting.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_DISCUSSION:
                $tmpquery = " WHERE pos.id=$doc_id";
                $postDetail = new request();
                $postDetail->openPosts($tmpquery);
                header('Location: ../topics/viewtopics.php?id=' . $postDetail->pos_topic[0] . '&msg=deleteFile');
                break;
            case DOC_NOTE:
                header('Location: ../notes/viewnote.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_EXPENSE:
                header('Location: ../expenses/viewexpense.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_SUPPORT_REQUEST:
                $tmpquery = " WHERE sr.id=$doc_id";
                $supportRequestDetail = new request();
                $supportRequestDetail->openSupportRequests($tmpquery);
                header('Location: ../support/viewrequest.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            case DOC_SUPPORT_POST:
                $tmpquery = " WHERE sp.id=$doc_id";
                $supportPostDetail = new request();
                $supportPostDetail->openSupportPosts($tmpquery);
                header('Location: ../support/viewrequest.php?id=' . $supportPostDetail->sp_request_id[0] . '&msg=deleteFile');
                break;
            case DOC_LEAVE:
                header('Location: ../leaves/viewleaverequest.php?id=' . $doc_id . '&msg=deleteFile');
                break;
            default:
                header('Location: ../linkedcontent/listfiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&msg=deleteFile');
                break;
        }
    }

    exit;
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0", lang_strings('files'), 'in'));
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $listFiles = new request();
        $listFiles->openFiles($tmpquery);
        item_bread_crumbs($listFiles->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id", $listFiles->fil_name[0], 'in'));
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case DOC_PHASE:
        $tmpquery = " WHERE pha.id=$doc_id";
        $phaseDetail = new request();
        $phaseDetail->openPhases($tmpquery);
        break;
    case DOC_TASK:
        $tmpquery = " WHERE tas.id=$doc_id";
        $taskDetail = new request();
        $taskDetail->openTasks($tmpquery);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $tmpquery = " WHERE pha.project_id=$project AND pha.order_num=" . $taskDetail->tas_parent_phase[0];
            $targetPhase = new request();
            $targetPhase->openPhases($tmpquery);
        }

        break;
    case DOC_MEETING:
        $tmpquery = " WHERE mee.id=$doc_id";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($tmpquery);
        break;
    case DOC_DISCUSSION:
        $tmpquery = " WHERE pos.id=$doc_id";
        $postDetail = new request();
        $postDetail->openPosts($tmpquery);
        break;
    case DOC_NOTE:
        $tmpquery = " WHERE note.id=$doc_id";
        $noteDetail = new request();
        $noteDetail->openNotes($tmpquery);
        break;
    case DOC_EXPENSE:
        $tmpquery = " WHERE exp.id=$doc_id";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($tmpquery);
        break;
    case DOC_SUPPORT_REQUEST:
        $tmpquery = " WHERE sr.id=$doc_id";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($tmpquery);
    case DOC_SUPPORT_POST:
        $tmpquery = " WHERE sp.id=$doc_id";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($tmpquery);
        break;
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id);
} else if ($doc_type == DOC_LEAVE) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings('timesheet'), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear", in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("leave_request") . " #$doc_id", in));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case DOC_PHASE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0], $phaseDetail->pha_name[0], 'in'));
            break;
        case DOC_TASK:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0], $targetPhase->pha_name[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project", lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id", $taskDetail->tas_name[0], 'in'));
            break;
        case DOC_MEETING:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project", lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id", $meetingDetail->mee_name[0], 'in'));
            break;
        case DOC_DISCUSSION:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project", lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0], $postDetail->pos_topic_subject[0], 'in'));
            break;
        case DOC_NOTE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project", lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0], $noteDetail->note_subject[0], 'in'));
            break;
        case DOC_EXPENSE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0], $expenseType['sets'][$expenseDetail->exp_expensetype[0]] . " " . $amount, 'in'));
            break;
        case DOC_SUPPORT_REQUEST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0], $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case DOC_SUPPORT_POST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0], $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id", lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("unlink_files"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "delF";
$block1->openForm("../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_id=$doc_id&id=$id&sendto=$sendto#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete"/>';
$block1->heading(lang_strings("unlink_files"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListFiles; $i++) {
    $block1->contentRow('', $listFiles->fil_name[$i]);
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
