<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editfolder.php,v 1.6 2009/09/04 08:58:46 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = 'onLoad="document.eFoForm.nm.focus();"';

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$parent = isset($_GET['parent'])?$_GET['parent']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$nm = isset($_POST['nm'])?$_POST['nm']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$error = '';

/**
 * Permission check
 */
if ($id == '') {
    if (!$SW_Permissions['File']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['File']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

if ($parent != '0') {
    $tmpquery = " WHERE fil.id=$parent AND fil.dir='" . B_TRUE . "'";
    $parentDetail = new request();
    $parentDetail->openFiles($tmpquery);
    $comptParentDetail = count($parentDetail->fil_id);

    if ($comptParentDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    } else {
        $path = $parentDetail->fil_fullname[0] . '/';
    }
} else {
    $path = '';
}

if ($id != '') {
    $tmpquery = " WHERE fil.id=$id AND fil.dir='" . B_TRUE . "'";
    $folderDetail = new request();
    $folderDetail->openFiles($tmpquery);
    $comptFolderDetail = count($folderDetail->fil_id);

    if ($comptFolderDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($folderDetail->fil_parent[0] != $parent) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'add' || $action == 'update') {
    if ($nm == '') {
        $error = lang_strings('name') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.eFoForm.nm.focus();"';
        $nm_highlight = true;
    }

    if ($error == '') {
        $nm = HtmlEntitiesNOD($nm);
        $c = HtmlEntitiesNOD($c);

        if ($action == 'add') {
            $tmpquery = "INSERT INTO " . $tableName['files'] . " (owner,doc_type,doc_id,name,date,size,comments,published,status,vc_status,vc_version,vc_parent,dir,parent) VALUES ($idSession,'0',0,'$nm','$dateheure',0,'$c','" . PB_NO . "','0','','','0','" . B_TRUE . "',$parent)";
            connectSql($tmpquery);
            $num = last_id($tableName['files']);
            $fullname = $path . urlencode($nm) . '--' . $num;
            createDir($fullname);
            $tmpquery = "UPDATE " . $tableName['files'] . " SET fullname='$fullname' WHERE id=$num";
            connectSql($tmpquery);
            header("Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=$num&id=$num&msg=add");
            exit;
        } else if ($action == 'update') {
            $tmpquery = "UPDATE " . $tableName['files'] . " SET name='$nm',comments='$c' WHERE id=$id";
            connectSql($tmpquery);
            header("Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=$id&id=$id&msg=update");
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($id != '') {
        $nm = $folderDetail->fil_name[0];
        $c = $folderDetail->fil_comments[0];
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0", lang_strings('files'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('files'));
        }
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id", $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($id == '') {
    item_bread_crumbs($parent);
    $blockPage->itemBreadcrumbs(lang_strings('add_folder'));
} else {
    item_bread_crumbs($id);
    $blockPage->itemBreadcrumbs(lang_strings('edit_folder'));
}

$blockPage->closeBreadcrumbs();

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "eFo";

if ($id == '') {
    $block1->openForm("../linkedcontent/editfolder.php?parent=$parent#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
} else {
    $block1->openForm("../linkedcontent/editfolder.php?parent=$parent&id=$id#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
}

if ($id == '') {
    $block1->heading(lang_strings('add_folder'));
} else {
    $block1->heading(lang_strings('edit_folder') . ' : ' . $folderDetail->fil_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($nm_highlight) {
    $nameStr = '<input size="44" class="input_text_highlight" type="text" name="nm" value="' . str_replace('"', '&quot;', $nm) . '" maxlength="100">';
} else {
    $nameStr = '<input size="44" class="input_text" type="text" name="nm" value="' . str_replace('"', '&quot;', $nm) . '" maxlength="100">';
}

$block1->contentRow("* " . lang_strings("name"), $nameStr);
$block1->contentRow(lang_strings('description'), "<textarea rows=\"3\" class=\"textarea_3rows\" name=\"c\" cols=\"47\">$c</textarea>");
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');
