<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listfiles.php,v 1.12 2009/11/15 05:38:37 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = isset($_GET['doc_id'])?$_GET['doc_id']:$id;
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($doc_id != '0') {
        $tmpquery = " WHERE fil.id=$doc_id AND fil.dir='" . B_TRUE . "'";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        $comptFileDetail = count($fileDetail->fil_id);

        if ($comptFileDetail == '0') {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }
} else if ($doc_type == DOC_LEAVE) {
    header('Location: ../general/permissiondenied.php');
    exit;
} else {
    switch ($doc_type) {
        case DOC_PROJECT:
            $tmpquery = "SELECT id FROM " . $tableName['projects'] . " WHERE id=$doc_id";
            break;
        case DOC_PHASE:
            $tmpquery = "SELECT project_id FROM " . $tableName['phases'] . " WHERE id=$doc_id";
            break;
        case DOC_TASK:
            $tmpquery = "SELECT project FROM " . $tableName['tasks'] . " WHERE id=$doc_id";
            break;
        case DOC_MEETING:
            $tmpquery = "SELECT project FROM " . $tableName['meetings'] . " WHERE id=$doc_id";
            break;
        case DOC_DISCUSSION:
            $tmpquery = "SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=$doc_id";
            break;
        case DOC_NOTE:
            $tmpquery = "SELECT project FROM " . $tableName['notes'] . " WHERE id=$doc_id";
            break;
        case DOC_EXPENSE:
            $tmpquery = "SELECT project FROM " . $tableName['expenses'] . " WHERE id=$doc_id";
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=$doc_id";
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=$doc_id";
            break;
        default:
            header('Location: ../general/permissiondenied.php');
            exit;
    }

    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $project = ($row[0]);
    } else {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $request1->close();
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_view_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $ids = str_replace('**', ',', $id);

    if ($addToSiteFile == 'true') {
        $tmpquery1 = 'UPDATE ' . $tableName['files'] . " SET published='" . PB_YES . "' WHERE id IN ($ids) OR vc_parent IN ($ids)";
        connectSql($tmpquery1);
        $msg = 'addToSite';
    } else if ($removeToSiteFile == 'true') {
        $tmpquery1 = 'UPDATE ' . $tableName['files'] . " SET published='" . PB_NO . "' WHERE id IN ($ids) OR vc_parent IN ($ids)";
        connectSql($tmpquery1);
        $msg = 'removeToSite';
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0", lang_strings('files'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('files'));
        }
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id", $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case DOC_PHASE:
        $tmpquery = " WHERE pha.id=$doc_id";
        $phaseDetail = new request();
        $phaseDetail->openPhases($tmpquery);
        break;
    case DOC_TASK:
        $tmpquery = " WHERE tas.id=$doc_id";
        $taskDetail = new request();
        $taskDetail->openTasks($tmpquery);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $tmpquery = " WHERE pha.project_id=$project AND pha.order_num=" . $taskDetail->tas_parent_phase[0];
            $targetPhase = new request();
            $targetPhase->openPhases($tmpquery);
        }

        break;
    case DOC_MEETING:
        $tmpquery = " WHERE mee.id=$doc_id";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($tmpquery);
        break;
    case DOC_DISCUSSION:
        $tmpquery = " WHERE pos.id=$doc_id";
        $postDetail = new request();
        $postDetail->openPosts($tmpquery);
        break;
    case DOC_NOTE:
        $tmpquery = " WHERE note.id=$doc_id";
        $noteDetail = new request();
        $noteDetail->openNotes($tmpquery);
        break;
    case DOC_EXPENSE:
        $tmpquery = " WHERE exp.id=$doc_id";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($tmpquery);
        break;
    case DOC_SUPPORT_REQUEST:
        $tmpquery = " WHERE sr.id=$doc_id";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($tmpquery);
    case DOC_SUPPORT_POST:
        $tmpquery = " WHERE sp.id=$doc_id";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($tmpquery);
        break;
    case '0':
        $tmpquery = "SELECT * FROM " . $tableName['files'] . " WHERE dir='" . B_TRUE . "' AND parent=$doc_id";
        $folders = compt($tmpquery);
        $tmpquery = "SELECT * FROM " . $tableName['files'] . " WHERE vc_parent=0 AND dir='" . B_FALSE . "' AND parent=$doc_id";
        $files = compt($tmpquery);
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id, false);
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case DOC_PHASE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0], $phaseDetail->pha_name[0], 'in'));
            break;
        case DOC_TASK:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project", lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0], $targetPhase->pha_name[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project", lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id", $taskDetail->tas_name[0], 'in'));
            break;
        case DOC_MEETING:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project", lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id", $meetingDetail->mee_name[0], 'in'));
            break;
        case DOC_DISCUSSION:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project", lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0], $postDetail->pos_topic_subject[0], 'in'));
            break;
        case DOC_NOTE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project", lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0], $noteDetail->note_subject[0], 'in'));
            break;
        case DOC_EXPENSE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0], $expenseType['sets'][$expenseDetail->exp_expensetype[0]] . " " . $amount, 'in'));
            break;
        case DOC_SUPPORT_REQUEST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0], $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case DOC_SUPPORT_POST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0], $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs(lang_strings("linked_content"));
}

$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();

if ($doc_type == '0' && $doc_id != '0' && $layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

if ($doc_type == '0') {
    if ($doc_id != '0') {
        $block1 = new block();
        $block1->form = "vvD";
        $block1->openForm("../linkedcontent/listfiles.php?id=$id&doc_type=$doc_type&doc_id=$doc_id#" . $block1->form . "Anchor");
        $block1->headingToggle(lang_strings("folder") . " : " . $fileDetail->fil_name[0]);
        $block1->openPaletteIcon();

        if ($SW_Permissions['File']['Admin'][$profilSession] && $doc_id != '1') {
            $block1->paletteIcon(0, "remove", lang_strings("delete"));
        }

        if ($SW_Permissions['File']['Edit'][$profilSession]) {
            $block1->paletteIcon(1, "edit", lang_strings("edit"));
            $block1->paletteIcon(2, "copy", lang_strings("copy"));
            $block1->paletteIcon(3, "move", lang_strings("move"));
        }

        $block1->paletteIcon(4, "export", lang_strings("export"));
        $block1->closePaletteIcon();
        $block1->openContent();
        $block1->contentTitle(lang_strings("info"));
        $block1->contentRow(lang_strings("description"), nl2br($fileDetail->fil_comments[0]));
        $block1->contentRow(lang_strings("size"), convertSize(folder_info_size($fileDetail->fil_fullname[0])));
        $block1->contentRow(lang_strings("contains"), $folders . '&nbsp;' . lang_strings("folders") . ",&nbsp;&nbsp;" . $files . '&nbsp;' . lang_strings("files"));
        $block1->contentRow(lang_strings("date"), $fileDetail->fil_date[0]);
        $block1->closeContent();
        $block1->closeForm();
        $block1->openPaletteScript();

        if ($SW_Permissions['File']['Admin'][$profilSession] && $doc_id != '1') {
            $block1->paletteScript(0, "remove", "../linkedcontent/deletefolder.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id", "true,true,false", lang_strings("delete"));
        }

        if ($SW_Permissions['File']['Edit'][$profilSession]) {
            $block1->paletteScript(1, "edit", "../linkedcontent/editfolder.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id", "true,true,false", lang_strings("edit"));
            $block1->paletteScript(2, "copy", "../linkedcontent/movefiles.php?cpy=true&parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id", "true,true,false", lang_strings("copy"));
            $block1->paletteScript(3, "move", "../linkedcontent/movefiles.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id", "true,true,false", lang_strings("move"));
        }

        $block1->paletteScript(4, "export", "../linkedcontent/accessfiles.php?folder=true&id=" . $fileDetail->fil_parent[0], "true,true,true", lang_strings('export'));
        $block1->closePaletteScript("", "");

        if ($layoutSession == LT_TWOPAGES) {
            $blockPage->turnPage();
        }
    }

    $block2 = new block();
    $block2->form = 'lsD';
    $block2->openForm("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings('subfolders'));
    $block2->openPaletteIcon();

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $block2->paletteIcon(0, 'add', lang_strings('add'));
    }

    if ($SW_Permissions['File']['Admin'][$profilSession]) {
        $block2->paletteIcon(1, 'remove', lang_strings('delete'));
    }

    $block2->paletteIcon(4, 'info', lang_strings('view'));

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block2->paletteIcon(5, 'edit', lang_strings('edit'));
        $block2->paletteIcon(2, 'copy', lang_strings('copy'));
        $block2->paletteIcon(3, 'move', lang_strings('move'));
    }

    $block2->paletteIcon(6, 'export', lang_strings('export'));
    $block2->closePaletteIcon();
    $block2->sorting('folders', $sortingUser->sor_folders[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.size', 2 => 'fil.date'));
    $tmpquery = " WHERE fil.dir='" . B_TRUE . "' AND fil.parent=$doc_id ORDER BY " . $block2->sortingValue;
    $listFolders = new request();
    $listFolders->openFiles($tmpquery);
    $comptListFolders = count($listFolders->fil_id);

    if ($comptListFolders != '0') {
        $block2->openResults();
        $block2->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('size'), 2 => lang_strings('date')), 'false');

        for ($i=0; $i<$comptListFolders; $i++) {
            $block2->openRow();
            $block2->checkboxRow($listFolders->fil_id[$i]);

            if (dirExists($listFolders->fil_fullname[$i])) {
                $block2->cellRow($blockPage->buildLink('../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $listFolders->fil_id[$i], $listFolders->fil_name[$i], 'in'));
            } else {
                $block2->cellRow(lang_strings('missing_folder') . ' (' . $listFolders->fil_name[$i] . ')');
            }

            $block2->cellRow(convertSize(folder_info_size($listFolders->fil_fullname[$i])));
            $block2->cellRow($listFolders->fil_date[$i]);
            $block2->closeRow();
        }

        $block2->closeResults();
    } else {
        $block2->noresults();
    }

    $block2->closeToggle();
    $block2->closeFormResults();
    $block2->openPaletteScript();

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $block2->paletteScript(0, 'add', '../linkedcontent/editfolder.php?parent=' . $doc_id, 'true,false,false', lang_strings('add'));
    }

    if ($SW_Permissions['File']['Admin'][$profilSession]) {
        $block2->paletteScript(1, 'remove', '../linkedcontent/deletefolder.php?parent=' . $doc_id, 'false,true,false', lang_strings('delete'));
    }

    $block2->paletteScript(4, 'info', '../linkedcontent/listfiles.php?doc_type=0', 'false,true,false', lang_strings('view'));

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block2->paletteScript(5, 'edit', '../linkedcontent/editfolder.php?parent=' . $doc_id, 'false,true,false', lang_strings('edit'));
        $block2->paletteScript(2, 'copy', '../linkedcontent/movefiles.php?cpy=true&parent=' . $doc_id, 'false,true,true', lang_strings('copy'));
        $block2->paletteScript(3, 'move', '../linkedcontent/movefiles.php?parent=' . $doc_id, 'false,true,true', lang_strings('move'));
    }

    $block2->paletteScript(6, 'export', '../linkedcontent/accessfiles.php?folder=true', 'false,true,true', lang_strings('export'));
    $block2->closePaletteScript($comptListFolders, $listFolders->fil_id);
}

if ($doc_type != '0' || $doc_id != '0') {
    $block3 = new block();
    $block3->form = "lsF";
    $block3->openForm("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id#" . $block3->form . "Anchor");

    if ($doc_type == '0') {
        $block3->headingToggle(lang_strings("files"));
    } else {
        $block3->headingToggle(lang_strings("linked_content"));
    }

    $listFiles = new request();
    $block3->openPaletteIcon();

    if ($doc_type == '0') {
        if ($SW_Permissions['File']['Write'][$profilSession]) {
            $block3->paletteIcon(0, 'add', lang_strings('add'));
        }

        if ($SW_Permissions['File']['Admin'][$profilSession]) {
            $block3->paletteIcon(1, 'remove', lang_strings('delete'));
        }

        $block3->paletteIcon(4, 'info', lang_strings('view'));

        if ($SW_Permissions['File']['Edit'][$profilSession]) {
            $block3->paletteIcon(5, 'edit', lang_strings('edit'));
            $block3->paletteIcon(2, 'copy', lang_strings('copy'));
            $block3->paletteIcon(3, 'move', lang_strings('move'));
        }

        if (strstr($sortingUser->sor_files[0], 'fil.published') !== false) {
            $sortingUser->sor_files[0] = 'fil.name ASC';
        }

        $block3->paletteIcon(6, 'export', lang_strings('export'));
        $block3->sorting('files', $sortingUser->sor_files[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.extension', 1 => 'fil.name', 2 => 'fil.size', 3 => 'fil.date', 4 => 'fil.status'));

        if ($SW_Permissions['Project']['Edit'][$profilSession]) {
            $tmpquery = " WHERE fil.parent=$doc_id AND fil.vc_parent='0' AND fil.dir='" . B_FALSE . "' ORDER BY $block3->sortingValue";
            $listFiles->openFiles($tmpquery);
        } else {
            $tmpquery = " WHERE fil.parent=$doc_id AND fil.vc_parent='0' ORDER BY $block3->sortingValue";
            $listFiles->openFilesView($idSession, $tmpquery);
        }
    } else {
        if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteIcon(0, 'add', lang_strings('add'));
        }

        if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteIcon(1, 'remove', lang_strings('delete'));
        }

        if ($sitePublish == 'true') {
            if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
                $block3->paletteIcon(2, 'add_projectsite', lang_strings('add_project_site'));
                $block3->paletteIcon(3, 'remove_projectsite', lang_strings('remove_project_site'));
            }
        }

        $block3->paletteIcon(4, 'info', lang_strings('view'));

        if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteIcon(5, 'edit', lang_strings('edit'));
        }

        $block3->paletteIcon(6, 'export', lang_strings('export'));
        $block3->sorting('files', $sortingUser->sor_files[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.extension', 1 => 'fil.name', 2 => 'fil.size', 3 => 'fil.date', 4 => 'fil.status', 5 => 'fil.published'));

        if ($doc_type == DOC_PROJECT) {
            $tmpquery = " WHERE fil.vc_parent='0' ORDER BY $block3->sortingValue";
            $listFiles->openProjectFiles($project, $tmpquery);
        } else if ($doc_type == DOC_SUPPORT_REQUEST) {
            $tmpquery = " WHERE sp.request_id=$doc_id";
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($tmpquery);
            $comptListSupportPosts = count($listSupportPosts->sp_id);

            if ($comptListSupportPosts == '0') {
                $tmpquery = " WHERE doc_type='" . DOC_SUPPORT_REQUEST . "' AND doc_id=$doc_id AND fil.vc_parent='0' ORDER BY $block3->sortingValue";
                $listFiles->openFiles($tmpquery);
            } else {
                $tmpquery = " WHERE ((doc_type='" . DOC_SUPPORT_REQUEST . "' AND doc_id=$doc_id) OR (doc_type='" . DOC_SUPPORT_POST . "' AND doc_id IN (" . implode(',', $listSupportPosts->sp_id) . "))) AND fil.vc_parent='0' ORDER BY $block3->sortingValue";
                $listFiles->openFiles($tmpquery);
            }
        } else if ($doc_type == DOC_SUPPORT_POST) {
            $tmpquery = " WHERE sp.request_id=" . $supportPostDetail->sp_request_id[0];
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($tmpquery);
            $tmpquery = " WHERE ((doc_type='" . DOC_SUPPORT_REQUEST . "' AND doc_id=" . $supportPostDetail->sp_request_id[0] . ") OR (doc_type='" . DOC_SUPPORT_POST . "' AND doc_id IN (" . implode(',', $listSupportPosts->sp_id) . "))) AND fil.vc_parent='0' ORDER BY $block3->sortingValue";
            $listFiles->openFiles($tmpquery);
        } else {
            $tmpquery = " WHERE doc_type='$doc_type' AND doc_id=$doc_id AND fil.vc_parent='0' ORDER BY $block3->sortingValue";
            $listFiles->openFiles($tmpquery);
        }
    }

    $block3->closePaletteIcon();
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles != '0') {
        $block3->openResults();

        if ($doc_type == '0') {
            $block3->labels($labels = array(0 => lang_strings('type'), 1 => lang_strings('name'), 2 => lang_strings('size'), 3 => lang_strings('date'), 4 => lang_strings('approval_tracking')), 'false');
        } else {
            $block3->labels($labels = array(0 => lang_strings('type'), 1 => lang_strings('name'), 2 => lang_strings('size'), 3 => lang_strings('date'), 4 => lang_strings('approval_tracking'), 5 => lang_strings('published')), 'true');
        }

        require_once('../includes/files_types.php');

        for ($i=0; $i<$comptListFiles; $i++) {
            $existFile = fileExists($listFiles->fil_fullname[$i]);
            $idStatus = $listFiles->fil_status[$i];
            $idPublish = $listFiles->fil_published[$i];
            $type = file_info_type($listFiles->fil_extension[$i]);
            $block3->openRow();
            $block3->checkboxRow($listFiles->fil_id[$i]);

            if ($existFile) {
                $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_id[$i], $type, 'icone'));
                $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_id[$i], $listFiles->fil_name[$i], 'in'));
            } else {
                $block3->cellRow('&nbsp;');
                $block3->cellRow(lang_strings('missing_file') . ' (' . $listFiles->fil_name[$i] . ')');
            }

            $block3->cellRow(convertSize($listFiles->fil_size[$i]));
            $block3->cellRow($listFiles->fil_date[$i]);
            $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in'));

            if ($sitePublish == 'true' && $doc_type != '0') {
                $block3->cellRow($statusPublish[$idPublish]);
            }

            $block3->closeRow();
        }

        $block3->closeResults();
    } else {
        $block3->noresults();
    }

    $block3->closeToggle();
    $block3->closeFormResults();
    $block3->openPaletteScript();

    if ($doc_type == '0') {
        if ($SW_Permissions['File']['Write'][$profilSession]) {
            $block3->paletteScript(0, 'add', '../linkedcontent/addfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'true,false,false', lang_strings('add'));
        }

        if ($SW_Permissions['File']['Admin'][$profilSession]) {
            $block3->paletteScript(1, 'remove', '../linkedcontent/deletefiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'false,true,true', lang_strings('delete'));
        }

        $block3->paletteScript(4, 'info', '../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'false,true,false', lang_strings('view'));

        if ($SW_Permissions['File']['Edit'][$profilSession]) {
            $block3->paletteScript(5, 'edit', '../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&edit=true', 'false,true,false', lang_strings('edit'));
            $block3->paletteScript(2, 'copy', '../linkedcontent/movefiles.php?cpy=true&parent=' . $doc_id, 'false,true,true', lang_strings('copy'));
            $block3->paletteScript(3, 'move', '../linkedcontent/movefiles.php?parent=' . $doc_id, 'false,true,true', lang_strings('move'));
        }
    } else {
        if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteScript(0, 'add', '../linkedcontent/addfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'true,false,false', lang_strings('add'));
        }

        if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteScript(1, 'remove', '../linkedcontent/deletefiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'false,true,true', lang_strings('delete'));
        }

        if ($sitePublish == 'true') {
            if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
                $block3->paletteScript(2, 'add_projectsite', '../linkedcontent/listfiles.php?addToSiteFile=true&doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&action=publish', 'false,true,true', lang_strings('add_project_site'));
                $block3->paletteScript(3, 'remove_projectsite', '../linkedcontent/listfiles.php?removeToSiteFile=true&doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&action=publish', 'false,true,true', lang_strings('remove_project_site'));
            }
        }

        $block3->paletteScript(4, 'info', '../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'false,true,false', lang_strings('view'));

        if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block3->paletteScript(5, 'edit', '../linkedcontent/viewfile.php?edit=true&doc_type=' . $doc_type . '&doc_id=' . $doc_id, 'false,true,false', lang_strings('edit'));
        }
    }

    $block3->paletteScript(6, 'export', '../linkedcontent/accessfiles.php?folders=false', 'false,true,true', lang_strings('export'));
    $block3->closePaletteScript($comptListFiles, $listFiles->fil_id);
}

if ($doc_type == '0' && $doc_id != '0' && $layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
