<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: movefiles.php,v 1.4 2009/09/01 15:01:17 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$ids = str_replace('**', ',', $id);
$ida = explode('**', $id);
$parent = isset($_GET['parent'])?$_GET['parent']:'0';
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$dest = isset($_POST['dest'])?$_POST['dest']:'0';

/**
 * Permission check
 */
if (!$SW_Permissions['File']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$tmpquery = " WHERE fil.id IN ($ids) AND fil.vc_parent=0 ORDER BY fil.dir,fil.name";
$listFiles = new request();
$listFiles->openFiles($tmpquery);
$comptListFiles = count($listFiles->fil_id);

if ($comptListFiles != count($ida)) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($action == 'move' && $dest != '0') {
    $tmpquery = " WHERE fil.id=$dest";
    $destFolder = new request();
    $destFolder->openFiles($tmpquery);
    $comptDestFolder = count($destFolder->fil_id);

    if ($comptDestFolder == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0", lang_strings('files'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('files'));
        }
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id", $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

function bof($id, $root = '')
{
    global $ids, $parent, $fol_id, $fol_path;
    $tmpquery = " WHERE fil.id NOT IN ($ids) AND fil.parent=$id AND fil.dir='" . B_TRUE . "' ORDER BY fil.name";
    $listFolders = new request();
    $listFolders->openFiles($tmpquery);
    $comptListFolders = count($listFolders->fil_id);

    for ($i=0; $i<$comptListFolders; $i++) {
        if ($listFolders->fil_id[$i] != $parent) {
            $fol_id[] = $listFolders->fil_id[$i];
            $fol_path[] = $root .'/' . $listFolders->fil_name[$i];
        }

        bof($listFolders->fil_id[$i], $root .'/' . $listFolders->fil_name[$i]);
    }
}

function copy_more_files($org_id, $new_id, $org_fullname, $new_fullname)
{
    global $tableName,$orgPath,$newPath,$nums,$idSession;
    $tmpquery = " WHERE fil.parent=$org_id AND fil.vc_parent=0 ORDER BY fil.dir,fil.name";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        $status = FS_NO_APPROVALS_NEEDED;
        $tmpquery = "INSERT INTO " . $tableName['files'] . " (owner,doc_type,doc_id,name,date,size,extension,comments,upload,published,status,vc_version,vc_parent,dir,parent,fullname) VALUES ($idSession,'0',$new_id,'" . HtmlEntitiesNOD($listFiles->fil_name[$i]) . "','$dateheure','" . $listFiles->fil_size[$i] . "','" . $listFiles->fil_extension[$i] . "','" . HtmlEntitiesNOD($listFiles->fil_comments[$i]) . "','" . $listFiles->fil_upload[$i] . "','" . PB_NO . "','$status','" . $listFiles->fil_vc_version[$i] . "','0','" . $listFiles->fil_dir[$i] . "',$new_id,'')";
        connectSql($tmpquery);
        $num = last_id($tableName["files"]);
        $nums[] = $num;
        $extension_len = strlen($listFiles->fil_extension[$i]) + 1;
        $filename_len = strlen($listFiles->fil_name[$i]);
        $filename_prefix = substr($listFiles->fil_name[$i], 0, $filename_len - $extension_len);
        $filename_prefix = urlencode($filename_prefix);

        if ($listFiles->fil_dir[$i] == B_TRUE) {
            $realname = $filename_prefix . '--' . $num;
        } else {
            $realname = $filename_prefix . '--' . $num . '.v' . $listFiles->fil_vc_version[$i] . '.' . $listFiles->fil_extension[$i];
        }

        $fullname = $new_fullname . '/' . $realname;
        $orgPath[] = $listFiles->fil_fullname[$i];
        $newPath[] = $fullname;
        $tmpquery = 'UPDATE ' . $tableName['files'] . " SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id=$num";
        connectSql($tmpquery);

        if ($listFiles->fil_dir[$i] == B_TRUE) {
            copy_more_files($listFiles->fil_id[$i], $num, $listFiles->fil_fullname[$i], $fullname);
        }
    }
}

function move_more_files($id, $org_fullname, $new_fullname)
{
    global $tableName;
    $tmpquery = " WHERE fil.parent=$id";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        $fullname = str_replace($org_fullname, $new_fullname, $listFiles->fil_fullname[$i]);

        if ($listFiles->fil_dir[$i] == B_TRUE) {
            move_more_files($listFiles->fil_id[$i], $listFiles->fil_fullname[$i], $fullname);
        }

        $tmpquery = "UPDATE " . $tableName['files'] . " SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id=" . $listFiles->fil_id[$i];
        connectSql($tmpquery);
    }
}

/**
 * Actions
 */
if ($action == "move") {
    if ($cpy == 'true') {
        for ($i=0; $i<$comptListFiles; $i++) {
            $status = FS_NO_APPROVALS_NEEDED;
            $tmpquery = "INSERT INTO " . $tableName['files'] . " (owner,doc_type,doc_id,name,date,size,extension,comments,upload,published,status,vc_version,vc_parent,dir,parent,fullname) VALUES ($idSession,'0',$dest,'" . HtmlEntitiesNOD($listFiles->fil_name[$i]) . "','$dateheure','" . $listFiles->fil_size[$i] . "','" . $listFiles->fil_extension[$i] . "','" . HtmlEntitiesNOD($listFiles->fil_comments[$i]) . "','" . $listFiles->fil_upload[$i] . "','" . PB_NO . "','$status','" . $listFiles->fil_vc_version[$i] . "','0','" . $listFiles->fil_dir[$i] . "',$dest,'')";
            connectSql($tmpquery);
            $num = last_id($tableName["files"]);
            $nums[] = $num;
            $extension_len = strlen($listFiles->fil_extension[$i]) + 1;
            $filename_len = strlen($listFiles->fil_name[$i]);
            $filename_prefix = substr($listFiles->fil_name[$i], 0, $filename_len - $extension_len);
            $filename_prefix = urlencode($filename_prefix);

            if ($listFiles->fil_dir[$i] == B_TRUE) {
                $realname = $filename_prefix . '--' . $num;
            } else {
                $realname = $filename_prefix . '--' . $num . '.v' . $listFiles->fil_vc_version[$i] . '.' . $listFiles->fil_extension[$i];
            }

            if ($dest == '0') {
                $fullname = $realname;
            } else {
                $fullname = $destFolder->fil_fullname[0] . '/' . $realname;
            }

            $orgPath[] = $listFiles->fil_fullname[$i];
            $newPath[] = $fullname;
            $tmpquery = 'UPDATE ' . $tableName['files'] . " SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id=$num";
            connectSql($tmpquery);

            if ($listFiles->fil_dir[$i] == B_TRUE) {
                copy_more_files($listFiles->fil_id[$i], $num, $listFiles->fil_fullname[$i], $fullname);
            }
        }

        foreach ($nums as $num) {
            $producer = $idSession;
            $doctype = ADT_FILE;
            require('../approvals/adddocument.php');
        }

        copyFiles($orgPath, $newPath);
        header('Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $dest . '&msg=copy');
        exit;
    } else {
        $tmpquery = " WHERE fil.id IN ($ids) ORDER BY fil.dir,fil.name";
        $listFiles = new request();
        $listFiles->openFiles($tmpquery);
        $comptListFiles = count($listFiles->fil_id);

        for ($i=0; $i<$comptListFiles; $i++) {
            if ($dest == '0') {
                $fullname = substr(strrchr($listFiles->fil_fullname[$i], '/'), 1);
            } else {
                if (strrchr($listFiles->fil_fullname[$i], '/') === false) {
                    $fullname = $destFolder->fil_fullname[0] . '/' . $listFiles->fil_fullname[$i];
                } else {
                    $fullname = $destFolder->fil_fullname[0] . strrchr($listFiles->fil_fullname[$i], '/');
                }
            }

            if ($listFiles->fil_dir[$i] == B_TRUE) {
                move_more_files($listFiles->fil_id[$i], $listFiles->fil_fullname[$i], $fullname);
            }

            $tmpquery = "UPDATE " . $tableName['files'] . " SET parent=$dest,fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id=" . $listFiles->fil_id[$i];
            connectSql($tmpquery);
        }

        moveFiles($listFiles->fil_fullname, $destFolder->fil_fullname[0]);
        header('Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $dest . '&msg=move');
        exit;
    }
}

/**
 * Prepare data
 */
if (!in_array(B_FALSE, $listFiles->fil_dir) && $parent != '0') {
    $fol_id[] = '0';
    $fol_path[] = '/';
}

bof('0');

if (count($fol_id) == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
item_bread_crumbs($parent);

if ($cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings('copy_files'));
} else {
    $blockPage->itemBreadcrumbs(lang_strings('move_files'));
}

$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = 'mvF';
$block1->openForm("../linkedcontent/movefiles.php?cpy=$cpy&parent=$parent&id=$id");
echo "<input type=\"hidden\" name=\"action\" value=\"move\">";
echo "<input type=\"hidden\" name=\"dest\" value=\"\">";

if ($cpy == 'true') {
    $block1->heading(lang_strings('copy_files'));
} else {
    $block1->heading(lang_strings('move_files'));
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

$block1->openContent();

if ($cpy == 'true') {
    $block1->contentTitle(lang_strings('copy_following'));
} else {
    $block1->contentTitle(lang_strings('move_following'));
}

for ($i=0; $i<$comptListFiles; $i++) {
    if ($listFiles->fil_dir[$i] == B_TRUE) {
        $block1->contentRow('', $listFiles->fil_name[$i] . '(' . lang_strings('folder') . ')');
    } else {
        $block1->contentRow('', $listFiles->fil_name[$i]);
    }
}

$block1->closeContent();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

$block1->openContent();
$block1->contentTitle(lang_strings('destination'));

for ($i=0; $i<count($fol_id); $i++) {
    $right = '<a href="javascript:document.mvFForm.dest.value=' . $fol_id[$i] . ';document.mvFForm.submit();">' . $fol_path[$i] . '</a>';
    $block1->contentRow('', $right);
}

$block1->closeContent();
$block1->closeForm();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
