<?php // $Revision: 1.27 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewfile.php,v 1.27 2009/09/18 05:54:16 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
require_once("../includes/files_types.php");

/**
 * Variables init
 */
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = isset($_GET['doc_id'])?$_GET['doc_id']:'0';
$id = isset($_GET['id'])?$_GET['id']:'0';
$file = isset($_GET['file'])?$_GET['file']:'0';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$c3 = isset($_POST['c3'])?$_POST['c3']:'';
$c4 = isset($_POST['c4'])?$_POST['c4']:'';
$revision = isset($_POST['revision'])?$_POST['revision']:'';
$change_file_version = isset($_POST['change_file_version'])?$_POST['change_file_version']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($action == 'publish') {
    $tmpquery = " WHERE fil.id=$file";
} else {
    $tmpquery = " WHERE fil.id=$id";
}

$fileDetail = new request();
$fileDetail->openFiles($tmpquery);
$comptFileDetail = count($fileDetail->fil_id);

if ($comptFileDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
} else {
    $fil_doc_type = $fileDetail->fil_doc_type[0];
    $fil_doc_id = $fileDetail->fil_doc_id[0];
}

if ($doc_type == '0') {
    if ($action == 'add' || $action == 'update') {
        if (!$SW_Permissions['File']['Edit'][$profilSession]) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else {
        if (!$SW_Permissions['File']['Read'][$profilSession]) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }

    $tmpquery = " WHERE fil.id=$doc_id AND fil.dir='" . B_TRUE . "'";
    $folderDetail = new request();
    $folderDetail->openFiles($tmpquery);
    $comptFolderDetail = count($folderDetail->fil_id);

    if ($comptFolderDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    switch ($fil_doc_type) {
        case DOC_PROJECT:
            $tmpquery = "SELECT id FROM " . $tableName['projects'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_PHASE:
            $tmpquery = "SELECT project_id FROM " . $tableName['phases'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_TASK:
            $tmpquery = "SELECT project FROM " . $tableName['tasks'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_MEETING:
            $tmpquery = "SELECT project FROM " . $tableName['meetings'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_DISCUSSION:
            $tmpquery = "SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=$fil_doc_id";
            break;
        case DOC_NOTE:
            $tmpquery = "SELECT project FROM " . $tableName['notes'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_EXPENSE:
            $tmpquery = "SELECT project FROM " . $tableName['expenses'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=$fil_doc_id";
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=$fil_doc_id";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery == '') {
        $linkedProject = '';
    } else {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $linkedProject = ($row[0]);
        } else {
            $linkedProject = '';
        }

        $request1->close();
    }
} else if ($doc_type == DOC_LEAVE) {
    $tmpquery = " WHERE lea.id=$doc_id";
    $leaveRequestDetail = new request();
    $leaveRequestDetail->openLeaveRequests($tmpquery);
    $comptLeaveRequestDetail = count($leaveRequestDetail->lea_id);

    if ($comptLeaveRequestDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $owner = $leaveRequestDetail->lea_owner[0];
    $status = $leaveRequestDetail->lea_status[0];

    if ($serialno == "") {
        $fyear = intval(substr($leaveRequestDetail->lea_date_start[0], 0, 4));
        $month = intval(substr($leaveRequestDetail->lea_date_start[0], 5, 2));
        $day = intval(substr($leaveRequestDetail->lea_date_start[0], 8, 2));

        if ($periodUnit == 'month') {
            $serialno = intval($month);
        } else {
            $weekday = date("w", mktime(12, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(12, 0, 0, $month, $day-6, $year);
            } else {
                $sdate = mktime(12, 0, 0, $month, $day-$weekday+1, $year);
            }

            $month = date('n', $sdate);
            $serialno = intval(date("W", $sdate));

            if ($sdate == '12' && $serialno == '1') {
                $fyear += 1;
            } else if ($sdate == '1' && $serialno > '50') {
                $fyear -= 1;
            }
        }
    }

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    }
} else {
    switch ($fil_doc_type) {
        case DOC_PROJECT:
            $tmpquery = "SELECT id FROM " . $tableName['projects'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_PHASE:
            $tmpquery = "SELECT project_id FROM " . $tableName['phases'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_TASK:
            $tmpquery = "SELECT project FROM " . $tableName['tasks'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_MEETING:
            $tmpquery = "SELECT project FROM " . $tableName['meetings'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_DISCUSSION:
            $tmpquery = "SELECT topic.project FROM " . $tableName['posts'] . " pos INNER JOIN " . $tableName['topics'] . " topic ON topic.id=pos.topic WHERE pos.id=$fil_doc_id";
            break;
        case DOC_NOTE:
            $tmpquery = "SELECT project FROM " . $tableName['notes'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_EXPENSE:
            $tmpquery = "SELECT project FROM " . $tableName['expenses'] . " WHERE id=$fil_doc_id";
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_requests'] . " req WHERE req.id=$fil_doc_id";
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = "SELECT req.project FROM " . $tableName['support_posts'] . " pos INNER JOIN " . $tableName['support_requests'] . " req ON req.id=pos.request_id WHERE pos.id=$fil_doc_id";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery == '') {
        $linkedProject = '';
    } else {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $linkedProject = ($row[0]);
        } else {
            $linkedProject = '';
        }

        $request1->close();
    }
}

if ($linkedProject != '') {
    $tmpquery = " WHERE pro.id=$linkedProject";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    $tmpquery = " WHERE tea.project=$linkedProject AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$linkedProject AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$linkedProject AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($action == "publish") {
        if ($permissionDetail->prp_publish_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $linkedProject);
            exit;
        }
    } else if ($action == 'add' || $action == 'update') {
        if ($permissionDetail->prp_update_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $linkedProject);
            exit;
        }
    } else {
        if ($permissionDetail->prp_view_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $linkedProject);
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($addToSiteFile == "true") {
        $tmpquery = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id=$file OR vc_parent=$file";
        connectSql($tmpquery);
        $msg = "addToSite";
        $id = $file;
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        $comptFileDetail = count($fileDetail->fil_id);
    } else if ($removeToSiteFile == "true") {
        $tmpquery = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id=$file OR vc_parent=$file";
        connectSql($tmpquery);
        $msg = "removeToSite";
        $id = $file;
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        $comptFileDetail = count($fileDetail->fil_id);
    }
} else if ($action == 'add') {
    if ($_FILES['upload']['name'] == '') {
        $error3 = lang_strings("no_file");
    } else if ($_FILES['upload']['size'] == '0') {
        $error3 = lang_strings('exceed_size');
    } else {
        $extension = strtolower(substr(strrchr($_FILES['upload']['name'], ".") , 1));
        $extension_len = strlen($extension) + 1;
        $filename_len = strlen($_FILES['upload']['name']);
        $filename_prefix = substr($_FILES['upload']['name'], 0, $filename_len - $extension_len);

        if ($allowPhp == "false") {
            if ($extension == "php" || $extension == "php3" || $extension == "phtml") {
                $error3 = lang_strings("no_php");
            }
        }
    }

    if ($error3 == "") {
        $c = HtmlEntitiesNOD($c3);
        $status = FS_NO_APPROVALS_NEEDED;
        $tmpquery = "INSERT INTO " . $tableName["files"] . "(owner,doc_type,doc_id,name,date,comments,upload,published,status,vc_version,vc_parent,dir,parent,fullname) VALUES ($idSession,$doc_type,$doc_id,'" . HtmlEntitiesNOD($_FILES['upload']['name']) . "','$dateheure','$c','$dateheure','" . $fileDetail->fil_published[0] . "','$status','" . $fileDetail->fil_vc_version[0] . "','$id','" . B_FALSE . "'," . $fileDetail->fil_parent[0] . ",'')";
        connectSql($tmpquery);
        $num = last_id($tableName["files"]);
        $realname = urlencode($filename_prefix) . '--' . $num . '.v' . $fileDetail->fil_vc_version[0] . '.r' . $revision . '.' . $extension;
        $path = substr($fileDetail->fil_fullname[0], 0, strrpos($fileDetail->fil_fullname[0], '/'));
        $size = uploadFile($path, $_FILES['upload']['tmp_name'], $realname);
        $extension = strtolower($extension);
        $fullname = HtmlEntitiesNOD($path . '/' . $realname);
        $tmpquery = 'UPDATE ' . $tableName['files'] . " SET size='$size',extension='$extension',fullname='$fullname' WHERE id=$num";
        connectSql($tmpquery);
        $producer = $idSession;
        $doctype = ADT_FILE;
        require_once('../approvals/adddocument.php');
        header("Location: ../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id&msg=addFile");
        exit;
    }
} else if ($action == 'update') {
    if ($_FILES['upload']['name'] == '') {
        $error4 = lang_strings("no_file");
    } else if ($_FILES['upload']['size'] == '0') {
        $error4 = lang_strings('exceed_size');
    } else {
        $extension = strtolower(substr(strrchr($_FILES['upload']['name'], ".") , 1));
        $extension_len = strlen($extension) + 1;
        $filename_len = strlen($_FILES['upload']['name']);
        $filename_prefix = substr($_FILES['upload']['name'], 0, $filename_len - $extension_len);

        if ($allowPhp == "false") {
            if ($extension == "php" || $extension == "php3" || $extension == "phtml") {
                $error4 = lang_strings("no_php");
            }
        }
    }

    if ($error4 == "") {
        $tmpquery = "INSERT INTO " . $tableName['files'] . " (owner,doc_type,doc_id,name,date,size,extension,comments,upload,published,status,vc_status,vc_version,vc_parent,dir,parent,fullname) VALUES (" . $fileDetail->fil_owner[0] . ",'" . $fileDetail->fil_doc_type[0] . "'," . $fileDetail->fil_doc_id[0] . ",'" . HtmlEntitiesNOD($fileDetail->fil_name[0]) . "','" . $fileDetail->fil_date[0] . "','" . $fileDetail->fil_size[0] . "','" . $fileDetail->fil_extension[0] . "','" . HtmlEntitiesNOD($fileDetail->fil_comments[0]) . "','" . $fileDetail->fil_upload[0] . "','" . $fileDetail->fil_published[0] . "','" . $fileDetail->fil_status[0] . "','3','" . $fileDetail->fil_vc_version[0] . "',$id,'" . $fileDetail->fil_dir[0] . "'," . $fileDetail->fil_parent[0] . ",'" . HtmlEntitiesNOD($fileDetail->fil_fullname[0]) . "')";
        connectSql($tmpquery);
        $newversion = $fileDetail->fil_vc_version[0] + $change_file_version;
        $c = HtmlEntitiesNOD($c4);
        $status = FS_NO_APPROVALS_NEEDED;
        $realname = urlencode($filename_prefix) . '--' . $num . '.v' . $newversion . '.' . $extension;
        $path = substr($fileDetail->fil_fullname[0], 0, strrpos($fileDetail->fil_fullname[0], '/'));
        $size = uploadFile($path, $_FILES['upload']['tmp_name'], $realname);
        $extension = strtolower($extension);
        $fullname .= HtmlEntitiesNOD($path . '/' . $realname);
        $num = $id;
        $tmpquery = 'UPDATE ' . $tableName['files'] . " SET owner=$idSession,name='" . HtmlEntitiesNOD($_FILES['upload']['name']) . "',date='$dateheure',size='$size',extension='$extension',comments='$c',status='$status',vc_version='$newversion',fullname='$fullname' WHERE id=$num";
        connectSql($tmpquery);
        $producer = $idSession;
        $doctype = ADT_FILE;
        require_once('../approvals/adddocument.php');
        header("Location: ../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$num&msg=addFile");
        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php', lang_strings('administration'), 'in'));
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0", lang_strings('files'), 'in'));
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id", $fileDetail->fil_name[0], 'in'));
    }
}

function getLocation($fid)
{
    $tmpquery = " WHERE fil.id=$fid";
    $fileDetail = new request();
    $fileDetail->openFiles($tmpquery);

    if ($fileDetail->fil_parent[0] == '0') {
        return '/' . $fileDetail->fil_name[0];
    } else {
        return getLocation($fileDetail->fil_parent[0]) . '/' . $fileDetail->fil_name[0];
    }
}

/**
 * Prepare data
 */
$type = file_info_type($fileDetail->fil_extension[0]);
$displayname = $fileDetail->fil_name[0];

switch ($doc_type) {
    case DOC_PHASE:
        $tmpquery = " WHERE pha.id=$doc_id";
        $phaseDetail = new request();
        $phaseDetail->openPhases($tmpquery);
        break;
    case DOC_TASK:
        $tmpquery = " WHERE tas.id=$doc_id";
        $taskDetail = new request();
        $taskDetail->openTasks($tmpquery);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $tmpquery = " WHERE pha.project_id=$linkedProject AND pha.order_num=" . $taskDetail->tas_parent_phase[0];
            $targetPhase = new request();
            $targetPhase->openPhases($tmpquery);
        }

        break;
    case DOC_MEETING:
        $tmpquery = " WHERE mee.id=$doc_id";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($tmpquery);
        break;
    case DOC_DISCUSSION:
        $tmpquery = " WHERE pos.id=$doc_id";
        $postDetail = new request();
        $postDetail->openPosts($tmpquery);
        break;
    case DOC_NOTE:
        $tmpquery = " WHERE note.id=$doc_id";
        $noteDetail = new request();
        $noteDetail->openNotes($tmpquery);
        break;
    case DOC_EXPENSE:
        $tmpquery = " WHERE exp.id=$doc_id";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($tmpquery);
        break;
    case DOC_SUPPORT_REQUEST:
        $tmpquery = " WHERE sr.id=$doc_id";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($tmpquery);
    case DOC_SUPPORT_POST:
        $tmpquery = " WHERE sp.id=$doc_id";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($tmpquery);
        break;
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id);
} else if ($doc_type == DOC_LEAVE) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings('timesheet'), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear", in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("leave_request") . " #$doc_id", in));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case DOC_PHASE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$linkedProject", lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$linkedProject&id=" . $phaseDetail->pha_id[0], $phaseDetail->pha_name[0], 'in'));
            break;
        case DOC_TASK:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$linkedProject", lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$linkedProject&id=" . $targetPhase->pha_id[0], $targetPhase->pha_name[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$linkedProject", lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id", $taskDetail->tas_name[0], 'in'));
            break;
        case DOC_MEETING:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$linkedProject", lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id", $meetingDetail->mee_name[0], 'in'));
            break;
        case DOC_DISCUSSION:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$linkedProject", lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0], $postDetail->pos_topic_subject[0], 'in'));
            break;
        case DOC_NOTE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$linkedProject", lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0], $noteDetail->note_subject[0], 'in'));
            break;
        case DOC_EXPENSE:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $linkedProject, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0], $expenseType['sets'][$expenseDetail->exp_expensetype[0]] . " " . $amount, 'in'));
            break;
        case DOC_SUPPORT_REQUEST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$linkedProject", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0], $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case DOC_SUPPORT_POST:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$linkedProject", lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0], $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id", lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages();
}

/**
 * File details block
 */
$block1 = new block();
$block1->form = "fdL";
$block1->openForm("../files/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id#" . $block1->form . "Anchor");

if ($doc_type == '0') {
    $block1->heading(lang_strings("files"));
} else {
    $block1->heading(lang_strings("linked_content"));
}

$block1->openPaletteIcon();

if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
    if (($SW_Permissions['File']['Admin'][$profilSession]) && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_delete_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) {
        $block1->paletteIcon(1, 'remove', lang_strings('delete'));
    }

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block1->paletteIcon(2, "copy", lang_strings("copy"));
        $block1->paletteIcon(3, "move", lang_strings("move"));
    }
} else {
    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, 'remove', lang_strings('delete'));
    }

    if ($sitePublish == 'true') {
        if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block1->paletteIcon(2, 'add_projectsite', lang_strings('add_project_site'));
            $block1->paletteIcon(3, 'remove_projectsite', lang_strings('remove_project_site'));
        }
    }
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("type"), "<img src=\"../interface/icones/$type\" border=\"0\" alt=\"\">");
$block1->contentRow(lang_strings("name"), $fileDetail->fil_name[0]);

if ($doc_type != '0') {
    $block1->contentRow(lang_strings('file_location'), $blockPage->buildLink('../linkedcontent/listfiles.php?id=' . $fileDetail->fil_parent[0], getLocation($fileDetail->fil_parent[0]), 'in'));
}

$block1->contentRow(lang_strings("vc_version"), $fileDetail->fil_vc_version[0]);
$block1->contentRow(lang_strings("ifc_last_date"), $fileDetail->fil_date[0]);
$block1->contentRow(lang_strings("size"), convertSize($fileDetail->fil_size[0]));
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink("../users/viewuser.php?id=" . $fileDetail->fil_mem_id[0], $fileDetail->fil_mem_name[0], 'in'));

if ($fileDetail->fil_comments[0] != "") {
    $block1->contentRow(lang_strings("comments"), nl2br($fileDetail->fil_comments[0]));
}

if ($doc_type != '0' && $doc_type != DOC_LEAVE) {
    $block1->contentRow(lang_strings("published"), $statusPublish[$fileDetail->fil_published[0]]);
}

if ($fil_doc_type != '0') {
    switch ($fil_doc_type) {
        case DOC_PROJECT:
            $tmpquery = " WHERE pro.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openProjects($tmpquery);
            $baseDoc = $blockPage->buildLink("../projects/viewproject.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->pro_name[0], 'in');
            break;
        case DOC_PHASE:
            $tmpquery = " WHERE pha.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openPhases($tmpquery);
            $baseDoc = $blockPage->buildLink("../phases/viewphase.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->pha_name[0], 'in');
            break;
        case DOC_TASK:
            $tmpquery = " WHERE tas.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openTasks($tmpquery);
            $baseDoc = $blockPage->buildLink("../tasks/viewtask.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->tas_name[0], 'in');
            break;
        case DOC_MEETING:
            $tmpquery = " WHERE mee.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openMeetings($tmpquery);
            $baseDoc = $blockPage->buildLink("../meetings/viewmeeting.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->mee_name[0], 'in');
            break;
        case DOC_DISCUSSION:
            $tmpquery = " WHERE pos.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openPosts($tmpquery);
            $baseDoc = $blockPage->buildLink("../topics/viewtopic.php?id=" . $baseReq->pos_topic[0], '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->pos_topic_subject[0], 'in');
            break;
        case DOC_NOTE:
            $tmpquery = " WHERE note.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openNotes($tmpquery);
            $baseDoc = $blockPage->buildLink("../notes/viewnote.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->note_subject[0], 'in');
            break;
        case DOC_EXPENSE:
            $baseDoc = $blockPage->buildLink("../expenses/viewexpense.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')#' . $fil_doc_id, 'in');
            break;
        case DOC_SUPPORT_REQUEST:
            $tmpquery = " WHERE sr.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openSupportRequests($tmpquery);
            $baseDoc = $blockPage->buildLink("../support/viewrequest.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->sr_subject[0], 'in');
            break;
        case DOC_SUPPORT_POST:
            $tmpquery = " WHERE sp.id=$fil_doc_id";
            $baseReq = new request();
            $baseReq->openSupportPosts($tmpquery);
            $baseDoc = $blockPage->buildLink("../support/viewrequest.php?id=" . $baseReq->sp_request_id[0], '(' . $fileDocType[$fil_doc_type] . ')' . $baseReq->sp_sr_subject[0], 'in');
            break;
        case DOC_LEAVE:
            $baseDoc = $blockPage->buildLink("../leaves/viewleaverequest.php?id=$fil_doc_id", '(' . $fileDocType[$fil_doc_type] . ')#' . $fil_doc_id, 'in');
            break;
    }

    $block1->contentRow(lang_strings('base_doc'), $baseDoc);
}

$block1->contentRow(lang_strings("approval_tracking"), $statusFile[$fileDetail->fil_status[0]]);
$tmpquery = " WHERE fil.id=$id OR (fil.vc_parent=$id AND fil.vc_status='" . FS_NO_APPROVALS_NEEDED . "') ORDER BY fil.date DESC";
$listVersions = new request();
$listVersions->openFiles($tmpquery);
$comptListVersions = count($listVersions->fil_vc_parent);
$version_history = "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableRevision\">";

for ($i=0, $class="new"; $i<$comptListVersions; $i++, $class=($class=="new")?"old":"new") {
    $version_history .= "<tr class=\"$class\"><td>";

    if (((($doc_type == '0' || $doc_type == DOC_LEAVE) && $SW_Permissions['File']['Admin'][$profilSession]) || ($doc_type != '0' && $doc_type != DOC_LEAVE && ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) && $listVersions->fil_id[$i] != $fileDetail->fil_id[0]) {
        $version_history .= "<a href=\"javascript:MM_toggleItem(document." . $block1->form . "Form, '" . $listVersions->fil_id[$i] . "', '" . $block1->form . "cb" . $listVersions->fil_id[$i] . "','" . THEME . "')\"><img name=\"" . $block1->form . "cb" . $listVersions->fil_id[$i] . "\" border=\"0\" src=\"../themes/" . THEME . "/checkbox_off_16.gif\" alt=\"\" vspace=\"0\"></a>";
    }

    $version_history .= "&nbsp;</td><td>" . lang_strings("vc_version") . " : " . $listVersions->fil_vc_version[$i] . "</td><td colspan=\"3\">" . $listVersions->fil_name[$i] . "&nbsp;&nbsp;";
    $existFile = fileExists($listVersions->fil_fullname[$i]);

    if ($existFile) {
        $version_history .= $blockPage->buildLink("../linkedcontent/accessfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;mode=view&amp;id=" . $listVersions->fil_id[$i], lang_strings("view"), 'in');
        $version_history .= " " . $blockPage->buildLink("../linkedcontent/accessfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;mode=download&amp;id=" . $listVersions->fil_id[$i], lang_strings("save"), 'in');
    } else {
        $version_history .= lang_strings("missing_file");
    }

    $version_history .= "</td><td>" . lang_strings("date") . " : " . $listVersions->fil_date[$i] . "</td></tr>";
}

$version_history .= "</table>";
$block1->contentRow(lang_strings("ifc_version_history"), $version_history);

if ($fileDetail->fil_status[0] != FS_NO_APPROVALS_NEEDED) {
    $block1->contentTitle(lang_strings("approval_history"));
    $tmpquery = " WHERE dap.docid=$id AND dap.doctype='" . ADT_FILE . "' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($tmpquery);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0,$ah=''; $i<$comptListDocumentsApproval; $i++,$ah.='<br>') {
        if ($i == 0) {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['submit_at']) . '</i>';
        } else {
            $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], $timezoneSession), $strings['resubmit_at']) . '</i>';
        }

        $tmpquery = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . AS_PENDING . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($tmpquery);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_APPROVED) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == AS_NOT_APPROVED) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], $timezoneSession), $ahd);
                $ah .= '<br><i>' . $ahd  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $ah .= '<br>' . nl2br($listDocumentsApprovalAuthorizer->daa_comments[$j]);
                }
            }
        }
    }

    $block1->contentRow('', $ah);
}

$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
    if (($SW_Permissions['File']['Admin'][$profilSession]) && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_delete_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) {
        $block1->paletteScript(1, "remove", "../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_id=$doc_id&id=$id&sendto=filedetails", "true,true,true", lang_strings("ifc_delete_version"));
    }

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block1->paletteScript(2, "copy", "../linkedcontent/movefiles.php?cpy=true&parent=" . $fileDetail->fil_parent[0] . "&id=$id", "true,true,false", lang_strings("copy"));
        $block1->paletteScript(3, "move", "../linkedcontent/movefiles.php?parent=" . $fileDetail->fil_parent[0] . "&id=$id", "true,true,false", lang_strings("move"));
    }
} else {
    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "remove", "../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_id=$doc_id&id=$id&sendto=filedetails", "true,true,true", lang_strings("ifc_delete_version"));
    }

    if ($sitePublish == 'true') {
        if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block1->paletteScript(2, "add_projectsite", "../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&addToSiteFile=true&file=$id&action=publish", "true,true,true", lang_strings("add_project_site"));
            $block1->paletteScript(3, "remove_projectsite", "../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&removeToSiteFile=true&file=$id&action=publish", "true,true,true", lang_strings("remove_project_site"));
        }
    }
}

$block1->closePaletteScript($comptFileDetail, $fileDetail->fil_id);

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

/**
 * Revision list block
 */
if ($peerReview == "true") {
    $block2 = new block();
    $block2->form = "rvF";
    $block2->openForm("../files/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id#" . $block2->form . "Anchor");
    $block2->heading(lang_strings("ifc_revisions"));
    $block2->openPaletteIcon();

    if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
        if (($SW_Permissions['File']['Admin'][$profilSession]) && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_delete_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) {
            $block2->paletteIcon(0, "remove", lang_strings("ifc_delete_review"));
        }
    } else {
        if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block2->paletteIcon(0, "remove", lang_strings("ifc_delete_review"));
        }
    }

    $block2->closePaletteIcon();
    $block2->openContent();
    $block2->contentTitle(lang_strings("details"));
    $tmpquery = " WHERE fil.vc_parent=$id AND fil.vc_status!='" . FS_NO_APPROVALS_NEEDED . "' ORDER BY fil.date";
    $listReviews = new request();
    $listReviews->openFiles($tmpquery);
    $comptListReviews = count($listReviews->fil_vc_parent);

    if ($comptListReviews != '0') {
        echo "<tr class=\"odd\"><td><br>";

        for ($i=0; $i<$comptListReviews; $i++) {
            // Sort odds and evens for bg color
            if (!($i % 2)) {
                $class = "odd";
                $highlightOff = $oddColor;
            } else {
                $class = "even";
                $highlightOff = $evenColor;
            }

            // Calculate a revision number for display for each listing
            $displayrev = $i + 1;
            echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableRevision\" onmouseover=\"this.style.backgroundColor='" . $block2->highlightOn . "'\" onmouseout=\"this.style.backgroundColor='" . $block2->highlightOff . "'\">
	<tr bgcolor=\"" . $block2->fgColor . "\"><td>";

            if ((($doc_type == '0' || $doc_type == DOC_LEAVE) && $SW_Permissions['File']['Admin'][$profilSession]) || ($doc_type != '0' && $doc_type != DOC_LEAVE && ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) {
                echo "<a href=\"javascript:MM_toggleItem(document." . $block2->form . "Form, '" . $listReviews->fil_id[$i] . "', '" . $block2->form . "cb" . $listReviews->fil_id[$i] . "','" . THEME . "')\"><img name=\"" . $block2->form . "cb" . $listReviews->fil_id[$i] . "\" border=\"0\" src=\"../themes/" . THEME . "/checkbox_off_16.gif\" alt=\"\" vspace=\"0\"></a>";
            }

            echo "&nbsp;</td>
	<td colspan=\"3\">$displayname&nbsp;&nbsp;";
            $existFile = fileExists($listReviews->fil_fullname[$i]);

            if ($existFile) {
                echo $blockPage->buildLink("../linkedcontent/accessfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;mode=view&amp;id=" . $listReviews->fil_id[$i], lang_strings("view"), 'in');
                echo " " . $blockPage->buildLink("../linkedcontent/accessfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;mode=download&amp;id=" . $listReviews->fil_id[$i], lang_strings("save"), 'in');
            } else {
                echo lang_strings("missing_file");
            }

            echo"</td><td align=\"right\">Revision: $displayrev&nbsp;&nbsp;</td></tr>
	<tr><td>&nbsp;</td><td width=\"30%\">" . lang_strings("ifc_revision_of") . " : " . $listReviews->fil_vc_version[$i] . "</td>
        <td width=\"40%\">" . lang_strings("owner") . " : " . $listReviews->fil_mem_name[$i] . "</td>
        <td colspan=\"2\" align=\"left\" width=\"30%\">" . lang_strings("date") . " : " . $listReviews->fil_date[$i] . "</td></tr>
	<tr><td>&nbsp;</td><td colspan=\"4\">" . lang_strings("comments") . " : " . nl2br($listReviews->fil_comments[$i]) . "</td></tr>
	</table><br>";
        }
    } else {
        $block2->contentRow("", lang_strings("ifc_no_revisions"));
    }

    $block2->closeResults();
    $block2->closeFormResults();
    $block2->openPaletteScript();

    if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
        if (($SW_Permissions['File']['Admin'][$profilSession]) && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_delete_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) {
            $block2->paletteScript(0, "remove", "../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_id=$doc_id&sendto=filedetails", "false,true,true", lang_strings("ifc_delete_review"));
        }
    } else {
        if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
            $block2->paletteScript(0, "remove", "../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_id=$doc_id&sendto=filedetails", "false,true,true", lang_strings("ifc_delete_review"));
        }
    }

    $block2->closePaletteScript($comptListReviews, $listReviews->fil_id);

    if ((($doc_type == '0' || $doc_type == DOC_LEAVE) && $SW_Permissions['File']['Edit'][$profilSession] && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_update_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) || ($doc_type != '0' && $doc_type != DOC_LEAVE && ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) {
        /**
         * Add new revision Block
         */
        $block3 = new block();
        $block3->form = "afR";
        echo "<a name=\"afRAnchor\"></a>";
        echo "<form accept-charset=\"UNKNOWN\" method=\"POST\" action=\"../linkedcontent/viewfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;action=add&amp;id=" . $fileDetail->fil_id[0] . "#afRAnchor\" name=\"afRForm\" enctype=\"multipart/form-data\">";

        if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
            echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $maxFileSize . '"/>';
        } else {
            echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $projectDetail->pro_upload_max[0] . '"/>';
        }

        if ($error3 != "") {
            $block3->headingError(lang_strings("errors"));
            $block3->contentError($error3);
        }

        $block3->heading(lang_strings("ifc_add_revision"));
        $block3->openContent();
        $block3->contentTitle(lang_strings("details"));
        // Add one to the number of current revisions
        $revision = $displayrev + 1;
        echo '<input type="hidden" name="revision" value="' . $revision . '"/>';
        $block3->contentRow(lang_strings("upload"), "<input size=\"44\" style=\"width: 400px\" name=\"upload\" type=\"FILE\">");
        $block3->contentRow(lang_strings("comments"), "<textarea rows=\"3\" style=\"width: 400px; height: 50px;\" name=\"c3\" cols=\"43\">$c3</textarea>");
        $block3->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
        $block3->closeContent();
        $block3->closeForm();
    }
}

/**
 * Update file Block
 */
if ((($doc_type == '0' || $doc_type == DOC_LEAVE) && $SW_Permissions['File']['Edit'][$profilSession] && (($linkedProject == '') || ($linkedProject != '' && $permissionDetail->prp_update_file[0] == B_TRUE) || $SW_Permissions['Project']['Edit'][$profilSession])) || ($doc_type != '0' && $doc_type != DOC_LEAVE && ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) {
    $block4 = new block();
    $block4->form = "updF";
    echo "<a name=\"updFAnchor\"></a>";
    echo "<form accept-charset=\"UNKNOWN\" method=\"POST\" action=\"../linkedcontent/viewfile.php?doc_type=$doc_type&amp;doc_id=$doc_id&amp;action=update&amp;id=" . $fileDetail->fil_id[0] . "#updFAnchor\" name=\"updFForm\" enctype=\"multipart/form-data\">";

    if ($doc_type == '0' || $doc_type == DOC_LEAVE) {
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $maxFileSize . '"/>';
    } else {
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="' . $projectDetail->pro_upload_max[0] . '"/>';
    }

    if ($error4 != "") {
        $block4->headingError(lang_strings("errors"));
        $block4->contentError($error4);
    }

    $block4->heading(lang_strings("ifc_update_file"));
    $block4->openContent();
    $block4->contentTitle(lang_strings("details"));
    $block4->contentRow(lang_strings("version_increm"), "<br>
	<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
	<tr><td align=\"right\">0.01</td><td width=\"30\" align=\"right\"><input name=\"change_file_version\" type=\"radio\" value=\"0.01\"></td></tr>
	<tr><td align=\"right\">0.1</td><td width=\"30\" align=\"right\"><input name=\"change_file_version\" type=\"radio\" value=\"0.1\" checked></td></tr>
	<tr><td align=\"right\">1.0</td><td width=\"30\" align=\"right\"><input name=\"change_file_version\" type=\"radio\" value=\"1.0\"></td></tr>
	</table>");
    $block4->contentRow(lang_strings("upload"), "<input size=\"44\" style=\"width: 400px\" name=\"upload\" type=\"FILE\">");
    $block4->contentRow(lang_strings("comments"), "<textarea rows=\"3\" style=\"width: 400px; height: 50px;\" name=\"c4\" cols=\"43\">$c4</textarea>");
    $block4->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["ifc_update_file"] . "\">");
    $block4->closeContent();
    $block4->closeForm();
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
