<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmeetingtime.php,v 1.18 2009/09/04 08:58:46 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$meeting = isset($_GET['meeting'])?$_GET['meeting']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$ld = isset($_POST['ld'])?$_POST['ld']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$bodyCommand = "onload=\"document.saMForm.hr.focus();\"";

/**
 * Permission check
 */
$tmpquery = " WHERE mti.id=$id";
$meetingTimeDetail = new request();
$meetingTimeDetail->openMeetingTime($tmpquery);
$comptMeetingTimeDetail = count($meetingTimeDetail->mti_id);

if ($comptMeetingTimeDetail == '0') {
    header('Location: ../general/home.php?msg=permissiondenied');
    exit;
}

if ($action == '') {
    $ld = $meetingTimeDetail->mti_date[0];
    $hr = $meetingTimeDetail->mti_hours[0];
    $comm = $meetingTimeDetail->mti_comments[0];
}

$tmpquery = " WHERE mee.id=$meeting";
$meetingDetail = new request();
$meetingDetail->openMeetings($tmpquery);
$project = $meetingDetail->mee_project[0];
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_log_meeting_hours[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE att.meeting=$meeting";
$listAttendants = new request();
$listAttendants->openAttendants($tmpquery);
$comptListAttendants = count($listAttendants->att_id);

if (array_search($idSession, $listAttendants->att_member) === FALSE) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == 'edit') {
    $error = ''; // init

    // make sure we have the required information
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            // we need this to be numeric
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
            $hr_highlight = true;
        } 
    } else {
        // we need this to be numeric
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '') {
        if ($ld < $meetingDetail->mee_date[0]) {
            $error = lang_strings("date_deviate");
        } else if (periodLocked($ld)) {
            $error = lang_strings("date_deviate");
        } else if ($enableTimesheet == 'true') {
            $fyear = intval(substr($ld, 0, 4));
            $month = intval(substr($ld, 5, 2));
            $day = intval(substr($ld, 8, 2));
            $weekday = date("w", mktime(12, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(12, 0, 0, $month, $day-6, $fyear);
            } else {
                $sdate = mktime(12, 0, 0, $month, $day-$weekday+1, $fyear);
            }

            if ($periodUnit == 'month') {
                $serialno = date("n");
            } else {
                $serialno = intval(date("W", $sdate));
            }

            $tmpquery = " WHERE tim.owner=$idSession AND per.fyear=$fyear AND per.serial_no=$serialno";
            $timesheetDetail = new request();
            $timesheetDetail->openTimesheet($tmpquery);
            $comptTimesheetDetail = count($timesheetDetail->tim_owner);

            if ($comptTimesheetDetail == '0') {
                $timesheetReadOnly = false;
            } else if ($timesheetDetail->tim_status[0] == FS_NEEDS_APPROVAL) {
                $timesheetReadOnly = true;
            } else {
                $timesheetReadOnly = false;
            }

            if ($timesheetReadOnly) {
                $error = lang_strings("no_permissions");
            }
        }
    }

    // update meeting time in database
    if ($error == '') {
        $hr = round($hr, $hourAccuracy);
        $comm = HtmlEntitiesNOD($comm);
        $tmpquery1  = "UPDATE " . $tableName['meetings_time'] . " ";
        $tmpquery1 .= "SET date='$ld',hours=$hr,";
        $tmpquery1 .= "comments='$comm',modified='$dateheures' ";
        $tmpquery1 .= "WHERE id=$id";
        connectSql($tmpquery1);
        header("Location: ../meetings/addmeetingtime.php?id=$meeting&msg=update");
        exit;
    }
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=" . $projectDetail->pro_id[0], lang_strings("meetings"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=" . $meetingDetail->mee_id[0], $meetingDetail->mee_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_meeting_time"));
$blockPage->closeBreadcrumbs();

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$blockPage->bornesNumber = "1";
// get actual time for meeting
$meetingActualTime = new request();
$actualTime = $meetingActualTime->getMeetingTime($meeting);
$block1 = new block();
$block1->form = "saM";
$block1->openForm("../meetings/editmeetingtime.php?id=$id&meeting=$meeting#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="edit">';
$block1->heading(lang_strings("edit_meeting_time") . " : " . $meetingDetail->mee_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings("meetings"), $meetingDetail->mee_name[0]);
$block1->contentRow(lang_strings("me_agenda"), nl2br($meetingDetail->mee_agenda[0]));
$block1->contentRow(lang_strings("actual_time"), $actualTime . " " . lang_strings("hours"));
$block1->contentTitle(lang_strings("edit_meeting_time"));
$block1->contentRow(lang_strings('date'), "
<input type=\"text\" class=\"input_datetime\" name=\"ld\" id=\"sel1\" size=\"20\" value=\"$ld\" readonly>
<button type=\"reset\" id=\"trigger_a\">...</button>
<script type=\"text/javascript\">
function closeSel1(cal)
{
    var x=document.saMForm;
    cal.hide();
    x.action.value = 'reload';
    x.submit();
    return true;
};
Calendar.setup({ inputField:\"sel1\", button:\"trigger_a\", onClose:closeSel1 });
</script>
");

if ($hr_highlight) {
    $block1->contentRow("* " . lang_strings("worked_hours"), '<input size="20" value="' . $hr . '" class="input_hours_highlight" name="hr" maxlength="6" type="text">');
} else {
    $block1->contentRow("* " . lang_strings("worked_hours"), '<input size="20" value="' . $hr . '" class="input_hours" name="hr" maxlength="6" type="text">');
}

$block1->contentRow(lang_strings("comments"), '<textarea rows="3" class="textarea_3rows" name="comm" cols="47">' . $comm . '</textarea>');
$block1->contentRow("", '<input type="SUBMIT" value="' . $strings["update"] . '"><input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
