<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listnotes.php,v 1.9 2009/09/01 15:01:17 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$project = isset($_GET['project'])?$_GET['project']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
$removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_note[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($permissionDetail->prp_publish_note[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    if ($addToSite == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["notes"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["notes"] . " SET published='" . PB_YES . "' WHERE id=$id";
        }

        connectSql($tmpquery1);
        $msg = "addToSite";
        $id = $project;
    }

    if ($removeToSite == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["notes"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["notes"] . " SET published='" . PB_NO . "' WHERE id=$id";
        }

        connectSql($tmpquery1);
        $msg = "removeToSite";
        $id = $project;
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("notes"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "lsN";
$block1->openForm("../notes/listnotes.php?project=$project#" . $block1->form . "Anchor");
$block1->heading(lang_strings("notes"));
$block1->openPaletteIcon();

if ($permissionDetail->prp_add_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, "add", lang_strings("add"));
}

if ($permissionDetail->prp_delete_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
}

if ($permissionDetail->prp_publish_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    if ($sitePublish == "true") {
        $block1->paletteIcon(3, "add_projectsite", lang_strings("add_project_site"));
        $block1->paletteIcon(4, "remove_projectsite", lang_strings("remove_project_site"));
    }
}

$block1->paletteIcon(5, "info", lang_strings("view"));

if ($permissionDetail->prp_modify_note_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(6, "edit", lang_strings("edit"));
}

$block1->closePaletteIcon();

if ($sitePublish == "true") {
    $block1->sorting("notes", $sortingUser->sor_notes[0], "note.date DESC", $sortingFields = array(0 => "note.subject", 1 => "note.topic", 2 => "note.date", 3 => "mem.name", 4 => "note.published"));
} else {
    $block1->sorting("notes", $sortingUser->sor_notes[0], "note.date DESC", $sortingFields = array(0 => "note.subject", 1 => "note.topic", 2 => "note.date", 3 => "mem.name"));
}

$tmpquery = " WHERE note.project=$project ORDER BY $block1->sortingValue";
$listNotes = new request();
$listNotes->openNotes($tmpquery);
$comptListNotes = count($listNotes->note_id);

if ($comptListNotes != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings("subject"), 1 => lang_strings("topic"), 2 => lang_strings("date"), 3 => lang_strings("owner"), 4 => lang_strings("published")), "true");

    for ($i = 0;$i < $comptListNotes;$i++) {
        $block1->openRow();
        $block1->checkboxRow($listNotes->note_id[$i]);
        $block1->cellRow($blockPage->buildLink("../notes/viewnote.php?id=" . $listNotes->note_id[$i], $listNotes->note_subject[$i], 'in'));
        $block1->cellRow($topicNote[$listNotes->note_topic[$i]]);
        $block1->cellRow($listNotes->note_date[$i]);
        $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listNotes->note_owner[$i], $listNotes->note_mem_name[$i], 'in'));

        if ($sitePublish == "true") {
            $idPublish = $listNotes->note_published[$i];
            $block1->cellRow($statusPublish[$idPublish]);
        }

        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($permissionDetail->prp_add_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(0, "add", "../notes/editnote.php?project=$project", "true,false,false", lang_strings("add"));
}

if ($permissionDetail->prp_delete_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "remove", "../notes/deletenotes.php?project=$project", "false,true,true", lang_strings("delete"));
}

if ($permissionDetail->prp_publish_note[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    if ($sitePublish == "true") {
        $block1->paletteScript(3, "add_projectsite", "../notes/listnotes.php?addToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("add_project_site"));
        $block1->paletteScript(4, "remove_projectsite", "../notes/listnotes.php?removeToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("remove_project_site"));
    }
}

$block1->paletteScript(5, "info", "../notes/viewnote.php?", "false,true,false", lang_strings("view"));

if ($permissionDetail->prp_modify_note_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(6, "edit", "../notes/editnote.php?project=$project", "false,true,false", lang_strings("edit"));
}

$block1->closePaletteScript($comptListNotes, $listNotes->note_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
