<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listphases.php,v 1.12 2009/09/01 15:01:17 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$project = isset($_GET['project'])?$_GET['project']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_phase[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("phases"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "wbSe";
$block1->openForm("../phases/listphases.php?project=$project#" . $block1->form . "Anchor");
$block1->headingToggle(lang_strings("phases"));
$block1->openPaletteIcon();
$block1->paletteIcon(0, "info", lang_strings("view"));

if ($permissionDetail->prp_modify_phase_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "edit", lang_strings("edit"));
}

$block1->closePaletteIcon();
$block1->sorting("phases", $sortingUser->sor_phases[0], "pha.order_num ASC", $sortingFields = array(0 => "pha.order_num", 1 => "pha.name", 2 => "none", 3 => "none", 4 => "pha.status", 5 => "pha.date_start", 6 => "pha.date_end"));
$tmpquery = " WHERE pha.project_id=$project ORDER BY $block1->sortingValue";
$listPhases = new request();
$listPhases->openPhases2($tmpquery);
$comptListPhases = count($listPhases->pha_id);

if ($comptListPhases != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings("order"), 1 => lang_strings("name"), 2 => lang_strings("total_tasks"), 3 => lang_strings("uncomplete_tasks"), 4 => lang_strings("status"), 5 => lang_strings("date_start"), 6 => lang_strings("date_end")), "false");

    for ($i = 0;$i < $comptListPhases;$i++) {
        if ($listPhases->pha_status[$i] == PS_NOT_STARTED) {
            $phaseStart = lang_strings("none");
            $phaseEnd = lang_strings("none");
        } else if ($listPhases->pha_status[$i] == PS_COMPLETE) {
            $phaseStart = $listPhases->pha_date_start[$i];
            $phaseEnd = $listPhases->pha_date_end[$i];
        } else {
            $phaseStart = $listPhases->pha_date_start[$i];
            $phaseEnd = lang_strings("none");
        }

        $block1->openRow();
        $block1->checkboxRow($listPhases->pha_id[$i]);
        $block1->cellRow($listPhases->pha_order_num[$i]);
        $block1->cellRow($blockPage->buildLink("../phases/viewphase.php?id=" . $listPhases->pha_id[$i], $listPhases->pha_name[$i], 'in'));
        $block1->cellRow($listPhases->pha_total_tasks[$i]);
        $block1->cellRow($listPhases->pha_uncompleted_tasks[$i]);
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/phase_' . $listPhases->pha_status[$i] . '.gif" alt="' . $phaseStatus[$listPhases->pha_status[$i]] . '">&nbsp;' . $phaseStatus[$listPhases->pha_status[$i]], '', true);
        $block1->cellRow($phaseStart);
        $block1->cellRow($phaseEnd);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeToggle();
$block1->closeFormResults();
$block1->openPaletteScript();
$block1->paletteScript(0, "info", "../phases/viewphase.php?project=$project", "false,true,true", lang_strings("view"));

if ($permissionDetail->prp_modify_phase_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "edit", "../phases/editphase.php?project=$project", "false,true,true", lang_strings("edit"));
}

$block1->closePaletteScript($comptListPhases, $listPhases->pha_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
