<?php // $Revision: 1.35.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewphase.php,v 1.35.2.1 2010/01/05 14:41:06 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$taskgroupList = array();

/**
 * Functions
 */
function add_taskgroup_to_changelist($parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $tmpquery = " WHERE tas.id=$parent";
    $parentDetail = new request();
    $parentDetail->openTasks($tmpquery);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($parent)
{
    global $tableName, $dateheures;
    $tmpquery = " WHERE tas.parent_task=$parent";
    $subtaskList = new request();
    $subtaskList->openTasks($tmpquery);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == ST_NOT_STARTED || $newStatus == ST_NOT_STARTED) {
                $newStatus = ST_NOT_STARTED;
            } else if ($status == ST_OPEN || $newStatus == ST_OPEN) {
                $newStatus = ST_OPEN;
            } else if ($status == ST_SUSPENDED || $newStatus == ST_SUSPENDED) {
                $newStatus = ST_SUSPENDED;
            } else if ($status == ST_CLIENT_COMPLETED || $newStatus == ST_CLIENT_COMPLETED) {
                $newStatus = ST_CLIENT_COMPLETED;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == ST_COMPLETED) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }

            if ($published == PB_YES) {
                $newPublished = PB_YES;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == ST_COMPLETED) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpquery = "UPDATE " . $tableName['tasks'] . " SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', modified='$dateheures', task_group='" . TG_YES . "', subtask='$newSubtask' WHERE id='$parent'";
    connectSql($tmpquery);
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$phase = isset($_GET['phase'])?$_GET['phase']:'0';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
$removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$base = isset($_GET['base'])?$_GET['base']:'1';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';

/**
 * Permission check
 */
if ($action == "publish") {
    $tmpquery = " WHERE pha.id=$phase";
} else {
    $tmpquery = " WHERE pha.id=$id";
}

$phaseDetail = new request();
$phaseDetail->openPhases2($tmpquery);
$comptPhaseDetail = count($phaseDetail->pha_id);

if ($comptPhaseDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $phaseDetail->pha_project_id[0];
$phase = $phaseDetail->pha_id[0];
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_phase[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

if ($action == 'publish') {
    if ($addToSite == 'true' || $removeToSite == 'true') {
        if ($permissionDetail->prp_publish_task[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
            exit;
        }
    } else if ($addToSiteFile == "true" || $removeToSiteFile == "true") {
        if ($permissionDetail->prp_publish_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $id1 = str_replace("**", ",", $id);

    if ($addToSite == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_YES . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "addToSite";
        $id = $phase;
    }

    if ($removeToSite == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_NO . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "removeToSite";
        $id = $phase;
    }

    if ($addToSite == 'true' || $removeToSite == 'true') {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewphase.php?id=$id&msg=$msg");
            exit;
        }

        $tmpquery = " WHERE tas.id IN ($id1)";
        $listTasks = new request();
        $listTasks->openTasks($tmpquery);
        $comptListTasks = count($listTasks->tas_id);

        for ($i=0; $i<$comptListTasks; $i++) {
            add_taskgroup_to_changelist($listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
        }

        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);
            reset($taskgroupList);

            while (list($parentTask, $level) = each($taskgroupList)) {
                change_parent_task($parentTask);
            }
        }

        leave_critical_section($criticalSection);
    }

    if ($addToSiteFile == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "addToSite";
        $id = $phase;
    }

    if ($removeToSiteFile == "true") {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "removeToSite";
        $id = $phase;
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=" . $projectDetail->pro_id[0], lang_strings("phases"), 'in'));
$blockPage->itemBreadcrumbs($phaseDetail->pha_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->bornesNumber = '1';
$blockPage->openLongList();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesLess");
}

$block1 = new block();
$block1->form = "pppD";
$block1->openForm("../projects/listprojects.php#" . $block1->form . "Anchor");
$block1->headingToggle(lang_strings("phase") . " : " . $phaseDetail->pha_name[0]);

if ($permissionDetail->prp_modify_phase_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "edit", lang_strings("edit"));
    $block1->closePaletteIcon();
}

if ($phaseDetail->pha_status[0] == PS_NOT_STARTED) {
    $phaseStart = lang_strings("none");
    $phaseEnd = lang_strings("none");
} else if ($phaseDetail->pha_status[0] == PS_COMPLETE) {
    $phaseStart = $phaseDetail->pha_date_start[0];
    $phaseEnd = $phaseDetail->pha_date_end[0];
} else {
    $phaseStart = $phaseDetail->pha_date_start[0];
    $phaseEnd = lang_strings("none");
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("name"), $phaseDetail->pha_name[0]);
$block1->contentRow(lang_strings("phase_id"), $phaseDetail->pha_id[0]);
$block1->contentRow(lang_strings("status"), $phaseStatus[$phaseDetail->pha_status[0]]);
$block1->contentRow(lang_strings("total_tasks"), $phaseDetail->pha_total_tasks[0]);
$block1->contentRow(lang_strings("uncomplete_tasks"), $phaseDetail->pha_uncompleted_tasks[0]);
$block1->contentRow(lang_strings("milestone"), $phaseDetail->pha_milestones[0]);
$block1->contentRow(lang_strings("date_start"), $phaseStart);
$block1->contentRow(lang_strings("date_end"), $phaseEnd);
$block1->contentRow(lang_strings("comments"), nl2br($phaseDetail->pha_comments[0]));
$block1->closeContent();
$block1->closeToggle();
$block1->closeForm();

if ($permissionDetail->prp_modify_phase_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->openPaletteScript();
    $block1->paletteScript(0, "edit", "../phases/editphase.php?id=$id", "true,true,true", lang_strings("edit"));
    $block1->closePaletteScript($comptListPhaese, $listPhases->pha_id);
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

if ($permissionDetail->prp_view_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block2 = new block();
    $block2->form = "saP";
    $block2->openForm("../phases/viewphase.php?id=$id#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("tasks"));
    $block2->openPaletteIcon();

    if ($permissionDetail->prp_create_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(0, "add", lang_strings("add"));
    }

    if ($permissionDetail->prp_delete_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(1, "remove", lang_strings("delete"));
    }

    if ($permissionDetail->prp_copy_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(2, "copy", lang_strings("copy"));
    }

    if ($permissionDetail->prp_publish_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block2->paletteIcon(4, "add_projectsite", lang_strings("add_project_site"));
            $block2->paletteIcon(5, "remove_projectsite", lang_strings("remove_project_site"));
        }
    }

    $block2->paletteIcon(6, "info", lang_strings("view"));

    if ($permissionDetail->prp_modify_task_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(7, "edit", lang_strings("edit"));
    }

    if ($permissionDetail->prp_log_task_hours[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(8, "timelog", lang_strings("loghours"));
    }

    if ($permissionDetail->prp_edit_task_relationships[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteIcon(9, "dependency", lang_strings("add_predecessor"));
        $block2->paletteIcon(10, "unlink", lang_strings("delete_dependencies"));
        $block2->paletteIcon(11, "indentation", lang_strings("indentation"));
        $block2->paletteIcon(12, "unindentation", lang_strings("unindentation"));
        $block2->paletteIcon(13, "add_taskgroup", lang_strings("add_taskgroup"));
    }

    $block2->closePaletteIcon();
    $block2->sorting("tasks", $sortingUser->sor_tasks[0], "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
    $tmpquery = " WHERE tas.project=$project AND tas.parent_phase='" . $phaseDetail->pha_order_num[0] . "' AND tas.level='0' ORDER BY " . $block2->sortingValue;
    $listTasks = new request();
    $listTasks->openTasks($tmpquery);
    $comptListTasks = count($listTasks->tas_id);

    if ($comptListTasks != "0") {
        $block2->openResults();
        $block2->labels($labels = array(0 => lang_strings("id"),1 => lang_strings("task"), 2 => lang_strings("priority"), 3 => lang_strings("status"), 4 => lang_strings("completion"), 5 => lang_strings("due_date"), 6 => lang_strings("assigned_to"), 7 => lang_strings("published")), "true");

        for ($i = 0;$i < $comptListTasks;$i++) {
            if ($listTasks->tas_due_date[$i] == "") {
                $listTasks->tas_due_date[$i] = lang_strings("none");
            }

            $tmpquery = "SELECT id FROM " . $tableName['tasks'] . " WHERE parent_task='" . $listTasks->tas_id[$i] . "'";
            $comptSubTasks = compt($tmpquery);

            if ($comptSubTasks > 0) {
                $namePostfix = "&nbsp;&nbsp;($comptSubTasks&nbsp;" . lang_strings('subtasks') . ")";
            } else {
                $namePostfix = '';
            }

            $idStatus = $listTasks->tas_status[$i];
            $idPriority = $listTasks->tas_priority[$i];
            $idPublish = $listTasks->tas_published[$i];
            $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
            $block2->openRow();
            $block2->checkboxRow($listTasks->tas_id[$i]);
            $block2->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_id[$i], 'in'));

            if ($idStatus == 1) {
                $block2->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i] . $namePostfix, 'instrike'));
            } else {
                $block2->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i] . $namePostfix, 'in'));
            }

            if ($listTasks->tas_milestone[$i] == MS_YES) {
                $block2->cellRow("") ;
                $block2->cellRow("") ;
                $block2->cellRow("") ;
            } else {
                $block2->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
                $block2->cellRow('<img src="../themes/' . THEME . '/gfx_status/' . $idStatus . '.gif" alt="' . $status[$idStatus] . '">&nbsp;' . $status[$idStatus], '', true);
                $block2->cellRow($complValue);
            }

            if ($listTasks->tas_milestone[$i] == MS_YES) {
                $block2->cellRow($listTasks->tas_due_date[$i]);
            } else if ($listTasks->tas_due_date[$i] <= $date) {
                $block2->cellRow("<b>" . $listTasks->tas_due_date[$i] . "</b>");
            } else {
                $block2->cellRow($listTasks->tas_due_date[$i]);
            }

            if ($listTasks->tas_start_date[$i] != "--" && $listTasks->tas_due_date[$i] != "--") {
                $gantt = "true";
            }

            if ($listTasks->tas_milestone[$i] == MS_YES) {
                $block2->cellRow("") ;
            } else if ($listTasks->tas_assigned_to[$i] == "0") {
                $block2->cellRow(lang_strings("unassigned"));
            } else {
                $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
                $resourceUsage = new request();
                $resourceUsage->openTaskHumanResource($tmpquery);
                $comptResourceUsage = count($resourceUsage->res_id);
                $assignedToStrings = "";

                for ($j = 0;$j < $comptResourceUsage;$j++) {
                    if ($j > 0) {
                        $assignedToStrings .= "&nbsp;";
                    }

                    $assignedToStrings .= $blockPage->buildLink("../users/viewuser.php?id=" . $resourceUsage->res_resource[$j], $resourceUsage->res_mem_name[$j], 'in');
                }

                $block2->cellRow($assignedToStrings);
            }

            echo "</td>";

            if ($sitePublish == "true") {
                $block2->cellRow($statusPublish[$idPublish]);
            }

            $block2->closeRow();
        }

        $block2->closeResults();

        if ($activeJpgraph == "true" && $gantt == "true") {
            if ($gantt_sd != '') {
                echo "<a href='viewphase.php?id=$id&amp;base=$base'>&lt;&lt;</a>&nbsp;";
                list($an1, $mois1, $jour1) = preg_split('/-/', $gantt_sd, 3);

                if ($base == '1') {
                    $gantt_sd_prev = date("Y-m-d", mktime(12,0,0,intval($mois1)-5,intval($jour1),intval($an1)));
                } else {
                    $gantt_sd_prev = date("Y-m-d", mktime(12,0,0,intval($mois1)-1,intval($jour1),intval($an1)));
                }
            }

            $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tableName['tasks'] . " WHERE project=$project AND parent_phase='" . $phaseDetail->pha_order_num[0] . "' AND start_date!='--' AND due_date!='--'";

            if ($gantt_sd != '') {
                if ($base == '1') {
                    $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois1)+5,intval($jour1),intval($an1)));
                } else {
                    $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois1)+1,intval($jour1),intval($an1)));
                }

                $tmpquery .= " AND due_date>='$gantt_sd_next'";
            }

            $boundaries = new request();
            $boundaries->connectClass();
            $boundaries->query($tmpquery);

            if ($boundaries->fetch()) {
                $start_date_b = ($row[0]);
                $due_date_b = ($row[1]);
                list($an2, $mois2, $jour2) = preg_split('/-/', $start_date_b, 3);

                if ($gantt_sd == '') {
                    if ($base == '1') {
                        $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois2)+5,intval($jour2),intval($an2)));
                    } else {
                        $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois2)+1,intval($jour2),intval($an2)));
                    }

                    $gantt_sd = $start_date_b;
                } else {
                    if ($gantt_sd_prev < $start_date_b) {
                        echo "<a href='viewphase.php?id=$id&amp;base=$base'>&lt;</a>&nbsp;";
                    } else {
                        echo "<a href='viewphase.php?id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                    }
                }

                if ($gantt_sd_next <= $due_date_b) {
                    $showNext = 'true';
                    list($an2, $mois2, $jour2) = preg_split('/-/', $due_date_b, 3);

                    if ($base == '1') {
                        $gantt_sd_last = date("Y-m-d", mktime(12,0,0,intval($mois2)-5,intval($jour2)+1,intval($an2)));
                    } else {
                        $gantt_sd_last = date("Y-m-d", mktime(12,0,0,intval($mois2)-1,intval($jour2)+1,intval($an2)));
                    }
                }
            }

            // show the expanded or compact Gantt Chart
            if ($base == 1) {
                echo "<a href='viewphase.php?id=$id&amp;base=0'>expand</a>";
            } else {
                echo "<a href='viewphase.php?id=$id&amp;base=1'>compact</a>";
            }

            if ($showNext == 'true') {
                echo "&nbsp;<a href='viewphase.php?id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
                echo "&nbsp;<a href='viewphase.php?id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
            }

            if ($gantt_sd != '') {
                echo "<br><img src=\"graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;phase=" . $phaseDetail->pha_order_num[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
            }
        }
    } else {
        $block2->noresults();
    }

    $block2->closeToggle();
    $block2->closeFormResults();
    $block2->openPaletteScript();

    if ($permissionDetail->prp_create_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(0, "add", "../tasks/edittask.php?project=$project&phase=" . $phaseDetail->pha_order_num[0] . "", "true,false,false", lang_strings("add"));
    }

    if ($permissionDetail->prp_delete_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(1, "remove", "../tasks/deletetasks.php?project=$project", "false,true,true", lang_strings("delete"));
    }

    if ($permissionDetail->prp_copy_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(2, "copy", "../tasks/edittask.php?project=$project&cpy=true", "false,true,false", lang_strings("copy"));
    }

    if ($permissionDetail->prp_publish_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block2->paletteScript(4, "add_projectsite", "../phases/viewphase.php?addToSite=true&phase=$phase&action=publish", "false,true,true", lang_strings("add_project_site"));
            $block2->paletteScript(5, "remove_projectsite", "../phases/viewphase.php?removeToSite=true&phase=$phase&action=publish", "false,true,true", lang_strings("remove_project_site"));
        }
    }

    $block2->paletteScript(6, "info", "../tasks/viewtask.php?", "false,true,false", lang_strings("view"));

    if ($permissionDetail->prp_modify_task_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(7, "edit", "../tasks/edittask.php?project=$project&phase=" . $phaseDetail->pha_order_num[0] . "", "false,true,false", lang_strings("edit"));
    }

    if ($permissionDetail->prp_log_task_hours[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(8, "timelog", "../tasks/addtasktime.php?project=$project&phase=" . $phaseDetail->pha_order_num[0], "false,true,false", lang_strings("loghours"));
    }

    if ($permissionDetail->prp_edit_task_relationships[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block2->paletteScript(9, "dependency", "../tasks/addpredecessor.php?project=$project", "false,true,false", lang_strings("add_predecessor"));
        $block2->paletteScript(10, "unlink", "../tasks/deletedependencies.php?project=$project", "false,true,false", lang_strings("delete_dependencies"));
        $block2->paletteScript(11, "indentation", "../tasks/indentation.php?project=$project&phase=" . $phaseDetail->pha_order_num[0], "false,true,false", lang_strings("indentation"));
        $block2->paletteScript(12, "unindentation", "../tasks/unindentation.php?project=$project&phase=" . $phaseDetail->pha_order_num[0], "false,true,false", lang_strings("unindentation"));
        $block2->paletteScript(13, "add_taskgroup", "../tasks/edittask.php?action=taskgroup&project=$project&phase=" . $phaseDetail->pha_order_num[0], "false,false,true", lang_strings("add_taskgroup"));
    }

    $block2->closePaletteScript($comptListTasks, $listTasks->tas_id);
}

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession])) {
    $block3 = new block();
    $block3->form = "tdC";
    $block3->openForm("../phases/viewphase.php?id=$id#" . $block3->form . "Anchor");
    $block3->headingToggle(lang_strings("linked_content"));
    $block3->openPaletteIcon();

    if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteIcon(0, "add", lang_strings("add"));
     }

    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteIcon(1, "remove", lang_strings("delete"));
    }

    if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block3->paletteIcon(2, "add_projectsite", lang_strings("add_project_site"));
            $block3->paletteIcon(3, "remove_projectsite", lang_strings("remove_project_site"));
        }
    }

    $block3->paletteIcon(4, "info", lang_strings("view"));

    if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteIcon(5, "edit", lang_strings("edit"));
    }

    $block3->paletteIcon(6, "export", lang_strings("export"));
    $block3->closePaletteIcon();
    $block3->borne = $blockPage->returnBorne('1');
    $block3->rowsLimit = '5';
    $block3->sorting("files", $sortingUser->sor_files[0], 'fil.name ASC', $sortingFields = array(0 => 'fil.extension', 1 => 'fil.name', 2 => 'fil.owner', 3 => 'fil.date', 4 => 'fil.status', 5 => 'fil.published'));
    $tmpquery = " WHERE fil.vc_parent=0 ORDER BY $block3->sortingValue";
    $sql = $initrequest["phase_files"];
    $sql = str_replace('%phase%', $id, $sql);
    $block3->recordsTotal = compt($sql . $tmpquery);
    $listFiles = new request();
    $listFiles->openPhaseFiles($id, $tmpquery, $block3->borne, $block3->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles != "0") {
        $block3->openResults();
        $block3->labels($labels = array(0 => lang_strings('type'), 1 => lang_strings('name'), 2 => lang_strings('owner'), 3 => lang_strings('date'), 4 => lang_strings('approval_tracking'), 5 => lang_strings('published')), 'true');
        require_once("../includes/files_types.php");

        for ($i=0; $i<$comptListFiles; $i++) {
            $idStatus = $listFiles->fil_status[$i];
            $idPublish = $listFiles->fil_published[$i];
            $type = file_info_type($listFiles->fil_extension[$i]);

            if (fileExists($listFiles->fil_fullname[$i])) {
                $existFile = 'true';
            } else {
                $existFile = 'false';
            }

            $block3->openRow();
            $block3->checkboxRow($listFiles->fil_id[$i]);

            if ($existFile == 'true') {
                $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_PHASE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $type, 'icone'));
            } else {
                $block3->cellRow('&nbsp;');
            }

            if ($existFile == 'true') {
                $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_PHASE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $listFiles->fil_name[$i], 'in'));
            } else {
                $block3->cellRow(lang_strings('missing_file') . ' (' . $listFiles->fil_name[$i] . ')');
            }

            $block3->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $listFiles->fil_owner[$i], $listFiles->fil_mem_name[$i], 'in'));
            $block3->cellRow($listFiles->fil_date[$i]);
            $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_PHASE . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in'));

            if ($sitePublish == 'true') {
                $block3->cellRow($statusPublish[$idPublish]);
            }

            $block3->closeRow();
        }

        $block3->closeResults();
        $block3->bornesFooter('1', $blockPage->bornesNumber, '../linkedcontent/listfiles.php?doc_type=' . DOC_PHASE . '&doc_id=' . $id, 'id=' . $id);
    } else {
        $block3->noresults();
    }

    $block3->closeToggle();
    $block3->closeFormResults();
    $block3->openPaletteScript();

    if ($permissionDetail->prp_add_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteScript(0, "add", "../linkedcontent/addfile.php?doc_type=" . DOC_PHASE . "&doc_id=$id", "true,false,false", lang_strings("add"));
     }

    if ($permissionDetail->prp_delete_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteScript(1, "remove", "../linkedcontent/deletefiles.php?doc_type=" . DOC_PHASE . "&doc_id=$id", "false,true,true", lang_strings("delete"));
     }

    if ($permissionDetail->prp_publish_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($sitePublish == "true") {
            $block3->paletteScript(2, "add_projectsite", "../phases/viewphase.php?addToSiteFile=true&phase=" . $phaseDetail->pha_id[0] . "&action=publish", "false,true,true", lang_strings("add_project_site"));
            $block3->paletteScript(3, "remove_projectsite", "../phases/viewphase.php?removeToSiteFile=true&phase=" . $phaseDetail->pha_id[0] . "&action=publish", "false,true,true", lang_strings("remove_project_site"));
        }
    }

    $block3->paletteScript(4, "info", "../linkedcontent/viewfile.php?doc_type=" . DOC_PHASE . "&doc_id=$id&", "false,true,false", lang_strings("view"));

    if ($permissionDetail->prp_update_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block3->paletteScript(5, "edit", "../linkedcontent/viewfile.php?edit=true&doc_type=" . DOC_PHASE . "&doc_id=$id&", "false,true,false", lang_strings("edit"));
    }

    $block3->paletteScript(6, "export", "../projects/accessfiles.php?zipfile=phase&project=$project", "false,true,true", lang_strings("export"));
    $block3->closePaletteScript($comptListFiles, $listFiles->fil_id);
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
