<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteproject.php,v 1.15 2009/09/24 16:02:30 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

if ($enable_cvs == 'true') {
    require_once('../includes/cvslib.php');
}

/**
 * Variables init
 */
$id = isset($_REQUEST['id'])?$_REQUEST['id']:'0';
$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$id";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied");
    exit;
}

$tmpquery = " WHERE tea.project=$id AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$id AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$id AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_delete_project[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied");
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    // if CVS repository enabled
    if ($enable_cvs == 'true') {
        cvs_delete_repository($id);
    }

    unset($sqls);
    $tmpquery = ' WHERE tas.project=' . $id;
    $listTasks = new request();
    $listTasks->openTasks($tmpquery);
    $comptListTasks = count($listTasks->tas_id);

    if ($comptListTasks == '0') {
        $tasks = '';
    } else {
        $tasks = implode(',', $listTasks->tas_id);
        $sqls[] = 'DELETE FROM ' . $tableName['assignments'] . ' WHERE task IN (' . $tasks .')';
        $sqls[] = 'DELETE FROM ' . $tableName['tasks_predecessor'] . ' WHERE task IN (' . $tasks .') OR predecessor IN (' . $tasks . ')';
        $sqls[] = 'DELETE FROM ' . $tableName['tasks_resource'] . ' WHERE task IN (' . $tasks .')';
    }

    $tmpquery = ' WHERE topic.project=' . $id;
    $listTopics = new request();
    $listTopics->openTopics($tmpquery);
    $comptListTopics = count($listTopics->top_id);

    if ($comptListTopics == '0') {
        $topics = '';
    } else {
        $topics = implode(',', $listTopics->top_id);
        $sqls[] = 'DELETE FROM ' . $tableName['topics'] . ' WHERE project=' . $id;
        $sqls[] = 'DELETE FROM ' . $tableName['posts'] . ' WHERE topic IN (' . $topics .')';
    }

    $listFiles = new request();
    $listFiles->openProjectFiles($id, '');
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles == '0') {
        $files = '';
    } else {
        $files = implode(',', $listFiles->fil_id);
        $sqls[] = 'DELETE FROM ' . $tableName['files'] . " WHERE id IN ($files)";
    }

    $sqls[] = 'DELETE FROM ' . $tableName['projects'] . ' WHERE id=' . $id;
    $sqls[] = 'DELETE FROM ' . $tableName['teams'] . ' WHERE project=' . $id;
    $sqls[] = 'DELETE FROM ' . $tableName['tasks'] . ' WHERE project=' . $id;
    $sqls[] = "DELETE FROM " . $tableName["meetings"] . " WHERE project=$id";
    $sqls[] = 'DELETE FROM ' . $tableName['notes'] . ' WHERE project=' . $id;
    $sqls[] = 'DELETE FROM ' . $tableName['support_requests'] . ' WHERE project=' . $id;
    $sqls[] = 'DELETE FROM ' . $tableName['support_posts'] . ' WHERE project=' . $id;
    $sqls[] = "DELETE FROM " . $tableName["attendants"] . " WHERE project=$id";
    $sqls[] = 'DELETE FROM ' . $tableName['project_permissions'] . ' WHERE project=' . $id;
    $sqls[] = 'DELETE FROM ' . $tableName['tasks_time'] . ' WHERE project=' . $id;
    $sqls[] = "DELETE FROM " . $tableName["meetings_time"] . " WHERE project=$id";
    $sqls[] = "DELETE FROM " . $tableName["work_hours"] . " WHERE project=$id";

    if ($projectDetail->pro_phase_set[0] != '0') {
        $sqls[] = 'DELETE FROM ' . $tableName['phases'] . ' WHERE project_id=' . $id;
    }

    $criticalSection = enter_critical_section();

    if ($criticalSection == -1) {
        header("Location: ../projects/listprojects.php?msg=$msg");
        exit;
    }

    foreach ($sqls as $sql) {
        connectSql($sql);
    }

    deleteFiles($listFiles->fil_fullname);
    leave_critical_section($criticalSection);
    header('Location: ../projects/listprojects.php?msg=delete');
    exit;
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?', lang_strings('projects'), in));
$blockPage->itemBreadcrumbs(lang_strings('delete_projects'));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = 'saP';
$block1->openForm('../projects/deleteproject.php?action=delete&amp;id=' . $id . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('delete_projects'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));
$block1->contentRow('#' . $projectDetail->pro_id[0], $projectDetail->pro_name[0], "false", "&nbsp;&nbsp;");
$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
