<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listprojects.php,v 1.17 2009/11/05 09:05:24 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * listprojects.php
 *
 * list projects grouped by either 'Active', 'Inavtive', or 'All' by
 * assigned status and sortable by header fields.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$show = isset($_GET['show'])?$_GET['show']:PJS_OPEN;
$borne1 = isset($_GET['borne1'])?$_GET['borne1']:'';
$client = isset($_GET['client'])?$_GET['client']:'';
$cview = isset($_GET['cview'])?$_GET['cview']:'';
$datefrom = isset($_GET['datefrom'])?$_GET['datefrom']:'';
$dateto = isset($_GET['dateto'])?$_GET['dateto']:'';
$cstatus = isset($_GET['cstatus'])?$_GET['cstatus']:'';
$cnum = isset($_GET['cnum'])?$_GET['cnum']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Functions
 */
function sql_count($sql)
{
    global $row;
    $request1 = new request();
    $request1->connectClass();
    $request1->query($sql);

    if ($request1->fetch()) {
        $res = ($row[0]);
    } else {
        $res = 0;
    }

    $request1->close();
    return $res;
}

/**
 * Load data
 */
if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    $tmpquery = 'SELECT COUNT(pro.id) FROM ' . $tableName['projects'] . ' pro LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . ' prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE tea.member=' . $idSession . " AND prp.view_project='" . B_TRUE . "'";
} else {
    $tmpquery = 'SELECT COUNT(pro.id) FROM ' . $tableName['projects'] . ' pro WHERE pro.id<>0';
}

$projectViewCounts['all'] = sql_count($tmpquery);
$projectViewCounts[PJS_PROPOSED] = sql_count($tmpquery . " AND pro.status='" . PJS_PROPOSED . "'");
$projectViewCounts[PJS_CANCELED] = sql_count($tmpquery . " AND pro.status='" . PJS_CANCELED . "'");
$projectViewCounts[PJS_CLIENT_COMPLETED] = sql_count($tmpquery . " AND pro.status='" . PJS_CLIENT_COMPLETED . "'");
$projectViewCounts[PJS_OPEN] = sql_count($tmpquery . " AND pro.status='" . PJS_OPEN . "'");
$projectViewCounts[PJS_COMPLETED] = sql_count($tmpquery . " AND pro.status='" . PJS_COMPLETED . "'");
$projectViewCounts[PJS_SUSPENDED] = sql_count($tmpquery . " AND pro.status='" . PJS_SUSPENDED . "'");

if ($client != '' && $cstatus != '' && $cnum != '') {
    $tmpquery = ' WHERE org.id=' . $client;
    $clientDetail = new request();
    $clientDetail->openOrganizations($tmpquery);
    $comptClientDetail = count($clientDetail->org_id);

    if ($comptClientDetail == '0') {
        header('Location: ../clients/listclients.php?msg=blankClient');
        exit;
    }

    $show = 'client';
}

/**
 * HTML
 */
require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$projectViewLinks['all'] = $blockPage->buildLink('../projects/listprojects.php?show=all', lang_strings('all') . '(' . $projectViewCounts['all'] . ')', 'in');
$projectViewLinks[PJS_PROPOSED] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_PROPOSED, $statusProject[PJS_PROPOSED] . '(' . $projectViewCounts[PJS_PROPOSED] . ')', 'in');
$projectViewLinks[PJS_CANCELED] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_CANCELED, $statusProject[PJS_CANCELED] . '(' . $projectViewCounts[PJS_CANCELED] . ')', 'in');
$projectViewLinks[PJS_CLIENT_COMPLETED] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_CLIENT_COMPLETED, $statusProject[PJS_CLIENT_COMPLETED] . '(' . $projectViewCounts[PJS_CLIENT_COMPLETED] . ')', 'in');
$projectViewLinks[PJS_OPEN] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_OPEN, $statusProject[PJS_OPEN] . '(' . $projectViewCounts[PJS_OPEN] . ')', 'in');
$projectViewLinks[PJS_COMPLETED] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_COMPLETED, $statusProject[PJS_COMPLETED] . '(' . $projectViewCounts[PJS_COMPLETED] . ')', 'in');
$projectViewLinks[PJS_SUSPENDED] = $blockPage->buildLink('../projects/listprojects.php?show=' . PJS_SUSPENDED, $statusProject[PJS_SUSPENDED] . '(' . $projectViewCounts[PJS_SUSPENDED] . ')', 'in');
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?', lang_strings('projects'), 'in'));
$breadcrumb = '';

foreach ($projectViewCounts as $view => $view_count) {
    if ($breadcrumb != '') {
        $breadcrumb .= ' | ';
    }

    if ($view_count == 0) $breadcrumb .= '<small>';

    if ($show == $view) {
        $recordsTotal = $view_count;

        if ($view == 'all') {
            $breadcrumb .= lang_strings('all') . '(' . $view_count . ')';
        } else {
            $breadcrumb .= $statusProject[$view] . '(' . $view_count . ')';
        }
    } else {
        $breadcrumb .= $projectViewLinks[$view];
    }

    if ($view_count == 0) $breadcrumb .= '</small>';
}

if ($show == 'client') {
    if ($cstatus == 'open') {
        $breadcrumb .= ' | ' . lang_strings('client') . '&nbsp;' . $clientDetail->org_name[0] . '&nbsp;' . lang_strings($cstatus) . ' (' . $cnum . ')';
    } else {
        $breadcrumb .= ' | ' . lang_strings('client') . '&nbsp;' . $clientDetail->org_name[0] . '&nbsp;' . lang_strings($cstatus) . '&nbsp;' . lang_strings($cview) . ' (' . $cnum . ')';
    }
}

$blockPage->itemBreadcrumbs($breadcrumb);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once('../includes/messages.php');
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'saP';
$block1->openForm('../projects/listprojects.php?borne1=' . $borne1 . '&show=' . $show . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('projects'));
$block1->openPaletteIcon();

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', lang_strings('add'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
    $block1->paletteIcon(2, 'copy', lang_strings('copy'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block1->paletteIcon(3, 'info', lang_strings('view'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(4, 'export', lang_strings('export'));
    $block1->paletteIcon(5, 'edit', lang_strings('edit'));

    if ($enable_cvs == 'true') {
        $block1->paletteIcon(6, 'cvs', lang_strings('browse_cvs'));
    }

    $block1->paletteIcon(7, 'bug', lang_strings('support_requests'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block1->paletteIcon(8, 'calendar', lang_strings('calendar'));
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = 20;
$block1->sorting('projects', $sortingUser->sor_projects[0], 'pro.name ASC', $sortingFields = array(0 => 'pro.id', 1 => 'pro.name', 2 => 'pro.priority', 3 => 'org.name', 4 => 'pro.status', 5 => 'mem.name', 6 => 'pro.published'));

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    switch ($show) {
        case 'all':
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . ' prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE tea.member=' . $idSession . " AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_PROPOSED:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_PROPOSED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_CANCELED:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_CANCELED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_CLIENT_COMPLETED:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_CLIENT_COMPLETED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_OPEN:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_OPEN . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_COMPLETED:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_COMPLETED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_SUSPENDED:
            $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . PJS_SUSPENDED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            break;
        case 'client':
            if ($cstatus == 'open') {
                $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.organization=$client AND pro.status='" . PJS_OPEN . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            } else {
                $tmpquery = ' LEFT OUTER JOIN ' . $tableName['teams'] . ' tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tableName['project_permissions'] . " prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.organization=$client AND pro.complete_date>='$datefrom' AND pro.complete_date<='$dateto' AND pro.status='" . PJS_COMPLETED . "' AND tea.member=$idSession AND prp.view_project='" . B_TRUE . "' ORDER BY " . $block1->sortingValue;
            }

            break;
    }
} else {
    switch ($show) {
        case 'all':
            $tmpquery = ' ORDER BY ' . $block1->sortingValue;
            break;
        case PJS_PROPOSED:
            $tmpquery = " WHERE pro.status='" . PJS_PROPOSED . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_CANCELED:
            $tmpquery = " WHERE pro.status='" . PJS_CANCELED . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_CLIENT_COMPLETED:
            $tmpquery = " WHERE pro.status='" . PJS_CLIENT_COMPLETED . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_OPEN:
            $tmpquery = " WHERE pro.status='" . PJS_OPEN . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_COMPLETED:
            $tmpquery = " WHERE pro.status='" . PJS_COMPLETED . "' ORDER BY " . $block1->sortingValue;
            break;
        case PJS_SUSPENDED:
            $tmpquery = " WHERE pro.status='" . PJS_SUSPENDED . "' ORDER BY " . $block1->sortingValue;
            break;
        case 'client':
            if ($cstatus == 'open') {
                $tmpquery = " WHERE pro.organization=$client AND pro.status='" . PJS_OPEN . "' ORDER BY " . $block1->sortingValue;
            } else {
                $tmpquery = " WHERE pro.organization=$client AND pro.complete_date>='$datefrom' AND pro.complete_date<='$dateto' AND pro.status='" . PJS_COMPLETED . "' ORDER BY " . $block1->sortingValue;
            }

            break;
    }
}

$block1->recordsTotal = $recordsTotal;
$listProjects = new request();
$listProjects->openProjects($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListProjects = count($listProjects->pro_id);

if ($comptListProjects != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('id'), 1 => lang_strings('project'), 2 => lang_strings('priority'), 3 => lang_strings('organization'), 4 => lang_strings('status'), 5 => lang_strings('owner'), 6 => lang_strings('project_site')), 'true');

    for ($i = 0; $i < $comptListProjects; $i++) {
        if ($listProjects->pro_org_id[$i] == 1) {
            $listProjects->pro_org_name[$i] = lang_strings('none');
        }

        $idStatus = $listProjects->pro_status[$i];
        $idPriority = $listProjects->pro_priority[$i];
        $block1->openRow();
        $block1->checkboxRow($listProjects->pro_id[$i]);
        $block1->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $listProjects->pro_id[$i], $listProjects->pro_id[$i], 'in'));
        $block1->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $listProjects->pro_id[$i], $listProjects->pro_name[$i], 'in'));
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
        $block1->cellRow($listProjects->pro_org_name[$i]);
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/project_' . $idStatus . '.gif" alt="' . $statusProject[$idStatus] . '">&nbsp;' . $statusProject[$idStatus], '', true);
        $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listProjects->pro_owner[$i], $listProjects->pro_mem_name[$i], 'in'));

        if ($sitePublish == 'true') {
            if ($listProjects->pro_published[$i] != PB_YES) {
                $block1->cellRow('&lt;' . $blockPage->buildLink('../projects/addprojectsite.php?id=' . $listProjects->pro_id[$i], lang_strings('create') . '...', 'in') . '&gt;');
            } else {
                $block1->cellRow('&lt;' . $blockPage->buildLink('../projects/viewprojectsite.php?id=' . $listProjects->pro_id[$i], lang_strings('details'), 'in') . '&gt;');
            }
        }

        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter(1, $blockPage->bornesNumber, '', 'show=' . $show);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    $st = ($show=='all')?PJS_PROPOSED:$show;
    $block1->paletteScript(0, 'add', '../projects/editproject.php?', 'true,false,false', lang_strings('add'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../projects/deleteproject.php', 'false,true,false', lang_strings('delete'));
    $block1->paletteScript(2, 'copy', '../projects/editproject.php?cpy=true', 'false,true,false', lang_strings('copy'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block1->paletteScript(3, 'info', '../projects/viewproject.php', 'false,true,false', lang_strings('view'));
}

if ($SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(4, "export", "../projects/exportproject.php?languageSession=$languageSession&type=project", "false,true,false", lang_strings("export"));
    $block1->paletteScript(5, 'edit', '../projects/editproject.php', 'false,true,false', lang_strings('edit'));

    if ($enable_cvs == 'true') {
        $block1->paletteScript(6, 'cvs', '../browsecvs/browsecvs.php', 'false,true,false', lang_strings('browse_cvs'));
    }

    $block1->paletteScript(7, 'bug', '../support/listrequests.php', 'false,true,false', lang_strings('support_requests'));
}

if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block1->paletteScript(8, 'calendar', '../calendar/viewcalendar.php?pc=true', 'false,true,false', lang_strings('calendar'));
}

$block1->closePaletteScript($comptListProjects, $listProjects->pro_id);
$blockPage->closeLongList();
require_once('../themes/' . THEME . '/footer.php');

?>
