<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphtasks.php,v 1.16 2009/09/18 03:29:05 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/jpgraph/jpgraph.php');
require_once('../includes/jpgraph/jpgraph_gantt.php');
require_once('../includes/library.php');

/**
 * Variables init
 */
$project = isset($_REQUEST['project'])?$_REQUEST['project']:'0';
$tasks = isset($_REQUEST['tasks'])?$_REQUEST['tasks']:'0';
$base = isset($_REQUEST['base'])?$_REQUEST['base']:true;
$gantt_sd = isset($_REQUEST['gantt_sd'])?$_REQUEST['gantt_sd']:'';

/**
 * Permission check
 */
if ($gantt_sd == '') {
    exit;
}

$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    exit;
}

/**
 * Prepare data
 */
$tasks = str_replace('**', ',', $tasks);
$projectDetail->pro_created[0] = createDate($projectDetail->pro_created[0], $timezoneSession);
$projectDetail->pro_name[0] = str_replace('&quot;', '"', $projectDetail->pro_name[0]);
$projectDetail->pro_name[0] = str_replace("&#39;", "'", $projectDetail->pro_name[0]);
$tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tableName['tasks'] . " WHERE (id IN ($tasks) OR (project=$project AND published='" . PB_YES . "' AND milestone='" . MS_YES . "')) AND start_date<>'--' AND due_date<>'--'";
list($an1, $mois1, $jour1) = preg_split('/-/', $gantt_sd, 3);
$weekday_sd = date('w', mktime(12, 0, 0, intval($mois1), intval($jour1), intval($an1)));

if ($weekday_sd != '1') {
    if ($weekday_sd == '0') {
        $gantt_sd = date('Y-m-d', mktime(12, 0, 0, intval($mois1), intval($jour1)-6, intval($an1)));
    } else {
        $gantt_sd = date('Y-m-d', mktime(12, 0, 0, intval($mois1), intval($jour1)-intval($weekday_sd)+1, intval($an1)));
    }

    list($an1, $mois1, $jour1) = preg_split('/-/', $gantt_sd, 3);
}

if ($base == true) {
    $gantt_dd = date('Y-m-d', mktime(12, 0, 0, intval($mois1)+6, intval($jour1)-1, intval($an1)));
} else {
    $gantt_dd = date('Y-m-d', mktime(12, 0, 0, intval($mois1)+2, intval($jour1)-1, intval($an1)));
}

list($an2, $mois2, $jour2) = preg_split('/-/', $gantt_dd, 3);
$weekday_dd = date('w', mktime(12, 0, 0, intval($mois2), intval($jour2), intval($an2)));

if ($weekday_dd != '0') {
    $gantt_dd = date('Y-m-d', mktime(12, 0, 0, intval($mois2), intval($jour2)-intval($weekday_dd)+7, intval($an2)));
}

$tmpquery .= " AND start_date<='$gantt_dd' AND due_date>='$gantt_sd'";
$boundaries = new request();
$boundaries->connectClass();
$boundaries->query($tmpquery);

if ($boundaries->fetch()) {
    $start_date_b = ($row[0]);
    $due_date_b = ($row[1]);
} else {
    exit;
}

$boundaries->close();
// set up the graph
$graph = new GanttGraph();
$graph->SetBox();
$graph->SetShadow();
$graph->SetMargin(20,20,20,20);
$graph->SetMarginColor('gainsboro');
// Set the Locale if you get errors with your environment
//$graph->scale->SetDateLocale('C');
// Add title
$graph->title->Set(' ' . $projectDetail->pro_name[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
$graph->title->SetMargin(10);
$graph->title->SetBox('linen');
$graph->title->SetShadow();
// month and week scales are always displayed
$graph->scale->month->Show(true);
$graph->scale->week->Show(true);

// Condensed Gantt or not?
if ($_GET['base'] == true) {
    $graph->scale->year->Show(true);
    $graph->scale->day->Show(false);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAME);
} else {
    $graph->scale->year->Show(false);
    $graph->scale->day->Show(true);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR4);
}

// week scale properties
$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(GRAPH_WEEK_FONT);
// month scale properties
$graph->scale->month->SetFontColor('white');
$graph->scale->month->SetBackgroundColor('steelblue4');
// year scale properties
$graph->scale->year->SetFontColor('white');
$graph->scale->year->SetBackgroundColor('steelblue4');
// Modify the appearance of the dividing lines
$graph->scale->divider->SetWeight(4);
$graph->scale->divider->SetColor('steelblue4');
$graph->scale->dividerh->SetWeight(1);
$graph->scale->dividerh->SetColor('black');
$graph->SetBox(true,'black',1);
// holiday scale properties
$tmpquery = " WHERE wca.date>='" . $start_date_b . "' AND wca.date<='" . $due_date_b . "' AND wca.hours='0'";
$holidayList = new request();
$holidayList->openWorkCalendar($tmpquery);
$comptHolidayList = count($holidayList->wca_id);

for ($i = 0;$i < $comptHolidayList;$i++) {
    $graph->scale->holidays[] = $holidayList->wca_date[$i];
}

// netOffice Dwins footer, please don't remove
$graph->footer->right->Set('Created by netOffice Dwins');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);
// Column Titles
$graph->scale->actinfo->SetColTitles(array($strings['name'],$strings['duration']));
$graph->scale->actinfo->SetBackgroundColor('steelblue4');
$graph->scale->actinfo->SetFontColor('white');
$graph->scale->actinfo->SetFont(GRAPH_ACTINFO_FONT,GRAPH_ACTINFO_FONT_STYLE);
// query for data
$tmpqueryC = " WHERE (tas.id IN ($tasks) OR (tas.project=$project AND tas.published='" . PB_YES . "' AND tas.milestone='" . MS_YES . "')) AND tas.start_date!='--' AND tas.due_date!='--' AND tas.start_date<='$gantt_dd' AND tas.due_date>='$gantt_sd'";
$tmpqueryS = " ORDER BY tas.due_date";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$comptListTasks = count($listTasks->tas_id);

for ($i = 0;$i < $comptListTasks;$i++) {
    $listTasks->tas_name[$i] = str_replace('&quot;', '"', $listTasks->tas_name[$i]);
    $listTasks->tas_name[$i] = str_replace("&#39;", "'", $listTasks->tas_name[$i]);
    $progress = round($listTasks->tas_completion[$i] / 10, 2);
    $printProgress = $listTasks->tas_completion[$i] * 10;

    // get the duration in hours for this task
    if ($listTasks->tas_estimated_time[$i] == "") {
        $duration = diff_hour($listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);
    } else {
        $duration = $listTasks->tas_estimated_time[$i] ;
    }

    // get actual time for task
    $taskActualTime = new request();
    $actualTime = $taskActualTime->getTaskTime($listTasks->tas_id[$i]);
    $duration_label = sprintf("%s / %sh", $actualTime, $duration);
    $start_date = ($listTasks->tas_start_date[$i]<$gantt_sd)?$gantt_sd:$listTasks->tas_start_date[$i];
    $due_date = ($listTasks->tas_due_date[$i]>$gantt_dd)?$gantt_dd:$listTasks->tas_due_date[$i];

    // build an activity group
    if ($listTasks->tas_task_group[$i]==TG_YES) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), $start_date, $due_date);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        if ($start_date == $listTasks->tas_start_date[$i]) {
            $activity->leftMark->Show();
            $activity->leftMark->SetType(MARK_LEFTTRIANGLE);
            $activity->leftMark->SetWidth(6);
            $activity->leftMark->SetColor('black');
            $activity->leftMark->SetFillColor('black');
        }

        if ($due_date == $listTasks->tas_due_date[$i]) {
            $activity->rightMark->Show();
            $activity->rightMark->SetType(MARK_RIGHTTRIANGLE);
            $activity->rightMark->SetWidth(6);
            $activity->rightMark->SetColor('black');
            $activity->rightMark->SetFillColor('black');
        }

        $activity->SetHeight(0.3);
        $activity->SetPattern(BAND_SOLID,'black');
    // build an activity bar
    } else if ($listTasks->tas_milestone[$i] != MS_YES) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), $start_date, $due_date);
        $activity->SetPattern(BAND_LDIAG, 'lightblue');
        $activity->caption->Set($printProgress . '%');
        $activity->caption->SetFont(ACTIVITY_CAPTION_FONT);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        $activity->SetFillColor('gray');

        if ($listTasks->tas_priority[$i] == PR_HIGH || $listTasks->tas_priority[$i] == PR_VERY_HIGH) {
            $activity->progress->SetPattern(BAND_SOLID, '#BB0000');
        } else {
            $activity->progress->SetPattern(BAND_SOLID, '#0000BB');
        }

        $activity->progress->Set($progress);
    // build a milestone
    } else {
        $activity = new MileStone($i, array($listTasks->tas_name[$i],""), $start_date);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }
    }

    // query for successors
    $tmpquery = " WHERE pre.predecessor='" . $listTasks->tas_id[$i] . "'";
    $listSuccessor = new request();
    $listSuccessor->openTaskPredecessor($tmpquery);
    $comptListSuccessor = count($listSuccessor->pre_id);

    if ($comptListSuccessor!="0") {
        // set constrains
        for ($j=0;$j<$comptListSuccessor;$j++) {
            for ($k=0;$k<$comptListTasks;$k++) {
                if ($listSuccessor->pre_task[$j]==$listTasks->tas_id[$k]) {
                    break;
                }
            }

            if ($k==$comptListTasks) {
                continue;
            }

            switch ($listSuccessor->pre_type[$j]) {
                case "FF":
                    $activity->SetConstrain($k, CONSTRAIN_ENDEND);
                    break;
                case "FS":
                    $activity->SetConstrain($k, CONSTRAIN_ENDSTART);
                    break;
                case "SF":
                    $activity->SetConstrain($k, CONSTRAIN_STARTEND);
                    break;
                case "SS":
                    $activity->SetConstrain($k, CONSTRAIN_STARTSTART);
                    break;
            }
        }
    }

    $graph->Add($activity);

    // Condensed Gantt or not?
    if ($_GET['base'] == false) {
        // Responsible for formatting individual milestones
        if ($listTasks->tas_milestone[$i]==MS_YES) {
            $activity = new GanttVLine($start_date);
            $graph->Add($activity);
        }
    }
}

$graph->Stroke();

?>
