<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: completed.php,v 1.12 2009/09/01 15:01:15 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/completed.php
 * 
 * show completed tasks for a particular timespan
 * 
 * TODO: enable month/year selection, as well as start/end times
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the member selection
if (isset($_POST['S_ATSEL'])) {
    if ($_POST['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        if (is_array($_POST['S_ATSEL'])) {
            $S_mem = implode(',', $_POST['S_ATSEL']);
        } else {
            $S_mem = $_POST['S_ATSEL'];
        }
    } 
} else {
    $S_mem = $idSession;
}

if ($S_mem == '') $S_mem = $idSession;

// a date range was selected
if (isset($_POST{'S_COMPLETEDATE'})) {
    if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
        $dateRange = true;

        // get the range start date (if given)
        if ($_POST{'S_SDATE2'}) {
            $s_sdate2 = $_POST{'S_SDATE2'};
        } else {
            $s_sdate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), "1", date("Y")));
        }

        // get the range end date
        if ($_POST{'S_EDATE2'}) {
            $s_edate2 = $_POST{'S_EDATE2'};
        } else {
            $s_edate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), date("j"), date("Y")));
        }
    } else {
        // select all dates
        $dateRange = false;
    }
} else {
    $dateRange = false;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("completed_task_report"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/completed.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("tasks", $sortingUser->sor_tasks[0], "tas.name ASC", $sortingFields = array(0 => "tas.assigned_to", 1 => "tas.name", 2 => "tas.project", 3 => "tas.complete_date"));
$query = " WHERE tas.status=" . ST_COMPLETED . " AND tas.milestone<>'" . MS_YES . "'";

// a date range was selected
if ($dateRange) {
    $query .= " AND (tas.complete_date<='$s_edate2' AND tas.complete_date>='$s_sdate2')";
}

// a member selection was made
if ($S_mem != "ALL") {
    $query .= " AND EXISTS (SELECT * FROM " . $tableName['tasks_resource'] . " res WHERE res.task=tas.id AND res.type='members' AND res.resource IN ($S_mem))";
}

$queryS = " ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($query, $queryS);
$comptListTasks = count($listTasks->tas_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTasks == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTasks == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTasks . " " . lang_strings("matches"));
} 

$block0->closeContent();

if ($comptListTasks != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $exportOptions = ""; // handle date ranges

    if ($dateRange) {
        $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
    }

    // a member selection was made
    if ($exportOptions != "") {
        $exportOptions .= "&S_ATSEL=$S_mem";
    } else {
        $exportOptions .= "S_ATSEL=$S_mem";
    }

    $block1->paletteScript(0, "export", "../reports/exportcompleted.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListOrganizations, $listOrganizations->org_id);
}

// set up the header string
$headerString = lang_strings('completed_task_report') . " ";

if ($dateRange) {
    $headerString .= lang_strings("hours_logged_from") . " " . $s_sdate2 . " " . lang_strings("hours_logged_to") . " " . $s_edate2;
}

$block1->heading($headerString);
echo "<input type=\"hidden\" name=\"S_ATSEL\" value=\"$S_mem\">";

if ($dateRange) {
    echo "<input type=\"hidden\" name=\"S_COMPLETEDATE\" value=\"DATERANGE\">";
    echo "<input type=\"hidden\" name=\"S_SDATE2\" value=\"$s_sdate2\">";
    echo "<input type=\"hidden\" name=\"S_EDATE2\" value=\"$s_edate2\">";
}

if ($comptListTasks != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("assigned_to"), 1 => lang_strings("task"), 2 => lang_strings("project"), 3 => lang_strings("complete_date")), "false");

    for ($i = 0;$i < $comptListTasks;$i++) {
        $block1->openRow();
        $block1->checkboxRow($listTasks->tas_id[$i], $checkbox = "false");

        if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assignedToStrings = "";

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink("../users/viewuser.php?id=" . $resourceUsage->res_resource[$j], $resourceUsage->res_mem_name[$j], 'in');
            }

            $block1->cellRow($assignedToStrings);
        }

        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], 'in'));
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTasks->tas_project[$i], $listTasks->tas_pro_name[$i], 'in'));
        $block1->cellRow($listTasks->tas_complete_date[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
