<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportcompleted.php,v 1.11 2009/10/06 09:16:44 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the member selection
if (isset($_GET['S_ATSEL'])) {
    if ($_GET['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = $_GET['S_ATSEL'];
    }
} else {
    $S_mem = $idSession;
}

if ($S_mem == '') $S_mem = $idSession;

// a date range was selected
if (isset($_GET{'S_COMPLETEDATE'}) && $_GET{'S_COMPLETEDATE'} == 'DATERANGE') {
    $dateRange = true;

    // get the range start date (if given)
    if ($_GET{'S_SDATE2'}) {
        $s_sdate2 = $_GET{'S_SDATE2'};
    } else {
        $s_sdate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), "1", date("Y")));
    }
    // get the range end date
    if ($_GET{'S_EDATE2'}) {
        $s_edate2 = $_GET{'S_EDATE2'};
    } else {
        $s_edate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), date("j"), date("Y")));
    }
} else {
    // select all dates
    $dateRange = false;
}

// this is the filename the 'save as' file window will bring up by default
$filename = "completed";
$export = "true";

function which_crlf()
{
    $the_crlf = "\n";
    // The 'NETOFFICE_USR_OS' constant is defined in "../includes/defines.lib.php"
    // Win case
    if (NETOFFICE_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    }
    // Mac case
    else if (NETOFFICE_USR_OS == 'Mac') {
        $the_crlf = "\r";
    }
    // Others
    else {
        $the_crlf = "\n";
    }

    return $the_crlf;
}

@set_time_limit(600);
$crlf = which_crlf();

/**
 * Send headers depending on whether the user choosen to download a dump file
 * or not
 */

$query = " WHERE tas.status = " . ST_COMPLETED . " AND tas.milestone <> '" . MS_YES . "'";
$headerText = "\"" . lang_strings('completed_task_report') . "\"";

// a date range was selected
if ($daterange) {
    $query .= " AND (tas.complete_date <= '$s_edate2'  AND tas.complete_date >= '$s_sdate2')";
    $headerText .= ",\"" . lang_strings("hours_logged_from") . "\",\"$s_sdate2\",\"" . lang_strings("hours_logged_to") . "\",\"$s_edate2\"";
}

$headerText .= $crlf;

// a member selection was made
if ($S_mem != "ALL") {
    $query .= " AND EXISTS (SELECT * FROM " . $tableName['tasks_resource'] . " res WHERE res.task=tas.id AND res.type='members' AND res.resource IN ($S_mem))";
}

$tmpquery = "$query";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpquery);
$comptListTasks = count($listTasks->tas_id);
$dump_buffer = $headerText . $crlf;

if ($comptListTasks != "0") {
    /**
     * Construct the header row
     */

    $dump_buffer .= "\"" . lang_strings("project") . "\",\"" . lang_strings("task") . "\",\"" . lang_strings("complete_date") . "\",\"" . lang_strings("assigned_to") . "\"" . $crlf;

    for ($i = 0;$i < $comptListTasks;$i++) {
        /**
         * The individual fields
         */
        // project name
        $dump_buffer .= "\"" . str_replace('"', '""', $listTasks->tas_pro_name[$i]) . "\",";
        // task name
        $dump_buffer .= "\"" . str_replace('"', '""', $listTasks->tas_name[$i]) . "\",";
        // complete date
        $dump_buffer .= "\"" . $listTasks->tas_complete_date[$i] . "\",";
        // member name
        $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
        $resourceUsage = new request();
        $resourceUsage->openTaskHumanResource($tmpquery);
        $comptResourceUsage = count($resourceUsage->res_id);

        for ($j = 0;$j < $comptResourceUsage;$j++) {
            if ($j > 0) {
                $dump_buffer .= ",";
            }

            $dump_buffer .= "\"" . str_replace('"', '""', $resourceUsage->res_mem_name[$j]) . "\"";
        }

        $dump_buffer .= $crlf;
    }
}

$ext = 'csv';
$mime_type = 'text/x-csv';
// Send headers
header('Content-Type: ' . $mime_type);
$content_disp = (NETOFFICE_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $ext . '"');
header('Pragma: no-cache');
header('Expires: 0');
echo $dump_buffer;

?>
