<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportru.php,v 1.10 2009/11/03 14:29:11 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the organization selection
$S_org = (isset($_GET['S_ORGSEL']))?$_GET['S_ORGSEL']:'ALL';
$S_org = ($S_org == '')?'ALL':$S_org;

// set up the project selection
$S_prj = (isset($_GET['S_PRJSEL']))?$_GET['S_PRJSEL']:'ALL';
$S_prj = ($S_prj == '')?'ALL':$S_prj;

// set up the member selection
if (isset($_GET['S_ATSEL'])) {
    if ($_GET['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = $_GET['S_ATSEL'];
    }
} else {
    $S_mem = $idSession;
}

if ($S_mem == '') $S_mem = $idSession;

// a date range was selected
if (isset($_GET{'S_COMPLETEDATE'}) && $_GET{'S_COMPLETEDATE'} == 'DATERANGE') {
    $dateRange = true;

    // get the range start date (if given)
    if ($_GET{'S_SDATE2'}) {
        $s_sdate2 = $_GET{'S_SDATE2'};
    } else {
        $s_sdate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), "1", date("Y")));
    }
    // get the range end date
    if ($_GET{'S_EDATE2'}) {
        $s_edate2 = $_GET{'S_EDATE2'};
    } else {
        $s_edate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), date("j"), date("Y")));
    }
} else {
    // select all dates
    $dateRange = false;
}

// billing selection
$billing = $_GET{'S_BILLING'};
// end of configuration
// this is the filename the 'save as' file window will bring up by default
$filename = "rusage";

/**
 * functions
 */
function which_crlf()
{
    $the_crlf = "\n";
    // The 'NETOFFICE_USR_OS' constant is defined in "../includes/defines.lib.php"
    // Win case
    if (NETOFFICE_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    }
    // Mac case
    else if (NETOFFICE_USR_OS == 'Mac') {
        $the_crlf = "\r";
    }
    // Others
    else {
        $the_crlf = "\n";
    }

    return $the_crlf;
}

@set_time_limit(600);
$crlf = which_crlf();

/**
 * Send headers depending on whether the user choosen to download a dump file
 * or not
 */

$reportHeader = "\"" . lang_strings("ru_detail") . "\"";

if ($dateRange) {
    if ($query != "") {
        $query .= " AND (tim.date >= '$s_sdate2'  AND tim.date <= '$s_edate2')";
    } else {
        $query .= " WHERE (tim.date >= '$s_sdate2'  AND tim.date <= '$s_edate2')";
    }
    if ($query1 != "") {
        $query1 .= " AND (mti.date >= '$s_sdate2'  AND mti.date <= '$s_edate2')";
    } else {
        $query1 .= " WHERE (mti.date >= '$s_sdate2'  AND mti.date <= '$s_edate2')";
    }
    if ($query2 != "") {
        $query2 .= " AND (wkh.date >= '$s_sdate2'  AND wkh.date <= '$s_edate2')";
    } else {
        $query2 .= " WHERE (wkh.date >= '$s_sdate2'  AND wkh.date <= '$s_edate2')";
    }
    $reportHeader .= ",\"" . lang_strings("ru_detail_from") . "\",\"$s_sdate2\",\"" . lang_strings("ru_detail_to") . "\",\"$s_edate2\"";
}

$reportHeader .= $crlf;

// a organization selection was made
if ($S_org != 'ALL') {
    if ($query != "") {
        $query .= " AND org.id IN($S_org)";
    } else {
        $query .= " WHERE org.id IN($S_org)";
    }

    if ($query1 != "") {
        $query1 .= " AND org.id IN($S_org)";
    } else {
        $query1 .= " WHERE org.id IN($S_org)";
    }

    if ($query2 != "") {
        $query2 .= " AND org.id IN($S_org)";
    } else {
        $query2 .= " WHERE org.id IN($S_org)";
    }
}

// a project selection was made
if ($S_prj != 'ALL') {
    if ($query != "") {
        $query .= " AND pro.id IN($S_prj)";
    } else {
        $query .= " WHERE pro.id IN($S_prj)";
    }

    if ($query1 != "") {
        $query1 .= " AND pro.id IN($S_prj)";
    } else {
        $query1 .= " WHERE pro.id IN($S_prj)";
    }

    if ($query2 != "") {
        $query2 .= " AND pro.id IN($S_prj)";
    } else {
        $query2 .= " WHERE pro.id IN($S_prj)";
    }
}

// a member selection was made
if ($S_mem != 'ALL') {
    if ($query != "") {
        $query .= " AND tim.owner IN ($S_mem)";
    } else {
        $query .= " WHERE tim.owner IN ($S_mem)";
    }
    if ($query1 != "") {
        $query1 .= " AND mti.owner IN ($S_mem)";
    } else {
        $query1 .= " WHERE mti.owner IN ($S_mem)";
    }
    if ($query2 != "") {
        $query2 .= " AND wkh.owner IN ($S_mem)";
    } else {
        $query2 .= " WHERE wkh.owner IN ($S_mem)";
    }
}
// billing selection
if ($billing != 'ALL') {
    if ($query != "") {
        $query .= " AND tim.billing='$billing'";
    } else {
        $query .= " WHERE tim.billing='$billing'";
    }
    if ($query2 != "") {
        $query2 .= " AND wkh.billing='$billing'";
    } else {
        $query2 .= " WHERE wkh.billing='$billing'";
    }
}

if ($query2 != "") {
    $query2 .= " AND wkh.project<>0";
} else {
    $query2 .= " WHERE wkh.project<>0";
}

$comptListHours = 0;
$listHours1 = new request();
$listHours1->openTaskTime($query);
$comptListHours1 = count($listHours1->tim_id);

for ($i=0; $i<$comptListHours1; $i++) {
    if ($listHours1->tim_pro_organization[$i] == '' || $listHours1->tim_pro_organization[$i] == '1') {
        $listHours->tim_org_name[$comptListHours] = '';
    } else {
        $listHours->tim_org_name[$comptListHours] = $listHours1->tim_org_name[$i];
    }

    $listHours->tim_pro_name[$comptListHours] = $listHours1->tim_pro_name[$i];
    $listHours->tim_mem_name[$comptListHours] = $listHours1->tim_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->tim_date[$i];
    $listHours->tim_task_name[$comptListHours] = $listHours1->tim_task_name[$i];
    $listHours->tim_hours[$comptListHours] = $listHours1->tim_hours[$i];
    $comptListHours++;
}

if ($billingSelection != BF_YES) {
    $listHours1 = new request();
    $listHours1->openMeetingTime($query1);
    $comptListHours1 = count($listHours1->mti_id);

    for ($i=0; $i<$comptListHours1; $i++) {
        if ($listHours1->mti_pro_organization[$i] == '' || $listHours1->mti_pro_organization[$i] == '1') {
            $listHours->tim_org_name[$comptListHours] = '';
        } else {
            $listHours->tim_org_name[$comptListHours] = $listHours1->mti_org_name[$i];
        }

        $listHours->tim_pro_name[$comptListHours] = $listHours1->mti_pro_name[$i];
        $listHours->tim_mem_name[$comptListHours] = $listHours1->mti_mem_name[$i];
        $listHours->tim_date[$comptListHours] = $listHours1->mti_date[$i];
        $listHours->tim_task_name[$comptListHours] = $listHours1->mti_meeting_name[$i];
        $listHours->tim_hours[$comptListHours] = $listHours1->mti_hours[$i];
        $comptListHours++;
    }
}

$listHours1 = new request();
$listHours1->openWorkHours($query2);
$comptListHours1 = count($listHours1->wkh_id);

for ($i=0; $i<$comptListHours1; $i++) {
    if ($listHours1->wkh_project[$i] == 0) {
        $listHours->tim_org_name[$comptListHours] = '';
        $listHours->tim_pro_name[$comptListHours] = '';
    } else {
        if ($listHours1->wkh_pro_organization[$i] == '' || $listHours1->wkh_pro_organization[$i] == '1') {
            $listHours->tim_org_name[$comptListHours] = '';
        } else {
            $listHours->tim_org_name[$comptListHours] = $listHours1->wkh_org_name[$i];
        }

        $listHours->tim_pro_name[$comptListHours] = $listHours1->wkh_pro_name[$i];
    }

    $listHours->tim_mem_name[$comptListHours] = $listHours1->wkh_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->wkh_date[$i];
    $listHours->tim_task_name[$comptListHours] = $hourCodeArray[$listHours1->wkh_work[$i]];
    $listHours->tim_hours[$comptListHours] = $listHours1->wkh_hours[$i];
    $comptListHours++;
}

array_multisort($listHours->tim_org_name, $listHours->tim_pro_name, $listHours->tim_mem_name, $listHours->tim_date, $listHours->tim_task_name, $listHours->tim_hours);
$dump_buffer = $reportHeader . $crlf;

if ($comptListHours != "0") {
    /**
     * Construct the header row
     */

    $dump_buffer .= "\"" . lang_strings("organization") . "\",\"" . lang_strings("project") . "\",\"" . lang_strings("member") . "\",\"" . lang_strings('task') . "\",\"" . lang_strings('hours') . "\"" . $crlf;

    for ($i = 0;$i < $comptListHours;$i++) {
        if ($i == 0) {
            // reset the counter
            $total_project_hours = 0;
            $total_org_hours = 0;
            $total_task_hours = 0;
            $project_name = str_replace('"', '""', $listHours->tim_pro_name[$i]);
            $org_name = str_replace('"', '""', $listHours->tim_org_name[$i]);
            $mem_name = str_replace('"', '""', $listHours->tim_mem_name[$i]);
            $task_name = str_replace('"', '""', $listHours->tim_task_name[$i]);

            // print a header row
            if ($org_name != "") {
                $dump_buffer .= "\"" . $org_name . "\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\"";
                $dump_buffer .= $crlf;
            }

            if ($project_name != "") {
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"" . $project_name . "\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\"";
                $dump_buffer .= $crlf;
            }
        }

        if ($org_name != $listHours->tim_org_name[$i]) {
            // display the individual member-task
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . $mem_name . "\",";
            $dump_buffer .= "\"" . $task_name . "\",";
            $dump_buffer .= $total_task_hours;
            $dump_buffer .= $crlf;
            // this is a new organization
            // print the totalled hours
            // print the project totals
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . lang_strings('ru_total_project') . "\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= $total_project_hours;
            $dump_buffer .= $crlf;
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . lang_strings('ru_total_org') . "\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= $total_org_hours;
            $dump_buffer .= $crlf;
            // reset the counter
            $total_project_hours = 0;
            $total_org_hours = 0;
            $total_task_hours = 0;
            $project_name = str_replace('"', '""', $listHours->tim_pro_name[$i]);
            $org_name = str_replace('"', '""', $listHours->tim_org_name[$i]);
            $mem_name = str_replace('"', '""', $listHours->tim_mem_name[$i]);
            $task_name = str_replace('"', '""', $listHours->tim_task_name[$i]);

            // print a header row
            if ($org_name != "") {
                $dump_buffer .= "\"" . $org_name . "\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\"";
                $dump_buffer .= $crlf;
            }

            if ($project_name != "") {
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"" . $project_name . "\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\"";
                $dump_buffer .= $crlf;
            }
        }

        if ($project_name != $listHours->tim_pro_name[$i]) {
            // display the individual member-task
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . $mem_name . "\",";
            $dump_buffer .= "\"" . $task_name . "\",";
            $dump_buffer .= $total_task_hours;
            $dump_buffer .= $crlf;
            // this is a new project
            // print the totalled hours
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . lang_strings('ru_total_project') . "\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= $total_project_hours;
            $dump_buffer .= $crlf;
            // reset the counter
            $total_project_hours = 0;
            $total_task_hours = 0;
            $project_name = str_replace('"', '""', $listHours->tim_pro_name[$i]);
            $mem_name = str_replace('"', '""', $listHours->tim_mem_name[$i]);
            $task_name = str_replace('"', '""', $listHours->tim_task_name[$i]);

            // print a new header row
            if ($project_name != "") {
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"" . $project_name . "\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\",";
                $dump_buffer .= "\"\"";
                $dump_buffer .= $crlf;
            }
        }

        if ($mem_name != $listHours->tim_mem_name[$i] || $task_name != $listHours->tim_task_name[$i]) {
            // display the individual member-task
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"\",";
            $dump_buffer .= "\"" . $mem_name . "\",";
            $dump_buffer .= "\"" . $task_name . "\",";
            $dump_buffer .= $total_task_hours;
            $dump_buffer .= $crlf;
            // reset the counter
            $total_task_hours = 0;
            $mem_name = str_replace('"', '""', $listHours->tim_mem_name[$i]);
            $task_name = str_replace('"', '""', $listHours->tim_task_name[$i]);
        }

        $total_org_hours += $listHours->tim_hours[$i];
        $total_project_hours += $listHours->tim_hours[$i];
        $total_task_hours += $listHours->tim_hours[$i];
    }

    // pick up the last straggler
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"" . $mem_name . "\",";
    $dump_buffer .= "\"" . $task_name . "\",";
    $dump_buffer .= $total_task_hours;
    $dump_buffer .= $crlf;
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"" . lang_strings('ru_total_project') . "\",";
    $dump_buffer .= "\"\",";
    $dump_buffer .= $total_project_hours;
    $dump_buffer .= $crlf;
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"\",";
    $dump_buffer .= "\"" . lang_strings('ru_total_org') . "\",";
    $dump_buffer .= "\"\",";
    $dump_buffer .= $total_org_hours;
    $dump_buffer .= $crlf;
}

$ext = 'csv';
$mime_type = 'text/x-csv';
// Send headers
header('Content-Type: ' . $mime_type);
$content_disp = (NETOFFICE_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $ext . '"');
header('Pragma: no-cache');
header('Expires: 0');
echo $dump_buffer;

?>
