<?php // $Revision: 1.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: issuetracking_summary.php,v 1.2 2009/09/01 15:01:15 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/issuetracking_summary.php
 * 
 * select options for report of issue tracking summary
 * 
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the member selection
$S_ORGSEL = isset($_POST['S_ORGSEL'])?$_POST['S_ORGSEL']:'';
$S_PROSEL = isset($_POST['S_PROSEL'])?$_POST['S_PROSEL']:'';
$S_BYCLIENT = isset($_POST['S_BYCLIENT'])?$_POST['S_BYCLIENT']:'';
$S_BYPROJECT = isset($_POST['S_BYPROJECT'])?$_POST['S_BYPROJECT']:'';
$S_BYSEVERITY = isset($_POST['S_BYSEVERITY'])?$_POST['S_BYSEVERITY']:'';
$S_BYRESOLUTION = isset($_POST['S_BYRESOLUTION'])?$_POST['S_BYRESOLUTION']:'';
$S_BYPRIORITY = isset($_POST['S_BYPRIORITY'])?$_POST['S_BYPRIORITY']:'';
$S_REPORTERSTATE = isset($_POST['S_REPORTERSTATE'])?$_POST['S_REPORTERSTATE']:'';
$S_HANDLERSTATE = isset($_POST['S_HANDLERSTATE'])?$_POST['S_HANDLERSTATE']:'';
$S_REPORTERBYRESOLUTION = isset($_POST['S_REPORTERBYRESOLUTION'])?$_POST['S_REPORTERBYRESOLUTION']:'';
$S_HANDLERBYRESOLUTION = isset($_POST['S_HANDLERBYRESOLUTION'])?$_POST['S_HANDLERBYRESOLUTION']:'';

if (is_array($S_ORGSEL)) {
    if (in_array('ALL', $S_ORGSEL)) {
        $orgSel = 'ALL';
    } else {
        $orgSel = implode(',', $S_ORGSEL);
    }
} else {
    $orgSel = '';
}

if (is_array($S_PROSEL)) {
    if (in_array('ALL', $S_PROSEL)) {
        $proSel = 'ALL';
    } else {
        $proSel = implode(',', $S_PROSEL);
    }
} else {
    $proSel = '';
}

// a date range was selected
if (isset($_REQUEST{'S_CREATEDDATE'})) {
    if ($_REQUEST{'S_CREATEDDATE'} == 'DATERANGE') {
        $dateRange = true;

        // get the range start date (if given)
        if ($_REQUEST{'S_SDATE2'}) {
            $s_sdate2 = $_REQUEST{'S_SDATE2'};
        } else {
            $s_sdate2 = date("Y-m-d", mktime(12, 0, 0, intval(date("n")), 1, intval(date("Y"))));
        }

        // get the range end date
        if ($_REQUEST{'S_EDATE2'}) {
            $s_edate2 = $_REQUEST{'S_EDATE2'};
        } else {
            $s_edate2 = date("Y-m-d", mktime(12, 0, 0, intval(date("n")), intval(date("j")), intval(date("Y"))));
        }
    } else {
        // select all dates
        $dateRange = false;
    }
} else {
    $dateRange = false;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("issue_tracking_summary"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "its1";
$block1->openForm("../reports/issuetracking_summary.php#" . $block1->form . "Anchor");
$querymore = '';

if ($orgSel != 'ALL') {
    $querymore = " WHERE org.id IN ($orgSel)";
}

if ($proSel != 'ALL') {
    if ($querymore == '') {
        $querymore = " WHERE pro.id IN ($proSel)";
    } else {
        $querymore .= " AND pro.id IN ($proSel)";
    }
}

if ($dateRange) {
    if ($querymore == '') {
        $querymore = " WHERE SUBSTRING(sr.date_open FROM 1 FOR 10)>='$s_sdate2' AND SUBSTRING(sr.date_open FROM 1 FOR 10)<='$s_edate2'";
    } else {
        $querymore .= " AND SUBSTRING(sr.date_open FROM 1 FOR 10)>='$s_sdate2' AND SUBSTRING(sr.date_open FROM 1 FOR 10)<='$s_edate2'";
    }
}

if ($S_BYCLIENT == 'TRUE') {
    $tmpquery = "SELECT org.id,org.name,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY org.id,org.name,sr.status ORDER BY org.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $org_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->org_id) || !in_array($org_id, $request1->org_id)) {
            $request1->org_id[$org_id] = $org_id;
            $request1->org_name[$org_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$org_id] = 0;
            $request1->sr_open[$org_id] = 0;
            $request1->sr_complete[$org_id] = 0;
            $request1->sr_total[$org_id] = 0;
        }

        switch ($row[2]) {
            case RQ_NEW:
                $request1->sr_new[$org_id] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$org_id] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$org_id] += $num;
                break;
        }

        $request1->sr_total[$org_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_organization'));

    if (count($request1->org_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("organization"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->org_id as $org_id) {
            if ($request1->sr_total[$org_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($org_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $org_id, $request1->org_name[$org_id], 'in'));
            $block1->cellRow($request1->sr_new[$org_id]);
            $block1->cellRow($request1->sr_open[$org_id]);
            $block1->cellRow($request1->sr_complete[$org_id]);
            $block1->cellRow($request1->sr_total[$org_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYPROJECT == 'TRUE') {
    $tmpquery = "SELECT pro.id,pro.name,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY pro.id,pro.name,sr.status ORDER BY pro.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $pro_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->pro_id) || !in_array($pro_id, $request1->pro_id)) {
            $request1->pro_id[$pro_id] = $pro_id;
            $request1->pro_name[$pro_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$pro_id] = 0;
            $request1->sr_open[$pro_id] = 0;
            $request1->sr_complete[$pro_id] = 0;
            $request1->sr_total[$pro_id] = 0;
        }

        switch ($row[2]) {
            case RQ_NEW:
                $request1->sr_new[$pro_id] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$pro_id] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$pro_id] += $num;
                break;
        }

        $request1->sr_total[$pro_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_project'));

    if (count($request1->pro_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("project"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->pro_id as $pro_id) {
            if ($request1->sr_total[$pro_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($pro_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $pro_id, $request1->pro_name[$pro_id], 'in'));
            $block1->cellRow($request1->sr_new[$pro_id]);
            $block1->cellRow($request1->sr_open[$pro_id]);
            $block1->cellRow($request1->sr_complete[$pro_id]);
            $block1->cellRow($request1->sr_total[$pro_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYSEVERITY == 'TRUE') {
    $tmpquery = "SELECT sr.severity,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.severity,sr.status ORDER BY sr.severity";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_severity = ($row[0]);
        $num = ($row[2]);

        if (!isset($request1->sr_severity) || !in_array($sr_severity, $request1->sr_severity)) {
            $request1->sr_severity[$sr_severity] = $sr_severity;
            $request1->sr_new[$sr_severity] = 0;
            $request1->sr_open[$sr_severity] = 0;
            $request1->sr_complete[$sr_severity] = 0;
            $request1->sr_total[$sr_severity] = 0;
        }

        switch ($row[1]) {
            case RQ_NEW:
                $request1->sr_new[$sr_severity] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$sr_severity] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$sr_severity] += $num;
                break;
        }

        $request1->sr_total[$sr_severity] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_severity'));

    if (count($request1->sr_severity) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("severity"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->sr_severity as $sr_severity) {
            if ($request1->sr_total[$sr_severity] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($sr_severity, $checkbox = "false");
            $block1->cellRow($severityArray[$sr_severity]);
            $block1->cellRow($request1->sr_new[$sr_severity]);
            $block1->cellRow($request1->sr_open[$sr_severity]);
            $block1->cellRow($request1->sr_complete[$sr_severity]);
            $block1->cellRow($request1->sr_total[$sr_severity]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT sr.resolution,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.resolution,sr.status ORDER BY sr.resolution";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_resolution = ($row[0]);
        $num = ($row[2]);

        if (!isset($request1->sr_resolution) || !in_array($sr_resolution, $request1->sr_resolution)) {
            $request1->sr_resolution[$sr_resolution] = $sr_resolution;
            $request1->sr_new[$sr_resolution] = 0;
            $request1->sr_open[$sr_resolution] = 0;
            $request1->sr_complete[$sr_resolution] = 0;
            $request1->sr_total[$sr_resolution] = 0;
        }

        switch ($row[1]) {
            case RQ_NEW:
                $request1->sr_new[$sr_resolution] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$sr_resolution] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$sr_resolution] += $num;
                break;
        }

        $request1->sr_total[$sr_resolution] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_resolution'));

    if (count($request1->sr_resolution) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("resolution"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->sr_resolution as $sr_resolution) {
            if ($request1->sr_total[$sr_resolution] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($sr_resolution, $checkbox = "false");
            $block1->cellRow($resolutionArray[$sr_resolution]);
            $block1->cellRow($request1->sr_new[$sr_resolution]);
            $block1->cellRow($request1->sr_open[$sr_resolution]);
            $block1->cellRow($request1->sr_complete[$sr_resolution]);
            $block1->cellRow($request1->sr_total[$sr_resolution]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYPRIORITY == 'TRUE') {
    $tmpquery = "SELECT sr.priority,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.priority,sr.status ORDER BY sr.priority";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_priority = ($row[0]);
        $num = ($row[2]);

        if (!isset($request1->sr_priority) || !in_array($sr_priority, $request1->sr_priority)) {
            $request1->sr_priority[$sr_priority] = $sr_priority;
            $request1->sr_new[$sr_priority] = 0;
            $request1->sr_open[$sr_priority] = 0;
            $request1->sr_complete[$sr_priority] = 0;
            $request1->sr_total[$sr_priority] = 0;
        }

        switch ($row[1]) {
            case RQ_NEW:
                $request1->sr_new[$sr_priority] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$sr_priority] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$sr_priority] += $num;
                break;
        }

        $request1->sr_total[$sr_priority] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_priority'));

    if (count($request1->sr_priority) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("priority"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->sr_priority as $sr_priority) {
            if ($request1->sr_total[$sr_priority] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($sr_priority, $checkbox = "false");
            $block1->cellRow($priority[$sr_priority]);
            $block1->cellRow($request1->sr_new[$sr_priority]);
            $block1->cellRow($request1->sr_open[$sr_priority]);
            $block1->cellRow($request1->sr_complete[$sr_priority]);
            $block1->cellRow($request1->sr_total[$sr_priority]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_REPORTERSTATE == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization INNER JOIN " . $tableName['members'] . " mem ON mem.id=sr.owner";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.status ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->mem_id) || !in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$mem_id] = 0;
            $request1->sr_open[$mem_id] = 0;
            $request1->sr_complete[$mem_id] = 0;
            $request1->sr_total[$mem_id] = 0;
        }

        switch ($row[2]) {
            case RQ_NEW:
                $request1->sr_new[$mem_id] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$mem_id] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$mem_id] += $num;
                break;
        }

        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('reporter_state'));

    if (count($request1->mem_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("reporter"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($mem_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $request1->mem_name[$mem_id], 'in'));
            $block1->cellRow($request1->sr_new[$mem_id]);
            $block1->cellRow($request1->sr_open[$mem_id]);
            $block1->cellRow($request1->sr_complete[$mem_id]);
            $block1->cellRow($request1->sr_total[$mem_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_HANDLERSTATE == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.status,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization INNER JOIN " . $tableName['members'] . " mem ON mem.id=sr.assigned_to";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.status ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->mem_id) || !in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$mem_id] = 0;
            $request1->sr_open[$mem_id] = 0;
            $request1->sr_complete[$mem_id] = 0;
            $request1->sr_total[$mem_id] = 0;
        }

        switch ($row[2]) {
            case RQ_NEW:
                $request1->sr_new[$mem_id] += $num;
                break;
            case RQ_OPEN:
                $request1->sr_open[$mem_id] += $num;
                break;
            case RQ_COMPLETE:
                $request1->sr_complete[$mem_id] += $num;
                break;
        }

        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('handler_state'));

    if (count($request1->mem_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels = array(0 => lang_strings("handler"), 1 => $requestStatus[RQ_NEW], 2 => $requestStatus[RQ_OPEN], 3 => $requestStatus[RQ_COMPLETE], 4 => lang_strings("total")), "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($mem_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $request1->mem_name[$mem_id], 'in'));
            $block1->cellRow($request1->sr_new[$mem_id]);
            $block1->cellRow($request1->sr_open[$mem_id]);
            $block1->cellRow($request1->sr_complete[$mem_id]);
            $block1->cellRow($request1->sr_total[$mem_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_REPORTERBYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.resolution,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization INNER JOIN " . $tableName['members'] . " mem ON mem.id=sr.owner";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.resolution ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->mem_id) || !in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);

            foreach ($resolutionArray as $key => $val) {
                $request1->sr_resolution[$mem_id][$key] = 0;
            }
        }

        $request1->sr_resolution[$mem_id][($row[2])] += $num;
        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    unset($labels);
    $labels[] = lang_strings("reporter");

    foreach ($resolutionArray as $key => $val) {
        $labels[] = $val;
    }

    $block1->heading(lang_strings('reporter_by_resolution'));

    if (count($request1->mem_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($mem_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $request1->mem_name[$mem_id], 'in'));

            foreach ($resolutionArray as $key => $val) {
                $block1->cellRow($request1->sr_resolution[$mem_id][$key]);
            }

            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_HANDLERBYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.resolution,COUNT(sr.id) AS num FROM " . $tableName['support_requests'] . " sr INNER JOIN " . $tableName['projects'] . " pro ON pro.id=sr.project INNER JOIN " . $tableName['organizations'] . " org ON org.id=pro.organization INNER JOIN " . $tableName['members'] . " mem ON mem.id=sr.assigned_to";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.resolution ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!isset($request1->mem_id) || !in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);

            foreach ($resolutionArray as $key => $val) {
                $request1->sr_resolution[$mem_id][$key] = 0;
            }
        }

        $request1->sr_resolution[$mem_id][($row[2])] += $num;
        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    unset($labels);
    $labels[] = lang_strings("handler");

    foreach ($resolutionArray as $key => $val) {
        $labels[] = $val;
    }

    $labels[] = lang_strings('fixed_rate');
    $block1->heading(lang_strings('handler_by_resolution'));

    if (count($request1->mem_id) != '0' && $numnum != 0) {
        $block1->openResults($checkbox = "false");
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) continue;
            $block1->openRow();
            $block1->checkboxRow($mem_id, $checkbox = "false");
            $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $request1->mem_name[$mem_id], 'in'));

            foreach ($resolutionArray as $key => $val) {
                $block1->cellRow($request1->sr_resolution[$mem_id][$key]);
            }

            $percentage = intval($request1->sr_resolution[$mem_id][SRE_FIXED] * 100 /$request1->sr_total[$mem_id]);
            $block1->cellRow($percentage . ' %');
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

$block1->closeFormResults();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
