<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: phasestatus.php,v 1.9 2009/10/06 14:05:14 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/phasestatus.php
 *
 * show a basic overview of all active projects and their phases
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("project_phasestatus"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
// These are considered active project status numbers
// 0 = Client Completed (not a closed project still active)
// 2 = Not Started (in the pipe sort of speak)
// 3 = Open (an open project)
if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $query = " WHERE pro.status IN ('" . PJS_PROPOSED . "','" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "') AND pro.phase_set!=0";
} else {
    $query = " LEFT OUTER JOIN " . $tableName["teams"] . " tea ON tea.project=pro.id LEFT OUTER JOIN " . $tableName['project_permissions'] . " prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member=$idSession AND prp.view_project='" . B_TRUE . "' AND prp.view_phase='" . B_TRUE . "' AND pro.status IN ('" . PJS_PROPOSED . "','" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "') AND pro.phase_set!=0";
}

$tmpquery = "$query ORDER BY pro.name";
$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);
// show the nice number-of-results header
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $blockPage->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $blockPage->contentRow("", "1 " . lang_strings("match"));
} else {
    $blockPage->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListProjects != "0") {
    for ($j = 0;$j < $comptListProjects;$j++) {
        $projectTitle = $listProjects->pro_name[$j];
        $projectId = $listProjects->pro_id[$j];
        $blockProject = new block();
        $blockProject->openContent();
        $blockProject->heading($blockPage->buildLink("../projects/viewproject.php?id=" . $projectId, $projectTitle, in));
        $blockProject->closeContent();
        $queryPhase = " WHERE pha.project_id=$projectId ORDER BY pha.order_num";
        $listPhases = new request();
        $listPhases->openPhases2($queryPhase);
        $comptListPhases = count($listPhases->pha_id);
        $blockProject->openResults($checkbox = "false");
        $blockProject->labels($labels = array(0 => lang_strings("phase"), 1 => lang_strings("status"), 2 => lang_strings("total_tasks"), 3 => lang_strings("uncomplete_tasks"), 4 => lang_strings("date_start"), 5 => lang_strings("date_end")), "true");

        for ($i = 0;$i < $comptListPhases;$i++) {
            if ($listPhases->pha_status[$i] == PS_NOT_STARTED) {
                $phaseStart = lang_strings("none");
                $phaseEnd = lang_strings("none");
            } else if ($listPhases->pha_status[$i] == PS_COMPLETE) {
                $phaseStart = $listPhases->pha_date_start[$i];
                $phaseEnd = $listPhases->pha_date_end[$i];
            } else {
                $phaseStart = $listPhases->pha_date_start[$i];
                $phaseEnd = lang_strings("none");
            }

            $blockProject->openRow();
            $blockProject->checkboxRow($phaseID, $checkbox = "false");
            $blockProject->cellRow($blockPage->buildLink("../phases/viewphase.php?id=" . $listPhases->pha_id[$i], $listPhases->pha_name[$i], in));
            $blockProject->cellRow($phaseStatus[$listPhases->pha_status[$i]]);
            $blockProject->cellRow($listPhases->pha_total_tasks[$i]);
            $blockProject->cellRow($listPhases->pha_uncompleted_tasks[$i]);
            $blockProject->cellRow($phaseStart);
            $blockProject->cellRow($phaseEnd);
            $blockProject->closeRow();
        }

        $blockProject->closeResults();
        print "<p><br></p>";
    }
} else {
    $block0->noresults();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
