<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: projectbreakdown.php,v 1.8 2009/10/06 14:05:14 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/projectbreakdown.php
 *
 * list projects by manager
 *
 * TODO: add export to CSV capabilities
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("project_breakdown"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $query = " LEFT OUTER JOIN " . $tableName["teams"] . " tea ON tea.project=pro.id LEFT OUTER JOIN " . $tableName['project_permissions'] . " prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member=$idSession AND prp.view_project='" . B_TRUE . "'";
}

// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/projectbreakdown.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("projects", $sortingUser->sor_projects[0], "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "pro.name", 2 => "org.name", 3 => "pro.status"));
$tmpquery = "$query ORDER BY $block1->sortingValue";
$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();
// set up the header string
$headerString = lang_strings('project_breakdown');
$block1->heading($headerString);

if ($comptListProjects != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("owner"), 1 => lang_strings("project"), 2 => lang_strings("organization"), 3 => lang_strings("status")), "false");

    for ($i = 0;$i < $comptListProjects;$i++) {
        $idStatus = $listProjects->pro_status[$i];
        $block1->openRow();
        $block1->checkboxRow($listProjects->pro_id[$i], $checkbox = "false");

        if ($listProjects->pro_owner[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $block1->cellRow($blockPage->buildLink($listProjects->pro_mem_email_work[$i], $listProjects->pro_mem_name[$i], mail));
        }

        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listProjects->pro_id[$i], $listProjects->pro_name[$i], in));
        if ($listProjects->pro_org_id[$i] == '' || $listProjects->pro_org_id[$i] == '1') {
            $block1->cellRow('');
        } else {
            $block1->cellRow($blockPage->buildLink("../clients/viewclient.php?id=" . $listProjects->pro_org_id[$i], $listProjects->pro_org_name[$i], 'in'));
        }

        // $block1->cellRow($listProjects->pro_status[$i]);
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/project_' . $idStatus . '.gif" alt="' . $statusProject[$idStatus] . '">&nbsp;' . $statusProject[$idStatus], '', true);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close this block
$block1->closeFormResults();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
