<?php // $Revision: 1.14.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: resource_usage.php,v 1.14.2.1 2009/12/04 07:38:19 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/resource_usage.php
 *
 * display total hours logged in a given time frame by project and
 * organization
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the organization selection
if (isset($_POST['S_ORGSEL'])) {
    if ($_POST['S_ORGSEL'] == 'ALL') {
        $S_org = 'ALL';
    } else {
        if (is_array($_POST['S_ORGSEL'])) {
            if (in_array('ALL', $_POST['S_ORGSEL'])) {
                $S_org = 'ALL';
            } else {
                $S_org = implode(',', $_POST['S_ORGSEL']);
            }
        } else {
            $S_org = $_POST['S_ORGSEL'];
        }
    }
} else {
    $S_org = 'ALL';
}

// set up the project selection
if (isset($_POST['S_PRJSEL'])) {
    if ($_POST['S_PRJSEL'] == 'ALL') {
        $S_prj = 'ALL';
    } else {
        if (is_array($_POST['S_PRJSEL'])) {
            if (in_array('ALL', $_POST['S_PRJSEL'])) {
                $S_prj = 'ALL';
            } else {
                $S_prj = implode(',', $_POST['S_PRJSEL']);
            }
        } else {
            $S_prj = $_POST['S_PRJSEL'];
        }
    }
} else {
    $S_prj = 'ALL';
}

// set up the member selection
if (isset($_POST['S_ATSEL'])) {
    if ($_POST['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        if (is_array($_POST['S_ATSEL'])) {
            $S_mem = implode(',', $_POST['S_ATSEL']);
        } else {
            $S_mem = $_POST['S_ATSEL'];
        }
    }
} else {
    $S_mem = $idSession;
}

if ($S_mem == '') $S_mem = $idSession;

// a date range was selected
if (isset($_POST{'S_COMPLETEDATE'})) {
    if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
        $dateRange = true;

        // get the range start date (if given)
        if ($_POST{'S_SDATE2'}) {
            $s_sdate2 = $_POST{'S_SDATE2'};
        } else {
            $s_sdate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), "1", date("Y")));
        }

        // get the range end date
        if ($_POST{'S_EDATE2'}) {
            $s_edate2 = $_POST{'S_EDATE2'};
        } else {
            $s_edate2 = date("Y-m-d", mktime(12, 0, 0, date("n"), date("j"), date("Y")));
        }
    } else {
        // select all dates
        $dateRange = false;
    }
} else {
    $dateRange = false;
}

// display itemized member hours
if (isset($_POST['S_MEMITEM'])) {
    $displayMemHourItems = ($_POST['S_MEMITEM']=='TRUE')?true:false;
} else {
    $displayMemHourItems = false;
}

// display total project hours
if (isset($_POST['S_PROJTOTAL'])) {
    $displayProjTotals = ($_POST['S_PROJTOTAL']=='TRUE')?true:false;
} else {
    $displayProjTotals = false;
}

// display total organization hours
if (isset($_POST['S_ORGTOTAL'])) {
    $displayOrgTotals = ($_POST['S_ORGTOTAL']=='TRUE')?true:false;
} else {
    $displayOrgTotals = false;
}

// display total member hours for project
if (isset($_POST['S_MEMTOTAL'])) {
    $displayMemTotals = ($_POST['S_MEMTOTAL']=='TRUE')?true:false;
} else {
    $displayMemTotals = false;
}

// display total member hours for period
if (isset($_POST['S_MEMPTOTAL'])) {
    $displayMemPTotals = ($_POST['S_MEMPTOTAL']=='TRUE')?true:false;
} else {
    $displayMemPTotals = false;
}

// billing selection
$billingSelection = isset($_POST{'S_BILLING'})?$_POST{'S_BILLING'}:'';

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("resource_usage"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/selectru.php#" . $block1->form . "Anchor");
$block1->openContent();

// handle date ranges, if supplied
if ($dateRange) {
    $query = " WHERE (tim.date<='$s_edate2' AND tim.date>='$s_sdate2')";
}

// a organization selection was made
if ($S_org != 'ALL') {
    $query .= (($query == '')?' WHERE ':' AND ') . "org.id IN ($S_org)";
}

// a project selection was made
if ($S_prj != 'ALL') {
    $query .= (($query == '')?' WHERE ':' AND ') . "pro.id IN ($S_prj)";
}

// a member selection was made
if ($S_mem != 'ALL') {
    $query .= (($query == '')?' WHERE ':' AND ') . "tim.owner IN ($S_mem)";
}

// billing selection
if ($billingSelection != 'ALL') {
    $query1 = (($query == '')?' WHERE ':' AND ') . "tim.billing='$billingSelection'";
}

$comptListHours = 0;
$tmpquery = $query . $query1;
$listHours1 = new request();
$listHours1->openTaskTime($tmpquery);
$comptListHours1 = count($listHours1->tim_id);

for ($i=0; $i<$comptListHours1; $i++) {
    $listHours->tim_id[$comptListHours] = $listHours1->tim_id[$i];
    if ($listHours1->tim_pro_organization[$i] == '' || $listHours1->tim_pro_organization[$i] == '1') {
        $listHours->tim_pro_organization[$comptListHours] = '';
        $listHours->tim_org_name[$comptListHours] = '';
    } else {
        $listHours->tim_pro_organization[$comptListHours] = $listHours1->tim_pro_organization[$i];
        $listHours->tim_org_name[$comptListHours] = $listHours1->tim_org_name[$i];
    }

    $listHours->tim_project[$comptListHours] = $listHours1->tim_project[$i];
    $listHours->tim_pro_name[$comptListHours] = $listHours1->tim_pro_name[$i];
    $listHours->tim_pro_type[$comptListHours] = $listHours1->tim_pro_type[$i];
    $listHours->tim_owner[$comptListHours] = $listHours1->tim_owner[$i];
    $listHours->tim_mem_name[$comptListHours] = $listHours1->tim_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->tim_date[$i];
    $listHours->tim_task[$comptListHours] = $listHours1->tim_task[$i];
    $listHours->tim_meeting[$comptListHours] = '';
    $listHours->tim_task_name[$comptListHours] = $listHours1->tim_task_name[$i];
    $listHours->tim_hours[$comptListHours] = $listHours1->tim_hours[$i];
    $comptListHours++;
}

if ($billingSelection != BF_YES) {
    $tmpquery = str_replace("tim", "mti", $query);
    $tmpquery = str_replace("tas", "mee", $tmpquery);
    $listHours1 = new request();
    $listHours1->openMeetingTime($tmpquery);
    $comptListHours1 = count($listHours1->mti_id);

    for ($i=0; $i<$comptListHours1; $i++) {
        $listHours->tim_id[$comptListHours] = $listHours1->mti_id[$i];
        if ($listHours1->mti_pro_organization[$i] == '' || $listHours1->mti_pro_organization[$i] == '1') {
            $listHours->tim_pro_organization[$comptListHours] = '';
            $listHours->tim_org_name[$comptListHours] = '';
        } else {
            $listHours->tim_pro_organization[$comptListHours] = $listHours1->mti_pro_organization[$i];
            $listHours->tim_org_name[$comptListHours] = $listHours1->mti_org_name[$i];
        }

        $listHours->tim_project[$comptListHours] = $listHours1->mti_project[$i];
        $listHours->tim_pro_name[$comptListHours] = $listHours1->mti_pro_name[$i];
        $listHours->tim_pro_type[$comptListHours] = $listHours1->mti_pro_type[$i];
        $listHours->tim_owner[$comptListHours] = $listHours1->mti_owner[$i];
        $listHours->tim_mem_name[$comptListHours] = $listHours1->mti_mem_name[$i];
        $listHours->tim_date[$comptListHours] = $listHours1->mti_date[$i];
        $listHours->tim_task[$comptListHours] = '';
        $listHours->tim_meeting[$comptListHours] = $listHours1->mti_meeting[$i];
        $listHours->tim_task_name[$comptListHours] = $listHours1->mti_meeting_name[$i];
        $listHours->tim_hours[$comptListHours] = $listHours1->mti_hours[$i];
        $comptListHours++;
    }
}

$tmpquery = $query . $query1;
$tmpquery = str_replace("tim", "wkh", $tmpquery);
$tmpquery = str_replace("tas.name", "wkh.work", $tmpquery);

if ($tmpquery != "") {
    $tmpquery .= " AND wkh.project<>0";
} else {
    $tmpquery = " WHERE wkh.project<>0";
}

$listHours1 = new request();
$listHours1->openWorkHours($tmpquery);
$comptListHours1 = count($listHours1->wkh_id);

for ($i=0; $i<$comptListHours1; $i++) {
    $listHours->tim_id[$comptListHours] = $listHours1->wkh_id[$i];

    if ($listHours1->wkh_project[$i] == 0) {
        $listHours->tim_pro_organization[$comptListHours] = '';
        $listHours->tim_org_name[$comptListHours] = '';
        $listHours->tim_project[$comptListHours] = '';
        $listHours->tim_pro_name[$comptListHours] = '';
        $listHours->tim_pro_type[$comptListHours] = '';
    } else {
        if ($listHours1->wkh_pro_organization[$i] == '' || $listHours1->wkh_pro_organization[$i] == '1') {
            $listHours->tim_pro_organization[$comptListHours] = '';
            $listHours->tim_org_name[$comptListHours] = '';
        } else {
            $listHours->tim_pro_organization[$comptListHours] = $listHours1->wkh_pro_organization[$i];
            $listHours->tim_org_name[$comptListHours] = $listHours1->wkh_org_name[$i];
        }

        $listHours->tim_project[$comptListHours] = $listHours1->wkh_project[$i];
        $listHours->tim_pro_name[$comptListHours] = $listHours1->wkh_pro_name[$i];
        $listHours->tim_pro_type[$comptListHours] = $listHours1->wkh_pro_type[$i];
    }

    $listHours->tim_owner[$comptListHours] = $listHours1->wkh_owner[$i];
    $listHours->tim_mem_name[$comptListHours] = $listHours1->wkh_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->wkh_date[$i];
    $listHours->tim_task[$comptListHours] = '';
    $listHours->tim_meeting[$comptListHours] = '';
    $listHours->tim_task_name[$comptListHours] = $hourCodeArray[$listHours1->wkh_work[$i]];
    $listHours->tim_hours[$comptListHours] = $listHours1->wkh_hours[$i];
    $comptListHours++;
}

if ($comptListHours > 0) {
    array_multisort($listHours->tim_org_name, SORT_ASC, SORT_STRING, $listHours->tim_pro_name, SORT_ASC, SORT_STRING, $listHours->tim_mem_name, SORT_ASC, SORT_STRING, $listHours->tim_pro_organization, $listHours->tim_project, $listHours->tim_pro_type, $listHours->tim_owner, $listHours->tim_date, $listHours->tim_id, $listHours->tim_task, $listHours->tim_meeting, $listHours->tim_task_name, $listHours->tim_hours);
}

$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListHours == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListHours == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListHours . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListHours != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $exportOptions = "";

    // handle date ranges
    if ($dateRange) {
        if ($exportOptions != "") {
            $exportOptions = "&S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        } else {
            $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        }
    }

    // a organization selection was made
    if ($S_org != "" && $S_org != "ALL") {
        if ($exportOptions != "") {
            $exportOptions .= "&S_ORGSEL=$S_org";
        } else {
            $exportOptions .= "S_ORGSEL=$S_org";
        }
    }

    // a project selection was made
    if ($S_prj != "" && $S_prj != "ALL") {
        if ($exportOptions != "") {
            $exportOptions .= "&S_PRJSEL=$S_prj";
        } else {
            $exportOptions .= "S_PRJSEL=$S_prj";
        }
    }

    // a member selection was made
    if ($S_mem != "") {
        if ($exportOptions != "") {
            $exportOptions .= "&S_ATSEL=$S_mem";
        } else {
            $exportOptions .= "S_ATSEL=$S_mem";
        }
    }

    // billing selection
    if ($exportOptions != "") {
        $exportOptions .= "&S_BILLING=$billingSelection";
    } else {
        $exportOptions .= "S_BILLING=$billingSelection";
    }

    $block1->paletteScript(0, "export", "../reports/exportru.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListHours, $listHours->tim_id);
}

// set up the header string
$block1HeadingText = lang_strings("ru_detail") . " ";

if ($dateRange) {
    $block1HeadingText .= lang_strings("ru_detail_from") . " " . $s_sdate2 . " " . lang_strings("ru_detail_to") . " " . $s_edate2;
}

$block1->heading($block1HeadingText);
// set up an organization name placeholder
$total_project_hours = 0;
$total_org_hours = 0;
$total_mem_hours = 0;
$total_task_hours = 0;
$project_name = "!@#$%^&*()";
$org_name = "!@#$%^&*()";
$mem_id = 0;
$mem_name = "!@#$%^&*()";
$task_id = '';
$meeting_id = '';
$task_name = "!@#$%^&*()";
$grand_total_member_hours = array();
echo "<input type=\"hidden\" name=\"S_ORGSEL\" value=\"$S_org\">";
echo "<input type=\"hidden\" name=\"S_PRJSEL\" value=\"$S_prj\">";
echo "<input type=\"hidden\" name=\"S_ATSEL\" value=\"$S_mem\">";

if ($dateRange) {
    echo "<input type=\"hidden\" name=\"S_COMPLETEDATE\" value=\"DATERANGE\">";
    echo "<input type=\"hidden\" name=\"S_SDATE2\" value=\"$s_sdate2\">";
    echo "<input type=\"hidden\" name=\"S_EDATE2\" value=\"$s_edate2\">";
}

echo "<input type=\"hidden\" name=\"S_BILLING\" value=\"$billingSelection\">";

if ($displayMemHourItems) {
    echo "<input type=\"hidden\" name=\"S_MEMITEM\" value=\"TRUE\">";
}

if ($displayProjTotals) {
    echo "<input type=\"hidden\" name=\"S_PROJTOTAL\" value=\"TRUE\">";
}

if ($displayOrgTotals) {
    echo "<input type=\"hidden\" name=\"S_ORGTOTAL\" value=\"TRUE\">";
}

if ($displayMemTotals) {
    echo "<input type=\"hidden\" name=\"S_MEMTOTAL\" value=\"TRUE\">";
}

if ($displayMemPTotals) {
    echo "<input type=\"hidden\" name=\"S_MEMPTOTAL\" value=\"TRUE\">";
}

if ($comptListHours != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("organization"), 1 => lang_strings("project"), 2 => lang_strings("member"), 3 => lang_strings("task"), 4 => lang_strings("hours")), "true");

    for ($i = 0;$i < $comptListHours;$i++) {
        // NEW ORGANIZATION
        if ($org_name != $listHours->tim_org_name[$i]) {
            // this is a new organization
            // print the totalled hours
            if ($org_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_task_hours);
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in'));

                if ($task_id != '') {
                    $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $task_id, $task_name, 'in'));
                } else if ($meeting_id != '') {
                    $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $meeting_id, $task_name, 'in'));
                } else {
                    $block1->cellRow($task_name);
                }

                $block1->cellRow('<div class="right">' . $nice_print . '</div>');
                $block1->closeRow();

                // display the individual member
                if ($displayMemTotals) {
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_mem_hours);
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow('<b>' . $blockPage->buildLink('../users/viewuser.php?id=' . $listHours->tim_owner[$i], $mem_name, 'in') . '</b>');
                    $block1->cellRow('<b>' . lang_strings('ru_subtotal') . '</b>');
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }

                // print the project totals
                if ($displayProjTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_project_hours);
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }

                if ($displayOrgTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_org') . "</b>");
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_org_hours);
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }
            }

            // reset the counter
            $total_project_hours = 0;
            $project_name = $listHours->tim_pro_name[$i];
            $total_org_hours = 0;
            $org_name = $listHours->tim_org_name[$i];
            $total_mem_hours = 0;
            $mem_id = $listHours->tim_owner[$i];
            $mem_name = $listHours->tim_mem_name[$i];
            $total_task_hours = 0;
            $task_id = $listHours->tim_task[$i];
            $meeting_id = $listHours->tim_meeting[$i];
            $task_name = $listHours->tim_task_name[$i];

            // print a header row
            if ($org_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $listHours->tim_pro_organization[$i], $org_name, 'in'));
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow();
            }

            if ($project_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->tim_project[$i], $listHours->tim_pro_name[$i], in));
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow();
            }
        }

        // NEW PROJECT
        if ($project_name != $listHours->tim_pro_name[$i]) {
            // this is a new project
            // print the totalled hours
            if ($project_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_task_hours);
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in'));

                if ($task_id != '') {
                    $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $task_id, $task_name, 'in'));
                } else if ($meeting_id != '') {
                    $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $meeting_id, $task_name, 'in'));
                } else {
                    $block1->cellRow($task_name);
                }

                $block1->cellRow('<div class="right">' . $nice_print . '</div>');
                $block1->closeRow();

                // display the individual member
                if ($displayMemTotals) {
                    // this is a new member
                    // print the line for the other member
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_mem_hours);
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow('<b>' . $blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in') . '</b>');
                    $block1->cellRow('<b>' . lang_strings('ru_subtotal') . '</b>');
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }

                if ($displayProjTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_project_hours);
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }
            }

            // reset the counter
            $total_project_hours = 0;
            $project_name = $listHours->tim_pro_name[$i];
            $total_mem_hours = 0;
            $mem_id = $listHours->tim_owner[$i];
            $mem_name = $listHours->tim_mem_name[$i];
            $total_task_hours = 0;
            $task_id = $listHours->tim_task[$i];
            $meeting_id = $listHours->tim_meeting[$i];
            $task_name = $listHours->tim_task_name[$i];

            // print a new header row
            if ($project_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->tim_project[$i], $listHours->tim_pro_name[$i], in));
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow();
            }
        }

        // NEW MEMBER
        if ($mem_name != $listHours->tim_mem_name[$i]) {
            // this is a new member
            // print the line for the other member
            if ($mem_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_task_hours);
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in'));

                if ($task_id != '') {
                    $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $task_id, $task_name, 'in'));
                } else if ($meeting_id != '') {
                    $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $meeting_id, $task_name, 'in'));
                } else {
                    $block1->cellRow($task_name);
                }

                $block1->cellRow('<div class="right">' . $nice_print . '</div>');
                $block1->closeRow();

                if ($displayMemTotals) {
                    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_mem_hours);
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow('<b>' . $blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in') . '</b>');
                    $block1->cellRow('<b>' . lang_strings('ru_subtotal') . '</b>');
                    $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
                    $block1->closeRow();
                }
            }

            // reset the counter
            $total_mem_hours = 0;
            $mem_id = $listHours->tim_owner[$i];
            $mem_name = $listHours->tim_mem_name[$i];
            $total_task_hours = 0;
            $task_id = $listHours->tim_task[$i];
            $meeting_id = $listHours->tim_meeting[$i];
            $task_name = $listHours->tim_task_name[$i];
        }

        // increment the grand total
        $grand_total_member_hours [$listHours->tim_owner[$i]] += $listHours->tim_hours[$i];

        // NEW TASK
        if ($task_name != $listHours->tim_task_name[$i]) {
            // this is a new task
            // print the line for the other task
            if ($task_name != "!@#$%^&*()") {
                $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_task_hours);
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in'));

                if ($task_id != '') {
                    $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $task_id, $task_name, 'in'));
                } else if ($meeting_id != '') {
                    $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $meeting_id, $task_name, 'in'));
                } else {
                    $block1->cellRow($task_name);
                }

                $block1->cellRow('<div class="right">' . $nice_print . '</div>');
                $block1->closeRow();
            }

            // reset the counter
            $total_task_hours = 0;
            $task_id = $listHours->tim_task[$i];
            $meeting_id = $listHours->tim_meeting[$i];
            $task_name = $listHours->tim_task_name[$i];
        }

        $total_task_hours += $listHours->tim_hours[$i];
        $total_mem_hours += $listHours->tim_hours[$i];
        $total_org_hours += $listHours->tim_hours[$i];
        $total_project_hours += $listHours->tim_hours[$i];
    }

    // pick up the last straggler
    $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_task_hours);
    $block1->openRow();
    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in'));

    if ($task_id != '') {
        $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $task_id, $task_name, 'in'));
    } else if ($meeting_id != '') {
        $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $meeting_id, $task_name, 'in'));
    } else {
        $block1->cellRow($task_name);
    }

    $block1->cellRow('<div class="right">' . $nice_print . '</div>');
    $block1->closeRow();

    if ($displayMemTotals) {
        $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_mem_hours);
        $block1->openRow();
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow('<b>' . $blockPage->buildLink('../users/viewuser.php?id=' . $mem_id, $mem_name, 'in') . '</b>');
        $block1->cellRow('<b>' . lang_strings('ru_subtotal') . '</b>');
        $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
        $block1->closeRow();
    }

    if ($displayProjTotals) {
        $block1->openRow();
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->$project_name, $listHours->tim_pro_name[$i], in));
        $block1->cellRow("");
        $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
        $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_project_hours);
        $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
        $block1->closeRow();
    }

    if ($displayOrgTotals) {
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("<b>" . lang_strings('ru_total_org') . "</b>");
        $nice_print = sprintf("%01." . $hourAccuracy . "f", $total_org_hours);
        $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
        $block1->closeRow();
    }

    // show a member total
    if ($displayMemPTotals) {
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->closeRow();
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("<b>" . lang_strings('ru_total_mem') . "</b>");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->closeRow();

        foreach ($grand_total_member_hours as $mem_id => $hrs) {
            $tmpquery = " WHERE mem.id=" . $mem_id;
            $listMembers = new request();
            $listMembers->openMembers($tmpquery);
            $mem_name = "Unknown";

            if ($listMembers->mem_name[0] != "") {
                $mem_name = $blockPage->buildLink('../users/viewuser.php?id=' . $listMembers->mem_id[0], $listMembers->mem_name[0], 'in');
            }

            $nice_print = sprintf("%01." . $hourAccuracy . "f", $hrs);
            $block1->openRow();
            $block1->checkboxRow("", $checkbox = "false");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow($mem_name);
            $block1->cellRow('<b><div class="right">' . $nice_print . '</div></b>');
            $block1->closeRow();
        }
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
