<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editservice.php,v 1.18 2009/09/04 08:58:47 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.svEForm.n.focus();\"";

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$n = isset($_POST['n'])?$_POST['n']:'';
$np = isset($_POST['np'])?$_POST['np']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$curr = isset($_POST['curr'])?$_POST['curr']:$defaultCurrency;

/**
 * Permission check
 */
if ($id != "") {
    if (!$SW_Permissions['Service']['Edit'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Service']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Actions
 */
if ($action == "add" || $action == "update") {
    if ($n == '') {
        $error = lang_strings('name') . ' ' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.svEForm.n.focus();\"";
        $n_highlight = true;
    } else if ($np == '') {
        $error = lang_strings('name_print') . ' ' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.svEForm.np.focus();\"";
        $np_highlight = true;
    } else if ($hr == '') {
        $error = lang_strings('hourly_rate') . ' ' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.svEForm.hr.focus();\"";
        $hr_highlight = true;
    } else if (!is_numeric($hr)) {
        $error = lang_strings('hourly_rate') . ' ' . lang_strings("error_numerical");
        $bodyCommand = "onLoad=\"document.svEForm.hr.focus();document.svEForm.hr.select();\"";
        $hr_highlight = true;
    } else if (floatval($hr) < 0 || floatval($hr) != round($hr, $rateAccuracy)) {
        $error = lang_strings('hourly_rate') . ' ' . lang_strings("value_deviate");
        $bodyCommand = "onLoad=\"document.svEForm.hr.focus();document.svEForm.hr.select();\"";
        $hr_highlight = true;
    } else {
        $hr = round($hr, $rateAccuracy);
        $n = HtmlEntitiesNOD($n);
        $np = HtmlEntitiesNOD($np);

        if ($action == "update") {
            $tmpquery = "UPDATE " . $tableName["services"] . " SET name='$n',name_print='$np',hourly_rate='$hr',currency='$curr' WHERE id=$id";
            connectSql($tmpquery);
            header("Location: ../services/listservices.php?msg=update");
            exit;
        } else if ($action == "add") {
            $tmpquery1 = "INSERT INTO " . $tableName["services"] . " (name,name_print,hourly_rate,currency) VALUES ('$n','$np','$hr','$curr')";
            connectSql($tmpquery1);
            header("Location: ../services/listservices.php?msg=add");
            exit;
        }
    }
}

if ($id != '' && $error == '') {
    $tmpquery = " WHERE serv.id=$id";
    $detailService = new request();
    $detailService->openServices($tmpquery);
    $comptDetailService = count($detailService->serv_id);

    if ($comptDetailService != "0") {
        $n = $detailService->serv_name[0];
        $np = $detailService->serv_name_print[0];
        $hr = $detailService->serv_hourly_rate[0];
        $curr = $detailService->serv_currency[0];
    }
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../services/listservices.php?", lang_strings("service_management"), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_service"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../services/viewservice.php?id=$id", $n, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_service"));
}

$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "svE";

if ($id == "") {
    $block1->openForm("../services/editservice.php?#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
} else {
    $block1->openForm("../services/editservice.php?id=$id#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
}

if ($id == "") {
    $block1->heading(lang_strings("add_service"));
} else {
    $block1->heading(lang_strings("edit_service") . " : " . $detailService->serv_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));

if ($n_highlight) {
    $block1->contentRow("* " . lang_strings("name"), "<input size=\"24\" class=\"input_text_highlight\" type=\"text\" name=\"n\" value=\"" . str_replace('"', '&quot;', $n) . "\" maxlength=\"154\">");
} else {
    $block1->contentRow("* " . lang_strings("name"), "<input size=\"24\" class=\"input_text\" type=\"text\" name=\"n\" value=\"" . str_replace('"', '&quot;', $n) . "\" maxlength=\"154\">");
}

if ($np_highlight) {
    $block1->contentRow("* " . lang_strings("name_print"), "<input size=\"24\" class=\"input_text_highlight\" type=\"text\" name=\"np\" value=\"" . str_replace('"', '&quot;', $np) . "\" maxlength=\"154\">");
} else {
    $block1->contentRow("* " . lang_strings("name_print"), "<input size=\"24\" class=\"input_text\" type=\"text\" name=\"np\" value=\"" . str_replace('"', '&quot;', $np) . "\" maxlength=\"154\">");
}

if ($hr_highlight) {
    $hourlyRate = "<input class=\"input_amount_highlight\" type=\"text\" name=\"hr\" value=\"$hr\" maxlength=\"19\">";
} else {
    $hourlyRate = "<input class=\"input_amount\" type=\"text\" name=\"hr\" value=\"$hr\" maxlength=\"19\">";
}

$helpStr = '<table>';
$currencyStr = '<select name="curr">';

foreach ($CurrencyMatrix['name'] as $currCode => $currName) {
    $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';

    if ($currCode == $curr) {
        $currencyStr .= '<option value="' . $currCode . '" selected>' . $currCode . '</option>';
    } else {
        $currencyStr .= '<option value="' . $currCode . '">' . $currCode . '</option>';
    }
}

$currencyStr .= '</select>';
$helpStr .= '</table>';

if ($currencyOnRight == 'true') {
    $block1->contentRow("* " . lang_strings("hourly_rate") . '&nbsp;' . $blockPage->printHelp($helpStr, 'true'), $hourlyRate . $currencyStr);
} else {
    $block1->contentRow("* " . lang_strings("hourly_rate") . '&nbsp;' . $blockPage->printHelp($helpStr, 'true'), $currencyStr . $hourlyRate);
}

$block1->contentRow("", '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>