<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphservice.php,v 1.3 2009/10/07 15:31:27 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/jpgraph/jpgraph.php');
require_once('../includes/jpgraph/jpgraph_line.php');
require_once('../includes/library.php');

/**
 * Variables init
 */
$service = isset($_REQUEST['service'])?$_REQUEST['service']:'0';
$sd = date('Y-m-d', mktime(12,0,0,intval(date('n'))-12,1,intval(date('Y'))));
$dd = date('Y-m-d', mktime(12,0,0,intval(substr($sd,5,2))+13,0,intval(substr($sd,0,4))));

/**
 * Permission check
 */
if ($sd == '') {
    exit;
}

if (!$SW_Permissions['Service']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE serv.id=$service";
$serviceDetail = new request();
$serviceDetail->openServices($tmpquery);
$comptServiceDetail = count($serviceDetail->serv_id);

if ($comptServiceDetail == '0') {
    exit;
}

/**
 * Prepare data
 */
$hourly_rate = $serviceDetail->serv_hourly_rate[0];
$tmpquery = "SELECT t0.month, SUM(t0.hours) FROM
(
    SELECT SUBSTRING(tim.date FROM 1 FOR 7) AS month, tim.hours AS hours FROM " . $tableName['tasks_time'] . " tim WHERE tim.date>='$sd' AND tim.date<='$dd' AND tim.service='$service'
    UNION ALL
    SELECT SUBSTRING(wkh.date FROM 1 FOR 7) AS month, wkh.hours AS hours FROM " . $tableName['work_hours'] . " wkh WHERE wkh.date>='$sd' AND wkh.date<='$dd' AND wkh.service='$service'
) t0 GROUP BY t0.month ORDER BY t0.month";
$request1 = new request();
$request1->connectClass();
$request1->query($tmpquery);

while ($request1->fetch()) {
    $request1->hours[($row[0])] = ($row[1]);
}

$request1->close();
$d1 = substr($sd,0,7);

while ($d1<=substr($dd,0,7)) {
    if (isset($request1->hours[$d1])) {
        $hours = round($request1->hours[$d1], $hourAccuracy);
    } else {
        $hours = 0;
    }

    $datax[] = $d1;
    $datay[] = $hours;
    $d1 = date('Y-m', mktime(12,0,0,intval(substr($d1,5,2))+1,1,intval(substr($d1,0,4))));
}

function toAmount($val)
{
    global $hourly_rate, $costAccuracy;
    return round($val*$hourly_rate, $costAccuracy);
}

// set up the graph
$graph = new Graph(1000, 160);
$graph->SetMargin(50,70,40,40);
$graph->SetMarginColor('white');
// Setup the scales for X,Y and Y2 axis
$graph->SetScale("intlin"); // X and Y axis
$graph->SetY2Scale("lin"); // Y2 axis
// Add title
$graph->title->Set(' ' . $strings['service'] . ' ' . $serviceDetail->serv_name_print[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
// Setup X-axis labels
$graph->xaxis->SetTickLabels($datax);
// CCreate Y data set
$graph->yaxis->title->Set($strings['hours']);
$graph->yaxis->title->SetMargin(10);
if (defined("YAXIS_TITLE_ANGLE")) $graph->yaxis->title->SetAngle(YAXIS_TITLE_ANGLE);
$graph->yaxis->title->SetFont(GRAPH_TITLE_FONT);
$lineplot=new LinePlot($datay);
// ... and add the plot to the Y-axis
$graph->Add($lineplot);
// Create Y2 scale data set
$l2plot = new LinePlot($datay);
$l2plot->SetWeight(0);
$graph->y2axis->title->Set($strings['amount'] . ' (' . $serviceDetail->serv_currency[0] . ')');
$graph->y2axis->title->SetMargin(10); // Some extra margin to clear labels
if (defined("YAXIS_TITLE_ANGLE")) $graph->y2axis->title->SetAngle(YAXIS_TITLE_ANGLE);
$graph->y2axis->title->SetFont(GRAPH_TITLE_FONT);
$graph->y2axis->SetLabelFormatCallback('toAmount');
$graph->y2axis->SetColor('navy');
// ... and add the plot to the Y2-axis
$graph->AddY2($l2plot);
// netOffice Dwins footer, please don't remove
$graph->footer->right->Set('Created by netOffice Dwins');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);
$graph->Stroke();

?>
