<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listservices.php,v 1.13 2009/09/15 03:41:58 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$view = isset($_GET['view'])?$_GET['view']:'this_year';

/**
 * Permission check
 */
if (!$SW_Permissions['Service']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("service_management"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "servList";
$block1->openForm("../services/listservices.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("service_management"));
$block1->openPaletteIcon();

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $block1->paletteIcon(0, "add", lang_strings("add"));
}

if ($SW_Permissions['Service']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
}

$block1->paletteIcon(2, "info", lang_strings("view"));

if ($SW_Permissions['Service']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, "edit", lang_strings("edit"));
}

$block1->closePaletteIcon();
$tmpquery = " ORDER BY serv.name ASC";
$listServices = new request();

switch ($view) {
    case 'this_year':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, 1, 1, intval(date('Y'))));
        $dateto = date('Y-m-d', mktime(12, 0, 0, 12, 31, intval(date('Y'))));
        break;
    case 'recent_month':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n'))-1, intval(date('j'))+1, intval(date('Y'))));
        $dateto = date('Y-m-d');
        break;
    case 'recent_quarter':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n'))-3, intval(date('j'))+1, intval(date('Y'))));
        $dateto = date('Y-m-d');
        break;
    case 'recent_year':
        $datefrom = date('Y-m-d', mktime(12, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y'))-1));
        $dateto = date('Y-m-d');
        break;
}

$listServices->openServices1($tmpquery, $datefrom, $dateto);
$comptListServices = count($listServices->serv_id);

if ($comptListServices != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings("name"), 1 => lang_strings("hourly_rate"), 2 => lang_strings('total') . ' *'), "false", $sorting = "false", $sortingOff = array(0 => "0", 1 => "ASC"));

    for ($i = 0;$i < $comptListServices;$i++) {
        $block1->openRow();
        $block1->checkboxRow($listServices->serv_id[$i]);
        $block1->cellRow($blockPage->buildLink("../services/viewservice.php?id=" . $listServices->serv_id[$i], $listServices->serv_name[$i], 'in'));

        if ($currencyOnRight == 'true') {
            $block1->cellRow(round($listServices->serv_hourly_rate[$i], $rateAccuracy) . " " . $listServices->serv_currency[$i]);
        } else {
            $block1->cellRow($listServices->serv_currency[$i] . " " . round($listServices->serv_hourly_rate[$i], $rateAccuracy));
        }

        $block1->cellRow($listServices->serv_total[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
    $linkStr = '';

    foreach (array('this_year','recent_month','recent_quarter','recent_year') as $val) {
        if ($linkStr != '') {
            $linkStr .= "&nbsp;|&nbsp;";
        }

        if ($val == $view) {
            $linkStr .= lang_strings($val);
        } else {
            $linkStr .= $blockPage->buildLink('../services/listservices.php?view=' . $val, lang_strings($val), 'in');
        }
    }

    $block1->note("*&nbsp;" . lang_strings('total_hours') . "&nbsp;&nbsp;&nbsp;&nbsp;" . $linkStr);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $block1->paletteScript(0, "add", "../services/editservice.php?", "true,false,false", lang_strings("add"));
}

if ($SW_Permissions['Service']['Admin'][$profilSession]) {
    $block1->paletteScript(1, "remove", "../services/deleteservices.php?", "false,true,true", lang_strings("delete"));
}

$block1->paletteScript(2, "info", "../services/viewservice.php?", "false,true,false", lang_strings("view"));

if ($SW_Permissions['Service']['Edit'][$profilSession]) {
    $block1->paletteScript(3, "edit", "../services/editservice.php?", "false,true,false", lang_strings("edit"));
}

$block1->closePaletteScript($comptListServices, $listServices->serv_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
