<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletepost.php,v 1.3 2009/09/01 15:01:18 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE sp.id=$id";
$supportPostDetail = new request();
$supportPostDetail->openSupportPosts($tmpquery);
$comptSupportPostDetail = count($supportPostDetail->sp_id);

if ($comptSupportPostDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($supportType == "admin") {
    if (!$SW_Permissions['Support']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    $project = $supportPostDetail->sp_project[0];
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    $request_id = $supportPostDetail->sp_request_id[0];
    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_add_support_response[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $tmpquery = "DELETE FROM " . $tableName["support_posts"] . " WHERE id=$id";
    connectSql($tmpquery);
    $tmpquery = " WHERE fil.doc_type='" . DOC_SUPPORT_POST . "' AND fil.doc_id=$id";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);

    if (count($listFiles->fil_id) != '0') {
        deleteFiles($listFiles->fil_fullname);
        $filids = implode(',', $listFiles->fil_id);
        $tmpquery = "DELETE FROM " . $tableName['files'] . " WHERE id IN ($filids)";
        connectSql($tmpquery);
    }

    header("Location: ../support/viewrequest.php?msg=delete&id=$request_id&sendto=$sendto");
    exit;
}

/**
 * Prepare data
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($supportType == "team") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project, lang_strings("support_requests"), 'in'));
} elseif ($supportType == "admin") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/support.php?", lang_strings("support_management"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project, lang_strings("support_requests"), 'in'));
}

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("delete_support_post"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "dsP";
$block1->openForm("../support/deletepost.php?id=$id&amp;sendto=$sendto#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete"/>';
$block1->heading(lang_strings("delete_support_post"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$block1->contentRow(lang_strings("subject"), nl2br($supportPostDetail->sp_sr_subject[0]));
$block1->contentRow(lang_strings("message"), nl2br($supportPostDetail->sp_message[0]));
$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
