<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleterequests.php,v 1.8 2009/09/01 15:01:18 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$ids = str_replace('**', ',', $id);
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if ($supportType == "admin") {
    if (!$SW_Permissions['Support']['Admin'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    $tmpquery = "SELECT DISTINCT project FROM " . $tableName["support_requests"] . " WHERE id IN ($ids)";

    if (compt($tmpquery) != '1') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tmpquery = " WHERE sr.id IN ($ids)";
    $listSupportRequests = new request();
    $listSupportRequests->openSupportRequests($tmpquery);
    $comptListSupportRequests = count($listSupportRequests->sr_id);
    $project = $listSupportRequests->sr_project[0];
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_delete_support_request[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $tmpquery1 = "DELETE FROM " . $tableName["support_requests"] . " WHERE id IN ($ids)";
    $tmpquery2 = "DELETE FROM " . $tableName["support_posts"] . " WHERE request_id IN ($ids)";
    connectSql($tmpquery1);
    connectSql($tmpquery2);
    $tmpquery = " WHERE (fil.doc_type='" . DOC_SUPPORT_REQUEST . "' AND fil.doc_id IN ($ids)) OR (fil.doc_type='" . DOC_SUPPORT_POST . "' AND fil.doc_id IN (SELECT id FROM " . $tableName['support_posts'] . " WHERE request_id IN ($ids)))";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);

    if (count($listFiles->fil_id) != '0') {
        deleteFiles($listFiles->fil_fullname);
        $filids = implode(',', $listFiles->fil_id);
        $tmpquery = "DELETE FROM " . $tableName['files'] . " WHERE id IN ($filids)";
        connectSql($tmpquery);
    }

    if ($sendto == '') {
        header("Location: ../support/listrequests.php?msg=delete&id=$project");
    } else {
        header("Location: ../support/support.php?msg=delete&action=$sendto&project=$project");
    }

    exit;
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($supportType == "team") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project, lang_strings("support_requests"), 'in'));
} elseif ($supportType == "admin") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/support.php?", lang_strings("support_management"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project, lang_strings("support_requests"), 'in'));
}

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("delete_support_requests"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "dsR";
$block1->openForm("../support/deleterequests.php?id=$id&amp;sendto=$sendto#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete"/>';
$block1->heading(lang_strings("delete_support_requests"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListSupportRequests; $i++) {
    $block1->contentRow('', $listSupportRequests->sr_subject[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
