<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: support.php,v 1.9 2009/10/21 08:38:13 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$action = isset($_GET['action'])?$_GET['action']:'';
$project = isset($_GET['project'])?$_GET['project']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($supportType == "admin") {
    if (!$SW_Permissions['Support']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_view_support_request[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($supportType == "team") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $projectDetail->pro_id[0], lang_strings("support_requests"), 'in'));
} else if ($supportType == "admin") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/support.php?", lang_strings("support_management"), 'in'));
}

if ($action == "new") {
    $blockPage->itemBreadcrumbs(lang_strings("new_requests"));
} else if ($action == "open") {
    $blockPage->itemBreadcrumbs(lang_strings("open_requests"));
} else if ($action == "complete") {
    $blockPage->itemBreadcrumbs(lang_strings("closed_requests"));
}

$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "srs";
$block1->openForm("../support/support.php?action=$action&amp;project=$project#" . $block1->form . "Anchor");

if ($action == "new") {
    $block1->heading(lang_strings("new_requests"));
} elseif ($action == "open") {
    $block1->heading(lang_strings("open_requests"));
} elseif ($action == "complete") {
    $block1->heading(lang_strings("closed_requests"));
}

$block1->openPaletteIcon();
$block1->paletteIcon(1, "add", lang_strings("add"));

if ($supportType == "admin") {
    if ($SW_Permissions['Support']['Edit'][$profilSession]) {
        $block1->paletteIcon(2, "edit", lang_strings("edit"));
    }

    if ($SW_Permissions['Support']['Admin'][$profilSession]) {
        $block1->paletteIcon(3, "remove", lang_strings("delete"));
    }
} else {
    if ($permissionDetail->prp_assign_support_request[0] == B_TRUE || $permissionDetail->prp_close_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(2, "edit", lang_strings("edit"));
    }

    if ($permissionDetail->prp_delete_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(3, "remove", lang_strings("delete"));
    }
}

$block1->paletteIcon(4, "info", lang_strings("view"));
$block1->closePaletteIcon();
$block1->sorting("support_requests", $sortingUser->sor_support_requests[0], "sr.id ASC", $sortingFields = array(0 => "sr.id", 1 => "sr.owner", 2 => "sr.status", 3 => "sr.reproducibility", 4 => "sr.severity", 5 => "sr.resolution", 6 => "sr.priority", 7 => "sr.date_open", 8 => "sr.date_close", 9 => "sr.subject"));

if ($supportType == "team") {
    if ($action == "new") {
        $tmpquery = " WHERE sr.status='" . RQ_NEW . "' AND sr.project=$project ORDER BY $block1->sortingValue";
    } elseif ($action == "open") {
        $tmpquery = " WHERE sr.status='" . RQ_OPEN . "' AND sr.project=$project ORDER BY $block1->sortingValue";
    } elseif ($action == "complete") {
        $tmpquery = " WHERE sr.status='" . RQ_COMPLETE . "' AND sr.project=$project ORDER BY $block1->sortingValue";
    }
} elseif ($supportType == "admin") {
    if ($action == "new") {
        $tmpquery = " WHERE sr.status='" . RQ_NEW . "' ORDER BY $block1->sortingValue";
    } elseif ($action == "open") {
        $tmpquery = " WHERE sr.status='" . RQ_OPEN . "' ORDER BY $block1->sortingValue";
    } elseif ($action == "complete") {
        $tmpquery = " WHERE sr.status='" . RQ_COMPLETE . "' ORDER BY $block1->sortingValue";
    }
}

$listSupportRequests = new request();
$listSupportRequests->openSupportRequests($tmpquery);
$comptListSupportRequests = count($listSupportRequests->sr_id);

if ($comptListSupportRequests != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings("id"), 1 => lang_strings("owner"), 2 => lang_strings("status"), 3 => lang_strings("reproducibility"), 4 => lang_strings("severity"), 5 => lang_strings("resolution"), 6 => lang_strings("priority"), 7 => lang_strings("date_open"), 8 => lang_strings("date_close"), 9 => lang_strings("subject")), "false");

    for ($i=0; $i<$comptListSupportRequests; $i++) {
        $block1->openRow();
        $block1->checkboxRow($listSupportRequests->sr_id[$i]);
        $block1->cellRow($blockPage->buildLink("../support/viewrequest.php?id=" . $listSupportRequests->sr_id[$i], $listSupportRequests->sr_id[$i], 'in'));
        $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listSupportRequests->sr_owner[$i], $listSupportRequests->sr_mem_name[$i], 'in'));
        $block1->cellRow($requestStatus[$listSupportRequests->sr_status[$i]]);
        $block1->cellRow($reproducibilityArray[$listSupportRequests->sr_reproducibility[$i]]);
        $block1->cellRow($severityArray[$listSupportRequests->sr_severity[$i]]);
        $block1->cellRow($resolutionArray[$listSupportRequests->sr_resolution[$i]]);
        $block1->cellRow($priority[$listSupportRequests->sr_priority[$i]]);
        $block1->cellRow($listSupportRequests->sr_date_open[$i]);
        $block1->cellRow($listSupportRequests->sr_date_close[$i]);
        $block1->cellRow($blockPage->buildLink("../support/viewrequest.php?sendto=$action&amp;id=" . $listSupportRequests->sr_id[$i], $listSupportRequests->sr_subject[$i], 'in'));
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();
$block1->paletteScript(1, "add", "../support/addsupport.php?project=$project", "true,false,false", lang_strings("add"));

if ($supportType == "admin") {
    if ($SW_Permissions['Support']['Edit'][$profilSession]) {
        $block1->paletteScript(2, "edit", "../support/editpost.php?sendto=$action", "false,true,false", lang_strings("edit"));
    }

    if ($SW_Permissions['Support']['Admin'][$profilSession]) {
        $block1->paletteScript(3, "remove", "../support/deleterequests.php?sendto=$action", "false,true,true", lang_strings("delete"));
    }
} else {
    if ($permissionDetail->prp_assign_support_request[0] == B_TRUE || $permissionDetail->prp_close_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(2, "edit", "../support/editpost.php?sendto=$action", "false,true,false", lang_strings("edit"));
    }

    if ($permissionDetail->prp_delete_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(3, "remove", "../support/deleterequests.php?sendto=$action", "false,true,true", lang_strings("delete"));
    }
}

$block1->paletteScript(4, "info", "../support/viewrequest.php?sendto=$action", "false,true,false", lang_strings("view"));
$block1->closePaletteScript($comptListSupportRequests, $listSupportRequests->sr_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
