<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewrequest.php,v 1.13 2009/11/12 02:24:28 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$sr = isset($_GET['sr'])?$_GET['sr']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';

/**
 * Permission check
 */
if ($action == 'publish') {
    $tmpquery = " WHERE sr.id=$sr";
} else {
    $tmpquery = " WHERE sr.id=$id";
}

$supportRequestDetail = new request();
$supportRequestDetail->openSupportRequests($tmpquery);
$comptSupportRequestDetail = count($supportRequestDetail->sr_id);

if ($comptSupportRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($supportType == "admin") {
    if (!$SW_Permissions['Support']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    $project = $supportRequestDetail->sr_project[0];
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    $tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_view_support_request[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }

    if ($action == 'publish') {
        if ($permissionDetail->prp_publish_file[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($addToSiteFile == 'true') {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_YES . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "addToSite";
        $id = $sr;
    } else if ($removeToSiteFile == 'true') {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $id = str_replace("**", ",", $id);
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["files"] . " SET published='" . PB_NO . "' WHERE id = '$id'";
        }

        connectSql("$tmpquery1");
        $msg = "removeToSite";
        $id = $sr;
    }
}

/**
 * Prepare Data
 */
$tmpquery = " WHERE sp.request_id=$id ORDER BY sp.date DESC";
$listSupportPosts = new request();
$listSupportPosts->openSupportPosts($tmpquery);
$comptListSupportPosts = count($listSupportPosts->sp_id);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($supportType == "team") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $supportRequestDetail->sr_project[0], $supportRequestDetail->sr_pro_name[0], 'in'));
} else if ($supportType == "admin") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/support.php?", lang_strings("support_management"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $supportRequestDetail->sr_project[0], lang_strings("support_requests"), 'in'));

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs($supportRequestDetail->sr_subject[0]);
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "sdt";
$block1->openForm("");
$block1->heading(lang_strings("support_request") . " : " . $supportRequestDetail->sr_subject[0]);
$block1->openPaletteIcon();

if ($supportType == "admin") {
    if ($SW_Permissions['Support']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", lang_strings("edit"));
    }

    if ($SW_Permissions['Support']['Admin'][$profilSession]) {
        $block1->paletteIcon(2, "remove", lang_strings("delete"));
    }
} else {
    if ($permissionDetail->prp_assign_support_request[0] == B_TRUE || $permissionDetail->prp_close_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", lang_strings("edit"));
    }

    if ($permissionDetail->prp_delete_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(2, "remove", lang_strings("delete"));
    }
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?id=" . $supportRequestDetail->sr_project[0], $supportRequestDetail->sr_pro_name[0], 'in'));
$block1->contentRow(lang_strings("support_id"), $supportRequestDetail->sr_id[0]);
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($supportRequestDetail->sr_mem_email_work[0], $supportRequestDetail->sr_mem_name[0], 'mail'));
$block1->contentRow(lang_strings("subject"), nl2br($supportRequestDetail->sr_subject[0]));
$block1->contentRow(lang_strings("status"), $requestStatus[$supportRequestDetail->sr_status[0]]);
$block1->contentRow(lang_strings("reproducibility"), $reproducibilityArray[$supportRequestDetail->sr_reproducibility[0]]);
$block1->contentRow(lang_strings("severity"), $severityArray[$supportRequestDetail->sr_severity[0]]);
$block1->contentRow(lang_strings("resolution"), $resolutionArray[$supportRequestDetail->sr_resolution[0]]);
$block1->contentRow(lang_strings("priority"), $priority[$supportRequestDetail->sr_priority[0]]);
$block1->contentRow(lang_strings("date_open"), $supportRequestDetail->sr_date_open[0]);

if ($supportRequestDetail->sr_status[0] == RQ_COMPLETE) {
    $block1->contentRow(lang_strings("date_close"), $supportRequestDetail->sr_date_close[0]);
}

$block1->contentRow(lang_strings("message"), nl2br($supportRequestDetail->sr_message[0]));

if ($supportRequestDetail->sr_status[0] != RQ_NEW) {
    $block1->contentRow(lang_strings("assigned_to"), $blockPage->buildLink($supportRequestDetail->sr_mem2_email_work[0], $supportRequestDetail->sr_mem2_name[0], 'mail'));
    $tmpquery = " WHERE tas.support_request=$id";
    $taskDetail = new request();
    $taskDetail->openTasks($tmpquery);
    $comptTaskDetail = count($taskDetail->tas_id);

    if ($comptTaskDetail != '0') {
        $block1->contentRow(lang_strings("task"), $blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0], $taskDetail->tas_name[0], 'in'));
    }
}

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession])) {
    $tmpquery = " WHERE fil.doc_type='" . DOC_SUPPORT_REQUEST . "' AND fil.doc_id=$id AND fil.vc_parent=0 ORDER BY fil.name";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    if ($comptListFiles != '0') {
        $block1->contentRow('', '');
        require_once("../includes/files_types.php");

        for ($j=0; $j<$comptListFiles; $j++) {
            $idStatus = $listFiles->fil_status[$j];
            $idPublish = $listFiles->fil_published[$j];
            $type = file_info_type($listFiles->fil_extension[$j]);

            if (fileExists($listFiles->fil_fullname[$j])) {
                $existFile = 'true';
            } else {
                $existFile = 'false';
            }

            if ($existFile == 'true') {
                $left = $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_SUPPORT_REQUEST . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$j], $type, 'icone');
            } else {
                $left = '&nbsp;';
            }

            if ($existFile == 'true') {
                $right = $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_SUPPORT_REQUEST . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$j], $listFiles->fil_name[$j], 'in');
            } else {
                $right = lang_strings('missing_file') . ' (' . $listFiles->fil_name[$j] . ')';
            }

            $right .= '&nbsp;' . $statusFile[$idStatus];
            $block1->contentRow($left, $right, 'false', '');
        }
    }
}

$block1->contentTitle(lang_strings("responses"));

if (($supportType == "admin" && $SW_Permissions['Support']['Write'][$profilSession]) || ($supportType == "team" && ($permissionDetail->prp_add_support_response[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) {
    $block1->contentRow("", $blockPage->buildLink("../support/addpost.php?id=" . $supportRequestDetail->sr_id[0], lang_strings("add_support_response"), 'in'));
}

for ($i=0; $i<$comptListSupportPosts; $i++) {
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listSupportPosts->sp_mem_email_work[$i], $listSupportPosts->sp_mem_name[$i], 'mail'));
    $block1->contentRow(lang_strings("date"), createDate($listSupportPosts->sp_date[$i], $timezoneSession));

    if (($supportType == "admin" && $SW_Permissions['Support']['Write'][$profilSession]) || ($supportType == "team" && ($permissionDetail->prp_add_support_response[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]))) {
        $block1->contentRow($blockPage->buildLink("../support/deletepost.php?sendto=$sendto&amp;id=" . $listSupportPosts->sp_id[$i], lang_strings("delete_message"), 'in'), nl2br($listSupportPosts->sp_message[$i]));
    } else {
        $block1->contentRow("", nl2br($listSupportPosts->sp_message[$i]));
    }

    if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession])) {
        $tmpquery = " WHERE fil.doc_type='" . DOC_SUPPORT_POST . "' AND fil.doc_id=" . $listSupportPosts->sp_id[$i] . " AND fil.vc_parent=0 ORDER BY fil.name";
        $listFiles = new request();
        $listFiles->openFiles($tmpquery);
        $comptListFiles = count($listFiles->fil_id);

        if ($comptListFiles != '0') {
            require_once("../includes/files_types.php");

            for ($j=0; $j<$comptListFiles; $j++) {
                $idStatus = $listFiles->fil_status[$j];
                $idPublish = $listFiles->fil_published[$j];
                $type = file_info_type($listFiles->fil_extension[$j]);

                if (fileExists($listFiles->fil_fullname[$j])) {
                    $existFile = 'true';
                } else {
                    $existFile = 'false';
                }

                if ($existFile == 'true') {
                    $left = $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_SUPPORT_POST . '&doc_id=' . $listSupportPosts->sp_id[$i] . '&id=' . $listFiles->fil_id[$j], $type, 'icone');
                } else {
                    $left = '&nbsp;';
                }

                if ($existFile == 'true') {
                    $right = $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . DOC_SUPPORT_POST . '&doc_id=' . $listSupportPosts->sp_id[$i] . '&id=' . $listFiles->fil_id[$j], $listFiles->fil_name[$j], 'in');
                } else {
                    $right = lang_strings('missing_file') . ' (' . $listFiles->fil_name[$j] . ')';
                }

                $right .= '&nbsp;' . $statusFile[$idStatus];
                $block1->contentRow($left, $right, 'false', '');
            }
        }
    }

    $block1->contentRow("", "", "true");
}

if ($status == $requestStatus[0]) {
    $status = "new";
} elseif ($status == $requestStatus[1]) {
    $status = "open";
} elseif ($status == $requestStatus[2]) {
    $status = "complete";
}

$block1->closeContent();
$block1->openPaletteScript();

if ($supportType == "admin") {
    if ($SW_Permissions['Support']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../support/editpost.php?sendto=$sendto&id=$id", "true,true,true", lang_strings("edit"));
    }

    if ($SW_Permissions['Support']['Admin'][$profilSession]) {
        $block1->paletteScript(2, "remove", "../support/deleterequests.php?sendto=$sendto&id=$id", "true,true,true", lang_strings("delete"));
    }
} else {
    if ($permissionDetail->prp_assign_support_request[0] == B_TRUE || $permissionDetail->prp_close_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../support/editpost.php?sendto=$sendto&id=$id", "true,true,true", lang_strings("edit"));
    }

    if ($permissionDetail->prp_delete_support_request[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(2, "remove", "../support/deleterequests.php?sendto=$sendto&id=$id", "true,true,true", lang_strings("delete"));
    }
}

$block1->closePaletteScript($comptListRequests, $listRequests->sr_id);
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
