<?php // $Revision: 1.30 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addtasktime.php,v 1.30 2009/10/06 14:43:23 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
$id = isset($_GET['id'])?$_GET['id']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$ld = isset($_POST['ld'])?$_POST['ld']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE tas.id=$id";
$taskDetail = new request();
$taskDetail->openTasks($tmpquery);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $taskDetail->tas_project[0];
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " AND res.task=$id AND res.resource=$idSession";
$resourceUsage = new request();
$resourceUsage->openTaskHumanResource($tmpquery);
$comptResourceUsage = count($resourceUsage->res_id);

if ($comptResourceUsage == '0') {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_log_task_hours[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'add') {
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        } else if ($hr > 24 || $hr <= 0) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_hours');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '' && periodLocked($ld)) {
        $error = lang_strings('period') . ' ' . $period_date_start . ' ~ ' . $period_date_end . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.saTForm.ld.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'add' && $error == '') {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $bf = ($serv=='0')?BF_NO:BF_YES;
    $tmpquery1 = 'INSERT INTO ' . $tableName['tasks_time'] . " (project,task,owner,date,hours,comments,billing,service,created) VALUES (" . $projectDetail->pro_id[0] . ", $id,$idSession,'$ld','$hr','$comm','$bf',$serv,'$dateheures')";
    connectSql($tmpquery1);
    $hr = null;
    $comm = null;
    // successful insert
    $msgLabel = '<b>' . lang_strings('success') . '</b> : ' . lang_strings('hours_updated');
}

/**
 * Set value in form
 */
if ($action == '' && $error == '') {
    if ($ld == '') {
        $ld = $date;
    }
}

// get actual time for task
$taskActualTime = new request();
$actualTime = $taskActualTime->getTaskTime($id);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0], lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0], $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_task_time"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = "1";

// message for success
if ($msgLabel) {
    $blockPage->messageBox($msgLabel);
}

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
    
if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages();
}

$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/addtasktime.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_task_time") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$block1->contentRow(lang_strings("tasks"), $blockPage->buildLink('../tasks/viewtask.php?id=' . $taskDetail->tas_id[0], $taskDetail->tas_name[0], 'in'));
$block1->contentRow(lang_strings("description"), nl2br($taskDetail->tas_description[0]));
$block1->contentRow(lang_strings("estimated_time"), $taskDetail->tas_estimated_time[0] . " " . lang_strings("hours"));
$block1->contentRow(lang_strings("actual_time"), $actualTime . " " . lang_strings("hours"));
$block1->contentTitle(lang_strings("add_task_time"));

if ($ld_highlight) {
    $block1->contentRow(lang_strings('date'), "
  <input type=\"text\" class=\"input_datetime_highlight\" name=\"ld\" id=\"sel1\" size=\"20\" value=\"$ld\" readonly>
  <button type=\"reset\" id=\"trigger_a\">...</button>
  <script type=\"text/javascript\">Calendar.setup({ inputField:\"sel1\", button:\"trigger_a\" });</script>");
} else {
    $block1->contentRow(lang_strings('date'), "
  <input type=\"text\" class=\"input_datetime\" name=\"ld\" id=\"sel1\" size=\"20\" value=\"$ld\" readonly>
  <button type=\"reset\" id=\"trigger_a\">...</button>
  <script type=\"text/javascript\">Calendar.setup({ inputField:\"sel1\", button:\"trigger_a\" });</script>");
}

$servSel = "<select name=\"serv\">";

if ($taskDetail->tas_service[0] != '0') {
    $tmpquery = " WHERE serv.id=" . $taskDetail->tas_service[0];
    $serviceDetail = new request();
    $serviceDetail->openServices($tmpquery);

    if ($taskDetail->tas_service[0] == $serv) {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
} else if ($memberDetail->tea_service[0] != '0') {
    $tmpquery = " WHERE serv.id=" . $memberDetail->tea_service[0];
    $serviceDetail = new request();
    $serviceDetail->openServices($tmpquery);

    if ($memberDetail->tea_service[0] == $serv) {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
}

if ($serv == '0') {
    $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
} else {
    $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);

// hours
if ($hr_highlight) {
    $block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr' class='input_hours_highlight' name='hr' maxlength='6' type='text'>");
} else {
    $block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr' class='input_hours' name='hr' maxlength='6' type='text'>");
}

// comments
$block1->contentRow(lang_strings("comments"), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");
$block1->contentRow("", "<input type='SUBMIT' value='" . $strings["save"] . "'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

// This will display time log detail for the current task
$block2 = new block();
$block2->form = "ahT";
$block2->openForm("../tasks/addtasktime.php?id=$id#" . $block2->form . "Anchor");
$block2->heading(lang_strings("task_time") . ' : ' . lang_strings("details"));
$block2->openPaletteIcon();
$block2->paletteIcon(0, "remove", lang_strings("delete"));
$block2->paletteIcon(1, "edit", lang_strings("edit"));
$block2->closePaletteIcon();
$block2->borne = $blockPage->returnBorne("1");
$block2->rowsLimit = "20";
$block2->sorting('tasks_time', $sortingUser->sor_tasks_time[0], 'tim.date ASC', $sortingFields = array(0 => 'mem.name', 1 => 'tim.date', 2 => 'tim.hours', 3 => 'tim.created', 4 => 'tim.modified', 5 => 'tim.comments', 6 => 'tim.billing'));
$tmpquery = " WHERE tim.task=$id ORDER BY $block2->sortingValue";
$block2->recordsTotal = compt($initrequest["tasks_time"] . " " . $tmpquery);
$listTaskTimes = new request();
$listTaskTimes->openTaskTime($tmpquery, $block2->borne, $block2->rowsLimit);
$comptListTaskTimes = count($listTaskTimes->tim_id);

if ($comptListTaskTimes != "0") {
    $block2->openResults();
    $block2->labels($labels = array(0 => lang_strings("owner"), 1 => lang_strings("date"), 2 => ucfirst(lang_strings("hours")), 3 => lang_strings("created"), 4 => lang_strings("modified"), 5 => lang_strings('comment'), 6 => lang_strings('billing')), "false"); 

    // display logged hours for project
    for ($i = 0;$i < $comptListTaskTimes;$i++) {
        $block2->openRow();
        $block2->checkboxRow($listTaskTimes->tim_id[$i], 'true');
        $block2->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $listTaskTimes->tim_owner[$i], $listTaskTimes->tim_mem_name[$i], 'in'));
        $block2->cellRow($listTaskTimes->tim_date[$i]);
        $block2->cellRow($listTaskTimes->tim_hours[$i]);
        $block2->cellRow($listTaskTimes->tim_created[$i]);
        $block2->cellRow($listTaskTimes->tim_modified[$i]); 
        // truncate large comments to keep the display clean
        $comments = nl2br($listTaskTimes->tim_comments[$i]);
        $lenComm = 40;

        if (strLen($comments) > $lenComm) {
            $comments = substr($comments, 0, $lenComm) . ' ...';
        }

        $block2->cellRow($comments);
        $block2->cellRow($billingFlag[$listTaskTimes->tim_billing[$i]]); 
        $block2->closeRow();
    }

    $block2->closeResults();
    $block2->bornesFooter("1", $blockPage->bornesNumber, "", "id=$id");
} else {
    $block2->noresults();
}

$block2->closeFormResults();
$block2->openPaletteScript();
$block2->paletteScript(0, "remove", "../tasks/deletetasktime.php?task=$id", "false,true,true", lang_strings("delete"));
$block2->paletteScript(1, "edit", "../tasks/edittasktime.php?task=$id", "false,true,false", lang_strings("edit"));
$block2->closePaletteScript($comptListTaskTimes, $listTaskTimes->tim_id);

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
