<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletepredecessors.php,v 1.9 2009/09/01 15:01:16 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$project = isset($_GET['project'])?$_GET['project']:'0';
$task = isset($_GET['task'])?$_GET['task']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = str_replace("**", ",", $id);

/**
 * Permission check
 */
$tmpquery = " WHERE tas.id=$task";
$taskDetail = new request();
$taskDetail->openTasks($tmpquery);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_edit_task_relationships[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    $criticalSection = enter_critical_section();

    if ($criticalSection == -1) {
        header("Location: ../tasks/viewtask.php?id=$task&msg=$msg");
        exit;
    }

    $tmpquery = "DELETE FROM " . $tableName["tasks_predecessor"] . " WHERE id IN ($ids)";
    connectSql($tmpquery);
    leave_critical_section($criticalSection);
    header("Location: ../tasks/viewtask.php?id=$task&msg=deletePredecessor");
    exit;
}

/**
 * Prepare data
 */
$tmpquery = " WHERE pre.id IN ($ids)";
$listPredecessors = new request();
$listPredecessors->openTaskPredecessor($tmpquery);
$comptListPredecessors = count($listPredecessors->pre_id);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $taskDetail->tas_project[0], $taskDetail->tas_pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $taskDetail->tas_project[0], lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0], $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_predecessors"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "dtP";
$block1->openForm("../tasks/deletepredecessors.php?project=$project&task=$task&id=$id#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_predecessors"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

if ($comptListPredecessors == '0') {
    $block1->noresults();
    $block1->contentRow("", "<input type=\"BUTTON\" value=\"" . $strings["goback"] . "\" onClick=\"history.back();\">");
} else {
    for ($i=0; $i<$comptListPredecessors; $i++) {
        $block1->contentRow("", $listPredecessors->pre_tas2_name[$i] . "&nbsp;&nbsp;<b><i>" . $taskPredecessorTypes[$listPredecessors->pre_type[$i]] . "</i></b>&nbsp;&nbsp;" . $listPredecessors->pre_tas_name[$i]);
    }

    $block1->contentRow("", "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
}

$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
