<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edittasktime.php,v 1.18 2009/09/04 08:58:45 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
$id = isset($_GET['id'])?$_GET['id']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$ld = isset($_POST['ld'])?$_POST['ld']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE tim.id=$id";
$taskTimeDetail = new request();
$taskTimeDetail->openTaskTime($tmpquery);
$comptTaskTimeDetail = count($taskTimeDetail->tim_id);

if ($comptTaskTimeDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($taskTimeDetail->tim_owner[0] != $idSession) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (periodLocked($taskTimeDetail->tim_date[0])) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $taskTimeDetail->tim_project[0];
$task = $taskTimeDetail->tim_task[0];
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'edit') {
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        } else if ($hr > 24 || $hr <= 0) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_hours');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '' && periodLocked($ld)) {
        $error = lang_strings('period') . ' ' . $period_date_start . ' ~ ' . $period_date_end . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.saTForm.ld.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'edit' && $error == '') {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $bf = ($serv=='0')?BF_NO:BF_YES;
    $tmpquery1  = "UPDATE " . $tableName['tasks_time'] . " SET date='$ld',hours='$hr',comments='$comm',billing='$bf',service=$serv,modified='$dateheures' WHERE id=$id";
    connectSql($tmpquery1);
    header("Location: ../tasks/addtasktime.php?id=$task&msg=update");
}

/**
 * Set value in form
 */
if ($action == '' && $error == '') {
    $ld = $taskTimeDetail->tim_date[0];
    $hr = $taskTimeDetail->tim_hours[0];
    $comm = $taskTimeDetail->tim_comments[0];
    $serv = $taskTimeDetail->tim_service[0];
}

/**
 * Prepare data
 */
$taskActualTime = new request();
$actualTime = $taskActualTime->getTaskTime($task);
$tmpquery = " WHERE tas.id=$task";
$taskDetail = new request();
$taskDetail->openTasks($tmpquery);
$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0], lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0], $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_task_time"));
$blockPage->closeBreadcrumbs();

if ($error != '') {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$blockPage->bornesNumber = "1";
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/edittasktime.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"edit\">";
$block1->heading(lang_strings("edit_task_time") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings("tasks"), $taskDetail->tas_name[0]);
$block1->contentRow(lang_strings("description"), nl2br($taskDetail->tas_description[0]));
$block1->contentRow(lang_strings("estimated_time"), $taskDetail->tas_estimated_time[0] . " " . lang_strings("hours"));
$block1->contentRow(lang_strings("actual_time"), $actualTime . " " . lang_strings("hours"));
$block1->contentTitle(lang_strings("edit_task_time"));

if ($ld_highlight) {
    $block1->contentRow(lang_strings('date'), "
  <input type=\"text\" class=\"input_datetime_highlight\" name=\"ld\" id=\"sel1\" size=\"20\" value=\"$ld\" readonly>
  <button type=\"reset\" id=\"trigger_a\">...</button>
  <script type=\"text/javascript\">Calendar.setup({ inputField:\"sel1\", button:\"trigger_a\" });</script>");
} else {
    $block1->contentRow(lang_strings('date'), "
  <input type=\"text\" class=\"input_datetime\" name=\"ld\" id=\"sel1\" size=\"20\" value=\"$ld\" readonly>
  <button type=\"reset\" id=\"trigger_a\">...</button>
  <script type=\"text/javascript\">Calendar.setup({ inputField:\"sel1\", button:\"trigger_a\" });</script>");
}

$servSel = "<select name=\"serv\">";

if ($taskDetail->tas_service[0] != '0') {
    $tmpquery = " WHERE serv.id=" . $taskDetail->tas_service[0];
    $serviceDetail = new request();
    $serviceDetail->openServices($tmpquery);

    if ($taskDetail->tas_service[0] == $serv) {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
} else if ($memberDetail->tea_service[0] != '0') {
    $tmpquery = " WHERE serv.id=" . $memberDetail->tea_service[0];
    $serviceDetail = new request();
    $serviceDetail->openServices($tmpquery);

    if ($memberDetail->tea_service[0] == $serv) {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
}

if ($serv == '0') {
    $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
} else {
    $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);

// hours
if ($hr_highlight) {
    $block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr' class='input_hours_highlight' name='hr' maxlength='6' type='text'>");
} else {
    $block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr' class='input_hours' name='hr' maxlength='6' type='text'>");
}

// comments
$block1->contentRow(lang_strings("comments"), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");
$block1->contentRow("", "<input type='SUBMIT' value='" . $strings["update"] . "'><input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
