<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listtasks.php,v 1.23 2009/09/01 15:01:16 luiswang Exp $
 * 
 * Copyright (c) 2009 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$taskgroupList = array();
$project = isset($_GET['project'])?$_GET['project']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$base = isset($_GET['base'])?$_GET['base']:'1';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';

if (isset($_GET['action'])) {
    $action = $_GET['action'];
    $addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
    $removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
    $id = isset($_GET['id'])?$_GET['id']:'';
}

/**
 * Functions
 */
function add_taskgroup_to_changelist($parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $tmpquery = " WHERE tas.id='$parent'";
    $parentDetail = new request();
    $parentDetail->openTasks($tmpquery);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($parent)
{
    global $tableName, $dateheures;
    $tmpquery = " WHERE tas.parent_task='$parent'";
    $subtaskList = new request();
    $subtaskList->openTasks($tmpquery);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == ST_NOT_STARTED || $newStatus == ST_NOT_STARTED) {
                $newStatus = ST_NOT_STARTED;
            } else if ($status == ST_OPEN || $newStatus == ST_OPEN) {
                $newStatus = ST_OPEN;
            } else if ($status == ST_SUSPENDED || $newStatus == ST_SUSPENDED) {
                $newStatus = ST_SUSPENDED;
            } else if ($status == ST_CLIENT_COMPLETED || $newStatus == ST_CLIENT_COMPLETED) {
                $newStatus = ST_CLIENT_COMPLETED;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == ST_COMPLETED) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }

            if ($published == PB_YES) {
                $newPublished = PB_YES;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == ST_COMPLETED) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpquery = "UPDATE " . $tableName['tasks'] . " SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', modified='$dateheures', task_group='" . TG_YES . "', subtask='$newSubtask' WHERE id='$parent'";
    connectSql("$tmpquery");
}

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == '0') {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($action == 'publish') {
    if ($addToSite == 'true' || $removeToSite == 'true') {
        if ($permissionDetail->prp_publish_task[0] != B_TRUE) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
            exit;
        }
    }
} else {
    if ($permissionDetail->prp_view_task[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'publish') {
    if ($addToSite == "true" || $removeToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/listtasks.php?project=$project&msg=$msg");
            exit;
        }

        $id = str_replace("**", ",", $id);

        if ($addToSite == "true") {
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_YES . "' WHERE id IN ($id)";
            $msg = "addToSite";
        } else {
            $tmpquery1 = "UPDATE " . $tableName["tasks"] . " SET published='" . PB_NO . "' WHERE id IN ($id)";
            $msg = "removeToSite";
        }

        connectSql("$tmpquery1");
        $tmpquery = " WHERE tas.id IN ($id)";
        $listTasks = new request();
        $listTasks->openTasks($tmpquery);
        $comptListTasks = count($listTasks->tas_id);

        for ($i=0; $i<$comptListTasks; $i++) {
            add_taskgroup_to_changelist($listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
        }

        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);
            reset($taskgroupList);

            while (list($parentTask, $level) = each($taskgroupList)) {
                change_parent_task($parentTask);
            }
        }

        leave_critical_section($criticalSection);
    }
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], in));
$blockPage->itemBreadcrumbs(lang_strings("tasks"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$blockPage->bornesNumber = "1";
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/listtasks.php?project=$project#" . $block1->form . "Anchor");
$block1->heading(lang_strings("tasks"));
$block1->openPaletteIcon();

if ($permissionDetail->prp_create_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, "add", lang_strings("add"));
}

if ($permissionDetail->prp_delete_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
}

if ($permissionDetail->prp_copy_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(2, "copy", lang_strings("copy"));
}

if ($sitePublish == "true") {
    if ($permissionDetail->prp_publish_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(4, "add_projectsite", lang_strings("add_project_site"));
        $block1->paletteIcon(5, "remove_projectsite", lang_strings("remove_project_site"));
    } 
} 

$block1->paletteIcon(6, "info", lang_strings("view"));

if ($permissionDetail->prp_modify_task_status[0] == B_TRUE || $permissionDetail->prp_modify_task_properties[0] || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(7, "edit", lang_strings("edit"));
}

if ($permissionDetail->prp_log_task_hours[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(8, "timelog", lang_strings("loghours"));
}

if ($permissionDetail->prp_edit_task_relationships[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(9, "dependency", lang_strings("add_predecessor"));
    $block1->paletteIcon(10, "unlink", lang_strings("delete_dependencies"));
    $block1->paletteIcon(11, "indentation", lang_strings("indentation"));
    $block1->paletteIcon(12, "unindentation", lang_strings("unindentation"));
    $block1->paletteIcon(13, "add_taskgroup", lang_strings("add_taskgroup"));
} 

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne("1");
$block1->rowsLimit = "20";
$block1->sorting("tasks", $sortingUser->sor_tasks[0], "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
$tmpqueryC = " WHERE tas.project=$project";
$tmpqueryS = " ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$block1->recordsTotal = count($listTasks->tas_id);
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS, $block1->borne, $block1->rowsLimit);
$comptListTasks = count($listTasks->tas_id);

if ($comptListTasks != "0") {
    $block1->openResults();
    $block1->labels($labels = array(0 => lang_strings('id'), 1 => lang_strings('task'), 2 => lang_strings('priority'), 3 => lang_strings('status'), 4 => lang_strings('completion'), 5 => lang_strings('due_date'), 6 => lang_strings('assigned_to'), 7 => lang_strings('published')), 'true');

    for ($i = 0;$i < $comptListTasks;$i++) {
        if ($listTasks->tas_due_date[$i] == "") {
            $listTasks->tas_due_date[$i] = lang_strings("none");
        }

        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];
        $idPublish = $listTasks->tas_published[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
        $block1->openRow();
        $block1->checkboxRow($listTasks->tas_id[$i]);
        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_id[$i], in));
        $leadingSpace = '';

        for ($j = 0;$j < $listTasks->tas_level[$i];$j++) {
            $leadingSpace .= '&nbsp;&nbsp;';
        }

        if ($idStatus == ST_COMPLETED) {
            $block1->cellRow($leadingSpace . $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], instrike));
        } else {
            $block1->cellRow($leadingSpace. $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], in));
        }

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
        } else {
            $block1->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
            $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/' . $idStatus . '.gif" alt="' . $status[$idStatus] . '">&nbsp;' . $status[$idStatus], '', true);
            $block1->cellRow($complValue);
        }

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow($listTasks->tas_due_date[$i]);
        } else if ($listTasks->tas_due_date[$i] <= $date && $listTasks->tas_completion[$i] != "10") {
            $block1->cellRow("<b>" . $listTasks->tas_due_date[$i] . "</b>");
        } else {
            $block1->cellRow($listTasks->tas_due_date[$i]);
        }

        if ($listTasks->tas_start_date[$i] != "--" && $listTasks->tas_due_date[$i] != "--") {
            $gantt = "true";
        }

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow("");
        } else if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task=" . $listTasks->tas_id[$i];
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assignedToStrings = "";

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink("../users/viewuser.php?id=" . $resourceUsage->res_resource[$j], $resourceUsage->res_mem_name[$j], 'in');
            }

            $block1->cellRow($assignedToStrings);
        }

        if ($sitePublish == "true") {
            $block1->cellRow($statusPublish[$idPublish]);
        }

        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "project=$project");

    if ($activeJpgraph == "true" && $gantt == "true") {
        if ($gantt_sd != '') {
            echo "<a href='listtasks.php?project=$project&amp;base=$base'>&lt;&lt;</a>&nbsp;";
            list($an1, $mois1, $jour1) = preg_split('/-/', $gantt_sd, 3);

            if ($base == '1') {
                $gantt_sd_prev = date("Y-m-d", mktime(12,0,0,intval($mois1)-5,intval($jour1),intval($an1)));
            } else {
                $gantt_sd_prev = date("Y-m-d", mktime(12,0,0,intval($mois1)-1,intval($jour1),intval($an1)));
            }
        }

        $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tableName['tasks'] . " WHERE project=$project AND start_date!='--' AND due_date!='--'";

        if ($gantt_sd != '') {
            if ($base == '1') {
                $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois1)+5,intval($jour1),intval($an1)));
            } else {
                $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois1)+1,intval($jour1),intval($an1)));
            }

            $tmpquery .= " AND due_date>='$gantt_sd_next'";
        }

        $boundaries = new request();
        $boundaries->connectClass();
        $boundaries->query($tmpquery);

        if ($boundaries->fetch()) {
            $start_date_b = ($row[0]);
            $due_date_b = ($row[1]);
            list($an2, $mois2, $jour2) = preg_split('/-/', $start_date_b, 3);

            if ($gantt_sd == '') {
                if ($base == '1') {
                    $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois2)+5,intval($jour2),intval($an2)));
                } else {
                    $gantt_sd_next = date("Y-m-d", mktime(12,0,0,intval($mois2)+1,intval($jour2),intval($an2)));
                }

                $gantt_sd = $start_date_b;
            } else {
                if ($gantt_sd_prev < $start_date_b) {
                    echo "<a href='listtasks.php?project=$project&amp;base=$base'>&lt;</a>&nbsp;";
                } else {
                    echo "<a href='listtasks.php?project=$project&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                }
            }

            if ($gantt_sd_next <= $due_date_b) {
                $showNext = 'true';
                list($an2, $mois2, $jour2) = preg_split('/-/', $due_date_b, 3);

                if ($base == '1') {
                    $gantt_sd_last = date("Y-m-d", mktime(12,0,0,intval($mois2)-5,intval($jour2)+1,intval($an2)));
                } else {
                    $gantt_sd_last = date("Y-m-d", mktime(12,0,0,intval($mois2)-1,intval($jour2)+1,intval($an2)));
                }
            }
        }

        // show the expanded or compact Gantt Chart
        if ($base == '1') {
            echo "<a href='listtasks.php?project=$project&amp;base=0'>expand</a>";
        } else {
            echo "<a href='listtasks.php?project=$project&amp;base=1'>compact</a>";
        }

        if ($showNext == 'true') {
            echo "&nbsp;<a href='listtasks.php?project=$project&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
            echo "&nbsp;<a href='listtasks.php?project=$project&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
        }

        if ($gantt_sd != '') {
            echo "<br><img src=\"graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
        }
    }
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($permissionDetail->prp_create_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(0, "add", "../tasks/edittask.php?project=$project", "true,false,false", lang_strings("add"));
}

if ($permissionDetail->prp_delete_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "remove", "../tasks/deletetasks.php?project=$project", "false,true,true", lang_strings("delete"));
}

if ($permissionDetail->prp_copy_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(2, "copy", "../tasks/edittask.php?project=$project&cpy=true", "false,true,false", lang_strings("copy"));
}

if ($sitePublish == "true") {
    if ($permissionDetail->prp_publish_task[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(4, "add_projectsite", "../tasks/listtasks.php?addToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("add_project_site"));
        $block1->paletteScript(5, "remove_projectsite", "../tasks/listtasks.php?removeToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("remove_project_site"));
    }
}

$block1->paletteScript(6, "info", "../tasks/viewtask.php?", "false,true,false", lang_strings("view"));

if ($permissionDetail->prp_modify_task_status[0] == B_TRUE || $permissionDetail->prp_modify_task_properties[0] || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(7, "edit", "../tasks/edittask.php?project=$project", "false,true,true", lang_strings("edit"));
}

if ($permissionDetail->prp_log_task_hours[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(8, "timelog", "../tasks/addtasktime.php?", "false,true,false", lang_strings("loghours"));
}

if ($permissionDetail->prp_edit_task_relationships[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(9, "dependency", "../tasks/addpredecessor.php?project=$project", "false,true,false", lang_strings("add_predecessor"));
    $block1->paletteScript(10, "unlink", "../tasks/deletedependencies.php?project=$project", "false,true,false", lang_strings("delete_dependencies"));
    $block1->paletteScript(11, "indentation", "../tasks/indentation.php?project=$project", "false,true,false", lang_strings("indentation"));
    $block1->paletteScript(12, "unindentation", "../tasks/unindentation.php?project=$project", "false,true,false", lang_strings("unindentation"));
    $block1->paletteScript(13, "add_taskgroup", "../tasks/edittask.php?action=taskgroup&project=$project", "false,false,true", lang_strings("add_taskgroup"));
}

$block1->closePaletteScript($comptListTasks, $listTasks->tas_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
