<?php // $Revision: 1.11.2.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updatetasks.php,v 1.11.2.3 2010/04/22 09:26:55 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$taskgroupList = array();
$id = isset($_GET['id'])?$_GET['id']:'0';
$project = isset($_GET['project'])?$_GET['project']:'';
$report = isset($_GET['report'])?$_GET['report']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$st = isset($_POST['st'])?$_POST['st']:'';
$compl = isset($_POST['compl'])?$_POST['compl']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$ids = str_replace("**", ",", $id);

/**
 * Functions
 */
function add_taskgroup_to_changelist($parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList))
        return;

    $taskgroupList[$parent] = $level;
    $tmpquery = "WHERE tas.id='$parent'";
    $parentDetail = new request();
    $parentDetail->openTasks($tmpquery);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($parent)
{
    global $tableName, $dateheures;
    $tmpquery = "WHERE tas.parent_task='$parent'";
    $subtaskList = new request();
    $subtaskList->openTasks($tmpquery);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == ST_OPEN || $newStatus == ST_OPEN) {
                $newStatus = ST_OPEN;
            } else if ($status == ST_SUSPENDED || $newStatus == ST_SUSPENDED) {
                $newStatus = ST_SUSPENDED;
            } else if ($status == ST_NOT_STARTED || $newStatus == ST_NOT_STARTED) {
                $newStatus = ST_NOT_STARTED;
            } else if ($status == ST_CLIENT_COMPLETED || $newStatus == ST_CLIENT_COMPLETED) {
                $newStatus = ST_CLIENT_COMPLETED;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == ST_COMPLETED) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }

            if ($published == PB_YES) {
                $newPublished = PB_YES;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == ST_COMPLETED) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = floor($newCompletion / $newSubtask);
    $tmpquery = "UPDATE " . $tableName['tasks'] . " SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', modified='$dateheures', task_group='" . TG_YES . "', subtask='$newSubtask' WHERE id='$parent'";
    connectSql("$tmpquery");
}

/**
 * Permission check
 */
if ($report != "") {
    $tmpquery = " WHERE rep.id=$report";
    $reportDetail = new request();
    $reportDetail->openReports($tmpquery);
    $compt1 = count($reportDetail->rep_id);
} else {
    $tmpquery = " WHERE pro.id=$project";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $compt1 = count($projectDetail->pro_id);
}

if ($compt1 == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = "SELECT DISTINCT project FROM " . $tableName['tasks'] . " WHERE id IN ($ids)";
$listProjects = new request();
$listProjects->connectClass();
$listProjects->query($tmpquery);

while ($listProjects->fetch()) {
    $tmpquery = " WHERE pro.id=" . ($row[0]);
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tmpquery = " WHERE tea.project=" . $projectDetail->pro_id[0] . " AND tea.member=$idSession";
    $memberDetail = new request();
    $memberDetail->openTeams($tmpquery);
    $comptMemberDetail = count($memberDetail->tea_id);

    if ($comptMemberDetail == 0) {
        $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . PJ_GUEST . "'";
    } else {
        $tmpquery = " WHERE prp.project=" . $projectDetail->pro_id[0] . " AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($tmpquery);
    $comptPermissionDetail = count($permissionDetail->prp_id);

    if ($permissionDetail->prp_modify_task_status[0] != B_TRUE && $permissionDetail->prp_modify_task_properties[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

$listProjects->close();
$tmpquery = "SELECT tas.id FROM " . $tableName['tasks'] . " tas WHERE tas.id IN ($ids) AND tas.milestone='" . MS_YES . "'";

if (compt($tmpquery) != '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE tas.id IN ($ids)";
$listTasks = new request();
$listTasks->openTasks($tmpquery);
$comptListTasks = count($listTasks->tas_id);

/**
 * Actions
 */
if ($action == 'update') {
    $query = "";
    $msg = "";

    if ($st != lang_strings("no_change")) {
        if ($query != "") {
            $query .= ",status='$st'";
        } else {
            $query .= "status='$st'";
        }
    }

    if ($compl != "") {
        if ($query != "") {
            $query .= ",completion='$compl'";
        } else {
            $query .= "completion='$compl'";
        }
    }

    if ($pr != lang_strings("no_change")) {
        if ($query != "") {
            $query .= ",priority='$pr'";
        } else {
            $query .= "priority='$pr'";
        }
    }

    if ($query != "") {
        for ($utc1 = 0;$utc1 < $comptListTasks;$utc1++) {
            if ($listTasks->tas_parent_task[$utc1] != "0") {
                add_taskgroup_to_changelist($listTasks->tas_parent_task[$utc1], $listTasks->tas_level[$utc1]);
            }

            $tmpquery = "UPDATE " . $tableName["tasks"] . " SET $query,modified='$dateheures' WHERE id=" . $listTasks->tas_id[$utc1];
            connectSql("$tmpquery");

            if ($notifications == "true") {
                $id = $listTasks->tas_id[$utc1];
                $project = $listTasks->tas_project[$utc1];
                $tmpquery = " AND res.task=$id";
                $resourceNoti = new request();
                $resourceNoti->openTaskHumanResource($tmpquery);
                $comptResourceNoti = count($resourceNoti->res_id);

                if ($comptResourceNoti > 0) {
                    $at = "";

                    for ($utc2 = 0;$utc2 < $comptResourceNoti;$utc2++) {
                        if ($at != "") {
                            $at .= ",";
                        }

                        $at .= "'" . $resourceNoti->res_resource[$utc2] . "'";
                    }

                    if ($st != lang_strings("no_change") && $listTasks->tas_status[$utc1] != $st) {
                        require_once("../tasks/noti_statustaskchange.php");
                    }

                    if ($pr != lang_strings("no_change") && $listTasks->tas_priority[$utc1] != $pr) {
                        require_once("../tasks/noti_prioritytaskchange.php");
                    }
                }
            }
        }

        // update parent tasks
        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);

            foreach ($taskgroupList as $parentTask => $lvl) {
                change_parent_task($parentTask);
            }
        }

        $msg = "update";
    }

    if ($report != "") {
        header("Location: ../reports/resultsreport.php?id=$report&msg=$msg");
    } else {
        header("Location: ../tasks/listtasks.php?project=$project&msg=$msg");
    }

    exit;
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($report != "") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../reports/createreport.php?", lang_strings("reports"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../reports/resultsreport.php?id=" . $reportDetail->rep_id[0], $reportDetail->rep_name[0], 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project", lang_strings("tasks"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("edit_multiple_tasks"));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "batT";
$block1->openForm("../tasks/updatetasks.php?id=$id&amp;project=$project&amp;report=$report#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
$block1->heading(lang_strings("edit_multiple_tasks"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow("", "$comptListTasks " . lang_strings("tasks_selected"));
$stSel = "<select name=\"st\" onchange=\"changeSt(this)\">
<option value=\"" . lang_strings("no_change") . "\" selected>" . lang_strings("no_change") . "</option>";
$comptSta = count($status);

for ($i = 0;$i < $comptSta;$i++) {
    $stSel .= "<option value=\"$i\">$status[$i]</option>";
}

$stSel .= "</select>";
$block1->contentRow(lang_strings("status"), $stSel);
$compSel = "<input name=\"compl\" type=\"hidden\" value=\"\">
<select name=\"completion\" onchange=\"changeCompletion(this)\">
<option value=\"" . lang_strings("no_change") . "\" selected>" . lang_strings("no_change") . "</option>";

for ($i = 0;$i < 11;$i++) {
    $complValue = ($i > 0) ? $i . "0 %": $i . " %";
    $compSel .= "<option value=\"" . $i . "\">" . $complValue . "</option>";
}

$compSel .= "</select>";
$block1->contentRow(lang_strings("completion"), $compSel);
$prSel = "<select name=\"pr\">
<option value=\"" . lang_strings("no_change") . "\" selected>" . lang_strings("no_change") . "</option>";
$comptPri = count($priority);

for ($i = 0;$i < $comptPri;$i++) {
    $prSel .= "<option value=\"$i\">$priority[$i]</option>";
}

$prSel .= "</select>";
$block1->contentRow(lang_strings("priority"), $prSel);
$block1->contentRow("", "<input type=\"SUBMIT\" value=\"" . $strings["update"] . "\">");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
<script type="text/javascript">
function changeSt(theObj, firstRun){
	if (theObj.selectedIndex==4) {
		if (firstRun!=true) document.forms[0].completion.selectedIndex=1;
		document.forms[0].compl.value=0;
		document.forms[0].completion.disabled=false;
	} else {
		if (theObj.selectedIndex==0) {
			document.forms[0].completion.selectedIndex=0;
			document.forms[0].compl.value='';
		} else if (theObj.selectedIndex==1 || theObj.selectedIndex==2) {
			document.forms[0].completion.selectedIndex=11;
			document.forms[0].compl.value=10;
		} else {
			document.forms[0].completion.selectedIndex=1;
			document.forms[0].compl.value=0;
		}
		document.forms[0].completion.disabled=true;
	}
}

function changeCompletion(){
	document.forms[0].compl.value = document.forms[0].completion.selectedIndex-1;
}

changeSt(document.forms[0].st, true);
</script>
