<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewuser.php,v 1.7 2009/10/26 15:34:43 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$project = isset($_GET['project'])?$_GET['project']:'0';
$id = isset($_GET['id'])?$_GET['id']:'0';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$tmpquery = " WHERE pro.id=$project";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject');
    exit;
}

if ($projectDetail->pro_status[0] == PJS_PROPOSED) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied');
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$idSession";
$memberDetail = new request();
$memberDetail->openTeams($tmpquery);
$comptMemberDetail = count($memberDetail->tea_id);

if ($comptMemberDetail == 0) {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . PJ_GUEST . "'";
} else {
    $tmpquery = " WHERE prp.project=$project AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($tmpquery);
$comptPermissionDetail = count($permissionDetail->prp_id);

if ($permissionDetail->prp_view_team[0] != B_TRUE && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header("Location: ../project/viewproject.php?id=$project&msg=permissiondenied");
    exit;
}

$tmpquery = " WHERE tea.project=$project AND tea.member=$id";
$teamDetail = new request();
$teamDetail->openTeams($tmpquery);
$comptTeamDetail = count($teamDetail->tea_id);

if ($comptTeamDetail == '0') {
    header("Location: ../project/viewproject.php?id=$project&msg=permissiondenied");
    exit;
}

$tmpquery = " WHERE mem.id=" . $teamDetail->tea_member[0];
$userDetail = new request();
$userDetail->openMembers($tmpquery);

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../teams/listusers.php?project=" . $projectDetail->pro_id[0], lang_strings("team_members"), 'in'));
$blockPage->itemBreadcrumbs($teamDetail->tea_mem_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "teV";
$block1->openForm("../teams/viewuser.php?project=$project&amp;id=$id#" . $block1->form . "Anchor");
$block1->heading(lang_strings("team"));
$block1->openPaletteIcon();

if ($permissionDetail->prp_view_team[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, "remove", lang_strings("delete"));
}

if ($sitePublish == 'true') {
    if ($permissionDetail->prp_publish_team_member[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($teamDetail->tea_published[0] == PB_YES) {
            $block1->paletteIcon(2, 'remove_projectsite', lang_strings('remove_project_site'));
        } else {
            $block1->paletteIcon(1, 'add_projectsite', lang_strings('add_project_site'));
        }
    }
}

if ($permissionDetail->prp_send_message[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(3,'email',lang_strings('email'));
}

if ($permissionDetail->prp_modify_team_member_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(4, 'edit', lang_strings('edit'));
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("team_member_details"));
$block1->contentRow(lang_strings("full_name"), $blockPage->buildLink('../users/viewuser.php?id=' . $teamDetail->tea_mem_id[$i], $teamDetail->tea_mem_name[$i], 'in'));
$block1->contentRow(lang_strings("role"), $projectRoles[$teamDetail->tea_profil[$i]]);
$block1->contentRow(lang_strings("user_name"), $blockPage->buildLink($teamDetail->tea_mem_email_work[$i], $teamDetail->tea_mem_login[$i], mail));
$block1->contentRow(lang_strings("work_phone"), $teamDetail->tea_mem_phone_work[$i]);
$block1->contentRow(lang_strings("home_phone"), $userDetail->mem_phone_home[0]);
$block1->contentRow(lang_strings("mobile_phone"), $userDetail->mem_mobile[0]);
$block1->contentRow(lang_strings("fax"), $userDetail->mem_fax[0]);

$tmpquery = " WHERE id=" . $teamDetail->tea_service[0];
$serviceDetail = new request();
$serviceDetail->openServices($tmpquery);
$comptServiceDetail = count($serviceDetail->serv_id);

if ($comptServiceDetail != '0') {
    $block1->contentRow(lang_strings("default_service"), $serviceDetail->serv_name_print[0]);
} else {
    $block1->contentRow(lang_strings("default_service"), lang_strings('none'));
}

$block1->contentRow(lang_strings("comments"), nl2br($teamDetail->tea_comments[0]));
$block1->contentTitle(lang_strings("information"));
$tmpquery = "SELECT res.id FROM " . $tableName["tasks_resource"] . " res LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id=res.task LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=tas.project WHERE res.resource=" . $userDetail->mem_id[0] . " AND res.type='members' AND tas.project=$project AND tas.status IN ('" . ST_CLIENT_COMPLETED . "','" . ST_NOT_STARTED . "','" . ST_OPEN . "') AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
compt($tmpquery);
$valueTasks = $countEnregTotal;
$tmpquery = "SELECT note.id FROM " . $tableName["notes"] . " note LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=note.project WHERE note.owner=" . $userDetail->mem_id[0] . " AND note.project=$project AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
compt($tmpquery);
$valueNotes = $countEnregTotal;
$block1->contentRow(lang_strings("tasks"), $valueTasks);
$block1->contentRow(lang_strings("notes"), $valueNotes);

if ($teamDetail->tea_mem_profil[0] == PF_CLIENT_USER) {
    $z = "(" . lang_strings("client_on_project_site") . ")";
} else {
    $z = "";
}

if ($userDetail->mem_log_connected[0] > $dateunix-5 * 60) {
    $connected_result = lang_strings("yes") . " " . $z;
} else {
    $connected_result = lang_strings("no");
}

$block1->contentRow(lang_strings("connected"), $connected_result);
$block1->contentRow(lang_strings("status"), ($userDetail->mem_deleted[0] == B_TRUE)?lang_strings("deleted"):(($userDetail->mem_active[0] == B_TRUE)?lang_strings("status_active"):lang_strings("status_inactive")));
$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($permissionDetail->prp_delete_team_member[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../teams/deleteusers.php?project=' . $projectDetail->pro_id[0] . '&id=' . $id, 'true,true,false', lang_strings('delete'));
}

if ($sitePublish == 'true') {
    if ($permissionDetail->prp_publish_team_member[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
        if ($teamDetail->tea_published[0] == PB_YES) {
        $block1->paletteScript(2, 'remove_projectsite', '../projects/viewproject.php?removeToSiteTeam=true&project=' . $projectDetail->pro_id[0] . '&action=publish&id=' . $id, 'true,true,false', lang_strings('remove_project_site'));
        } else {
            $block1->paletteScript(1, 'add_projectsite', '../projects/viewproject.php?addToSiteTeam=true&project=' . $projectDetail->pro_id[0] . '&action=publish&id=' . $id, 'true,true,false', lang_strings('add_project_site'));
        }
    }
}

if ($permissionDetail->prp_send_message[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(3,'email','../users/emailusers.php?id=' . $id,'true,true,false',lang_strings('email'));
}

if ($permissionDetail->prp_modify_team_member_properties[0] == B_TRUE || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(4, 'edit', '../teams/updateusers.php?project=' . $projectDetail->pro_id[0] . '&id=' . $id, 'true,true,false', lang_strings('edit'));
}

$block1->closePaletteScript("", "");
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
