<?php // $Revision: 1.26.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmeetingtime.php,v 1.26.2.1 2010/04/22 09:26:55 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$commO = isset($_POST['commO'])?$_POST['commO']:'';
$prj = isset($_POST['prj'])?$_POST['prj']:'';
$mee = isset($_POST['mee'])?$_POST['mee']:'';
$dat = isset($_POST['dat'])?$_POST['dat']:'';
$hours = isset($_POST['hours'])?$_POST['hours']:'';
$ooy = isset($_POST['ooy'])?$_POST['ooy']:'Y';
$bodyCommand = "onLoad=\"document.em1Form.hours.focus();\"";

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

$date_start = date('Y-m-d', $sdate);
$date_end = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))+6, intval(substr($date_start, 0, 4))));
$date_past7 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))-7, intval(substr($date_start, 0, 4))));

if ($periodUnit == 'month') {
    $date_start_period = date('Y-m-d', mktime(12, 0, 0, $serialno, 1, $fyear));
    $date_end_period = date('Y-m-d', mktime(12, 0, 0, $serialno+1, 0, $fyear));
} else {
    $date_start_period = $date_start;
    $date_end_period = $date_end;
}

/**
 * Permission check
 */
$tmpquery = " WHERE (wca.date>='$date_start_period' OR wca.date>='$date_start') AND (wca.date<='$date_end_period' OR wca.date<='$date_end') ORDER BY wca.date";
$listWorkCalendar = new request();
$listWorkCalendar->openWorkCalendar($tmpquery);
$comptListWorkCalendar = count($listWorkCalendar->wca_id);
$date_start1 = ($date_start_period>$date_start)?$date_start:$date_start_period;
$date_end1 = ($date_end_period>$date_end)?$date_end_period:$date_end;
$compt1 = 0;

while ($date_start1<=$date_end1) {
    $compt1 += 1;
    $date_start1 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start1, 5, 2)), intval(substr($date_start1, 8, 2))+1, intval(substr($date_start1, 0, 4))));
}

if ($comptListWorkCalendar < $compt1) {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

if ($id != "") {
    $tmpquery = " WHERE mti.id=$id";
    $meetingTimeDetail = new request();
    $meetingTimeDetail->openMeetingTime($tmpquery);

    if ($meetingTimeDetail->mti_owner[0] != $idSession) {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=permissiondenied");
        exit;
    }

    $prj = $meetingTimeDetail->mti_project[0];
    $mee = $meetingTimeDetail->mti_meeting[0];
}

if ($mee != '' && $mee != '0' && is_numeric($mee)) {
    $tmpquery = " WHERE mee.id=$mee";
    $meetingDetail = new request();
    $meetingDetail->openMeetings($tmpquery);
    $comptMeetingDetail = count($meetingDetail->mee_id);

    if ($comptMeetingDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $tmpquery = " WHERE tim.owner=$idSession AND per.date_start<='" . $meetingDetail->mee_date[0] . "' AND per.date_end>='" . $meetingDetail->mee_date[0] . "'";
    $listTimesheet = new request();
    $listTimesheet->openTimesheet($tmpquery);
    $comptListTimesheet = count($listTimesheet->tim_owner);
    $timesheetReadOnly = false;
    $resetTimesheet = '';

    for ($i=0; $i<$comptListTimesheet; $i++) {
        if ($listTimesheet->tim_status[$i] == FS_NEEDS_APPROVAL) {
            $timesheetReadOnly = true;
            break;
        } else if ($listTimesheet->tim_status[$i] == FS_NO_APPROVALS_NEEDED || $listTimesheet->tim_status[$i] == FS_APPROVED) {
            $resetTimesheet = $listTimesheet->tim_id[$i];
        }
    }

    if (periodLocked($meetingDetail->mee_date[0]) || $timesheetReadOnly) {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=permissiondenied");
        exit;
    }
}

/**
 * Actions
 */
if ($action != '') {
    $comm = HtmlEntitiesNOD($comm);
    $commO = HtmlEntitiesNOD($commO);

    // make sure we have the required information
    if ($hours == '') {
        $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.em1Form.hours.focus();\"";
        $hours_highlight = true;
    } else if (!is_numeric($hours)) {
        $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_numerical');
        $bodyCommand = "onLoad=\"document.em1Form.hours.focus();document.em1Form.hours.select();\"";
        $hours_highlight = true;
    } else if ($hours > 24) {
        $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_hours');
        $bodyCommand = "onLoad=\"document.em1Form.hours.focus();document.em1Form.hours.select();\"";
        $hours_highlight = true;
    }

    // update task time in database
    if (empty($error)) {
        if ($action == 'update') {
            $tmpquery = "DELETE FROM " . $tableName['meetings_time'] . " WHERE project=$prj AND meeting=$mee AND owner=$idSession AND date='$dat' AND comments='$commO'";
            connectSql($tmpquery);

            if ($resetTimesheet != '') {
                $tmpquery = "UPDATE " . $tableName['timesheet'] . " SET status='" . FS_APPROVED_WITH_CHANGES . "' WHERE id=$resetTimesheet";
                connectSql($tmpquery);
            }
        }

        $hours = round($hours, $hourAccuracy);
        $tmpquery = "INSERT INTO " . $tableName['meetings_time'] . " (project,meeting,owner,date,hours,comments,created) VALUES ($prj,$mee,$idSession,'$dat','$hours','$comm','$dateheures')";
        connectSql($tmpquery);

        if ($action == 'update') {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=update");
        } else {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=add");
        }

        exit;
    }
}

/**
 * Prepare data
 */
$tmpquery = " LEFT OUTER JOIN " . $tableName['project_permissions'] . " prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member=$idSession AND prp.log_meeting_hours='" . B_TRUE . "'";

if ($ooy == 'Y') {
    $tmpquery .= " AND pro.status='" . PJS_OPEN . "' ORDER BY pro.name";
} else {
    $tmpquery .= " ORDER BY pro.name";
}

$listProjects = new request();
$listProjects->openTeams($tmpquery);
$comptListProjects = count($listProjects->tea_id);
$sdate1 = $sdate;

for ($daynumber=1; $daynumber<=7; $daynumber++) {
    $logHours[$daynumber] = 0;
    $date1 = date('Y-m-d', $sdate1);
    $i = array_search($date1, $listWorkCalendar->wca_date);
    $stdHours[$daynumber] = $listWorkCalendar->wca_hours[$i];
    $dayType[$daynumber] = $listWorkCalendar->wca_type[$i];
    $dayComments[$daynumber] = nl2br($listWorkCalendar->wca_comments[$i]);
    list($an1, $mois1, $jour1) = preg_split('/-/', $date1, 3);
    $sdate1 = mktime(12,0,0,intval($mois1),intval($jour1)+1,intval($an1));
}

if ($prj == '' && $comptListProjects > 0) {
    $prj = $listProjects->tea_project[0];
} else if ($prj != '' && $id == '') {
    if ($comptListProjects == '0') {
        $prj = '';
    } else if (!in_array($prj, $listProjects->tea_project)) {
        $prj = '';
    }
}

if ($prj != '') {
    $tmpquery = " WHERE pro.id=$prj";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);

    if ($id == '') {
        $tmpquery = " WHERE att.project=$prj AND att.member=$idSession AND mee.date>='$date_start' AND mee.date<='$date_end' ORDER BY mee.name";
    } else {
        $tmpquery = " WHERE att.meeting=$mee ORDER BY mee.name";
    }

    $listMeeAttendants = new request();
    $listMeeAttendants->openAttendants($tmpquery);
    $comptListMeeAttendants = count($listMeeAttendants->att_id);
} else {
    $comptListMeeAttendants = 0;
}

if ($mee == '' && $comptListMeeAttendants > 0) {
    $mee = $listMeeAttendants->att_meeting[0];
} else if ($mee != '' && $comptListMeeAttendants == 0) {
    $mee = '';
}

if ($mee != '') {
    $tmpquery = " WHERE mee.id=$mee";
    $meetingDetail = new request();
    $meetingDetail->openMeetings($tmpquery);
    $dat = $meetingDetail->mee_date[0];
    $stime = $meetingDetail->mee_start_time[0];
    $etime = $meetingDetail->mee_end_time[0];
} else {
    $dat = '';
    $stime = '';
    $etime = '';
}

if ($prj == '' || $mee == '') {
    $saveDisabled = 'disabled';
}

if ($ooy == 'Y') {
    $openonlyChecked = 'checked';
}

if (empty($error) && $id != "") {
    $comm = $meetingTimeDetail->mti_comments[0];
    $tmpquery = " WHERE mti.project=$prj AND mti.meeting=$mee AND mti.owner=$idSession AND mti.date='" . $meetingTimeDetail->mti_date[0] . "' AND mti.comments='" . HtmlEntitiesNOD($comm) . "'";
    $listMeetingTime = new request();
    $listMeetingTime->openMeetingTime($tmpquery);
    $comptListMeetingTime = count($listMeetingTime->mti_id);
    $hours = 0;

    if ($comptListMeetingTime > 0) {
        foreach ($listMeetingTime->mti_hours as $h) $hours += $h;
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear ( $date_start ~ $date_end )", 'in'));

if ($id != "") {  // edit meeting time
    $blockPage->itemBreadcrumbs(lang_strings('edit_meeting_time'));
} else { // add meeting time
    $blockPage->itemBreadcrumbs(lang_strings('add_meeting_time'));
}

$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "em1";

if ($id != "") {  // edit meeting time
    $block1->openForm("../timesheet/editmeetingtime.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;section=workhour&amp;id=$id#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
} else { // add meeting time
    $block1->openForm("../timesheet/editmeetingtime.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;section=workhour#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
}

if ($id != "") {
    $block1->heading(lang_strings('edit_meeting_time'));
} else {
    $block1->heading(lang_strings('add_meeting_time'));
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($id != '') {
    $block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
    $block1->contentRow(lang_strings("meeting"), $meetingDetail->mee_name[0]);
    echo "<input name=\"prj\" type=\"hidden\" value=\"" . $meetingTimeDetail->mti_project[0] . "\">";
    echo "<input name=\"mee\" type=\"hidden\" value=\"" . $meetingTimeDetail->mti_meeting[0] . "\">";
    echo "<input name=\"commO\" type=\"hidden\" value=\"" . str_replace('"', '&quot;', $meetingTimeDetail->mti_comments[0]) ."\">";
} else {
    // project
    $projectSel = "<select name=\"prj\" onchange=\"changeOptions()\">";

    for ($i=0; $i<$comptListProjects; $i++) {
        $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\" ";

        if ($prj == $listProjects->tea_project[$i]) {
            $projectSel .= "selected";
        }

        $projectSel .= ">" . $listProjects->tea_pro_name[$i] . "</option>";
    }

    $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)" ' . $openonlyChecked . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
    $block1->contentRow(lang_strings("project"), $projectSel);
    // meeting
    $meetingSel = "<select name=\"mee\" onchange=\"changeOptions()\">";

    for ($i=0; $i<$comptListMeeAttendants; $i++) {
        $meetingSel .= "<option value=\"" . $listMeeAttendants->att_meeting[$i] . "\" ";

        if ($mee == $listMeeAttendants->att_meeting[$i]) {
            $meetingSel .= "selected";
        }

        $meetingSel .= ">" . $listMeeAttendants->att_mee_name[$i] . "</option>";
    }

    $meetingSel .= "</select>";
    $block1->contentRow(lang_strings("meeting"), $meetingSel);
}

echo "<input name=\"dat\" type=\"hidden\" value=\"$dat\">";
$block1->contentRow(lang_strings("date"), $dat);
$block1->contentRow(lang_strings("start_time"), $stime);
$block1->contentRow(lang_strings("end_time"), $etime);
$block1->contentRow(lang_strings("comments"), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");

if ($hours_highlight) {
    $block1->contentRow("* " . lang_strings('worked_hours'), "<input type=\"text\" class=\"input_hours_highlight\" name=\"hours\" size=\"6\" value=\"$hours\">");
} else {
    $block1->contentRow("* " . lang_strings('worked_hours'), "<input type=\"text\" class=\"input_hours\" name=\"hours\" size=\"6\" value=\"$hours\">");
}

$block1->contentRow("", "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\" $saveDisabled>");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
<script type="text/javascript">
function changeOptions()
{
    var x=document.em1Form;
    x.action.value="";
    document.em1Form.submit();
}
function changeOpenOnly(theObj)
{
    if (theObj.checked==true) {
        document.em1Form.ooy.value = 'Y';
    } else {
        document.em1Form.ooy.value = 'N';
    }

    document.em1Form.action.value="";
    document.em1Form.submit();
}
</script>
