<?php // $Revision: 1.28.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: submittimesheet.php,v 1.28.2.1 2012/03/15 04:41:41 luiswang Exp $
 *
 * Copyright (c) 2011 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = 'onLoad="document.tssForm.comm.focus();"';

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

$date_start = date('Y-m-d', $sdate);
$date_end = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))+6, intval(substr($date_start, 0, 4))));
$date_past7 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))-7, intval(substr($date_start, 0, 4))));

if ($periodUnit == 'month') {
    $date_start_period = date('Y-m-d', mktime(12, 0, 0, $serialno, 1, $fyear));
    $date_end_period = date('Y-m-d', mktime(12, 0, 0, $serialno+1, 0, $fyear));
} else {
    $date_start_period = $date_start;
    $date_end_period = $date_end;
}

/**
 * Permission check
 */
$tmpquery = " WHERE (wca.date>='$date_start_period' OR wca.date>='$date_start') AND (wca.date<='$date_end_period' OR wca.date<='$date_end') ORDER BY wca.date";
$listWorkCalendar = new request();
$listWorkCalendar->openWorkCalendar($tmpquery);
$comptListWorkCalendar = count($listWorkCalendar->wca_id);
$date_start1 = ($date_start_period>$date_start)?$date_start:$date_start_period;
$date_end1 = ($date_end_period>$date_end)?$date_end_period:$date_end;
$compt1 = 0;

while ($date_start1<=$date_end1) {
    $compt1 += 1;
    $date_start1 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start1, 5, 2)), intval(substr($date_start1, 8, 2))+1, intval(substr($date_start1, 0, 4))));
}

if ($comptListWorkCalendar < $compt1) {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

$tmpquery = " WHERE tim.owner=$idSession AND per.fyear=$fyear AND per.serial_no=$serialno";
$timesheetDetail = new request();
$timesheetDetail->openTimesheet($tmpquery);
$comptTimesheetDetail = count($timesheetDetail->tim_owner);

if ($comptTimesheetDetail != '0' && $timesheetDetail->tim_status[0] == FS_NEEDS_APPROVAL) {
    header("Location:../general/permissiondenied.php");
    exit;
}

// Actual hours
$memberTimeOfPeriodDetail = new request();
$actualHours = $memberTimeOfPeriodDetail->getMemberTimeOfPeriod($idSession, $date_start_period, $date_end_period);

if (floatval($actualHours) == 0) {
    header("Location:../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == 'submit') {
    // Standard hours
    $standardHours = 0;

    for ($i=0; $i<$comptListWorkCalendar; $i++) {
        $date1 = $listWorkCalendar->wca_date[$i];

        if ($date1>=$date_start_period && $date1<=$date_end_period) {
            $standardHours += $listWorkCalendar->wca_hours[$i];
            $listOvertime[$date1] = 0 - $listWorkCalendar->wca_hours[$i];
            $listOverLeave[$date1] = 0 - $listWorkCalendar->wca_hours[$i];
        }
    }

    // Overtime hours
    $tmpquery = " WHERE wkh.owner=$idSession AND wkh.date BETWEEN '$date_start_period' AND '$date_end_period'";
    $listWorkHours = new request();
    $listWorkHours->openWorkHours($tmpquery);
    $comptListWorkHours = count($listWorkHours->wkh_id);

    for ($i=0; $i<$comptListWorkHours; $i++) {
        $listOvertime[$listWorkHours->wkh_date[$i]] += $listWorkHours->wkh_hours[$i];

        if ($listWorkHours->wkh_work[$i] == LV_ANNUAL || $listWorkHours->wkh_work[$i] == LV_SICK || $listWorkHours->wkh_work[$i] == LV_ABSENCE || $listWorkHours->wkh_work[$i] == LV_BANKHOLIDAY || $listWorkHours->wkh_work[$i] == LV_MOURNING || $listWorkHours->wkh_work[$i] == LV_HONEYMOON || $listWorkHours->wkh_work[$i] == LV_MATERNITY) {
            $listOverLeave[$listWorkHours->wkh_date[$i]] += $listWorkHours->wkh_hours[$i];
        }
    }

    $tmpquery = " WHERE tim.owner=$idSession AND tim.date BETWEEN '$date_start_period' AND '$date_end_period'";
    $listTaskTime = new request();
    $listTaskTime->openTaskTime($tmpquery);
    $comptListTaskTime = count($listTaskTime->tim_id);

    for ($i=0; $i<$comptListTaskTime; $i++) {
        $listOvertime[$listTaskTime->tim_date[$i]] += $listTaskTime->tim_hours[$i];
    }

    $tmpquery = " WHERE mti.owner=$idSession AND mti.date BETWEEN '$date_start_period' AND '$date_end_period'";
    $listMeetingTime = new request();
    $listMeetingTime->openMeetingTime($tmpquery);
    $comptListMeetingTime = count($listMeetingTime->mti_id);

    for ($i=0; $i<$comptListMeetingTime; $i++) {
        $listOvertime[$listMeetingTime->mti_date[$i]] += $listMeetingTime->mti_hours[$i];
    }

    $overtimeHours = 0;
    $sdate1 = mktime(12, 0, 0, intval(substr($date_start_period, 5, 2)), intval(substr($date_start_period, 8, 2)), intval(substr($date_start_period, 0, 4)));
    $sdate2 = mktime(12, 0, 0, intval(substr($date_end_period, 5, 2)), intval(substr($date_end_period, 8, 2)), intval(substr($date_end_period, 0, 4)));

    while ($sdate1 <= $sdate2) {
        $date1 = date('Y-m-d', $sdate1);
        $listOvertime[$date1] -= ($listOverLeave[$date1]>0)?$listOverLeave[$date1]:0;

        if ($listOvertime[$date1] < 0) {
            $listOvertime[$date1] = 0;
        }

        $overtimeHours += $listOvertime[$date1];
        list($an1, $mois1, $jour1) = preg_split('/-/', $date1, 3);
        $sdate1 = mktime(12, 0 , 0, intval($mois1), intval($jour1)+1, intval($an1));
    }

    // Billable hours
    $billableHours = $memberTimeOfPeriodDetail->getMemberBillableTimeOfPeriod($idSession, $date_start_period, $date_end_period);
    $comm = HtmlEntitiesNOD($comm);
    $status = FS_NO_APPROVALS_NEEDED;
    $tmpquery = " WHERE per.fyear=$fyear AND per.serial_no=$serialno";
    $periodDetail = new request();
    $periodDetail->openPeriods($tmpquery);
    $comptPeriodDetail = count($periodDetail->per_id);

    if ($comptPeriodDetail == '0') {
        $tmpquery = "INSERT INTO " . $tableName['periods'] . " (fyear,serial_no,date_start,date_end,locked,created) VALUES ($fyear,$serialno,'$date_start_period','$date_end_period','N','$dateheure')";
        connectSql($tmpquery);
        $num = last_id($tableName['periods']);
    } else {
        $num = $periodDetail->per_id[0];
    }

    if ($comptTimesheetDetail != '0') {
        $tmpquery = "UPDATE " . $tableName['timesheet'] . " SET standard_hours=$standardHours,actual_hours=$actualHours,billable_hours=$billableHours,overtime_hours=$overtimeHours,status='$status',comments='$comm',modified='$dateheures' WHERE id=" . $timesheetDetail->tim_id[0];
        connectSql($tmpquery);
        $num = $timesheetDetail->tim_id[0];
    } else {
        $tmpquery = "INSERT INTO " . $tableName['timesheet'] . " (owner,period,standard_hours,actual_hours,billable_hours,overtime_hours,status,comments,created) VALUES ($idSession,$num,$standardHours,$actualHours,$billableHours,$overtimeHours,'$status','$comm','$dateheures')";
        connectSql($tmpquery);
        $num = last_id($tableName['timesheet']);
    }

    $producer = $idSession;
    $doctype = ADT_TIMESHEET;
    require_once('../approvals/adddocument.php');
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=addToSubmitted");
    exit;
}

$sdatePrevWeek = mktime(12, 0, 0, date('n', $sdate), date('j', $sdate)-7, date('Y', $sdate));
$sdateNextWeek = mktime(12, 0, 0, date('n', $sdate), date('j', $sdate)+7, date('Y', $sdate));

if ($periodUnit == 'month') {
    $mois1 = date('n', $sdatePrevWeek);

    if ($mois1 != $serialno) {
        $serialnoPrevWeek = $mois1;

        if ($mois1 == '12') {
            $fyearPrevWeek = $fyear - 1;
        } else {
            $fyearPrevWeek = $fyear;
        }
    } else {
        $serialnoPrevWeek = $serialno;
        $fyearPrevWeek = $fyear;
    }

    $mois1 = date('n', $sdateNextWeek);

    if ($mois1 != $serialno) {
        $serialnoNextWeek = $mois1;

        if ($mois1 == '1') {
            $fyearNextWeek = $fyear + 1;
        } else {
            $fyearNextWeek = $fyear;
        }
    } else {
        $serialnoNextWeek = $serialno;
        $fyearNextWeek = $fyear;
    }

    $prev1st = mktime(12, 0, 0, $serialno-1, 1, $fyear);
    $w = date('w', $prev1st);

    if ($w == '0') {
        $sdatePrevMonth = mktime(12, 0, 0, date('n', $prev1st), 2, date('Y', $prev1st));
    } else {
        $sdatePrevMonth = mktime(12, 0, 0, date('n', $prev1st), 2-$w, date('Y', $prev1st));
    }

    if ($serialno == '1') {
        $fyearPrevMonth = $fyear - 1;
        $serialnoPrevMonth = '12';
    } else {
        $fyearPrevMonth = $fyear;
        $serialnoPrevMonth = $serialno - 1;
    }

    $next1st = mktime(12, 0, 0, $serialno+1, 1, $fyear);
    $w = date('w', $next1st);

    if ($w == '0') {
        $sdateNextMonth = mktime(12, 0, 0, date('n', $next1st), 2, date('Y', $next1st));
    } else {
        $sdateNextMonth = mktime(12, 0, 0, date('n', $next1st), 2-$w, date('Y', $next1st));
    }

    if ($serialno == '12') {
        $fyearNextMonth = $fyear + 1;
        $serialnoNextMonth = '1';
    } else {
        $fyearNextMonth = $fyear;
        $serialnoNextMonth = $serialno + 1;
    }
} else {
    $serialnoPrevWeek = intval(date('W', $sdatePrevWeek));
    $fyearPrevWeek = date('Y', $sdatePrevWeek);
    $mois1 = date('n', $sdatePrevWeek);

    if ($fyearPrevWeek == $fyear && $mois1 == 1 && $serialnoPrevWeek > 50) {
        $fyearPrevWeek -= 1;
    }

    $serialnoNextWeek = intval(date('W', $sdateNextWeek));
    $fyearNextWeek = date('Y', $sdateNextWeek);
    $mois1 = date('n', $sdateNextWeek);

    if ($fyearNextWeek == $fyear && $mois1 == 12 && $serialnoNextWeek == 1) {
        $fyearNextWeek += 1;
    }
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear ( $date_start ~ $date_end )", 'in'));
$blockPage->itemBreadcrumbs(lang_strings('submit_timesheet'));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->heading(lang_strings('submit_timesheet') . " : $serialname $fyear");
$block1->form = "tss";
$block1->openForm("../timesheet/submittimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="submit">';
$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('comments'), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");
$block1->contentRow("", "<input type=\"submit\" name=\"Save\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
