<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewmeetingtime.php,v 1.15 2009/11/05 09:53:37 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

$date_start = date('Y-m-d', $sdate);
$date_end = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))+6, intval(substr($date_start, 0, 4))));
$date_past7 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start, 5, 2)), intval(substr($date_start, 8, 2))-7, intval(substr($date_start, 0, 4))));

if ($periodUnit == 'month') {
    $date_start_period = date('Y-m-d', mktime(12, 0, 0, $serialno, 1, $fyear));
    $date_end_period = date('Y-m-d', mktime(12, 0, 0, $serialno+1, 0, $fyear));
} else {
    $date_start_period = $date_start;
    $date_end_period = $date_end;
}

$tmpquery = " WHERE tim.owner=$idSession AND per.fyear=$fyear AND per.serial_no=$serialno";
$timesheetDetail = new request();
$timesheetDetail->openTimesheet($tmpquery);
$comptTimesheetDetail = count($timesheetDetail->tim_owner);

if ($comptTimesheetDetail == '0') {
    $timesheetReadOnly = false;
} else if ($timesheetDetail->tim_status[0] == FS_NEEDS_APPROVAL) {
    $timesheetReadOnly = true;
} else {
    $timesheetReadOnly = false;
}

$comptDayLocked = '0';
$sdate1 = $sdate;

for ($daynumber=1; $daynumber<=7; $daynumber++) {
    $date1 = date('Y-m-d', $sdate1);
    $day_locked[$daynumber] = periodLocked($date1);

    if ($day_locked[$daynumber]) {
        $comptDayLocked++;
    }

    list($an1, $mois1, $jour1) = preg_split('/-/', $date1, 3);
    $sdate1 = mktime(12,0,0,intval($mois1),intval($jour1)+1,intval($an1));
}

/**
 * Permission check
 */
$tmpquery = " WHERE (wca.date>='$date_start_period' OR wca.date>='$date_start') AND (wca.date<='$date_end_period' OR wca.date<='$date_end') ORDER BY wca.date";
$listWorkCalendar = new request();
$listWorkCalendar->openWorkCalendar($tmpquery);
$comptListWorkCalendar = count($listWorkCalendar->wca_id);
$date_start1 = ($date_start_period>$date_start)?$date_start:$date_start_period;
$date_end1 = ($date_end_period>$date_end)?$date_end_period:$date_end;
$compt1 = 0;

while ($date_start1<=$date_end1) {
    $compt1 += 1;
    $date_start1 = date('Y-m-d', mktime(12, 0, 0, intval(substr($date_start1, 5, 2)), intval(substr($date_start1, 8, 2))+1, intval(substr($date_start1, 0, 4))));
}

if ($comptListWorkCalendar < $compt1) {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

$tmpquery = " WHERE mti.id=$id";
$meetingTimeDetail = new request();
$meetingTimeDetail->openMeetingTime($tmpquery);

if ($meetingTimeDetail->mti_owner[0] != $idSession) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=permissiondenied");
    exit;
}

/**
 * Prepare data
 */
$prj = $meetingTimeDetail->mti_project[0];
$mee = $meetingTimeDetail->mti_meeting[0];
$comm = nl2br($meetingTimeDetail->mti_comments[0]);
$dat = $meetingTimeDetail->mti_date[0];
$tmpquery = " WHERE mti.project=$prj AND mti.meeting=$mee AND mti.owner=$idSession AND mti.date='$dat' AND mti.comments='" . HtmlEntitiesNOD($meetingTimeDetail->mti_comments[0]) . "'";
$listMeetingTime = new request();
$listMeetingTime->openMeetingTime($tmpquery);
$comptListMeetingTime = count($listMeetingTime->mti_id);
$hours = 0;

for ($i=0; $i<$comptListMeetingTime; $i++) {
    $hours += $listMeetingTime->mti_hours[$i];
}

$tmpquery = " WHERE mee.id=$mee";
$meetingDetail = new request();
$meetingDetail->openMeetings($tmpquery);

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", "$serialname $fyear ( $date_start ~ $date_end )", 'in'));
$blockPage->itemBreadcrumbs(lang_strings('view_meeting_time'));
$blockPage->closeBreadcrumbs();
$blockPage->openLongList();
$block1 = new block();
$block1->form = "vtm";
$block1->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;section=meetingtime#" . $block1->form . "Anchor");
$block1->heading(lang_strings('view_meeting_time'));

if (!periodLocked($dat) && !$timesheetReadOnly) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
    $block1->paletteIcon(7, "edit", lang_strings("edit"));
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('project'), $meetingDetail->mee_pro_name[0]);
$block1->contentRow(lang_strings('meeting'), $meetingDetail->mee_name[0]);
$block1->contentRow(lang_strings("date"), $meetingDetail->mee_date[0]);
$block1->contentRow(lang_strings("start_time"), $meetingDetail->mee_start_time[0]);
$block1->contentRow(lang_strings("end_time"), $meetingDetail->mee_end_time[0]);
$block1->contentRow(lang_strings('comments'), $comm);
$block1->contentRow(lang_strings("worked_hours"), $hours);
$block1->closeContent();

if (!periodLocked($dat) && !$timesheetReadOnly) {
    $block1->openPaletteScript();
    $block1->paletteScript(1, "remove", "../timesheet/deleteworkhours.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&id2=$id", "true,true,false", lang_strings("delete"));
    $block1->paletteScript(7, "edit", "../timesheet/editmeetingtime.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&id=$id", "true,true,false", lang_strings("edit"));
    $block1->closePaletteScript('', '');
}

$block1->closeForm();
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
