<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addclientuser.php,v 1.19 2009/09/24 16:02:30 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.cuAForm.un.focus();\"";

/**
 * Variables init
 */
$organization = isset($_GET['organization'])?$_GET['organization']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';
$clod = isset($_POST['clod'])?$_POST['clod']:$organization;
$un = isset($_POST['un'])?$_POST['un']:'';
$fn = isset($_POST['fn'])?$_POST['fn']:'';
$tit = isset($_POST['tit'])?$_POST['tit']:'';
$em = isset($_POST['em'])?$_POST['em']:'';
$wp = isset($_POST['wp'])?$_POST['wp']:'';
$hp = isset($_POST['hp'])?$_POST['hp']:'';
$mp = isset($_POST['mp'])?$_POST['mp']:'';
$fax = isset($_POST['fax'])?$_POST['fax']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$pw = isset($_POST['pw'])?$_POST['pw']:'';
$pwa = isset($_POST['pwa'])?$_POST['pwa']:'';
$act = isset($_POST['act'])?$_POST['act']:'';
$act = ($act=='X'?B_TRUE:B_FALSE);

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Write'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

if (!is_numeric($organization)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$tmpquery = " WHERE org.id=$organization";
$clientDetail = new request();
$clientDetail->openOrganizations($tmpquery);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Fields check
 */
if ($action == 'add') {
    if ($un == '') {
        $error = lang_strings("blank_fields");
        $bodyCommand = "onLoad=\"document.cuAForm.un.focus();\"";
        $un_highlight = true;
    } else if (preg_match("/^[A-Za-z0-9]+$/", $un) !== 1) {
        $error = lang_strings("alpha_only");
        $bodyCommand = "onLoad=\"document.cuAForm.un.focus();document.cuAForm.un.select();\"";
        $un_highlight = true;
    } else if ($fn == '') {
        $error = lang_strings("blank_fields");
        $bodyCommand = "onLoad=\"document.cuAForm.fn.focus();\"";
        $fn_highlight = true;
    } else if ($em != '' && !ValidateMail($em)) {
        $error = lang_strings("invalid_email");
        $bodyCommand = "onLoad=\"document.cuAForm.em.focus();document.cuAForm.em.select();\"";
        $em_highlight = true;
    } else if (($pw != $pwa) || $pw == "") {
        $error = lang_strings("new_password_error");
        $bodyCommand = "onLoad=\"document.cuAForm.pw.focus();\"";
        $pw_highlight = true;
    } else {
        // test if login already exists
        $tmpquery = " WHERE mem.login='$un'";
        $existsUser = new request();
        $existsUser->openMembers($tmpquery);
        $comptExistsUser = count($existsUser->mem_id);

        if ($comptExistsUser != "0") {
            $error = lang_strings("user_already_exists");
            $bodyCommand = "onLoad=\"document.cuAForm.un.focus();document.cuAForm.un.select();\"";
            $un_highlight = true;
        }
    }
}

/**
 * Actions
 */
if ($error == '' && $action == 'add') {
    // replace quotes by html code
    $fn = HtmlEntitiesNOD($fn);
    $tit = HtmlEntitiesNOD($tit);
    $wp = HtmlEntitiesNOD($wp);
    $hp = HtmlEntitiesNOD($hp);
    $mp = HtmlEntitiesNOD($mp);
    $fax = HtmlEntitiesNOD($fax);
    $dep_new = HtmlEntitiesNOD($dep_new);
    $c = HtmlEntitiesNOD($c);
    $pw = get_password($pw);
    $tmpquery = "INSERT INTO " . $tableName["members"] . "(organization,login,name,title,email_work,phone_work,phone_home,mobile,fax,comments,password,profil,created,timezone,active,deleted) VALUES($clod,'$un','$fn','$tit','$em','$wp','$hp','$mp','$fax','$c','$pw','" . PF_CLIENT_USER . "','$dateheures','0','$act','" . B_FALSE . "')";
    connectSql($tmpquery);
    $num = last_id($tableName["members"]);
    $tmpquery = "INSERT INTO " . $tableName["notifications"] . "(member,taskAssignment,removeProjectTeam,addProjectTeam,newTopic,newPost,statusTaskChange,priorityTaskChange,duedateTaskChange,clientAddTask) VALUES ($num,'0','0','0','0','0','0','0','0','0')";
    connectSql($tmpquery);
    header("Location: ../clients/viewclient.php?id=$clod&msg=add");
    exit;
}

/**
 * Html
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/listclients.php?", lang_strings("clients"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/viewclient.php?id=" . $clientDetail->org_id[0], $clientDetail->org_name[0], in));
$blockPage->itemBreadcrumbs(lang_strings("add_client_user"));
$blockPage->closeBreadcrumbs();

if ($error != "") {
    $blockPage->errorBox($error);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "cuA";
$block1->openForm("../users/addclientuser.php?organization=$organization#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
$block1->heading(lang_strings("add_client_user"));

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages();
}

$block1->openContent();
$block1->contentTitle(lang_strings("enter_user_details"));

if ($un_highlight) {
    $block1->contentRow("* " . lang_strings("user_name"), "<input size=\"24\" class=\"input_text_highlight\" maxlength=\"16\" type=\"text\" name=\"un\" value=\"$un\">");
} else {
    $block1->contentRow("* " . lang_strings("user_name"), "<input size=\"24\" class=\"input_text\" maxlength=\"16\" type=\"text\" name=\"un\" value=\"$un\">");
}

if ($fn_highlight) {
    $block1->contentRow("* " . lang_strings("full_name"), "<input size=\"24\" class=\"input_text_highlight\" maxlength=\"64\" type=\"text\" name=\"fn\" value=\"" . str_replace('"', '&quot;', $fn) . "\">");
} else {
    $block1->contentRow("* " . lang_strings("full_name"), "<input size=\"24\" class=\"input_text\" maxlength=\"64\" type=\"text\" name=\"fn\" value=\"" . str_replace('"', '&quot;', $fn) . "\">");
}

$block1->contentRow(lang_strings("title"), "<input size=\"24\" class=\"input_text\" maxlength=\"64\" type=\"text\" name=\"tit\" value=\"" . str_replace('"', '&quot;', $tit) . "\">");
$selectOrganization = "<select name=\"clod\">";
$tmpquery = " WHERE org.id!=1 ORDER BY org.name";
$listOrganizations = new request();
$listOrganizations->openOrganizations($tmpquery);
$comptListOrganizations = count($listOrganizations->org_id);

for ($i = 0;$i < $comptListOrganizations;$i++) {
    if ($clod == $listOrganizations->org_id[$i]) {
        $selectOrganization .= "<option value=\"" . $listOrganizations->org_id[$i] . "\" selected>" . $listOrganizations->org_name[$i] . "</option>";
    } else {
        $selectOrganization .= "<option value=\"" . $listOrganizations->org_id[$i] . "\">" . $listOrganizations->org_name[$i] . "</option>";
    }
}

$selectOrganization .= "</select>";
$block1->contentRow(lang_strings("organization"), $selectOrganization);

if ($em_highlight) {
    $block1->contentRow(lang_strings("email"), "<input size=\"24\" class=\"input_text_highlight\" maxlength=\"128\" type=\"text\" name=\"em\" value=\"$em\">");
} else {
    $block1->contentRow(lang_strings("email"), "<input size=\"24\" class=\"input_text\" maxlength=\"128\" type=\"text\" name=\"em\" value=\"$em\">");
}

$block1->contentRow(lang_strings("work_phone"), "<input size=\"14\" class=\"input_text\" maxlength=\"32\" type=\"text\" name=\"wp\" value=\"" . str_replace('"', '&quot;', $wp) . "\">");
$block1->contentRow(lang_strings("home_phone"), "<input size=\"14\" class=\"input_text\" maxlength=\"32\" type=\"text\" name=\"hp\" value=\"" . str_replace('"', '&quot;', $hp) . "\">");
$block1->contentRow(lang_strings("mobile_phone"), "<input size=\"14\" class=\"input_text\" maxlength=\"32\" type=\"text\" name=\"mp\" value=\"" . str_replace('"', '&quot;', $mp) . "\">");
$block1->contentRow(lang_strings("fax"), "<input size=\"14\" class=\"input_text\" maxlength=\"32\" type=\"text\" name=\"fax\" value=\"" . str_replace('"', '&quot;', $fax) . "\">");
$block1->contentRow(lang_strings("comments"), "<textarea class=\"textarea_3rows\" name=\"c\" cols=\"35\" rows=\"3\">$c</textarea>");
$block1->contentRow("<input size=\"32\" name=\"act\" value=\"X\" type=\"checkbox\" checked>", lang_strings("active_user"), "false", "");
$block1->closeContent();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

$block1->openContent();
$block1->contentTitle(lang_strings("enter_password"));

if ($pw_highlight) {
    $block1->contentRow("* " . lang_strings("password"), "<input size=\"24\" class=\"input_text_highlight\" maxlength=\"16\" type=\"password\" name=\"pw\" value=\"\">");
} else {
    $block1->contentRow("* " . lang_strings("password"), "<input size=\"24\" class=\"input_text\" maxlength=\"16\" type=\"password\" name=\"pw\" value=\"\">");
}

$block1->contentRow("* " . lang_strings("confirm_password"), "<input size=\"24\" class=\"input_text\" maxlength=\"16\" type=\"password\" name=\"pwa\" value=\"\">");
$block1->contentRow("", "<input type=\"submit\" name=\"Save\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
