<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listusers.php,v 1.15 2009/09/01 15:01:17 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['User']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
$blockPage->itemBreadcrumbs(lang_strings("user_management"));
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "ulU";
$block1->openForm("../users/listusers.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("user_management"));
$block1->openPaletteIcon();

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $block1->paletteIcon(0, "add", lang_strings("add"));
}

if ($SW_Permissions['User']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
}

$block1->paletteIcon(2, "info", lang_strings("view"));

if ($SW_Permissions['User']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, "edit", lang_strings("edit"));
}

$block1->paletteIcon(4, "email", lang_strings("email"));
$block1->closePaletteIcon();

if ($enableTimesheet == 'true') {
    $block1->sorting("users", $sortingUser->sor_users[0], "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "mem.login", 2 => "mem.email_work", 3 => "mem.profil", 4 => "dep.name", 5 => "mem2.name", 6 => "mem3.name", 7 => "log.connected", 8 => "mem.active"));
} else {
    $block1->sorting("users", $sortingUser->sor_users[0], "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "mem.login", 2 => "mem.email_work", 3 => "mem.profil", 4 => "log.connected", 5 => "mem.active"));
}

$tmpquery = " WHERE mem.id!=1 AND mem.profil!='" . PF_CLIENT_USER . "' ORDER BY $block1->sortingValue";
$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers != "0") {
    $block1->openResults();

    if ($enableTimesheet == 'true') {
        $block1->labels($labels = array(0 => lang_strings("full_name"), 1 => lang_strings("user_name"), 2 => lang_strings("email"), 3 => lang_strings("profile"), 4 => lang_strings("department"), 5 => lang_strings("manager"), 6 => lang_strings("deputy"), 7 => lang_strings("connected"), 8 => lang_strings("active_user")), "false");
    } else {
        $block1->labels($labels = array(0 => lang_strings("full_name"), 1 => lang_strings("user_name"), 2 => lang_strings("email"), 3 => lang_strings("profile"), 4 => lang_strings("connected"), 5 => lang_strings("active_user")), "false");
    }

    for ($i = 0;$i < $comptListMembers;$i++) {
        $idProfil = $listMembers->mem_profil[$i];
        $block1->openRow();
        $block1->checkboxRow($listMembers->mem_id[$i]);
        $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listMembers->mem_id[$i], $listMembers->mem_name[$i], in));
        $block1->cellRow($listMembers->mem_login[$i]);
        $block1->cellRow($blockPage->buildLink($listMembers->mem_email_work[$i], $listMembers->mem_email_work[$i], mail));
        $block1->cellRow($profil[$idProfil]);

        if ($enableTimesheet == 'true') {
            if ($listMembers->mem_department[$i] == "0") {
                $block1->cellRow(lang_strings('none'));
            } else {
                $block1->cellRow($listMembers->mem_dep_name[$i]);
            }

            if ($listMembers->mem_manager[$i] == "0") {
                $block1->cellRow(lang_strings('none'));
            } else {
                $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listMembers->mem_manager[$i], $listMembers->mem_mem2_name[$i], in));
            }

            if ($listMembers->mem_deputy[$i] == "0") {
                $block1->cellRow(lang_strings('none'));
            } else {
                $block1->cellRow($blockPage->buildLink("../users/viewuser.php?id=" . $listMembers->mem_deputy[$i], $listMembers->mem_mem3_name[$i], in));
            }
        }

        if ($listMembers->mem_log_connected[$i] > $dateunix-5 * 60) {
            $block1->cellRow(lang_strings("yes") . " " . $z);
        } else {
            $block1->cellRow(lang_strings("no"));
        }

        if ($listMembers->mem_active[$i] == B_TRUE) {
            $block1->cellRow(lang_strings("yes"));
        } else {
            $block1->cellRow(lang_strings("no"));
        }

        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $block1->paletteScript(0, "add", "../users/edituser.php?", "true,false,false", lang_strings("add"));
}

if ($SW_Permissions['User']['Admin'][$profilSession]) {
    $block1->paletteScript(1, "remove", "../users/deleteusers.php?", "false,true,true", lang_strings("delete"));
}

$block1->paletteScript(2, "info", "../users/viewuser.php?", "false,true,false", lang_strings("view"));

if ($SW_Permissions['User']['Edit'][$profilSession]) {
    $block1->paletteScript(3, "edit", "../users/edituser.php?", "false,true,false", lang_strings("edit"));
}

$block1->paletteScript(4, "email", "../users/emailusers.php?", "false,true,true", lang_strings("email"));
$block1->closePaletteScript($comptListMembers, $listMembers->mem_id);
$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
