<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewuser.php,v 1.23 2009/09/16 03:53:02 luiswang Exp $
 *
 * Copyright (c) 2009 by the netOffice Dwins developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['User']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != '') {
    $tmpquery = " WHERE mem.id=$id";
    $userDetail = new request();
    $userDetail->openMembers($tmpquery);
    $comptUserDetail = count($userDetail->mem_id);
} else {
    $comptUserDetail = 0;
}

if ($comptUserDetail == 0) {
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
} else if ($userDetail->mem_profil[0] == PF_CLIENT_USER) {
    header("Location: ../users/viewclientuser.php?id=$id&organization=" . $userDetail->mem_organization[0]);
    exit;
}

/**
 * HTML
 */
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), in));
$blockPage->itemBreadcrumbs($userDetail->mem_name[0]);
$blockPage->closeBreadcrumbs();

if ($msg != '') {
    require_once("../includes/messages.php");
    $blockPage->messageBox($msgLabel);
}

$blockPage->openLongList();
$block1 = new block();
$block1->form = "userD";
$block1->openForm("../users/viewuser.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("user_profile"));

if ($userDetail->mem_deleted[0] == B_FALSE) {
    $block1->openPaletteIcon();

    if ($SW_Permissions['User']['Admin'][$profilSession]) {
        $block1->paletteIcon(0, "remove", lang_strings("delete"));
    }

    if ($SW_Permissions['User']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", lang_strings("edit"));
    }

    $block1->paletteIcon(2, "export", lang_strings("export"));
    $block1->closePaletteIcon();
}

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->openTwoPages("twopagesMore");
}

$block1->openContent();
$block1->contentTitle(lang_strings("user_details"));
$block1->contentRow(lang_strings("user_name"), $userDetail->mem_login[0]);
$block1->contentRow(lang_strings("full_name"), $userDetail->mem_name[0]);
$block1->contentRow(lang_strings("title"), $userDetail->mem_title[0]);
$block1->contentRow(lang_strings("email"), $blockPage->buildLink($userDetail->mem_email_work[0], $userDetail->mem_email_work[0], mail));
$block1->contentRow(lang_strings("work_phone"), $userDetail->mem_phone_work[0]);
$block1->contentRow(lang_strings("home_phone"), $userDetail->mem_phone_home[0]);
$block1->contentRow(lang_strings("mobile_phone"), $userDetail->mem_mobile[0]);
$block1->contentRow(lang_strings("fax"), $userDetail->mem_fax[0]);

if ($userDetail->mem_profil[0] == PF_ADMINISTRATOR) {
    $block1->contentRow(lang_strings("permissions"), lang_strings("administrator_permissions"));
} else if ($userDetail->mem_profil[0] == PF_PROJECT_MANAGER) {
    $block1->contentRow(lang_strings("permissions"), lang_strings("project_manager_permissions"));
} else if ($userDetail->mem_profil[0] == PF_USER) {
    $block1->contentRow(lang_strings("permissions"), lang_strings("user_permissions"));
} else if ($userDetail->mem_profil[0] == PF_PROJECT_MANAGER_ADMINISTRATOR) {
    $block1->contentRow(lang_strings("permissions"), lang_strings("project_manager_administrator_permissions"));
} else if ($userDetail->mem_profil[0] == PF_RESOURCE_MANAGER) {
    $block1->contentRow(lang_strings("permissions"), lang_strings("resource_manager_permissions"));
}

if ($enableTimesheet == 'true') {
    if ($userDetail->mem_department[0] == "0") {
        $block1->contentRow(lang_strings("department"), lang_strings('none'));
    } else {
        $block1->contentRow(lang_strings("department"), $userDetail->mem_dep_name[0]);
    }

    if ($userDetail->mem_manager[0] == "0") {
        $block1->contentRow(lang_strings("manager"), lang_strings('none'));
    } else {
        $block1->contentRow(lang_strings("manager"), $blockPage->buildLink("../users/viewuser.php?id=" . $userDetail->mem_manager[0], $userDetail->mem_mem2_name[0], 'in'));
    }

    if ($userDetail->mem_deputy[0] == "0") {
        $block1->contentRow(lang_strings("deputy"), lang_strings('none'));
    } else {
        $block1->contentRow(lang_strings("deputy"), $blockPage->buildLink("../users/viewuser.php?id=" . $userDetail->mem_deputy[0], $userDetail->mem_mem3_name[0], 'in'));
    }

    $block1->contentRow(lang_strings("timeticket"), $blockPage->buildLink("../timetickets/viewtimeticket.php?id=" . $userDetail->mem_timeticket[0], $userDetail->mem_tim_name[0], 'in'));
}

$block1->contentRow(lang_strings("comments"), nl2br($userDetail->mem_comments[0]));
$block1->contentRow(lang_strings("account_created"), createDate($userDetail->mem_created[0], $timezoneSession));
$block1->closeContent();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->turnPage();
}

$block1->openContent();
$block1->contentTitle(lang_strings("information"));
$tmpquery = "SELECT tea.id FROM " . $tableName["teams"] . " tea LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=tea.project WHERE tea.member=" . $userDetail->mem_id[0] . " AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
compt($tmpquery);
$valueProjects = $countEnregTotal;
$tmpquery = "SELECT res.id FROM " . $tableName["tasks_resource"] . " res LEFT OUTER JOIN " . $tableName["tasks"] . " tas ON tas.id=res.task LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=tas.project WHERE res.resource=" . $userDetail->mem_id[0] . " AND res.type = 'members' AND tas.status IN ('" . ST_CLIENT_COMPLETED . "','" . ST_NOT_STARTED . "','" . ST_OPEN . "') AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
compt($tmpquery);
$valueTasks = $countEnregTotal;
$tmpquery = "SELECT note.id FROM " . $tableName["notes"] . " note LEFT OUTER JOIN " . $tableName["projects"] . " pro ON pro.id=note.project WHERE note.owner=" . $userDetail->mem_id[0] . " AND pro.status IN ('" . PJS_CLIENT_COMPLETED . "','" . PJS_OPEN . "')";
compt($tmpquery);
$valueNotes = $countEnregTotal;
$block1->contentRow(lang_strings("projects"), $valueProjects);
$block1->contentRow(lang_strings("tasks"), $valueTasks);
$block1->contentRow(lang_strings("notes"), $valueNotes);

if ($userDetail->mem_log_connected[0] > $dateunix-5 * 60) {
    $connected_result = lang_strings("yes") . " " . $z;
} else {
    $connected_result = lang_strings("no");
}

$block1->contentRow(lang_strings("connected"), $connected_result);
$block1->contentRow(lang_strings("status"), ($userDetail->mem_deleted[0] == B_TRUE)?lang_strings("deleted"):(($userDetail->mem_active[0] == B_TRUE)?lang_strings("status_active"):lang_strings("status_inactive")));
$block1->closeContent();

if ($layoutSession == LT_TWOPAGES) {
    $blockPage->closeTwoPages();
}

$block1->closeForm();

if ($userDetail->mem_deleted[0] == B_FALSE) {
    $block1->openPaletteScript();

    if ($SW_Permissions['User']['Admin'][$profilSession]) {
        $block1->paletteScript(0, "remove", "../users/deleteusers.php?id=$id", "true,true,true", lang_strings("delete"));
    }

    if ($SW_Permissions['User']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../users/edituser.php?id=$id", "true,true,true", lang_strings("edit"));
    }

    $block1->paletteScript(2, "export", "../users/exportuser.php?id=$id", "true,true,true", lang_strings("export"));
    $block1->closePaletteScript("", "");
}

$blockPage->closeLongList();
require_once("../themes/" . THEME . "/footer.php");

?>
